/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],E=0,T=ge.length;E<T;E++)e[E]=Ce[ge[E]];return e};define(Ce[66],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function E(R){return($,g,w)=>{let A=null,S=null;if(typeof w.value=="function"?(A="value",S=w.value):typeof w.get=="function"&&(A="get",S=w.get),!S)throw new Error("not supported");w[A]=R(S,g)}}function T(R,$,g){let w=null,A=null;if(typeof g.value=="function"?(w="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",A=g.get),!A)throw new Error("not supported");const S=`$memoize$${$}`;g[w]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[S]}}e.$th=T;function I(R,$,g){return E((w,A)=>{const S=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=g?g():void 0),clearTimeout(this[S]),$&&(this[l]=$(this[l],...p),p=[this[l]]),this[S]=setTimeout(()=>{w.apply(this,p),this[l]=g?g():void 0},R)}})}e.$uh=I;function L(R,$,g){return E((w,A)=>{const S=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,b=`$throttle$pending$${A}`;return function(...r){if(this[l]||(this[l]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...r)),this[b])return;const a=this[p]+R;a<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0):(this[b]=!0,this[S]=setTimeout(()=>{this[b]=!1,this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0},a-Date.now()))}})}e.$vh=L}),define(Ce[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=e.$WM=void 0;class E{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$WM=E,e.$XM=new E("id#")}),define(Ce[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(i,s=!1){let u=0;const d=i.length;let m="",f=0,k=16,F=0;function v(V){let P=0,C=0;for(;P<V;){const Z=i.charCodeAt(u);if(Z>=48&&Z<=57)C=C*16+Z-48;else if(Z>=65&&Z<=70)C=C*16+Z-65+10;else if(Z>=97&&Z<=102)C=C*16+Z-97+10;else break;u++,P++}return P<V&&(C=-1),C}function y(V){u=V,m="",f=0,k=16,F=0}function D(){const V=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&w(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&w(i.charCodeAt(u)))for(u++;u<i.length&&w(i.charCodeAt(u));)u++;else return F=3,i.substring(V,u);let P=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&w(i.charCodeAt(u))){for(u++;u<i.length&&w(i.charCodeAt(u));)u++;P=u}else F=3;return i.substring(V,P)}function N(){let V="",P=u;for(;;){if(u>=d){V+=i.substring(P,u),F=2;break}const C=i.charCodeAt(u);if(C===34){V+=i.substring(P,u),u++;break}if(C===92){if(V+=i.substring(P,u),u++,u>=d){F=2;break}switch(i.charCodeAt(u++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const ce=v(4);ce>=0?V+=String.fromCharCode(ce):F=4;break}default:F=5}P=u;continue}if(C>=0&&C<=31)if(g(C)){V+=i.substring(P,u),F=2;break}else F=6;u++}return V}function O(){if(m="",F=0,f=u,u>=d)return f=d,k=17;let V=i.charCodeAt(u);if($(V)){do u++,m+=String.fromCharCode(V),V=i.charCodeAt(u);while($(V));return k=15}if(g(V))return u++,m+=String.fromCharCode(V),V===13&&i.charCodeAt(u)===10&&(u++,m+=`
`),k=14;switch(V){case 123:return u++,k=1;case 125:return u++,k=2;case 91:return u++,k=3;case 93:return u++,k=4;case 58:return u++,k=6;case 44:return u++,k=5;case 34:return u++,m=N(),k=10;case 47:{const P=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return m=i.substring(P,u),k=12}if(i.charCodeAt(u+1)===42){u+=2;const C=d-1;let Z=!1;for(;u<C;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,Z=!0;break}u++}return Z||(u++,F=1),m=i.substring(P,u),k=13}return m+=String.fromCharCode(V),u++,k=16}case 45:if(m+=String.fromCharCode(V),u++,u===d||!w(i.charCodeAt(u)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=D(),k=11;default:for(;u<d&&W(V);)u++,V=i.charCodeAt(u);if(f!==u){switch(m=i.substring(f,u),m){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return m+=String.fromCharCode(V),u++,k=16}}function W(V){if($(V)||g(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let V;do V=O();while(V>=12&&V<=15);return V}return{setPosition:y,getPosition:()=>u,scan:s?z:O,getToken:()=>k,getTokenValue:()=>m,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>F}}e.$9m=R;function $(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function S(i,s){const u=[],d=new Object;let m;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function F(v,y,D,N){f.value=v,f.offset=y,f.length=D,f.type=N,f.colonOffset=void 0,m=f}try{o(i,{onObjectBegin:(v,y)=>{if(s<=v)throw d;m=void 0,k=s>v,u.push("")},onObjectProperty:(v,y,D)=>{if(s<y||(F(v,y,D,"property"),u[u.length-1]=v,s<=y+D))throw d},onObjectEnd:(v,y)=>{if(s<=v)throw d;m=void 0,u.pop()},onArrayBegin:(v,y)=>{if(s<=v)throw d;m=void 0,u.push(0)},onArrayEnd:(v,y)=>{if(s<=v)throw d;m=void 0,u.pop()},onLiteralValue:(v,y,D)=>{if(s<y||(F(v,y,D,h(v)),s<=y+D))throw d},onSeparator:(v,y,D)=>{if(s<=y)throw d;if(v===":"&&m&&m.type==="property")m.colonOffset=y,k=!1,m=void 0;else if(v===","){const N=u[u.length-1];typeof N=="number"?u[u.length-1]=N+1:(k=!0,u[u.length-1]=""),m=void 0}}})}catch(v){if(v!==d)throw v}return{path:u,previousNode:m,isAtPropertyKey:k,matches:v=>{let y=0;for(let D=0;y<v.length&&D<u.length;D++)if(v[y]===u[D]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.$0m=S;function l(i,s=[],u=L.DEFAULT){let d=null,m=[];const f=[];function k(v){Array.isArray(m)?m.push(v):d!==null&&(m[d]=v)}return o(i,{onObjectBegin:()=>{const v={};k(v),f.push(m),m=v,d=null},onObjectProperty:v=>{d=v},onObjectEnd:()=>{m=f.pop()},onArrayBegin:()=>{const v=[];k(v),f.push(m),m=v,d=null},onArrayEnd:()=>{m=f.pop()},onLiteralValue:k,onError:(v,y,D)=>{s.push({error:v,offset:y,length:D})}},u),m[0]}e.$$m=l;function p(i,s=[],u=L.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(v){d.type==="property"&&(d.length=v-d.offset,d=d.parent)}function f(v){return d.children.push(v),v}o(i,{onObjectBegin:v=>{d=f({type:"object",offset:v,length:-1,parent:d,children:[]})},onObjectProperty:(v,y,D)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:v,offset:y,length:D,parent:d})},onObjectEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onArrayBegin:(v,y)=>{d=f({type:"array",offset:v,length:-1,parent:d,children:[]})},onArrayEnd:(v,y)=>{d.length=v+y-d.offset,d=d.parent,m(v+y)},onLiteralValue:(v,y,D)=>{f({type:h(v),offset:y,length:D,parent:d,value:v}),m(y+D)},onSeparator:(v,y,D)=>{d.type==="property"&&(v===":"?d.colonOffset=y:v===","&&m(y))},onError:(v,y,D)=>{s.push({error:v,offset:y,length:D})}},u);const F=d.children[0];return F&&delete F.parent,F}e.$_m=p;function b(i,s){if(!i)return;let u=i;for(const d of s)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],m=!0;break}if(!m)return}else{const m=d;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}e.$an=b;function r(i){if(!i.parent||!i.parent.children)return[];const s=r(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.$bn=r;function a(i){switch(i.type){case"array":return i.children.map(a);case"object":{const s=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(s[u.children[0].value]=a(d))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$cn=a;function t(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.$dn=t;function n(i,s,u=!1){if(t(i,s,u)){const d=i.children;if(Array.isArray(d))for(let m=0;m<d.length&&d[m].offset<=s;m++){const f=n(d[m],s,u);if(f)return f}return i}}e.$en=n;function o(i,s,u=L.DEFAULT){const d=R(i,!1);function m(ie){return ie?()=>ie(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(ie){return ie?Se=>ie(Se,d.getTokenOffset(),d.getTokenLength()):()=>!0}const k=m(s.onObjectBegin),F=f(s.onObjectProperty),v=m(s.onObjectEnd),y=m(s.onArrayBegin),D=m(s.onArrayEnd),N=f(s.onLiteralValue),O=f(s.onSeparator),W=m(s.onComment),z=f(s.onError),V=u&&u.disallowComments,P=u&&u.allowTrailingComma;function C(){for(;;){const ie=d.scan();switch(d.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:V||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(ie){case 12:case 13:V?Z(10):W();break;case 16:Z(1);break;case 15:case 14:break;default:return ie}}}function Z(ie,Se=[],oe=[]){if(z(ie),Se.length+oe.length>0){let x=d.getToken();for(;x!==17;){if(Se.indexOf(x)!==-1){C();break}else if(oe.indexOf(x)!==-1)break;x=C()}}}function ce(ie){const Se=d.getTokenValue();return ie?N(Se):F(Se),C(),!0}function me(){switch(d.getToken()){case 11:{let ie=0;try{ie=JSON.parse(d.getTokenValue()),typeof ie!="number"&&(Z(2),ie=0)}catch{Z(2)}N(ie);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return C(),!0}function be(){return d.getToken()!==10?(Z(3,[],[2,5]),!1):(ce(!1),d.getToken()===6?(O(":"),C(),de()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function ke(){k(),C();let ie=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ie||Z(4,[],[]),O(","),C(),d.getToken()===2&&P)break}else ie&&Z(6,[],[]);be()||Z(4,[],[2,5]),ie=!0}return v(),d.getToken()!==2?Z(7,[2],[]):C(),!0}function fe(){y(),C();let ie=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ie||Z(4,[],[]),O(","),C(),d.getToken()===4&&P)break}else ie&&Z(6,[],[]);de()||Z(4,[],[4,5]),ie=!0}return D(),d.getToken()!==4?Z(8,[4],[]):C(),!0}function de(){switch(d.getToken()){case 3:return fe();case 1:return ke();case 10:return ce(!0);default:return me()}}return C(),d.getToken()===17?u.allowEmptyContent?!0:(Z(4,[],[]),!1):de()?(d.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}e.$fn=o;function c(i,s){const u=R(i),d=[];let m,f=0,k;do switch(k=u.getPosition(),m=u.scan(),m){case 12:case 13:case 17:f!==k&&d.push(i.substring(f,k)),s!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,s)),f=u.getPosition();break}while(m!==17);return d.join("")}e.$gn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$hn=h}),function(ge,e){typeof define=="function"&&define.amd?define(Ce[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Pe,ae){for(var te=0;te<ae.length;te++){var J=ae[te];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Pe,J.key,J)}}function E(Pe,ae,te){return ae&&e(Pe.prototype,ae),te&&e(Pe,te),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function T(Pe,ae){if(Pe){if(typeof Pe=="string")return I(Pe,ae);var te=Object.prototype.toString.call(Pe).slice(8,-1);if(te==="Object"&&Pe.constructor&&(te=Pe.constructor.name),te==="Map"||te==="Set")return Array.from(Pe);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return I(Pe,ae)}}function I(Pe,ae){(ae==null||ae>Pe.length)&&(ae=Pe.length);for(var te=0,J=new Array(ae);te<ae;te++)J[te]=Pe[te];return J}function L(Pe,ae){var te=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(te)return(te=te.call(Pe)).next.bind(te);if(Array.isArray(Pe)||(te=T(Pe))||ae&&Pe&&typeof Pe.length=="number"){te&&(Pe=te);var J=0;return function(){return J>=Pe.length?{done:!0}:{done:!1,value:Pe[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function $(Pe){ge.defaults=Pe}var g=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ae){return l[ae]};function b(Pe,ae){if(ae){if(g.test(Pe))return Pe.replace(w,p)}else if(A.test(Pe))return Pe.replace(S,p);return Pe}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Pe){return Pe.replace(r,function(ae,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Pe,ae){Pe=typeof Pe=="string"?Pe:Pe.source,ae=ae||"";var te={replace:function(ee,$e){return $e=$e.source||$e,$e=$e.replace(t,"$1"),Pe=Pe.replace(ee,$e),te},getRegex:function(){return new RegExp(Pe,ae)}};return te}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Pe,ae,te){if(Pe){var J;try{J=decodeURIComponent(a(te)).replace(o,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ae&&!c.test(te)&&(te=m(ae,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Pe,ae){i[" "+Pe]||(s.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=v(Pe,"/",!0)),Pe=i[" "+Pe];var te=Pe.indexOf(":")===-1;return ae.substring(0,2)==="//"?te?ae:Pe.replace(u,"$1")+ae:ae.charAt(0)==="/"?te?ae:Pe.replace(d,"$1")+ae:Pe+ae}var f={exec:function(){}};function k(Pe){for(var ae=1,te,J;ae<arguments.length;ae++){te=arguments[ae];for(J in te)Object.prototype.hasOwnProperty.call(te,J)&&(Pe[J]=te[J])}return Pe}function F(Pe,ae){var te=Pe.replace(/\|/g,function($e,ve,Fe){for(var le=!1,we=ve;--we>=0&&Fe[we]==="\\";)le=!le;return le?"|":" |"}),J=te.split(/ \|/),ee=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ae)J.splice(ae);else for(;J.length<ae;)J.push("");for(;ee<J.length;ee++)J[ee]=J[ee].trim().replace(/\\\|/g,"|");return J}function v(Pe,ae,te){var J=Pe.length;if(J===0)return"";for(var ee=0;ee<J;){var $e=Pe.charAt(J-ee-1);if($e===ae&&!te)ee++;else if($e!==ae&&te)ee++;else break}return Pe.slice(0,J-ee)}function y(Pe,ae){if(Pe.indexOf(ae[1])===-1)return-1;for(var te=Pe.length,J=0,ee=0;ee<te;ee++)if(Pe[ee]==="\\")ee++;else if(Pe[ee]===ae[0])J++;else if(Pe[ee]===ae[1]&&(J--,J<0))return ee;return-1}function D(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Pe,ae){if(ae<1)return"";for(var te="";ae>1;)ae&1&&(te+=Pe),ae>>=1,Pe+=Pe;return te+Pe}function O(Pe,ae,te,J){var ee=ae.href,$e=ae.title?b(ae.title):null,ve=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){J.state.inLink=!0;var Fe={type:"link",raw:te,href:ee,title:$e,text:ve,tokens:J.inlineTokens(ve)};return J.state.inLink=!1,Fe}return{type:"image",raw:te,href:ee,title:$e,text:b(ve)}}function W(Pe,ae){var te=Pe.match(/^(\s+)(?:```)/);if(te===null)return ae;var J=te[1];return ae.split(`
`).map(function(ee){var $e=ee.match(/^\s+/);if($e===null)return ee;var ve=$e[0];return ve.length>=J.length?ee.slice(J.length):ee}).join(`
`)}var z=function(){function Pe(te){this.options=te||ge.defaults}var ae=Pe.prototype;return ae.space=function(J){var ee=this.rules.block.newline.exec(J);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ae.code=function(J){var ee=this.rules.block.code.exec(J);if(ee){var $e=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:v($e,`
`)}}},ae.fences=function(J){var ee=this.rules.block.fences.exec(J);if(ee){var $e=ee[0],ve=W($e,ee[3]||"");return{type:"code",raw:$e,lang:ee[2]?ee[2].trim():ee[2],text:ve}}},ae.heading=function(J){var ee=this.rules.block.heading.exec(J);if(ee){var $e=ee[2].trim();if(/#$/.test($e)){var ve=v($e,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&($e=ve.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:$e,tokens:this.lexer.inline($e)}}},ae.hr=function(J){var ee=this.rules.block.hr.exec(J);if(ee)return{type:"hr",raw:ee[0]}},ae.blockquote=function(J){var ee=this.rules.block.blockquote.exec(J);if(ee){var $e=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},ae.list=function(J){var ee=this.rules.block.list.exec(J);if(ee){var $e,ve,Fe,le,we,M,K,H,U,Q,X,ye,Te=ee[1].trim(),We=Te.length>1,He={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ye=!1,!(!(ee=Ye.exec(J))||this.rules.block.hr.test(J)));){if($e=ee[0],J=J.substring($e.length),H=ee[2].split(`
`,1)[0],U=J.split(`
`,1)[0],this.options.pedantic?(le=2,X=H.trimLeft()):(le=ee[2].search(/[^ ]/),le=le>4?1:le,X=H.slice(le),le+=ee[1].length),M=!1,!H&&/^ *$/.test(U)&&($e+=U+`
`,J=J.substring(U.length+1),ye=!0),!ye)for(var st=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),at=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");J&&(Q=J.split(`
`,1)[0],H=Q,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(H)||at.test(H)||st.test(H)||nt.test(J)));){if(H.search(/[^ ]/)>=le||!H.trim())X+=`
`+H.slice(le);else if(!M)X+=`
`+H;else break;!M&&!H.trim()&&(M=!0),$e+=Q+`
`,J=J.substring(Q.length+1)}He.loose||(K?He.loose=!0:/\n *\n *$/.test($e)&&(K=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(X),ve&&(Fe=ve[0]!=="[ ] ",X=X.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:$e,task:!!ve,checked:Fe,loose:!1,text:X}),He.raw+=$e}He.items[He.items.length-1].raw=$e.trimRight(),He.items[He.items.length-1].text=X.trimRight(),He.raw=He.raw.trimRight();var ct=He.items.length;for(we=0;we<ct;we++){this.lexer.state.top=!1,He.items[we].tokens=this.lexer.blockTokens(He.items[we].text,[]);var ze=He.items[we].tokens.filter(function(Y){return Y.type==="space"}),vt=ze.every(function(Y){for(var _=Y.raw.split(""),pe=0,Be=L(_),Qe;!(Qe=Be()).done;){var it=Qe.value;if(it===`
`&&(pe+=1),pe>1)return!0}return!1});!He.loose&&ze.length&&vt&&(He.loose=!0,He.items[we].loose=!0)}return He}},ae.html=function(J){var ee=this.rules.block.html.exec(J);if(ee){var $e={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]);$e.type="paragraph",$e.text=ve,$e.tokens=this.lexer.inline(ve)}return $e}},ae.def=function(J){var ee=this.rules.block.def.exec(J);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var $e=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ee[0],href:ee[2],title:ee[3]}}},ae.table=function(J){var ee=this.rules.block.table.exec(J);if(ee){var $e={type:"table",header:F(ee[1]).map(function(K){return{text:K}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ee[0];var ve=$e.align.length,Fe,le,we,M;for(Fe=0;Fe<ve;Fe++)/^ *-+: *$/.test($e.align[Fe])?$e.align[Fe]="right":/^ *:-+: *$/.test($e.align[Fe])?$e.align[Fe]="center":/^ *:-+ *$/.test($e.align[Fe])?$e.align[Fe]="left":$e.align[Fe]=null;for(ve=$e.rows.length,Fe=0;Fe<ve;Fe++)$e.rows[Fe]=F($e.rows[Fe],$e.header.length).map(function(K){return{text:K}});for(ve=$e.header.length,le=0;le<ve;le++)$e.header[le].tokens=this.lexer.inline($e.header[le].text);for(ve=$e.rows.length,le=0;le<ve;le++)for(M=$e.rows[le],we=0;we<M.length;we++)M[we].tokens=this.lexer.inline(M[we].text);return $e}}},ae.lheading=function(J){var ee=this.rules.block.lheading.exec(J);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ae.paragraph=function(J){var ee=this.rules.block.paragraph.exec(J);if(ee){var $e=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:$e,tokens:this.lexer.inline($e)}}},ae.text=function(J){var ee=this.rules.block.text.exec(J);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ae.escape=function(J){var ee=this.rules.inline.escape.exec(J);if(ee)return{type:"escape",raw:ee[0],text:b(ee[1])}},ae.tag=function(J){var ee=this.rules.inline.tag.exec(J);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]):ee[0]}},ae.link=function(J){var ee=this.rules.inline.link.exec(J);if(ee){var $e=ee[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var ve=v($e.slice(0,-1),"\\");if(($e.length-ve.length)%2===0)return}else{var Fe=y(ee[2],"()");if(Fe>-1){var le=ee[0].indexOf("!")===0?5:4,we=le+ee[1].length+Fe;ee[2]=ee[2].substring(0,Fe),ee[0]=ee[0].substring(0,we).trim(),ee[3]=""}}var M=ee[2],K="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(M);H&&(M=H[1],K=H[3])}else K=ee[3]?ee[3].slice(1,-1):"";return M=M.trim(),/^</.test(M)&&(this.options.pedantic&&!/>$/.test($e)?M=M.slice(1):M=M.slice(1,-1)),O(ee,{href:M&&M.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ae.reflink=function(J,ee){var $e;if(($e=this.rules.inline.reflink.exec(J))||($e=this.rules.inline.nolink.exec(J))){var ve=($e[2]||$e[1]).replace(/\s+/g," ");if(ve=ee[ve.toLowerCase()],!ve||!ve.href){var Fe=$e[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O($e,ve,$e[0],this.lexer)}},ae.emStrong=function(J,ee,$e){$e===void 0&&($e="");var ve=this.rules.inline.emStrong.lDelim.exec(J);if(ve&&!(ve[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ve[1]||ve[2]||"";if(!Fe||Fe&&($e===""||this.rules.inline.punctuation.exec($e))){var le=ve[0].length-1,we,M,K=le,H=0,U=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,ee=ee.slice(-1*J.length+le);(ve=U.exec(ee))!=null;)if(we=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!we){if(M=we.length,ve[3]||ve[4]){K+=M;continue}else if((ve[5]||ve[6])&&le%3&&!((le+M)%3)){H+=M;continue}if(K-=M,!(K>0)){if(M=Math.min(M,M+K+H),Math.min(le,M)%2){var Q=J.slice(1,le+ve.index+M);return{type:"em",raw:J.slice(0,le+ve.index+M+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var X=J.slice(2,le+ve.index+M-1);return{type:"strong",raw:J.slice(0,le+ve.index+M+1),text:X,tokens:this.lexer.inlineTokens(X)}}}}}},ae.codespan=function(J){var ee=this.rules.inline.code.exec(J);if(ee){var $e=ee[2].replace(/\n/g," "),ve=/[^ ]/.test($e),Fe=/^ /.test($e)&&/ $/.test($e);return ve&&Fe&&($e=$e.substring(1,$e.length-1)),$e=b($e,!0),{type:"codespan",raw:ee[0],text:$e}}},ae.br=function(J){var ee=this.rules.inline.br.exec(J);if(ee)return{type:"br",raw:ee[0]}},ae.del=function(J){var ee=this.rules.inline.del.exec(J);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ae.autolink=function(J,ee){var $e=this.rules.inline.autolink.exec(J);if($e){var ve,Fe;return $e[2]==="@"?(ve=b(this.options.mangle?ee($e[1]):$e[1]),Fe="mailto:"+ve):(ve=b($e[1]),Fe=ve),{type:"link",raw:$e[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},ae.url=function(J,ee){var $e;if($e=this.rules.inline.url.exec(J)){var ve,Fe;if($e[2]==="@")ve=b(this.options.mangle?ee($e[0]):$e[0]),Fe="mailto:"+ve;else{var le;do le=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(le!==$e[0]);ve=b($e[0]),$e[1]==="www."?Fe="http://"+ve:Fe=ve}return{type:"link",raw:$e[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},ae.inlineText=function(J,ee){var $e=this.rules.inline.text.exec(J);if($e){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):b($e[0]):$e[0]:ve=b(this.options.smartypants?ee($e[0]):$e[0]),{type:"text",raw:$e[0],text:ve}}},Pe}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=n(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=n(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=n(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=n(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=n(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=n(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=k({},V),V.gfm=k({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=n(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=n(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=k({},V.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(V._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",V._label).getRegex(),P.nolink=n(P.nolink).replace("ref",V._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=k({},P),P.pedantic=k({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=k({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=k({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function C(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Z(Pe){var ae="",te,J,ee=Pe.length;for(te=0;te<ee;te++)J=Pe.charCodeAt(te),Math.random()>.5&&(J="x"+J.toString(16)),ae+="&#"+J+";";return ae}var ce=function(){function Pe(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ge.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:V.normal,inline:P.normal};this.options.pedantic?(J.block=V.pedantic,J.inline=P.pedantic):this.options.gfm&&(J.block=V.gfm,this.options.breaks?J.inline=P.breaks:J.inline=P.gfm),this.tokenizer.rules=J}Pe.lex=function(J,ee){var $e=new Pe(ee);return $e.lex(J)},Pe.lexInline=function(J,ee){var $e=new Pe(ee);return $e.inlineTokens(J)};var ae=Pe.prototype;return ae.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ae.blockTokens=function(J,ee){var $e=this;ee===void 0&&(ee=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(K,H,U){return H+"    ".repeat(U.length)});for(var ve,Fe,le,we;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(ve=K.call({lexer:$e},J,ee))?(J=J.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.space(J)){J=J.substring(ve.raw.length),ve.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(ve);continue}if(ve=this.tokenizer.code(J)){J=J.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ee.push(ve);continue}if(ve=this.tokenizer.fences(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.heading(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.hr(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.blockquote(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.list(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.html(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.def(J)){J=J.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.lheading(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(le=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,H=J.slice(1),U=void 0;$e.options.extensions.startBlock.forEach(function(Q){U=Q.call({lexer:this},H),typeof U=="number"&&U>=0&&(K=Math.min(K,U))}),K<1/0&&K>=0&&(le=J.substring(0,K+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(le))){Fe=ee[ee.length-1],we&&Fe.type==="paragraph"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ee.push(ve),we=le.length!==J.length,J=J.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(J)){J=J.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ee.push(ve);continue}if(J){var M="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(M);break}else throw new Error(M)}}return this.state.top=!0,ee},ae.inline=function(J,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:J,tokens:ee}),ee},ae.inlineTokens=function(J,ee){var $e=this;ee===void 0&&(ee=[]);var ve,Fe,le,we=J,M,K,H;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(M=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)U.includes(M[0].slice(M[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,M.index)+"["+N("a",M[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(M=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,M.index)+"["+N("a",M[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(M=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,M.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(K||(H=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(ve=X.call({lexer:$e},J,ee))?(J=J.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.tag(J)){J=J.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.link(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.emStrong(J,we,H)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.codespan(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.br(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.del(J)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.autolink(J,Z)){J=J.substring(ve.raw.length),ee.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(J,Z))){J=J.substring(ve.raw.length),ee.push(ve);continue}if(le=J,this.options.extensions&&this.options.extensions.startInline&&function(){var X=1/0,ye=J.slice(1),Te=void 0;$e.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},ye),typeof Te=="number"&&Te>=0&&(X=Math.min(X,Te))}),X<1/0&&X>=0&&(le=J.substring(0,X+1))}(),ve=this.tokenizer.inlineText(le,C)){J=J.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(H=ve.raw.slice(-1)),K=!0,Fe=ee[ee.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ee.push(ve);continue}if(J){var Q="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return ee},E(Pe,null,[{key:"rules",get:function(){return{block:V,inline:P}}}]),Pe}(),me=function(){function Pe(te){this.options=te||ge.defaults}var ae=Pe.prototype;return ae.code=function(J,ee,$e){var ve=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(J,ve);Fe!=null&&Fe!==J&&($e=!0,J=Fe)}return J=J.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+b(ve,!0)+'">'+($e?J:b(J,!0))+`</code></pre>
`:"<pre><code>"+($e?J:b(J,!0))+`</code></pre>
`},ae.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ae.html=function(J){return J},ae.heading=function(J,ee,$e,ve){if(this.options.headerIds){var Fe=this.options.headerPrefix+ve.slug($e);return"<h"+ee+' id="'+Fe+'">'+J+"</h"+ee+`>
`}return"<h"+ee+">"+J+"</h"+ee+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(J,ee,$e){var ve=ee?"ol":"ul",Fe=ee&&$e!==1?' start="'+$e+'"':"";return"<"+ve+Fe+`>
`+J+"</"+ve+`>
`},ae.listitem=function(J){return"<li>"+J+`</li>
`},ae.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(J){return"<p>"+J+`</p>
`},ae.table=function(J,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ee+`</table>
`},ae.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ae.tablecell=function(J,ee){var $e=ee.header?"th":"td",ve=ee.align?"<"+$e+' align="'+ee.align+'">':"<"+$e+">";return ve+J+("</"+$e+`>
`)},ae.strong=function(J){return"<strong>"+J+"</strong>"},ae.em=function(J){return"<em>"+J+"</em>"},ae.codespan=function(J){return"<code>"+J+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(J){return"<del>"+J+"</del>"},ae.link=function(J,ee,$e){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return $e;var ve='<a href="'+b(J)+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=">"+$e+"</a>",ve},ae.image=function(J,ee,$e){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return $e;var ve='<img src="'+J+'" alt="'+$e+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=this.options.xhtml?"/>":">",ve},ae.text=function(J){return J},Pe}(),be=function(){function Pe(){}var ae=Pe.prototype;return ae.strong=function(J){return J},ae.em=function(J){return J},ae.codespan=function(J){return J},ae.del=function(J){return J},ae.html=function(J){return J},ae.text=function(J){return J},ae.link=function(J,ee,$e){return""+$e},ae.image=function(J,ee,$e){return""+$e},ae.br=function(){return""},Pe}(),ke=function(){function Pe(){this.seen={}}var ae=Pe.prototype;return ae.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(J,ee){var $e=J,ve=0;if(this.seen.hasOwnProperty($e)){ve=this.seen[J];do ve++,$e=J+"-"+ve;while(this.seen.hasOwnProperty($e))}return ee||(this.seen[J]=ve,this.seen[$e]=0),$e},ae.slug=function(J,ee){ee===void 0&&(ee={});var $e=this.serialize(J);return this.getNextSafeSlug($e,ee.dryrun)},Pe}(),fe=function(){function Pe(te){this.options=te||ge.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new ke}Pe.parse=function(J,ee){var $e=new Pe(ee);return $e.parse(J)},Pe.parseInline=function(J,ee){var $e=new Pe(ee);return $e.parseInline(J)};var ae=Pe.prototype;return ae.parse=function(J,ee){ee===void 0&&(ee=!0);var $e="",ve,Fe,le,we,M,K,H,U,Q,X,ye,Te,We,He,Ye,st,nt,tt,at,ct=J.length;for(ve=0;ve<ct;ve++){if(X=J[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(at=this.options.extensions.renderers[X.type].call({parser:this},X),at!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){$e+=at||"";continue}switch(X.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(X.tokens),X.depth,a(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(U="",H="",we=X.header.length,Fe=0;Fe<we;Fe++)H+=this.renderer.tablecell(this.parseInline(X.header[Fe].tokens),{header:!0,align:X.align[Fe]});for(U+=this.renderer.tablerow(H),Q="",we=X.rows.length,Fe=0;Fe<we;Fe++){for(K=X.rows[Fe],H="",M=K.length,le=0;le<M;le++)H+=this.renderer.tablecell(this.parseInline(K[le].tokens),{header:!1,align:X.align[le]});Q+=this.renderer.tablerow(H)}$e+=this.renderer.table(U,Q);continue}case"blockquote":{Q=this.parse(X.tokens),$e+=this.renderer.blockquote(Q);continue}case"list":{for(ye=X.ordered,Te=X.start,We=X.loose,we=X.items.length,Q="",Fe=0;Fe<we;Fe++)Ye=X.items[Fe],st=Ye.checked,nt=Ye.task,He="",Ye.task&&(tt=this.renderer.checkbox(st),We?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=tt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=tt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:tt}):He+=tt),He+=this.parse(Ye.tokens,We),Q+=this.renderer.listitem(He,nt,st);$e+=this.renderer.list(Q,ye,Te);continue}case"html":{$e+=this.renderer.html(X.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(Q=X.tokens?this.parseInline(X.tokens):X.text;ve+1<ct&&J[ve+1].type==="text";)X=J[++ve],Q+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);$e+=ee?this.renderer.paragraph(Q):Q;continue}default:{var ze='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return $e},ae.parseInline=function(J,ee){ee=ee||this.renderer;var $e="",ve,Fe,le,we=J.length;for(ve=0;ve<we;ve++){if(Fe=J[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(le=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){$e+=le||"";continue}switch(Fe.type){case"escape":{$e+=ee.text(Fe.text);break}case"html":{$e+=ee.html(Fe.text);break}case"link":{$e+=ee.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ee));break}case"image":{$e+=ee.image(Fe.href,Fe.title,Fe.text);break}case"strong":{$e+=ee.strong(this.parseInline(Fe.tokens,ee));break}case"em":{$e+=ee.em(this.parseInline(Fe.tokens,ee));break}case"codespan":{$e+=ee.codespan(Fe.text);break}case"br":{$e+=ee.br();break}case"del":{$e+=ee.del(this.parseInline(Fe.tokens,ee));break}case"text":{$e+=ee.text(Fe.text);break}default:{var M='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(M);return}else throw new Error(M)}}}return $e},Pe}();function de(Pe,ae,te){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ae=="function"&&(te=ae,ae=null),ae=k({},de.defaults,ae||{}),D(ae),te){var J=ae.highlight,ee;try{ee=ce.lex(Pe,ae)}catch(we){return te(we)}var $e=function(M){var K;if(!M)try{ae.walkTokens&&de.walkTokens(ee,ae.walkTokens),K=fe.parse(ee,ae)}catch(H){M=H}return ae.highlight=J,M?te(M):te(null,K)};if(!J||J.length<3||(delete ae.highlight,!ee.length))return $e();var ve=0;de.walkTokens(ee,function(we){we.type==="code"&&(ve++,setTimeout(function(){J(we.text,we.lang,function(M,K){if(M)return $e(M);K!=null&&K!==we.text&&(we.text=K,we.escaped=!0),ve--,ve===0&&$e()})},0))}),ve===0&&$e();return}function Fe(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+b(we.message+"",!0)+"</pre>";throw we}try{var le=ce.lex(Pe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(de.walkTokens(le,ae.walkTokens)).then(function(){return fe.parse(le,ae)}).catch(Fe);de.walkTokens(le,ae.walkTokens)}return fe.parse(le,ae)}catch(we){Fe(we)}}de.options=de.setOptions=function(Pe){return k(de.defaults,Pe),$(de.defaults),de},de.getDefaults=R,de.defaults=ge.defaults,de.use=function(){for(var Pe=arguments.length,ae=new Array(Pe),te=0;te<Pe;te++)ae[te]=arguments[te];var J=k.apply(void 0,[{}].concat(ae)),ee=de.defaults.extensions||{renderers:{},childTokens:{}},$e;ae.forEach(function(ve){if(ve.extensions&&($e=!0,ve.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var we=ee.renderers?ee.renderers[le.name]:null;we?ee.renderers[le.name]=function(){for(var M=arguments.length,K=new Array(M),H=0;H<M;H++)K[H]=arguments[H];var U=le.renderer.apply(this,K);return U===!1&&(U=we.apply(this,K)),U}:ee.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[le.level]?ee[le.level].unshift(le.tokenizer):ee[le.level]=[le.tokenizer],le.start&&(le.level==="block"?ee.startBlock?ee.startBlock.push(le.start):ee.startBlock=[le.start]:le.level==="inline"&&(ee.startInline?ee.startInline.push(le.start):ee.startInline=[le.start]))}le.childTokens&&(ee.childTokens[le.name]=le.childTokens)})),ve.renderer&&function(){var le=de.defaults.renderer||new me,we=function(H){var U=le[H];le[H]=function(){for(var Q=arguments.length,X=new Array(Q),ye=0;ye<Q;ye++)X[ye]=arguments[ye];var Te=ve.renderer[H].apply(le,X);return Te===!1&&(Te=U.apply(le,X)),Te}};for(var M in ve.renderer)we(M);J.renderer=le}(),ve.tokenizer&&function(){var le=de.defaults.tokenizer||new z,we=function(H){var U=le[H];le[H]=function(){for(var Q=arguments.length,X=new Array(Q),ye=0;ye<Q;ye++)X[ye]=arguments[ye];var Te=ve.tokenizer[H].apply(le,X);return Te===!1&&(Te=U.apply(le,X)),Te}};for(var M in ve.tokenizer)we(M);J.tokenizer=le}(),ve.walkTokens){var Fe=de.defaults.walkTokens;J.walkTokens=function(le){var we=[];return we.push(ve.walkTokens.call(this,le)),Fe&&(we=we.concat(Fe.call(this,le))),we}}$e&&(J.extensions=ee),de.setOptions(J)})},de.walkTokens=function(Pe,ae){for(var te=[],J=function(){var Fe=$e.value;switch(te=te.concat(ae.call(de,Fe)),Fe.type){case"table":{for(var le=L(Fe.header),we;!(we=le()).done;){var M=we.value;te=te.concat(de.walkTokens(M.tokens,ae))}for(var K=L(Fe.rows),H;!(H=K()).done;)for(var U=H.value,Q=L(U),X;!(X=Q()).done;){var ye=X.value;te=te.concat(de.walkTokens(ye.tokens,ae))}break}case"list":{te=te.concat(de.walkTokens(Fe.items,ae));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[Fe.type]?de.defaults.extensions.childTokens[Fe.type].forEach(function(Te){te=te.concat(de.walkTokens(Fe[Te],ae))}):Fe.tokens&&(te=te.concat(de.walkTokens(Fe.tokens,ae)))}},ee=L(Pe),$e;!($e=ee()).done;)J();return te},de.parseInline=function(Pe,ae){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ae=k({},de.defaults,ae||{}),D(ae);try{var te=ce.lexInline(Pe,ae);return ae.walkTokens&&de.walkTokens(te,ae.walkTokens),fe.parseInline(te,ae)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+b(J.message+"",!0)+"</pre>";throw J}},de.Parser=fe,de.parser=fe.parse,de.Renderer=me,de.TextRenderer=be,de.Lexer=ce,de.lexer=ce.lex,de.Tokenizer=z,de.Slugger=ke,de.parse=de;var ie=de.options,Se=de.setOptions,oe=de.use,x=de.walkTokens,q=de.parseInline,ne=de,Ie=fe.parse,Ae=ce.lex;ge.Lexer=ce,ge.Parser=fe,ge.Renderer=me,ge.Slugger=ke,ge.TextRenderer=be,ge.Tokenizer=z,ge.getDefaults=R,ge.lexer=Ae,ge.marked=de,ge.options=ie,ge.parse=ne,ge.parseInline=q,ge.parser=Ie,ge.setOptions=Se,ge.use=oe,ge.walkTokens=x,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Ce[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function E(r){const a=L(r);if(a&&a.length>0)return new Uint32Array(a)}e.$Nj=E;let T=0;const I=new Uint32Array(10);function L(r){if(T=0,R(r,S,4352),T>0||(R(r,l,4449),T>0)||(R(r,p,4520),T>0)||(R(r,b,12593),T))return I.subarray(0,T);if(r>=44032&&r<=55203){const a=r-44032,t=a%588,n=Math.floor(a/588),o=Math.floor(t/28),c=t%28-1;if(n<S.length?R(n,S,0):4352+n-12593<b.length&&R(4352+n,b,12593),o<l.length?R(o,l,0):4449+o-12593<b.length&&R(4449+o-12593,b,12593),c>=0&&(c<p.length?R(c,p,0):4520+c-12593<b.length&&R(4520+c-12593,b,12593)),T>0)return I.subarray(0,T)}}function R(r,a,t){r>=t&&r<t+a.length&&$(a[r-t])}function $(r){r!==0&&(I[T++]=r&255,r>>8&&(I[T++]=r>>8&255),r>>16&&(I[T++]=r>>16&255))}var g;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var w;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(w||(w={}));var A;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(A||(A={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),b=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.rot=e.$3l=void 0;function E($,g,w){return Math.min(Math.max($,g),w)}e.$3l=E;function T($,g){return(g+$%g)%g}e.rot=T;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$5l=I;class L{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$6l=L;class R{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$7l=R}),function(){function ge(I){const L=[];typeof I=="number"&&L.push("code/timeOrigin",I);function R(g){L.push(g,Date.now())}function $(){const g=[];for(let w=0;w<L.length;w+=2)g.push({name:L[w],startTime:L[w+1]});return g}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(I+R.startTime)});return L}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function E(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:ge)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function E(T){if(e[T])return e[T].exports;var I=e[T]={i:T,l:!1,exports:{}};return ge[T].call(I.exports,I,I.exports,E),I.l=!0,I.exports}return E.m=ge,E.c=e,E.d=function(T,I,L){E.o(T,I)||Object.defineProperty(T,I,{enumerable:!0,get:L})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,I){if(1&I&&(T=E(T)),8&I||4&I&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(E.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&I&&typeof T!="string")for(var R in T)E.d(L,R,function($){return T[$]}.bind(null,R));return L},E.n=function(T){var I=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(I,"a",I),I},E.o=function(T,I){return Object.prototype.hasOwnProperty.call(T,I)},E.p="",E(E.s=0)}([function(ge,e,E){(function(T){var I;e=ge.exports=oe,I=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],g=e.src=[],w=0,A=w++;g[A]="0|[1-9]\\d*";var S=w++;g[S]="[0-9]+";var l=w++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=w++;g[p]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var b=w++;g[b]="("+g[S]+")\\.("+g[S]+")\\.("+g[S]+")";var r=w++;g[r]="(?:"+g[A]+"|"+g[l]+")";var a=w++;g[a]="(?:"+g[S]+"|"+g[l]+")";var t=w++;g[t]="(?:-("+g[r]+"(?:\\."+g[r]+")*))";var n=w++;g[n]="(?:-?("+g[a]+"(?:\\."+g[a]+")*))";var o=w++;g[o]="[0-9A-Za-z-]+";var c=w++;g[c]="(?:\\+("+g[o]+"(?:\\."+g[o]+")*))";var h=w++,i="v?"+g[p]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var s="[v=\\s]*"+g[b]+g[n]+"?"+g[c]+"?",u=w++;g[u]="^"+s+"$";var d=w++;g[d]="((?:<|>)?=?)";var m=w++;g[m]=g[S]+"|x|X|\\*";var f=w++;g[f]=g[A]+"|x|X|\\*";var k=w++;g[k]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var F=w++;g[F]="[v=\\s]*("+g[m]+")(?:\\.("+g[m]+")(?:\\.("+g[m]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var v=w++;g[v]="^"+g[d]+"\\s*"+g[k]+"$";var y=w++;g[y]="^"+g[d]+"\\s*"+g[F]+"$";var D=w++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=w++;g[N]="(?:~>?)";var O=w++;g[O]="(\\s*)"+g[N]+"\\s+",$[O]=new RegExp(g[O],"g");var W=w++;g[W]="^"+g[N]+g[k]+"$";var z=w++;g[z]="^"+g[N]+g[F]+"$";var V=w++;g[V]="(?:\\^)";var P=w++;g[P]="(\\s*)"+g[V]+"\\s+",$[P]=new RegExp(g[P],"g");var C=w++;g[C]="^"+g[V]+g[k]+"$";var Z=w++;g[Z]="^"+g[V]+g[F]+"$";var ce=w++;g[ce]="^"+g[d]+"\\s*("+s+")$|^$";var me=w++;g[me]="^"+g[d]+"\\s*("+i+")$|^$";var be=w++;g[be]="(\\s*)"+g[d]+"\\s*("+s+"|"+g[k]+")",$[be]=new RegExp(g[be],"g");var ke=w++;g[ke]="^\\s*("+g[k]+")\\s+-\\s+("+g[k]+")\\s*$";var fe=w++;g[fe]="^\\s*("+g[F]+")\\s+-\\s+("+g[F]+")\\s*$";var de=w++;g[de]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)I(ie,g[ie]),$[ie]||($[ie]=new RegExp(g[ie]));function Se(U,Q){if(U instanceof oe)return U;if(typeof U!="string"||U.length>L||!(Q?$[u]:$[h]).test(U))return null;try{return new oe(U,Q)}catch{return null}}function oe(U,Q){if(U instanceof oe){if(U.loose===Q)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof oe))return new oe(U,Q);I("SemVer",U,Q),this.loose=Q;var X=U.trim().match(Q?$[u]:$[h]);if(!X)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Te=+ye;if(Te>=0&&Te<R)return Te}return ye}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=Se,e.valid=function(U,Q){var X=Se(U,Q);return X?X.version:null},e.clean=function(U,Q){var X=Se(U.trim().replace(/^[=v]+/,""),Q);return X?X.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(U){return I("SemVer.compare",this.version,this.loose,U),U instanceof oe||(U=new oe(U,this.loose)),this.compareMain(U)||this.comparePre(U)},oe.prototype.compareMain=function(U){return U instanceof oe||(U=new oe(U,this.loose)),q(this.major,U.major)||q(this.minor,U.minor)||q(this.patch,U.patch)},oe.prototype.comparePre=function(U){if(U instanceof oe||(U=new oe(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var Q=0;do{var X=this.prerelease[Q],ye=U.prerelease[Q];if(I("prerelease compare",Q,X,ye),X===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(X===void 0)return-1;if(X!==ye)return q(X,ye)}while(++Q)},oe.prototype.inc=function(U,Q){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,Q,X,ye){typeof X=="string"&&(ye=X,X=void 0);try{return new oe(U,X).inc(Q,ye).version}catch{return null}},e.diff=function(U,Q){if(Pe(U,Q))return null;var X=Se(U),ye=Se(Q);if(X.prerelease.length||ye.prerelease.length){for(var Te in X)if((Te==="major"||Te==="minor"||Te==="patch")&&X[Te]!==ye[Te])return"pre"+Te;return"prerelease"}for(var Te in X)if((Te==="major"||Te==="minor"||Te==="patch")&&X[Te]!==ye[Te])return Te},e.compareIdentifiers=q;var x=/^[0-9]+$/;function q(U,Q){var X=x.test(U),ye=x.test(Q);return X&&ye&&(U=+U,Q=+Q),X&&!ye?-1:ye&&!X?1:U<Q?-1:U>Q?1:0}function ne(U,Q,X){return new oe(U,X).compare(new oe(Q,X))}function Ie(U,Q,X){return ne(U,Q,X)>0}function Ae(U,Q,X){return ne(U,Q,X)<0}function Pe(U,Q,X){return ne(U,Q,X)===0}function ae(U,Q,X){return ne(U,Q,X)!==0}function te(U,Q,X){return ne(U,Q,X)>=0}function J(U,Q,X){return ne(U,Q,X)<=0}function ee(U,Q,X,ye){var Te;switch(Q){case"===":typeof U=="object"&&(U=U.version),typeof X=="object"&&(X=X.version),Te=U===X;break;case"!==":typeof U=="object"&&(U=U.version),typeof X=="object"&&(X=X.version),Te=U!==X;break;case"":case"=":case"==":Te=Pe(U,X,ye);break;case"!=":Te=ae(U,X,ye);break;case">":Te=Ie(U,X,ye);break;case">=":Te=te(U,X,ye);break;case"<":Te=Ae(U,X,ye);break;case"<=":Te=J(U,X,ye);break;default:throw new TypeError("Invalid operator: "+Q)}return Te}function $e(U,Q){if(U instanceof $e){if(U.loose===Q)return U;U=U.value}if(!(this instanceof $e))return new $e(U,Q);I("comparator",U,Q),this.loose=Q,this.parse(U),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(U,Q){return q(Q,U)},e.major=function(U,Q){return new oe(U,Q).major},e.minor=function(U,Q){return new oe(U,Q).minor},e.patch=function(U,Q){return new oe(U,Q).patch},e.compare=ne,e.compareLoose=function(U,Q){return ne(U,Q,!0)},e.rcompare=function(U,Q,X){return ne(Q,U,X)},e.sort=function(U,Q){return U.sort(function(X,ye){return e.compare(X,ye,Q)})},e.rsort=function(U,Q){return U.sort(function(X,ye){return e.rcompare(X,ye,Q)})},e.gt=Ie,e.lt=Ae,e.eq=Pe,e.neq=ae,e.gte=te,e.lte=J,e.cmp=ee,e.Comparator=$e;var ve={};function Fe(U,Q){if(U instanceof Fe)return U.loose===Q?U:new Fe(U.raw,Q);if(U instanceof $e)return new Fe(U.value,Q);if(!(this instanceof Fe))return new Fe(U,Q);if(this.loose=Q,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function le(U){return!U||U.toLowerCase()==="x"||U==="*"}function we(U,Q,X,ye,Te,We,He,Ye,st,nt,tt,at,ct){return((Q=le(X)?"":le(ye)?">="+X+".0.0":le(Te)?">="+X+"."+ye+".0":">="+Q)+" "+(Ye=le(st)?"":le(nt)?"<"+(+st+1)+".0.0":le(tt)?"<"+st+"."+(+nt+1)+".0":at?"<="+st+"."+nt+"."+tt+"-"+at:"<="+Ye)).trim()}function M(U,Q){for(var X=0;X<U.length;X++)if(!U[X].test(Q))return!1;if(Q.prerelease.length){for(X=0;X<U.length;X++)if(I(U[X].semver),U[X].semver!==ve&&U[X].semver.prerelease.length>0){var ye=U[X].semver;if(ye.major===Q.major&&ye.minor===Q.minor&&ye.patch===Q.patch)return!0}return!1}return!0}function K(U,Q,X){try{Q=new Fe(Q,X)}catch{return!1}return Q.test(U)}function H(U,Q,X,ye){var Te,We,He,Ye,st;switch(U=new oe(U,ye),Q=new Fe(Q,ye),X){case">":Te=Ie,We=J,He=Ae,Ye=">",st=">=";break;case"<":Te=Ae,We=te,He=Ie,Ye="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(U,Q,ye))return!1;for(var nt=0;nt<Q.set.length;++nt){var tt=Q.set[nt],at=null,ct=null;if(tt.forEach(function(ze){ze.semver===ve&&(ze=new $e(">=0.0.0")),at=at||ze,ct=ct||ze,Te(ze.semver,at.semver,ye)?at=ze:He(ze.semver,ct.semver,ye)&&(ct=ze)}),at.operator===Ye||at.operator===st||(!ct.operator||ct.operator===Ye)&&We(U,ct.semver)||ct.operator===st&&He(U,ct.semver))return!1}return!0}$e.prototype.parse=function(U){var Q=this.loose?$[ce]:$[me],X=U.match(Q);if(!X)throw new TypeError("Invalid comparator: "+U);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new oe(X[2],this.loose):this.semver=ve},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(U){return I("Comparator.test",U,this.loose),this.semver===ve||(typeof U=="string"&&(U=new oe(U,this.loose)),ee(U,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(U,Q){if(!(U instanceof $e))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new Fe(U.value,Q),K(this.value,X,Q);if(U.operator==="")return X=new Fe(this.value,Q),K(U.semver,X,Q);var ye=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),We=this.semver.version===U.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ye=ee(this.semver,"<",U.semver,Q)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),st=ee(this.semver,">",U.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ye||Te||We&&He||Ye||st},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(U){var Q=this.loose;U=U.trim(),I("range",U,Q);var X=Q?$[fe]:$[ke];U=U.replace(X,we),I("hyphen replace",U),U=U.replace($[be],"$1$2$3"),I("comparator trim",U,$[be]),U=(U=(U=U.replace($[O],"$1~")).replace($[P],"$1^")).split(/\s+/).join(" ");var ye=Q?$[ce]:$[me],Te=U.split(" ").map(function(We){return function(He,Ye){return I("comp",He),He=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){I("caret",at,ct);var ze=ct?$[Z]:$[C];return at.replace(ze,function(vt,Y,_,pe,Be){var Qe;return I("caret",at,vt,Y,_,pe,Be),le(Y)?Qe="":le(_)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":le(pe)?Qe=Y==="0"?">="+Y+"."+_+".0 <"+Y+"."+(+_+1)+".0":">="+Y+"."+_+".0 <"+(+Y+1)+".0.0":Be?(I("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=Y==="0"?_==="0"?">="+Y+"."+_+"."+pe+Be+" <"+Y+"."+_+"."+(+pe+1):">="+Y+"."+_+"."+pe+Be+" <"+Y+"."+(+_+1)+".0":">="+Y+"."+_+"."+pe+Be+" <"+(+Y+1)+".0.0"):(I("no pr"),Qe=Y==="0"?_==="0"?">="+Y+"."+_+"."+pe+" <"+Y+"."+_+"."+(+pe+1):">="+Y+"."+_+"."+pe+" <"+Y+"."+(+_+1)+".0":">="+Y+"."+_+"."+pe+" <"+(+Y+1)+".0.0"),I("caret return",Qe),Qe})}(tt,nt)}).join(" ")}(He,Ye),I("caret",He),He=function(st,nt){return st.trim().split(/\s+/).map(function(tt){return function(at,ct){var ze=ct?$[z]:$[W];return at.replace(ze,function(vt,Y,_,pe,Be){var Qe;return I("tilde",at,vt,Y,_,pe,Be),le(Y)?Qe="":le(_)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":le(pe)?Qe=">="+Y+"."+_+".0 <"+Y+"."+(+_+1)+".0":Be?(I("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+Y+"."+_+"."+pe+Be+" <"+Y+"."+(+_+1)+".0"):Qe=">="+Y+"."+_+"."+pe+" <"+Y+"."+(+_+1)+".0",I("tilde return",Qe),Qe})}(tt,nt)}).join(" ")}(He,Ye),I("tildes",He),He=function(st,nt){return I("replaceXRanges",st,nt),st.split(/\s+/).map(function(tt){return function(at,ct){at=at.trim();var ze=ct?$[y]:$[v];return at.replace(ze,function(vt,Y,_,pe,Be,Qe){I("xRange",at,vt,Y,_,pe,Be,Qe);var it=le(_),rt=it||le(pe),Ne=rt||le(Be);return Y==="="&&Ne&&(Y=""),it?vt=Y===">"||Y==="<"?"<0.0.0":"*":Y&&Ne?(rt&&(pe=0),Ne&&(Be=0),Y===">"?(Y=">=",rt?(_=+_+1,pe=0,Be=0):Ne&&(pe=+pe+1,Be=0)):Y==="<="&&(Y="<",rt?_=+_+1:pe=+pe+1),vt=Y+_+"."+pe+"."+Be):rt?vt=">="+_+".0.0 <"+(+_+1)+".0.0":Ne&&(vt=">="+_+"."+pe+".0 <"+_+"."+(+pe+1)+".0"),I("xRange return",vt),vt})}(tt,nt)}).join(" ")}(He,Ye),I("xrange",He),He=function(st,nt){return I("replaceStars",st,nt),st.trim().replace($[de],"")}(He,Ye),I("stars",He),He}(We,Q)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(We){return!!We.match(ye)})),Te=Te.map(function(We){return new $e(We,Q)})},Fe.prototype.intersects=function(U,Q){if(!(U instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(ye){return U.set.some(function(Te){return Te.every(function(We){return ye.intersects(We,Q)})})})})},e.toComparators=function(U,Q){return new Fe(U,Q).set.map(function(X){return X.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new oe(U,this.loose));for(var Q=0;Q<this.set.length;Q++)if(M(this.set[Q],U))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(U,Q,X){var ye=null,Te=null;try{var We=new Fe(Q,X)}catch{return null}return U.forEach(function(He){We.test(He)&&(ye&&Te.compare(He)!==-1||(Te=new oe(ye=He,X)))}),ye},e.minSatisfying=function(U,Q,X){var ye=null,Te=null;try{var We=new Fe(Q,X)}catch{return null}return U.forEach(function(He){We.test(He)&&(ye&&Te.compare(He)!==1||(Te=new oe(ye=He,X)))}),ye},e.validRange=function(U,Q){try{return new Fe(U,Q).range||"*"}catch{return null}},e.ltr=function(U,Q,X){return H(U,Q,"<",X)},e.gtr=function(U,Q,X){return H(U,Q,">",X)},e.outside=H,e.prerelease=function(U,Q){var X=Se(U,Q);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(U,Q,X){return U=new Fe(U,X),Q=new Fe(Q,X),U.intersects(Q)},e.coerce=function(U){if(U instanceof oe)return U;if(typeof U!="string")return null;var Q=U.match($[D]);return Q==null?null:Se((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,E(1))},function(ge,e){var E,T,I=ge.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(a){if(E===setTimeout)return setTimeout(a,0);if((E===L||!E)&&setTimeout)return E=setTimeout,setTimeout(a,0);try{return E(a,0)}catch{try{return E.call(null,a,0)}catch{return E.call(this,a,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:L}catch{E=L}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var g,w=[],A=!1,S=-1;function l(){A&&g&&(A=!1,g.length?w=g.concat(w):S=-1,w.length&&p())}function p(){if(!A){var a=$(l);A=!0;for(var t=w.length;t;){for(g=w,w=[];++S<t;)g&&g[S].run();S=-1,t=w.length}g=null,A=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(a)}}function b(a,t){this.fun=a,this.array=t}function r(){}I.nextTick=function(a){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];w.push(new b(a,t)),w.length!==1||A||$(p)},b.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(a){return[]},I.binding=function(a){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(a){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ce[123],Re([1,0,14,6]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function I(c){const h=c;return h?typeof h.read=="function":!1}e.$4d=I;function L(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$5d=L;function R(c){const h=c;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$6d=R;function $(c,h){return new g(c,h)}e.$7d=$;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const u=s.indexOf(i);u>=0&&s.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let s;for(;(s=c.read())!==null;)i.push(s);return h(i)}e.$8d=w;function A(c,h,i){const s=[];let u;for(;(u=c.read())!==null&&s.length<i;)s.push(u);return u===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$9d=A;function S(c,h){return new Promise((i,s)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?s(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$0d=S;function l(c,h,i){c.on("error",s=>{i?.isCancellationRequested||h.onError(s)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",s=>{i?.isCancellationRequested||h.onData(s)})}e.$$d=l;function p(c,h){return new Promise((i,s)=>{const u=new T.$Rc,d=[],m=F=>{if(d.push(F),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=F=>(u.dispose(),s(F)),k=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,T.$Qc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,T.$Qc)(()=>c.removeListener("end",k))),c.on("end",k),u.add((0,T.$Qc)(()=>c.removeListener("data",m))),c.on("data",m)})}e.$_d=p;function b(c,h){const i=$(h);return i.end(c),i}e.$ae=b;function r(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}e.$be=r;function a(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$ce=a;function t(c,h,i){const s=$(i);return l(c,{onData:u=>s.write(h.data(u)),onError:u=>s.error(h.error?h.error(u):u),onEnd:()=>s.end()}),s}e.$de=t;function n(c,h,i){let s=!1;return{read:()=>{const u=h.read();return s?u:(s=!0,u!==null?i([c,u]):c)}}}e.$ee=n;function o(c,h,i){let s=!1;const u=$(i);return l(h,{onData:d=>s?u.write(d):(s=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.$fe=o}),define(Ce[24],Re([1,0,39,123]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const I=typeof Buffer<"u",L=new E.$V(()=>new Uint8Array(256));let R,$;class g{static alloc(D){return I?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return I&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,N){return!(N?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(D)):(R||(R=new TextEncoder),new g(R.encode(D)))}static fromByteArray(D){const N=g.alloc(D.length);for(let O=0,W=D.length;O<W;O++)N.buffer[O]=D[O];return N}static concat(D,N){if(typeof N>"u"){N=0;for(let z=0,V=D.length;z<V;z++)N+=D[z].byteLength}const O=g.alloc(N);let W=0;for(let z=0,V=D.length;z<V;z++){const P=D[z];O.set(P,W),W+=P.byteLength}return O}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return I?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(D,N){return new g(this.buffer.subarray(D,N))}set(D,N){if(D instanceof g)this.buffer.set(D.buffer,N);else if(D instanceof Uint8Array)this.buffer.set(D,N);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),N);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,N){p(this.buffer,D,N)}readUInt32LE(D){return b(this.buffer,D)}writeUInt32LE(D,N){r(this.buffer,D,N)}readUInt8(D){return a(this.buffer,D)}writeUInt8(D,N){t(this.buffer,D,N)}indexOf(D,N=0){return w(this.buffer,D instanceof g?D.buffer:D,N)}}e.$ge=g;function w(y,D,N=0){const O=D.byteLength,W=y.byteLength;if(O===0)return 0;if(O===1)return y.indexOf(D[0]);if(O>W-N)return-1;const z=L.value;z.fill(D.length);for(let Z=0;Z<D.length;Z++)z[D[Z]]=D.length-Z-1;let V=N+D.length-1,P=V,C=-1;for(;V<W;)if(y[V]===D[P]){if(P===0){C=V;break}V--,P--}else V+=Math.max(D.length-P,z[y[V]]),P=D.length-1;return C}e.$he=w;function A(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}e.$ie=A;function S(y,D,N){y[N+0]=D&255,D=D>>>8,y[N+1]=D&255}e.$je=S;function l(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}e.$ke=l;function p(y,D,N){y[N+3]=D,D=D>>>8,y[N+2]=D,D=D>>>8,y[N+1]=D,D=D>>>8,y[N]=D}e.$le=p;function b(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}e.$me=b;function r(y,D,N){y[N+0]=D&255,D=D>>>8,y[N+1]=D&255,D=D>>>8,y[N+2]=D&255,D=D>>>8,y[N+3]=D&255}e.$ne=r;function a(y,D){return y[D]}e.$oe=a;function t(y,D,N){y[N]=D}e.$pe=t;function n(y){return T.$8d(y,D=>g.concat(D))}e.$qe=n;function o(y){return T.$ce(y)}e.$re=o;function c(y){return T.$0d(y,D=>g.concat(D))}e.$se=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$te=h;function i(y){return T.$ae(y,D=>g.concat(D))}e.$ue=i;function s(y){return T.$de(y,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}e.$ve=s;function u(y){return T.$7d(D=>g.concat(D),y)}e.$we=u;function d(y,D){return T.$ee(y,D,N=>g.concat(N))}e.$xe=d;function m(y,D){return T.$fe(y,D,N=>g.concat(N))}e.$ye=m;function f(y){let D=0,N=0,O=0;const W=new Uint8Array(Math.floor(y.length/4*3)),z=P=>{switch(N){case 3:W[O++]=D|P,N=0;break;case 2:W[O++]=D|P>>>2,D=P<<6,N=3;break;case 1:W[O++]=D|P>>>4,D=P<<4,N=2;break;default:D=P<<2,N=1}};for(let P=0;P<y.length;P++){const C=y.charCodeAt(P);if(C>=65&&C<=90)z(C-65);else if(C>=97&&C<=122)z(C-97+26);else if(C>=48&&C<=57)z(C-48+52);else if(C===43||C===45)z(62);else if(C===47||C===95)z(63);else{if(C===61)break;throw new SyntaxError(`Unexpected base64 character ${y[P]}`)}}const V=O;for(;N>0;)z(0);return g.wrap(W).slice(0,V)}e.$ze=f;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:y},D=!0,N=!1){const O=N?F:k;let W="";const z=y.byteLength%3;let V=0;for(;V<y.byteLength-z;V+=3){const P=y[V+0],C=y[V+1],Z=y[V+2];W+=O[P>>>2],W+=O[(P<<4|C>>>4)&63],W+=O[(C<<2|Z>>>6)&63],W+=O[Z&63]}if(z===1){const P=y[V+0];W+=O[P>>>2],W+=O[P<<4&63],D&&(W+="==")}else if(z===2){const P=y[V+0],C=y[V+1];W+=O[P>>>2],W+=O[(P<<4|C>>>4)&63],W+=O[C<<2&63],D&&(W+="=")}return W}e.$Ae=v}),define(Ce[124],Re([1,0,28,121,11]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function L(...le){return function(we,M){for(let K=0,H=le.length;K<H;K++){const U=le[K](we,M);if(U)return U}return null}}e.or=L,e.$Pj=R.bind(void 0,!1),e.$Qj=R.bind(void 0,!0);function R(le,we,M){if(!M||M.length<we.length)return null;let K;return le?K=I.$9e(M,we):K=M.indexOf(we)===0,K?we.length>0?[{start:0,end:we.length}]:[]:null}function $(le,we){const M=we.toLowerCase().indexOf(le.toLowerCase());return M===-1?null:[{start:M,end:M+le.length}]}e.$Rj=$;function g(le,we){return w(le.toLowerCase(),we.toLowerCase(),0,0)}e.$Sj=g;function w(le,we,M,K){if(M===le.length)return[];if(K===we.length)return null;if(le[M]===we[K]){let H=null;return(H=w(le,we,M+1,K+1))?c({start:K,end:K+1},H):null}return w(le,we,M,K+1)}function A(le){return 97<=le&&le<=122}function S(le){return 65<=le&&le<=90}e.$Tj=S;function l(le){return 48<=le&&le<=57}function p(le){return le===32||le===9||le===10||le===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>b.add(le.charCodeAt(0)));function r(le){return p(le)||b.has(le)}function a(le,we){return le===we||r(le)&&r(we)}const t=new Map;function n(le){if(t.has(le))return t.get(le);let we;const M=(0,T.$Nj)(le);return M&&(we=M),t.set(le,we),we}function o(le){return A(le)||S(le)||l(le)}function c(le,we){return we.length===0?we=[le]:le.end===we[0].start?we[0].start=le.start:we.unshift(le),we}function h(le,we){for(let M=we;M<le.length;M++){const K=le.charCodeAt(M);if(S(K)||l(K)||M>0&&!o(le.charCodeAt(M-1)))return M}return le.length}function i(le,we,M,K){if(M===le.length)return[];if(K===we.length)return null;if(le[M]!==we[K].toLowerCase())return null;{let H=null,U=K+1;for(H=i(le,we,M+1,K+1);!H&&(U=h(we,U))<we.length;)H=i(le,we,M+1,U),U++;return H===null?null:c({start:K,end:K+1},H)}}function s(le){let we=0,M=0,K=0,H=0,U=0;for(let We=0;We<le.length;We++)U=le.charCodeAt(We),S(U)&&we++,A(U)&&M++,o(U)&&K++,l(U)&&H++;const Q=we/le.length,X=M/le.length,ye=K/le.length,Te=H/le.length;return{upperPercent:Q,lowerPercent:X,alphaPercent:ye,numericPercent:Te}}function u(le){const{upperPercent:we,lowerPercent:M}=le;return M===0&&we>.6}function d(le){const{upperPercent:we,lowerPercent:M,alphaPercent:K,numericPercent:H}=le;return M>.2&&we<.8&&K>.6&&H<.2}function m(le){let we=0,M=0,K=0,H=0;for(let U=0;U<le.length;U++)K=le.charCodeAt(U),S(K)&&we++,A(K)&&M++,p(K)&&H++;return(we===0||M===0)&&H===0?le.length<=30:we<=5}function f(le,we){if(!we||(we=we.trim(),we.length===0)||!m(le)||we.length>60)return null;const M=s(we);if(!d(M)){if(!u(M))return null;we=we.toLowerCase()}let K=null,H=0;for(le=le.toLowerCase();H<we.length&&(K=i(le,we,0,H))===null;)H=h(we,H+1);return K}e.$Uj=f;function k(le,we,M=!1){if(!we||we.length===0)return null;let K=null,H=0;for(le=le.toLowerCase(),we=we.toLowerCase();H<we.length&&(K=F(le,we,0,H,M),K===null);)H=v(we,H+1);return K}e.$Vj=k;function F(le,we,M,K,H){let U=0;if(M===le.length)return[];if(K===we.length)return null;if(!a(le.charCodeAt(M),we.charCodeAt(K))){const ye=n(le.charCodeAt(M));if(!ye)return null;for(let Te=0;Te<ye.length;Te++)if(!a(ye[Te],we.charCodeAt(K+Te)))return null;U+=ye.length-1}let Q=null,X=K+U+1;if(Q=F(le,we,M+1,X,H),!H)for(;!Q&&(X=v(we,X))<we.length;)Q=F(le,we,M+1,X,H),X++;if(!Q)return null;if(le.charCodeAt(M)!==we.charCodeAt(K)){const ye=n(le.charCodeAt(M));if(!ye)return Q;for(let Te=0;Te<ye.length;Te++)if(ye[Te]!==we.charCodeAt(K+Te))return Q}return c({start:K,end:K+U+1},Q)}function v(le,we){for(let M=we;M<le.length;M++)if(r(le.charCodeAt(M))||M>0&&r(le.charCodeAt(M-1)))return M;return le.length}const y=L(e.$Qj,f,$),D=L(e.$Qj,f,g),N=new E.$Dc(1e4);function O(le,we,M=!1){if(typeof le!="string"||typeof we!="string")return null;let K=N.get(le);K||(K=new RegExp(I.$Re(le),"i"),N.set(le,K));const H=K.exec(we);return H?[{start:H.index,end:H.index+H[0].length}]:M?D(le,we):y(le,we)}e.$Wj=O;function W(le,we){const M=ae(le,le.toLowerCase(),0,we,we.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return M?V(M):null}e.$Xj=W;function z(le,we,M,K,H,U){const Q=Math.min(13,le.length);for(;M<Q;M++){const X=ae(le,we,M,K,H,U,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,U]}e.$Yj=z;function V(le){if(typeof le>"u")return[];const we=[],M=le[1];for(let K=le.length-1;K>1;K--){const H=le[K]+M,U=we[we.length-1];U&&U.end===H?U.end=H+1:we.push({start:H,end:H+1})}return we}e.$Zj=V;const P=128;function C(){const le=[],we=[];for(let M=0;M<=P;M++)we[M]=0;for(let M=0;M<=P;M++)le.push(we.slice(0));return le}function Z(le){const we=[];for(let M=0;M<=le;M++)we[M]=0;return we}const ce=Z(2*P),me=Z(2*P),be=C(),ke=C(),fe=C(),de=!1;function ie(le,we,M,K,H){function U(X,ye,Te=" "){for(;X.length<ye;)X=Te+X;return X}let Q=` |   |${K.split("").map(X=>U(X,3)).join("|")}
`;for(let X=0;X<=M;X++)X===0?Q+=" |":Q+=`${we[X-1]}|`,Q+=le[X].slice(0,H+1).map(ye=>U(ye.toString(),3)).join("|")+`
`;return Q}function Se(le,we,M,K){le=le.substr(we),M=M.substr(K),console.log(ie(ke,le,le.length,M,M.length)),console.log(ie(fe,le,le.length,M,M.length)),console.log(ie(be,le,le.length,M,M.length))}function oe(le,we){if(we<0||we>=le.length)return!1;const M=le.codePointAt(we);switch(M){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$of(M)}}function x(le,we){if(we<0||we>=le.length)return!1;switch(le.charCodeAt(we)){case 32:case 9:return!0;default:return!1}}function q(le,we,M){return we[le]!==M[le]}function ne(le,we,M,K,H,U,Q=!1){for(;we<M&&H<U;)le[we]===K[H]&&(Q&&(ce[we]=H),we+=1),H+=1;return we===M}e.$1j=ne;var Ie;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Ae;(function(le){le.Default=[-100,0];function we(M){return!M||M.length===2&&M[0]===-100&&M[1]===0}le.isDefault=we})(Ae||(e.FuzzyScore=Ae={}));class Pe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(we,M){this.firstMatchCanBeWeak=we,this.boostFullMatch=M}}e.$2j=Pe;function ae(le,we,M,K,H,U,Q=Pe.default){const X=le.length>P?P:le.length,ye=K.length>P?P:K.length;if(M>=X||U>=ye||X-M>ye-U||!ne(we,M,X,H,U,ye,!0))return;te(X,ye,M,U,we,H);let Te=1,We=1,He=M,Ye=U;const st=[!1];for(Te=1,He=M;He<X;Te++,He++){const ze=ce[He],vt=me[He],Y=He+1<X?me[He+1]:ye;for(We=ze-U+1,Ye=ze;Ye<Y;We++,Ye++){let _=Number.MIN_SAFE_INTEGER,pe=!1;Ye<=vt&&(_=J(le,we,He,M,K,H,Ye,ye,U,be[Te-1][We-1]===0,st));let Be=0;_!==Number.MAX_SAFE_INTEGER&&(pe=!0,Be=_+ke[Te-1][We-1]);const Qe=Ye>ze,it=Qe?ke[Te][We-1]+(be[Te][We-1]>0?-5:0):0,rt=Ye>ze+1&&be[Te][We-1]>0,Ne=rt?ke[Te][We-2]+(be[Te][We-2]>0?-5:0):0;if(rt&&(!Qe||Ne>=it)&&(!pe||Ne>=Be))ke[Te][We]=Ne,fe[Te][We]=3,be[Te][We]=0;else if(Qe&&(!pe||it>=Be))ke[Te][We]=it,fe[Te][We]=2,be[Te][We]=0;else if(pe)ke[Te][We]=Be,fe[Te][We]=1,be[Te][We]=be[Te-1][We-1]+1;else throw new Error("not possible")}}if(de&&Se(le,M,K,U),!st[0]&&!Q.firstMatchCanBeWeak)return;Te--,We--;const nt=[ke[Te][We],U];let tt=0,at=0;for(;Te>=1;){let ze=We;do{const vt=fe[Te][ze];if(vt===3)ze=ze-2;else if(vt===2)ze=ze-1;else break}while(ze>=1);tt>1&&we[M+Te-1]===H[U+We-1]&&!q(ze+U-1,K,H)&&tt+1>be[Te][ze]&&(ze=We),ze===We?tt++:tt=1,at||(at=ze),Te--,We=ze-1,nt.push(We)}ye===X&&Q.boostFullMatch&&(nt[0]+=2);const ct=at-X;return nt[0]-=ct,nt}e.$3j=ae;function te(le,we,M,K,H,U){let Q=le-1,X=we-1;for(;Q>=M&&X>=K;)H[Q]===U[X]&&(me[Q]=X,Q--),X--}function J(le,we,M,K,H,U,Q,X,ye,Te,We){if(we[M]!==U[Q])return Number.MIN_SAFE_INTEGER;let He=1,Ye=!1;return Q===M-K?He=le[M]===H[Q]?7:5:q(Q,H,U)&&(Q===0||!q(Q-1,H,U))?(He=le[M]===H[Q]?7:5,Ye=!0):oe(U,Q)&&(Q===0||!oe(U,Q-1))?He=5:(oe(U,Q-1)||x(U,Q-1))&&(He=5,Ye=!0),He>1&&M===K&&(We[0]=!0),Ye||(Ye=q(Q,H,U)||oe(U,Q-1)||x(U,Q-1)),M===K?Q>ye&&(He-=Ye?3:5):Te?He+=Ye?2:0:He+=Ye?0:1,Q+1===X&&(He-=Ye?3:5),He}function ee(le,we,M,K,H,U,Q){return ve(le,we,M,K,H,U,!0,Q)}e.$4j=ee;function $e(le,we,M,K,H,U,Q){return ve(le,we,M,K,H,U,!1,Q)}e.$5j=$e;function ve(le,we,M,K,H,U,Q,X){let ye=ae(le,we,M,K,H,U,X);if(ye&&!Q)return ye;if(le.length>=3){const Te=Math.min(7,le.length-1);for(let We=M+1;We<Te;We++){const He=Fe(le,We);if(He){const Ye=ae(He,He.toLowerCase(),M,K,H,U,X);Ye&&(Ye[0]-=3,(!ye||Ye[0]>ye[0])&&(ye=Ye))}}}return ye}function Fe(le,we){if(we+1>=le.length)return;const M=le[we],K=le[we+1];if(M!==K)return le.slice(0,we)+K+M+le.slice(we+2)}}),define(Ce[31],Re([1,0,11]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(T||(T={})),function(I){const L="error",R="warning",$="warn",g="info",w="ignore";function A(l){return l?E.$8e(L,l)?I.Error:E.$8e(R,l)||E.$8e($,l)?I.Warning:E.$8e(g,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function S(l){switch(l){case I.Error:return L;case I.Warning:return R;case I.Info:return g;default:return w}}I.toString=S}(T||(T={})),e.default=T}),define(Ce[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Ce[50],Re([1,0,18,11]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class I{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const b=p.charCodeAt(0),r=this.b.charCodeAt(this.c);return b-r}value(){return this.b[this.c]}}e.$4h=I;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$2e)(p,this.b,0,p.length,this.c,this.d):(0,T.$4e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=L;class R{constructor(p=!0,b=!0){this.f=p,this.g=b}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let b=p.length-1;b>=0;b--,this.c--){const r=this.b.charCodeAt(b);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$2e)(p,this.b,0,p.length,this.d,this.e):(0,T.$4e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=R;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class g{constructor(p,b){this.f=p,this.g=b,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$3e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$3e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$1e)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$1e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class S{static forUris(p=()=>!1,b=()=>!1){return new S(new g(p,b))}static forPaths(p=!1){return new S(new R(void 0,!p))}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,b){if(b){const r=b.slice(0);(0,E.$Xb)(r);for(const a of r)this.set(a,p)}else{const r=p.slice(0);(0,E.$Xb)(r);for(const a of r)this.set(a[0],a[1])}}set(p,b){const r=this.b.reset(p);let a;this.c||(this.c=new w,this.c.segment=r.value());const t=[];for(a=this.c;;){const o=r.cmp(a.segment);if(o>0)a.left||(a.left=new w,a.left.segment=r.value()),t.push([-1,a]),a=a.left;else if(o<0)a.right||(a.right=new w,a.right.segment=r.value()),t.push([1,a]),a=a.right;else if(r.hasNext())r.next(),a.mid||(a.mid=new w,a.mid.segment=r.value()),t.push([0,a]),a=a.mid;else break}const n=a.value;a.value=b,a.key=p;for(let o=t.length-1;o>=0;o--){const c=t[o][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[o][0],s=t[o+1][0];if(i===1&&s===1)t[o][1]=c.rotateLeft();else if(i===-1&&s===-1)t[o][1]=c.rotateRight();else if(i===1&&s===-1)c.right=t[o+1][1]=t[o+1][1].rotateRight(),t[o][1]=c.rotateLeft();else if(i===-1&&s===1)c.left=t[o+1][1]=t[o+1][1].rotateLeft(),t[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(t[o-1][0]){case-1:t[o-1][1].left=t[o][1];break;case 1:t[o-1][1].right=t[o][1];break;case 0:t[o-1][1].mid=t[o][1];break}else this.c=t[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const b=this.b.reset(p);let r=this.c;for(;r;){const a=b.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(b.hasNext())b.next(),r=r.mid;else break}return r}has(p){const b=this.d(p);return!(b?.value===void 0&&b?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,b){const r=this.b.reset(p),a=[];let t=this.c;for(;t;){const n=r.cmp(t.segment);if(n>0)a.push([-1,t]),t=t.left;else if(n<0)a.push([1,t]),t=t.right;else if(r.hasNext())r.next(),a.push([0,t]),t=t.mid;else break}if(t){if(b?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:o,value:c,segment:h}=n;this.e(n.key,!1),t.key=o,t.value=c,t.segment=h}}else{const n=t.left??t.right;if(a.length>0){const[o,c]=a[a.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const o=a[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),a[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),a[n][1]=o.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const b=this.b.reset(p);let r=this.c,a;for(;r;){const t=b.cmp(r.segment);if(t>0)r=r.left;else if(t<0)r=r.right;else if(b.hasNext())b.next(),a=r.value||a,r=r.mid;else break}return r&&r.value||a}findSuperstr(p){return this.g(p,!1)}g(p,b){const r=this.b.reset(p);let a=this.c;for(;a;){const t=r.cmp(a.segment);if(t>0)a=a.left;else if(t<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this.h(a.mid):b?a.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[b,r]of this)p(r,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const b=[];return this.j(p,b),b[Symbol.iterator]()}j(p,b){p&&(p.left&&this.j(p.left,b),p.value&&b.push([p.key,p.value]),p.mid&&this.j(p.mid,b),p.right&&this.j(p.right,b))}_isBalanced(){const p=b=>{if(!b)return!0;const r=b.balanceFactor();return r<-1||r>1?!1:p(b.left)&&p(b.right)};return p(this.c)}}e.$8h=S}),define(Ce[45],Re([1,0,90]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var T;(function(R){function $(g){return g&&typeof g=="object"&&typeof g.id=="string"}R.isThemeColor=$})(T||(e.ThemeColor=T={}));function I(R){return{id:R}}e.$9j=I;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function g(n){const o=$.exec(n.id);if(!o)return g(E.$8j.error);const[,c,h]=o,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}R.asClassNameArray=g;function w(n){return g(n).join(" ")}R.asClassName=w;function A(n){return"."+g(n).join(".")}R.asCSSSelector=A;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}R.isThemeIcon=S;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(n){const o=l.exec(n);if(!o)return;const[,c]=o;return{id:c}}R.fromString=p;function b(n){return{id:n}}R.fromId=b;function r(n,o){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),o&&(c=`${c}~${o}`),{id:c}}R.modify=r;function a(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}R.getModifier=a;function t(n,o){return n.id===o.id&&n.color?.id===o.color?.id}R.isEqual=t})(L||(e.ThemeIcon=L={}))}),define(Ce[126],Re([1,0,124,11,45]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const L="$(",R=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function g(t){return t.replace($,(n,o)=>o?n:`\\${n}`)}e.$0j=g;const w=new RegExp(`\\\\${R.source}`,"g");function A(t){return t.replace(w,n=>`\\${n}`)}e.$$j=A;const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(t){return t.indexOf(L)===-1?t:t.replace(S,(n,o,c,h)=>c?n:o||h||"")}e.$_j=l;function p(t){return t?t.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$ak=p;const b=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(t){b.lastIndex=0;let n="";const o=[];let c=0;for(;;){const h=b.lastIndex,i=b.exec(t),s=t.substring(h,i?.index);if(s.length>0){n+=s;for(let u=0;u<s.length;u++)o.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:o}}e.$bk=r;function a(t,n,o=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,E.$Wj)(t,c,o);const i=(0,T.$Pe)(c," "),s=c.length-i.length,u=(0,E.$Wj)(t,i,o);if(u)for(const d of u){const m=h[d.start+s]+s;d.start+=m,d.end+=m}return u}e.$ck=a}),define(Ce[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(I){return E.test(I)}e.$lg=T,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function($){for(let g=0;g<$.length;g++)$[g]=Math.floor(Math.random()*256);return $};const L=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){I(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let g=0,w="";return w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+="-",w+=R[L[g++]],w+=R[L[g++]],w+="-",w+=R[L[g++]],w+=R[L[g++]],w+="-",w+=R[L[g++]],w+=R[L[g++]],w+="-",w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w}}()}),define(Ce[127],Re([1,0,18,67,33]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.$at=void 0;function L(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$at=L;function R(S,l,p){const b={id:(0,I.$mg)(),name:S,uri:l,data:p};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$bt=R;class ${constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return T.Iterable.some(this,([b,r])=>r.asFile())&&p.push("files"),A(g(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const b=this.a.get(l);b?b.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const b of p)yield[l,b]}b(l){return g(l)}}e.$ct=$;function g(S){return S.toLowerCase()}function w(S,l){return A(g(S),l.map(g))}e.$dt=w;function A(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const p=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[b,r,a]=p;return a==="*"?l.some(t=>t.startsWith(r+"/")):!1}e.$et=Object.freeze({create:S=>(0,E.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$et.split(S).filter(l=>!l.startsWith("#"))})}),define(Ce[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.StringEOL=void 0;var E;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(I){let L=0,R=0,$=0,g=0;for(let w=0,A=I.length;w<A;w++){const S=I.charCodeAt(w);S===13?(L===0&&(R=w),L++,w+1<A&&I.charCodeAt(w+1)===10?(g|=2,w++):g|=3,$=w+1):S===10&&(g|=1,L===0&&(R=w),L++,$=w+1)}return L===0&&(R=I.length),[L,R,I.length-$,g]}e.$ht=T}),define(Ce[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,e.$es={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let g=0,w=$.notIn.length;g<w;g++)switch($.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,g){if($.getTokenCount()===0)return!0;const w=$.findTokenIndexAtOffset(g-2),A=$.getStandardTokenType(w);return this.isOK(A)}g($,g){for(let w=$;w<=g;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Et=T;class I{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of $)L(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),L(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),L(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),L(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&L(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Ft=I;function L(R,$,g){R.has($)?R.get($).push(g):R.set($,[g])}}),define(Ce[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=e.NodeColor=e.$DB=void 0;class E{constructor(a,t){this.piece=a,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$EB)return I(this.right);let a=this;for(;a.parent!==e.$EB&&a.parent.left!==a;)a=a.parent;return a.parent===e.$EB?e.$EB:a.parent}prev(){if(this.left!==e.$EB)return L(this.left);let a=this;for(;a.parent!==e.$EB&&a.parent.right!==a;)a=a.parent;return a.parent===e.$EB?e.$EB:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$DB=E;var T;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$EB=new E(null,0),e.$EB.parent=e.$EB,e.$EB.left=e.$EB,e.$EB.right=e.$EB,e.$EB.color=0;function I(r){for(;r.left!==e.$EB;)r=r.left;return r}e.$FB=I;function L(r){for(;r.right!==e.$EB;)r=r.right;return r}e.$GB=L;function R(r){return r===e.$EB?0:r.size_left+r.piece.length+R(r.right)}function $(r){return r===e.$EB?0:r.lf_left+r.piece.lineFeedCnt+$(r.right)}function g(){e.$EB.parent=e.$EB}function w(r,a){const t=a.right;t.size_left+=a.size_left+(a.piece?a.piece.length:0),t.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=t.left,t.left!==e.$EB&&(t.left.parent=a),t.parent=a.parent,a.parent===e.$EB?r.root=t:a.parent.left===a?a.parent.left=t:a.parent.right=t,t.left=a,a.parent=t}e.$HB=w;function A(r,a){const t=a.left;a.left=t.right,t.right!==e.$EB&&(t.right.parent=a),t.parent=a.parent,a.size_left-=t.size_left+(t.piece?t.piece.length:0),a.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),a.parent===e.$EB?r.root=t:a===a.parent.right?a.parent.right=t:a.parent.left=t,t.right=a,a.parent=t}e.$IB=A;function S(r,a){let t,n;if(a.left===e.$EB?(n=a,t=n.right):a.right===e.$EB?(n=a,t=n.left):(n=I(a.right),t=n.right),n===r.root){r.root=t,t.color=0,a.detach(),g(),r.root.parent=e.$EB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===a?(t.parent=n.parent,b(r,t)):(n.parent===a?t.parent=n:t.parent=n.parent,b(r,t),n.left=a.left,n.right=a.right,n.parent=a.parent,n.color=a.color,a===r.root?r.root=n:a===a.parent.left?a.parent.left=n:a.parent.right=n,n.left!==e.$EB&&(n.left.parent=n),n.right!==e.$EB&&(n.right.parent=n),n.size_left=a.size_left,n.lf_left=a.lf_left,b(r,n)),a.detach(),t.parent.left===t){const h=R(t),i=$(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const s=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,p(r,t.parent,s,u)}}if(b(r,t.parent),o){g();return}let c;for(;t!==r.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(r,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(r,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(r,t.parent),t=r.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(r,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(r,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(r,t.parent),t=r.root));t.color=0,g()}e.$JB=S;function l(r,a){for(b(r,a);a!==r.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const t=a.parent.parent.right;t.color===1?(a.parent.color=0,t.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,w(r,a)),a.parent.color=0,a.parent.parent.color=1,A(r,a.parent.parent))}else{const t=a.parent.parent.left;t.color===1?(a.parent.color=0,t.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,A(r,a)),a.parent.color=0,a.parent.parent.color=1,w(r,a.parent.parent))}r.root.color=0}e.$KB=l;function p(r,a,t,n){for(;a!==r.root&&a!==e.$EB;)a.parent.left===a&&(a.parent.size_left+=t,a.parent.lf_left+=n),a=a.parent}e.$LB=p;function b(r,a){let t=0,n=0;if(a!==r.root){for(;a!==r.root&&a===a.parent.right;)a=a.parent;if(a!==r.root)for(a=a.parent,t=R(a.left)-a.size_left,n=$(a.left)-a.lf_left,a.size_left+=t,a.lf_left+=n;a!==r.root&&(t!==0||n!==0);)a.parent.left===a&&(a.parent.size_left+=t,a.parent.lf_left+=n),a=a.parent}}e.$MB=b}),define(Ce[91],Re([1,0,92,29,93,131,94]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=void 0;const $=65535;function g(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class w{constructor(n,o,c,h,i){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function A(t,n=!0){const o=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const s=t.charCodeAt(h);s===13?h+1<i&&t.charCodeAt(h+1)===10?(o[c++]=h+2,h++):o[c++]=h+1:s===10&&(o[c++]=h+1)}return n?g(o):o}e.$TB=A;function S(t,n){t.length=0,t[0]=0;let o=1,c=0,h=0,i=0,s=!0;for(let d=0,m=n.length;d<m;d++){const f=n.charCodeAt(d);f===13?d+1<m&&n.charCodeAt(d+1)===10?(i++,t[o++]=d+2,d++):(c++,t[o++]=d+1):f===10?(h++,t[o++]=d+1):s&&f!==9&&(f<32||f>126)&&(s=!1)}const u=new w(g(t),c,h,i,s);return t.length=0,u}e.$UB=S;class l{constructor(n,o,c,h,i){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$VB=l;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$WB=p;class b{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==L.$EB&&n.iterate(n.root,c=>(c!==L.$EB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,o=!0;continue}}if(o){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class a{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=L.$EB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let h=null;for(let i=0,s=n.length;i<s;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,u)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,c=o-Math.floor(o/3),h=c*2;let i="",s=0;const u=[];if(this.iterate(this.root,d=>{const m=this.R(d),f=m.length;if(s<=c||s+f<h)return i+=m,s+=f,!0;const k=i.replace(/\r\n|\r|\n/g,n);return u.push(new p(k,A(k))),i=m,s=f,!0}),s>0){const d=i.replace(/\r\n|\r|\n/g,n);u.push(new p(d,A(d)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new b(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,h=>{if(h===L.$EB)return!0;const i=this.R(h),s=i.length,u=n.G(o),d=n.G(o+s),m=n.getValueInRange2(u,d);return o+=s,i===m})}getOffsetAt(n,o){let c=0,h=this.root;for(;h!==L.$EB;)if(h.left!==L.$EB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+o-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const h=n;for(;o!==L.$EB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const i=this.A(o,n-o.size_left);if(c+=o.lf_left+i.index,i.index===0){const s=this.getOffsetAt(c+1,1),u=h-s;return new E.$Gs(c+1,u+1)}return new E.$Gs(c+1,i.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===L.$EB){const i=this.getOffsetAt(c+1,1),s=h-n-i;return new E.$Gs(c+1,s+1)}else o=o.right;return new E.$Gs(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return o?o!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,o):i}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,d=this.a[u.piece.bufferIndex].buffer,m=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(m+n.remainder,m+o.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let s=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==L.$EB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){s+=u.substring(d,d+o.remainder);break}else s+=u.substr(d,c.piece.length);c=c.next()}return s}getLinesContent(){const n=[];let o=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===L.$EB)return!0;const s=i.piece;let u=s.length;if(u===0)return!0;const d=this.a[s.bufferIndex].buffer,m=this.a[s.bufferIndex].lineStarts,f=s.start.line,k=s.end.line;let F=m[f]+s.start.column;if(h&&(d.charCodeAt(F)===10&&(F++,u--),n[o++]=c,c="",h=!1,u===0))return!0;if(f===k)return!this.f&&d.charCodeAt(F+u-1)===13?(h=!0,c+=d.substr(F,u-1)):c+=d.substr(F,u),!0;c+=this.f?d.substring(F,Math.max(F,m[f+1]-this.e)):d.substring(F,m[f+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let v=f+1;v<k;v++)c=this.f?d.substring(m[v],m[v+1]-this.e):d.substring(m[v],m[v+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&d.charCodeAt(m[k]+s.end.column-1)===13?(h=!0,s.end.column===0?o--:c=d.substr(m[k],s.end.column-1)):c=d.substr(m[k],s.end.column),!0}),h&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],h=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(h)}else{const o=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(h)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,h,i,s,u,d,m,f,k){const F=this.a[n.piece.bufferIndex],v=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),D=this.u(n.piece.bufferIndex,s);let N;const O={line:0,column:0};let W,z;o._wordSeparators?(W=F.buffer.substring(y,D),z=V=>V+y,o.reset(0)):(W=F.buffer,z=V=>V,o.reset(y));do if(N=o.next(W),N){if(z(N.index)>=D)return f;this.s(n,z(N.index)-v,O);const V=this.t(n.piece.bufferIndex,i,O),P=O.line===i.line?O.column-i.column+h:O.column+1,C=P+N[0].length;if(k[f++]=(0,R.$PB)(new T.$Hs(c+V,P,c+V,C),N,d),z(N.index)+N[0].length>=D||f>=m)return f}while(N);return f}findMatchesLineByLine(n,o,c,h){const i=[];let s=0;const u=new R.$SB(o.wordSeparators,o.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const m=this.H(n.endLineNumber,n.endColumn);if(m===null)return[];let f=this.s(d.node,d.remainder);const k=this.s(m.node,m.remainder);if(d.node===m.node)return this.findMatchesInNode(d.node,u,n.startLineNumber,n.startColumn,f,k,o,c,h,s,i),i;let F=n.startLineNumber,v=d.node;for(;v!==m.node;){const D=this.t(v.piece.bufferIndex,f,v.piece.end);if(D>=1){const O=this.a[v.piece.bufferIndex].lineStarts,W=this.u(v.piece.bufferIndex,v.piece.start),z=O[f.line+D],V=F===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode(v,u,F,V,f,this.s(v,z-W),o,c,h,s,i),s>=h)return i;F+=D}const N=F===n.startLineNumber?n.startColumn-1:0;if(F===n.endLineNumber){const O=this.getLineContent(F).substring(N,n.endColumn-1);return s=this.n(o,u,O,n.endLineNumber,N,s,i,c,h),i}if(s=this.n(o,u,this.getLineContent(F).substr(N),F,N,s,i,c,h),s>=h)return i;F++,d=this.H(F,1),v=d.node,f=this.s(d.node,d.remainder)}if(F===n.endLineNumber){const D=F===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(F).substring(D,n.endColumn-1);return s=this.n(o,u,N,n.endLineNumber,D,s,i,c,h),i}const y=F===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(m.node,u,F,y,f,k,o,c,h,s,i),i}n(n,o,c,h,i,s,u,d,m){const f=n.wordSeparators;if(!d&&n.simpleSearch){const F=n.simpleSearch,v=F.length,y=c.length;let D=-v;for(;(D=c.indexOf(F,D+v))!==-1;)if((!f||(0,R.$RB)(f,c,y,D,v))&&(u[s++]=new I.$Zu(new T.$Hs(h,D+1+i,h,D+1+v+i),null),s>=m))return s;return s}let k;o.reset(0);do if(k=o.next(c),k&&(u[s++]=(0,R.$PB)(new T.$Hs(h,k.index+1+i,h,k.index+1+k[0].length+i),k,d),s>=m))return s;while(k);return s}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==L.$EB){const{node:h,remainder:i,nodeStartOffset:s}=this.G(n),u=h.piece,d=u.bufferIndex,m=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&s+u.length===n&&o.length<$){this.F(h,o),this.y();return}if(s===n)this.o(o,h),this.h.validate(n);else if(s+h.piece.length>n){const f=[];let k=new l(u.bufferIndex,m,u.end,this.t(u.bufferIndex,m,u.end),this.u(d,u.end)-this.u(d,m));if(this.K()&&this.M(o)&&this.I(h,i)===10){const D={line:k.start.line+1,column:0};k=new l(k.bufferIndex,D,k.end,this.t(k.bufferIndex,D,k.end),k.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(h,i-1)===13){const D=this.s(h,i-1);this.C(h,D),o="\r"+o,h.piece.length===0&&f.push(h)}else this.C(h,m);else this.C(h,m);const F=this.w(o);k.length>0&&this.S(h,k);let v=h;for(let y=0;y<F.length;y++)v=this.S(v,F[y]);this.v(f)}else this.q(o,h)}else{const h=this.w(o);let i=this.T(null,h[0]);for(let s=1;s<h.length;s++)i=this.S(i,h[s])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===L.$EB)return;const c=this.G(n),h=this.G(n+o),i=c.node,s=h.node;if(i===s){const F=this.s(i,c.remainder),v=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(o===i.piece.length){const y=i.next();(0,L.$JB)(this,i),this.N(y),this.y();return}this.D(i,v),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+o){this.C(i,F),this.O(i),this.y();return}this.E(i,F,v),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(n),i.piece.length===0&&u.push(i);const m=this.s(s,h.remainder);this.D(s,m),s.piece.length===0&&u.push(s);const f=i.next();for(let F=f;F!==L.$EB&&F!==s;F=F.next())u.push(F);const k=i.piece.length===0?i.prev():i;this.v(u),this.O(k),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const s=o.piece,u={line:s.start.line+1,column:0},d=new l(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),s.length-1);o.piece=d,n+=`
`,(0,L.$LB)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const h=this.w(n);let i=this.T(o,h[h.length-1]);for(let s=h.length-2;s>=0;s--)i=this.T(i,h[s]);this.N(i),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),h=this.S(o,c[0]);let i=h;for(let s=1;s<c.length;s++)i=this.S(i,c[s]);this.N(h)}s(n,o,c){const h=n.piece,i=n.piece.bufferIndex,s=this.a[i].lineStarts,d=s[h.start.line]+h.start.column+o;let m=h.start.line,f=h.end.line,k=0,F=0,v=0;for(;m<=f&&(k=m+(f-m)/2|0,v=s[k],k!==f);)if(F=s[k+1],d<v)f=k-1;else if(d>=F)m=k+1;else break;return c?(c.line=k,c.column=d-v,null):{line:k,column:d-v}}t(n,o,c){if(c.column===0)return c.line-o.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-o.line;const i=h[c.line+1],s=h[c.line]+c.column;if(i>s+1)return c.line-o.line;const u=s-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,L.$JB)(this,n[o])}w(n){if(n.length>$){const f=[];for(;n.length>$;){const F=n.charCodeAt($-1);let v;F===13||F>=55296&&F<=56319?(v=n.substring(0,$-1),n=n.substring($-1)):(v=n.substring(0,$),n=n.substring($));const y=A(v);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:v.length-y[y.length-1]},y.length-1,v.length)),this.a.push(new p(v,y))}const k=A(n);return f.push(new l(this.a.length,{line:0,column:0},{line:k.length-1,column:n.length-k[k.length-1]},k.length-1,n.length)),this.a.push(new p(n,k)),f}let o=this.a[0].buffer.length;const c=A(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let f=0;f<c.length;f++)c[f]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[s],d={line:s,column:u},m=new l(0,h,d,this.t(0,h,d),i-o);return this.g=d,[m]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const s=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=u.substring(d+s,d+c.piece.length);else{const m=this.B(c,n-i.nodeStartLineNumber);return u.substring(d+s,d+m-o)}}else{let s=0;const u=n;for(;c!==L.$EB;)if(c.left!==L.$EB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),m=this.B(c,n-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,k=this.u(c.piece.bufferIndex,c.piece.start);return s+=c.size_left,this.h.set({node:c,nodeStartOffset:s,nodeStartLineNumber:u-(n-1-c.lf_left)}),f.substring(k+d,k+m-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),m=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=m.substring(f+d,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==L.$EB;){const s=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=s.substring(d,d+u-o),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=s.substr(u,c.piece.length)}c=c.next()}return h}y(){let n=this.root,o=1,c=0;for(;n!==L.$EB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,h=this.s(n,o),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const s=this.t(n.piece.bufferIndex,c.start,h);if(s!==i)return{index:s,remainder:0}}return{index:i,remainder:h.column}}B(n,o){if(o<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+o+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,o){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),s=o,u=this.u(c.bufferIndex,s),d=this.t(c.bufferIndex,c.start,s),m=d-h,f=u-i,k=c.length+f;n.piece=new l(c.bufferIndex,c.start,s,d,k),(0,L.$LB)(this,n,f,m)}D(n,o){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),s=o,u=this.t(c.bufferIndex,s,c.end),d=this.u(c.bufferIndex,s),m=u-h,f=i-d,k=c.length+f;n.piece=new l(c.bufferIndex,s,c.end,u,k),(0,L.$LB)(this,n,f,m)}E(n,o,c){const h=n.piece,i=h.start,s=h.end,u=h.length,d=h.lineFeedCnt,m=o,f=this.t(h.bufferIndex,h.start,m),k=this.u(h.bufferIndex,o)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,m,f,k),(0,L.$LB)(this,n,k-u,f-d);const F=new l(h.bufferIndex,c,s,this.t(h.bufferIndex,c,s),this.u(h.bufferIndex,s)-this.u(h.bufferIndex,c)),v=this.S(n,F);this.N(v)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=o;const i=A(o,!1);for(let v=0;v<i.length;v++)i[v]+=h;if(c){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const s=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:u},m=n.piece.length+o.length,f=n.piece.lineFeedCnt,k=this.t(0,n.piece.start,d),F=k-f;n.piece=new l(n.piece.bufferIndex,n.piece.start,d,k,m),this.g=d,(0,L.$LB)(this,n,o.length,F)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;o!==L.$EB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){h+=o.size_left;const i={node:o,remainder:n-o.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=o.size_left+o.piece.length,h+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,h=0;for(;c!==L.$EB;)if(c.left!==L.$EB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),s=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+o-1,s),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+o-1<=c.piece.length)return{node:c,remainder:i+o-1,nodeStartOffset:h};o-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==L.$EB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),s=this.J(c);return{node:c,remainder:Math.min(o-1,i),nodeStartOffset:s}}else if(c.piece.length>=o-1){const i=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:i}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.$EB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,h=o.start.line,i=c[h]+o.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.$EB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,s),(0,L.$LB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:o.piece.start.line+1,column:0},m=o.piece.length-1,f=this.t(o.piece.bufferIndex,d,o.piece.end);o.piece=new l(o.piece.bufferIndex,d,o.piece.end,f,m),(0,L.$LB)(this,o,-1,-1),o.piece.length===0&&c.push(o);const k=this.w(`\r
`);this.S(n,k[0]);for(let F=0;F<c.length;F++)(0,L.$JB)(this,c[F])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,L.$JB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},s=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,s),(0,L.$LB)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===L.$EB)return o(L.$EB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===L.$EB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return o.buffer.substring(h,i)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,h)}S(n,o){const c=new L.$DB(o,1);if(c.left=L.$EB,c.right=L.$EB,c.parent=L.$EB,c.size_left=0,c.lf_left=0,this.root===L.$EB)this.root=c,c.color=0;else if(n.right===L.$EB)n.right=c,c.parent=n;else{const i=(0,L.$FB)(n.right);i.left=c,c.parent=i}return(0,L.$KB)(this,c),c}T(n,o){const c=new L.$DB(o,1);if(c.left=L.$EB,c.right=L.$EB,c.parent=L.$EB,c.size_left=0,c.lf_left=0,this.root===L.$EB)this.root=c,c.color=0;else if(n.left===L.$EB)n.left=c,c.parent=n;else{const h=(0,L.$GB)(n.left);h.right=c,c.parent=h}return(0,L.$KB)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$XB=a}),define(Ce[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7=e.$07=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$07=E;class T{constructor(L){this.identifier=L}}e.$$7=T}),define(Ce[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Ce[134],Re([1,0,5,6,133]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class L extends T.$Sc{constructor(l,p="",b="",r=!0,a){super(),this.h=this.B(new E.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=b,this.w=r,this.C=a}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Gi=L;class R extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new E.$Sd),this.onWillRun=this.f.event,this.m=this.B(new E.$Sd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let b;try{await this.u(l,p)}catch(r){b=r}this.m.fire({action:l,error:b})}async u(l,p){await l.run(p)}}e.$Hi=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const b of l)b.length&&(p.length?p=[...p,new $,...b]:p=b);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Ii=$;class g{get actions(){return this.a}constructor(l,p,b,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=r,this.a=b}async run(){}}e.$Ji=g;class w extends L{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,I.localize(0,null),void 0,!1)}}e.$Ki=w;function A(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...l)=>S.run(...l),tooltip:S.label}}e.$Li=A}),define(Ce[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Ce[136],Re([1,0,135]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0;const T=60,I=T*60,L=I*24,R=L*7,$=L*30,g=L*365;function w(S,l,p,b){typeof S!="number"&&(S=S.getTime());const r=Math.round((new Date().getTime()-S)/1e3);if(r<-30)return(0,E.localize)(0,null,w(new Date().getTime()+r*1e3,!1));if(!b&&r<30)return(0,E.localize)(1,null);let a;return r<T?(a=r,l?a===1?p?(0,E.localize)(2,null,a):(0,E.localize)(3,null,a):p?(0,E.localize)(4,null,a):(0,E.localize)(5,null,a):a===1?p?(0,E.localize)(6,null,a):(0,E.localize)(7,null,a):p?(0,E.localize)(8,null,a):(0,E.localize)(9,null,a)):r<I?(a=Math.floor(r/T),l?a===1?p?(0,E.localize)(10,null,a):(0,E.localize)(11,null,a):p?(0,E.localize)(12,null,a):(0,E.localize)(13,null,a):a===1?p?(0,E.localize)(14,null,a):(0,E.localize)(15,null,a):p?(0,E.localize)(16,null,a):(0,E.localize)(17,null,a)):r<L?(a=Math.floor(r/I),l?a===1?p?(0,E.localize)(18,null,a):(0,E.localize)(19,null,a):p?(0,E.localize)(20,null,a):(0,E.localize)(21,null,a):a===1?p?(0,E.localize)(22,null,a):(0,E.localize)(23,null,a):p?(0,E.localize)(24,null,a):(0,E.localize)(25,null,a)):r<R?(a=Math.floor(r/L),l?a===1?(0,E.localize)(26,null,a):(0,E.localize)(27,null,a):a===1?(0,E.localize)(28,null,a):(0,E.localize)(29,null,a)):r<$?(a=Math.floor(r/R),l?a===1?p?(0,E.localize)(30,null,a):(0,E.localize)(31,null,a):p?(0,E.localize)(32,null,a):(0,E.localize)(33,null,a):a===1?p?(0,E.localize)(34,null,a):(0,E.localize)(35,null,a):p?(0,E.localize)(36,null,a):(0,E.localize)(37,null,a)):r<g?(a=Math.floor(r/$),l?a===1?p?(0,E.localize)(38,null,a):(0,E.localize)(39,null,a):p?(0,E.localize)(40,null,a):(0,E.localize)(41,null,a):a===1?p?(0,E.localize)(42,null,a):(0,E.localize)(43,null,a):p?(0,E.localize)(44,null,a):(0,E.localize)(45,null,a)):(a=Math.floor(r/g),l?a===1?p?(0,E.localize)(46,null,a):(0,E.localize)(47,null,a):p?(0,E.localize)(48,null,a):(0,E.localize)(49,null,a):a===1?p?(0,E.localize)(50,null,a):(0,E.localize)(51,null,a):p?(0,E.localize)(52,null,a):(0,E.localize)(53,null,a))}e.$rm=w;function A(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$sm=A}),define(Ce[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Ce[40],Re([1,0,18,16,137]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function L(S,l){return l&&(S.stack||S.stacktrace)?I.localize(0,null,$(S),R(S.stack)||R(S.stacktrace)):$(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?I.localize(1,null,S.message):S.message||I.localize(2,null)}function g(S=null,l=!1){if(!S)return I.localize(3,null);if(Array.isArray(S)){const p=E.$Hb(S),b=g(p[0],l);return p.length>1?I.localize(4,null,b,p.length):b}if(T.$Ef(S))return S;if(S.detail){const p=S.detail;if(p.error)return L(p.error,l);if(p.exception)return L(p.exception,l)}return S.stack?L(S,l):S.message?S.message:I.localize(5,null)}e.$Mi=g;function w(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}e.$Ni=w;function A(S,l){let p;return typeof S=="string"?p=new Error(S):p=S,p.actions=l,p}e.$Oi=A}),define(Ce[138],Re([1,0,39,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=void 0;const I=new E.$V(()=>{const F=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:F,collatorIsNumeric:F.resolvedOptions().numeric}}),L=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(F,v,y=!1){const D=F||"",N=v||"",O=I.value.collator.compare(D,N);return I.value.collatorIsNumeric&&O===0&&D!==N?D<N?-1:1:O}e.$vq=$;function g(F,v){const y=L.value.collator;return F=F||"",v=v||"",c(y,F,v)}e.$wq=g;function w(F,v){const y=L.value.collator;return F=F||"",v=v||"",u(F,v)||c(y,F,v)}e.$xq=w;function A(F,v){const y=L.value.collator;return F=F||"",v=v||"",s(F,v)||c(y,F,v)}e.$yq=A;function S(F,v){return F=F||"",v=v||"",F===v?0:F<v?-1:1}e.$zq=S;function l(F,v){const[y,D]=n(F),[N,O]=n(v);let W=I.value.collator.compare(D,O);if(W===0){if(I.value.collatorIsNumeric&&D!==O)return D<O?-1:1;if(W=I.value.collator.compare(y,N),I.value.collatorIsNumeric&&W===0&&y!==N)return y<N?-1:1}return W}e.$Aq=l;function p(F,v){F=F||"",v=v||"";const y=o(F),D=o(v),N=L.value.collator,O=R.value.collator;return c(O,y,D)||c(N,F,v)}e.$Bq=p;function b(F,v){F=F||"",v=v||"";const y=o(F),D=o(v),N=L.value.collator,O=R.value.collator;return c(O,y,D)||u(F,v)||c(N,F,v)}e.$Cq=b;function r(F,v){F=F||"",v=v||"";const y=o(F),D=o(v),N=L.value.collator,O=R.value.collator;return c(O,y,D)||s(F,v)||c(N,F,v)}e.$Dq=r;function a(F,v){F=F||"",v=v||"";const y=o(F).toLowerCase(),D=o(v).toLowerCase();return y!==D?y<D?-1:1:F!==v?F<v?-1:1:0}e.$Eq=a;const t=/^(.*?)(\.([^.]*))?$/;function n(F,v=!1){const y=F?t.exec(F):[];let D=[y&&y[1]||"",y&&y[3]||""];return v&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function o(F){const v=F?t.exec(F):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(F,v,y){const D=F.compare(v,y);return D!==0?D:v.length!==y.length?v.length<y.length?-1:1:0}function h(F){const v=F.charAt(0);return v.toLocaleUpperCase()!==v}function i(F){const v=F.charAt(0);return v.toLocaleLowerCase()!==v}function s(F,v){return h(F)&&i(v)?-1:i(F)&&h(v)?1:0}function u(F,v){return i(F)&&h(v)?-1:h(F)&&i(v)?1:0}function d(F,v,y=!1){return y||(F=F&&F.toLowerCase(),v=v&&v.toLowerCase()),F===v?0:F<v?-1:1}function m(F,v,y=!1){const D=F.split(T.sep),N=v.split(T.sep),O=D.length-1,W=N.length-1;let z,V;for(let P=0;;P++){if(z=O===P,V=W===P,z&&V)return $(D[P],N[P],y);if(z)return-1;if(V)return 1;const C=d(D[P],N[P],y);if(C!==0)return C}}e.$Fq=m;function f(F,v,y){const D=F.toLowerCase(),N=v.toLowerCase(),O=k(F,v,y);if(O)return O;const W=D.endsWith(y),z=N.endsWith(y);if(W!==z)return W?-1:1;const V=$(D,N);return V!==0?V:D.localeCompare(N)}e.$Gq=f;function k(F,v,y){const D=F.toLowerCase(),N=v.toLowerCase(),O=D.startsWith(y),W=N.startsWith(y);if(O!==W)return O?-1:1;if(O&&W){if(D.length<N.length)return-1;if(D.length>N.length)return 1}return 0}e.$Hq=k}),define(Ce[46],Re([1,0,19,21,11,16]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function R(f){return f===47||f===92}e.$Wf=R;function $(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$Xf=$;function g(f){return f.indexOf("/")===-1&&(f=$(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Yf=g;function w(f,k=E.$gc.sep){if(!f)return"";const F=f.length,v=f.charCodeAt(0);if(R(v)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let D=3;const N=D;for(;D<F&&!R(f.charCodeAt(D));D++);if(N!==D&&!R(f.charCodeAt(D+1))){for(D+=1;D<F;D++)if(R(f.charCodeAt(D)))return f.slice(0,D+1).replace(/[\\/]/g,k)}}return k}else if(t(v)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+k:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<F;y++)if(R(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$Zf=w;function A(f){if(!T.$i||!f||f.length<5)return!1;let k=f.charCodeAt(0);if(k!==92||(k=f.charCodeAt(1),k!==92))return!1;let F=2;const v=F;for(;F<f.length&&(k=f.charCodeAt(F),k!==92);F++);return!(v===F||(k=f.charCodeAt(F+1),isNaN(k)||k===92))}e.$1f=A;const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(f,k=T.$i){const F=k?S:l;return!(!f||f.length===0||/^\s+$/.test(f)||(F.lastIndex=0,F.test(f))||k&&p.test(f)||f==="."||f===".."||k&&f[f.length-1]==="."||k&&f.length!==f.trim().length||f.length>255)}e.$2f=b;function r(f,k,F){const v=f===k;return!F||v?v:!f||!k?!1:(0,I.$8e)(f,k)}e.$3f=r;function a(f,k,F,v=E.sep){if(f===k)return!0;if(!f||!k||k.length>f.length)return!1;if(F){if(!(0,I.$9e)(f,k))return!1;if(k.length===f.length)return!0;let D=k.length;return k.charAt(k.length-1)===v&&D--,f.charAt(D)===v}return k.charAt(k.length-1)!==v&&(k+=v),f.indexOf(k)===0}e.$4f=a;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$5f=t;function n(f,k){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(k,f)),f=(0,E.$hc)(f),T.$i?(f=(0,I.$Qe)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,I.$Qe)(f,E.sep),f||(f=E.sep)),f}e.$6f=n;function o(f){const k=(0,E.$hc)(f);return T.$i?f.length>3?!1:c(k)&&(f.length===2||k.charCodeAt(2)===92):k===E.$gc.sep}e.$7f=o;function c(f,k=T.$i){return k?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$8f=c;function h(f,k=T.$i){return c(f,k)?f[0]:void 0}e.$9f=h;function i(f,k,F){return k.length>f.length?-1:f===k?0:(F&&(f=f.toLowerCase(),k=k.toLowerCase()),f.indexOf(k))}e.$0f=i;function s(f){const k=f.split(":");let F,v,y;for(const D of k){const N=Number(D);(0,L.$If)(N)?v===void 0?v=N:y===void 0&&(y=N):F=F?[F,D].join(":"):D}if(!F)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:F,line:v!==void 0?v:void 0,column:y!==void 0?y:v!==void 0?1:void 0}}e.$$f=s;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(f,k,F=8){let v="";for(let D=0;D<F;D++){let N;D===0&&T.$i&&!k&&(F===3||F===4)?N=d:N=u,v+=N.charAt(Math.floor(Math.random()*N.length))}let y;return k?y=`${k}-${v}`:y=v,f?(0,E.$jc)(f,y):y}e.$_f=m}),define(Ce[68],Re([1,0,19]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=e.$4r=void 0,e.$4r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const S=(0,E.$oc)(A),l=T[S.toLowerCase()];return l!==void 0?l:R(A)}e.$5r=L;function R(A){const S=(0,E.$oc)(A);return I[S.toLowerCase()]}e.$6r=R;function $(A){for(const S in I)if(I[S]===A)return S}e.$7r=$;const g=/^(.+)\/(.+?)(;.+)?$/;function w(A,S){const l=g.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:A}e.$8r=w}),define(Ce[51],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function I(g){return JSON.stringify(g,R)}e.$wh=I;function L(g){let w=JSON.parse(g);return w=$(w),w}e.$xh=L;function R(g,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function $(g,w=0){if(!g||w>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$ge||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=$(g[A],w+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=$(g[A],w+1))}return g}e.$yh=$}),define(Ce[12],Re([1,0,14,21,11,2]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function $(l,p){return L.URI.isUri(l)?(0,I.$8e)(l.scheme,p):(0,I.$9e)(l,p+":")}e.$ag=$;function g(l,...p){return p.some(b=>$(l,b))}e.$bg=g,e.$cg="vscode-tkn",e.$dg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,b,r){this.a[p]=b,this.b[p]=r}setConnectionToken(p,b){this.c[p]=b}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(o){return E.$1(o),p}const b=p.authority;let r=this.a[b];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const a=this.b[b],t=this.c[b];let n=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(n+=`&${e.$dg}=${encodeURIComponent(t)}`),L.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${r}:${a}`,path:this.f,query:n})}}e.$eg=new w,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class A{static{this.a=e.$jg}asBrowserUri(p){const b=this.b(p,ge);return this.uriToBrowserUri(b)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$eg.rewrite(p):p.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${A.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const b=this.b(p,ge);return this.uriToFileUri(b)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,b){return L.URI.isUri(p)?p:L.URI.parse(b.toUrl(p))}}e.$kg=new A;var S;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const b="vscode-coi";function r(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:L.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const o=n?.get(b);if(o)return p.get(o)}l.getHeadersFromQuery=r;function a(t,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";t instanceof URLSearchParams?t.set(b,c):t[b]=c}l.addSearchParam=a})(S||(e.COI=S={}))}),define(Ce[25],Re([1,0,46,12,19,21,11,2]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function g(p){return(0,$.$wc)(p,!0)}e.$rg=g;class w{constructor(b){this.a=b}compare(b,r,a=!1){return b===r?0:(0,R.$1e)(this.getComparisonKey(b,a),this.getComparisonKey(r,a))}isEqual(b,r,a=!1){return b===r?!0:!b||!r?!1:this.getComparisonKey(b,a)===this.getComparisonKey(r,a)}getComparisonKey(b,r=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,r,a=!1){if(b.scheme===r.scheme){if(b.scheme===T.Schemas.file)return E.$4f(g(b),g(r),this.a(b))&&b.query===r.query&&(a||b.fragment===r.fragment);if((0,e.$Ig)(b.authority,r.authority))return E.$4f(b.path,r.path,this.a(b),"/")&&b.query===r.query&&(a||b.fragment===r.fragment)}return!1}joinPath(b,...r){return $.URI.joinPath(b,...r)}basenameOrAuthority(b){return(0,e.$Ag)(b)||b.authority}basename(b){return I.$gc.basename(b.path)}extname(b){return I.$gc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let r;return b.scheme===T.Schemas.file?r=$.URI.file(I.$mc(g(b))).path:(r=I.$gc.dirname(b.path),b.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),r="/")),b.with({path:r})}normalizePath(b){if(!b.path.length)return b;let r;return b.scheme===T.Schemas.file?r=$.URI.file(I.$hc(g(b))).path:r=I.$gc.normalize(b.path),b.with({path:r})}relativePath(b,r){if(b.scheme!==r.scheme||!(0,e.$Ig)(b.authority,r.authority))return;if(b.scheme===T.Schemas.file){const n=I.$lc(g(b),g(r));return L.$i?E.$Xf(n):n}let a=b.path||"/";const t=r.path||"/";if(this.a(b)){let n=0;for(const o=Math.min(a.length,t.length);n<o&&!(a.charCodeAt(n)!==t.charCodeAt(n)&&a.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);a=t.substr(0,n)+a.substr(n)}return I.$gc.relative(a,t)}resolvePath(b,r){if(b.scheme===T.Schemas.file){const a=$.URI.file(I.$kc(g(b),r));return b.with({authority:a.authority,path:a.path})}return r=E.$Yf(r),b.with({path:I.$gc.resolve(b.path,r)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,r){return b===r||b!==void 0&&r!==void 0&&(0,R.$8e)(b,r)}hasTrailingPathSeparator(b,r=I.sep){if(b.scheme===T.Schemas.file){const a=g(b);return a.length>E.$Zf(a).length&&a[a.length-1]===r}else{const a=b.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,r=I.sep){return(0,e.$Jg)(b,r)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,r=I.sep){let a=!1;if(b.scheme===T.Schemas.file){const t=g(b);a=t!==void 0&&t.length===E.$Zf(t).length&&t[t.length-1]===r}else{r="/";const t=b.path;a=t.length===1&&t.charCodeAt(t.length-1)===47}return!a&&!(0,e.$Jg)(b,r)?b.with({path:b.path+"/"}):b}}e.$sg=w,e.$tg=new w(()=>!1),e.$ug=new w(p=>p.scheme===T.Schemas.file?!L.$k:!0),e.$vg=new w(p=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function A(p,b){const r=[];for(let a=0;a<p.length;a++){const t=b(p[a]);p.some((n,o)=>o===a?!1:(0,e.$xg)(t,b(n)))||r.push(p[a])}return r}e.$Mg=A;var S;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function b(r){const a=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,h]=o.split(":");c&&h&&a.set(c,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&a.set(p.META_DATA_MIME,n),a}p.parseMetaData=b})(S||(e.DataUri=S={}));function l(p,b,r){if(b){let a=p.path;return a&&a[0]!==I.$gc.sep&&(a=I.$gc.sep+a),p.with({scheme:r,authority:b,path:a})}return p.with({scheme:r})}e.$Ng=l}),define(Ce[13],Re([1,0,20,14,5,6,25,21,125,39]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function A(ae){return!!ae&&typeof ae.then=="function"}e.$Og=A;function S(ae){const te=new E.$3d,J=ae(te.token),ee=new Promise(($e,ve)=>{const Fe=te.token.onCancellationRequested(()=>{Fe.dispose(),te.dispose(),ve(new T.$5)});Promise.resolve(J).then(le=>{Fe.dispose(),te.dispose(),$e(le)},le=>{Fe.dispose(),te.dispose(),ve(le)})});return new class{cancel(){te.cancel()}then($e,ve){return ee.then($e,ve)}catch($e){return this.then(void 0,$e)}finally($e){return ee.finally($e)}}}e.$Pg=S;function l(ae,te,J){return new Promise((ee,$e)=>{const ve=te.onCancellationRequested(()=>{ve.dispose(),ee(J)});ae.then(ee,$e).finally(()=>ve.dispose())})}e.$Qg=l;function p(ae,te){return new Promise((J,ee)=>{const $e=te.onCancellationRequested(()=>{$e.dispose(),ee(new T.$5)});ae.then(J,ee).finally(()=>$e.dispose())})}e.$Rg=p;async function b(ae){let te=-1;const J=ae.map((ee,$e)=>ee.then(ve=>(te=$e,ve)));try{return await Promise.race(J)}finally{ae.forEach((ee,$e)=>{$e!==te&&ee.cancel()})}}e.$Sg=b;function r(ae,te,J){let ee;const $e=setTimeout(()=>{ee?.(void 0),J?.()},te);return Promise.race([ae.finally(()=>clearTimeout($e)),new Promise(ve=>ee=ve)])}e.$Tg=r;function a(ae){return new Promise((te,J)=>{const ee=ae();A(ee)?ee.then(te,J):te(ee)})}e.$Ug=a;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const J=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(J,J).then(ee)})}return new Promise((J,ee)=>{this.b.then(J,ee)})}return this.a=te(),new Promise((J,ee)=>{this.a.then($e=>{this.a=null,J($e)},$e=>{this.a=null,ee($e)})})}dispose(){this.f=!0}}e.$Vg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$Wg=n;class o{constructor(){this.a=new Map}queue(te,J){const $e=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.a.get(te)===$e&&this.a.delete(te)});return this.a.set(te,$e),$e}}e.$Xg=o;const c=(ae,te)=>{let J=!0;const ee=setTimeout(()=>{J=!1,te()},ae);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ee),J=!1}}},h=ae=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ae())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class i{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,J=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise(($e,ve)=>{this.d=$e,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=J===g.$Pd?h(ee):c(J,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=i;class s{constructor(te){this.a=new i(te),this.b=new t}trigger(te,J){return this.a.trigger(()=>this.b.queue(te),J)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=s;class u{constructor(){this.a=!1,this.b=new Promise((te,J)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=u;class d extends u{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$2g=d;function m(ae,te){return te?new Promise((J,ee)=>{const $e=setTimeout(()=>{ve.dispose(),J()},ae),ve=te.onCancellationRequested(()=>{clearTimeout($e),ve.dispose(),ee(new T.$5)})}):S(J=>m(ae,J))}e.$3g=m;function f(ae,te=0,J){const ee=setTimeout(()=>{ae(),J&&$e.dispose()},te),$e=(0,L.$Qc)(()=>{clearTimeout(ee),J?.deleteAndLeak($e)});return J?.add($e),$e}e.$4g=f;function k(ae){const te=[];let J=0;const ee=ae.length;function $e(){return J<ee?ae[J++]():null}function ve(Fe){Fe!=null&&te.push(Fe);const le=$e();return le?le.then(ve):Promise.resolve(te)}return Promise.resolve(null).then(ve)}e.$5g=k;function F(ae,te=ee=>!!ee,J=null){let ee=0;const $e=ae.length,ve=()=>{if(ee>=$e)return Promise.resolve(J);const Fe=ae[ee++];return Promise.resolve(Fe()).then(we=>te(we)?Promise.resolve(we):ve())};return ve()}e.$6g=F;function v(ae,te=ee=>!!ee,J=null){if(ae.length===0)return Promise.resolve(J);let ee=ae.length;const $e=()=>{ee=-1;for(const ve of ae)ve.cancel?.()};return new Promise((ve,Fe)=>{for(const le of ae)le.then(we=>{--ee>=0&&te(we)?($e(),ve(we)):ee===0&&ve(J)}).catch(we=>{--ee>=0&&($e(),Fe(we))})})}e.$7g=v;class y{constructor(te){this.a=0,this.d=te,this.f=[],this.b=0,this.g=new I.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(te){return this.a++,new Promise((J,ee)=>{this.f.push({factory:te,c:J,e:ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const te=this.f.shift();this.b++;const J=te.factory();J.then(te.c,te.e),J.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=y;class D extends y{constructor(){super(1)}}e.$9g=D;class N{constructor(){this.a=new ke,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$0g=N;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new ie;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueFor(te,J=R.$tg){const ee=J.getComparisonKey(te);let $e=this.a.get(ee);if(!$e){$e=new D;const ve=this.f++,Fe=I.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ee),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$2c),this.d.set(ve,Fe),this.a.set(ee,$e)}return $e}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=O;class W{constructor(te,J){this.a=-1,typeof te=="function"&&typeof J=="number"&&this.setIfNotSet(te,J)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,J){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},J)}setIfNotSet(te,J){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},J))}}e.$_g=W;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,J,ee=globalThis){this.cancel();const $e=ee.setInterval(()=>{te()},J);this.d=(0,L.$Qc)(()=>{ee.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$ah=z;class V{constructor(te,J){this.b=-1,this.a=te,this.d=J,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=V;class P{constructor(te,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.a=te,this.b=J,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=P;class C extends V{constructor(te,J){super(te,J),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$dh=C;class Z extends L.$Sc{constructor(te,J){super(),this.g=te,this.h=J,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const J of te)this.a.push(J);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(ae,te)=>{(0,$.$B)(()=>{if(J)return;const ee=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$gh=(ae,te,J)=>{const ee=ae.requestIdleCallback(te,typeof J=="number"?{timeout:J}:void 0);let $e=!1;return{dispose(){$e||($e=!0,ae.cancelIdleCallback(ee))}}},e.$fh=ae=>(0,e.$gh)(globalThis,ae)}();class ce{constructor(te,J){this.g=!1,this.d=()=>{try{this.j=J()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$gh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=ce;class me extends ce{constructor(te){super(globalThis,te)}}e.$ih=me;async function be(ae,te,J){let ee;for(let $e=0;$e<J;$e++)try{return await ae()}catch(ve){ee=ve,await m(te)}throw ee}e.$jh=be;class ke{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,J,ee){return this.a={taskId:te,cancel:()=>ee?.(),promise:J},J.then(()=>this.d(te),()=>this.d(te)),J}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let J,ee;const $e=new Promise((ve,Fe)=>{J=ve,ee=Fe});this.b={run:te,promise:$e,promiseResolve:J,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=ke;class fe{constructor(te,J=()=>Date.now()){this.d=te,this.f=J,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$lh=fe;var de;(function(ae){ae[ae.Resolved=0]="Resolved",ae[ae.Rejected=1]="Rejected"})(de||(de={}));class ie{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,J)=>{this.a=te,this.b=J})}complete(te){return new Promise(J=>{this.a(te),this.d={outcome:0,value:te},J()})}error(te){return new Promise(J=>{this.b(te),this.d={outcome:1,value:te},J()})}cancel(){return this.error(new T.$5)}}e.$mh=ie;var Se;(function(ae){async function te(ee){let $e;const ve=await Promise.all(ee.map(Fe=>Fe.then(le=>le,le=>{$e||($e=le)})));if(typeof $e<"u")throw $e;return ve}ae.settled=te;function J(ee){return new Promise(async($e,ve)=>{try{await ee($e,ve)}catch(Fe){ve(Fe)}})}ae.withAsyncBody=J})(Se||(e.Promises=Se={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(J=>(this.a=J,this.d=!0,J),J=>{throw this.b=J,this.d=!0,J})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=oe;class x{constructor(te){this.b=te,this.a=new w.$V(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=x;var q;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(q||(q={}));class ne{static fromArray(te){return new ne(J=>{J.emitMany(te)})}static fromPromise(te){return new ne(async J=>{J.emitMany(await te)})}static fromPromises(te){return new ne(async J=>{await Promise.all(te.map(async ee=>J.emitOne(await ee)))})}static merge(te){return new ne(async J=>{await Promise.all(te.map(async ee=>{for await(const $e of ee)J.emitOne($e)}))})}static{this.EMPTY=ne.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new I.$Sd,queueMicrotask(async()=>{const J={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(te(J)),this.j()}catch(ee){this.k(ee)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(te,J){return new ne(async ee=>{for await(const $e of te)ee.emitOne(J($e))})}map(te){return ne.map(this,te)}static filter(te,J){return new ne(async ee=>{for await(const $e of te)J($e)&&ee.emitOne($e)})}filter(te){return ne.filter(this,te)}static coalesce(te){return ne.filter(te,J=>!!J)}coalesce(){return ne.coalesce(this)}static async toPromise(te){const J=[];for await(const ee of te)J.push(ee);return J}toPromise(){return ne.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$ph=ne;class Ie extends ne{constructor(te,J){super(J),this.l=te}cancel(){this.l.cancel()}}e.$qh=Ie;function Ae(ae){const te=new E.$3d,J=ae(te.token);return new Ie(te,async ee=>{const $e=te.token.onCancellationRequested(()=>{$e.dispose(),te.dispose(),ee.reject(new T.$5)});try{for await(const ve of J){if(te.token.isCancellationRequested)return;ee.emitOne(ve)}$e.dispose(),te.dispose()}catch(ve){$e.dispose(),te.dispose(),ee.reject(ve)}})}e.$rh=Ae;class Pe{constructor(){this.a=new ie,this.b=new ne(ee=>{if(te){ee.reject(te);return}return J&&ee.emitMany(J),this.d=$e=>ee.reject($e),this.f=$e=>ee.emitOne($e),this.a.p});let te,J;this.f=ee=>{J||(J=[]),J.push(ee)},this.d=ee=>{te||(te=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$sh=Pe}),define(Ce[34],Re([1,0,18,13,46,28,19,21,11]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function w(){return Object.create(null)}e.$Dj=w,e.$Ej="**",e.$Fj="/";const A="[/\\\\]",S="[^/\\\\]",l=/\//g;function p(me,be){switch(me){case 0:return"";case 1:return`${S}*?`;default:return`(?:${A}|${S}+${A}${be?`|${A}${S}+`:""})*?`}}function b(me,be){if(!me)return[];const ke=[];let fe=!1,de=!1,ie="";for(const Se of me){switch(Se){case be:if(!fe&&!de){ke.push(ie),ie="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":de=!0;break;case"]":de=!1;break}ie+=Se}return ie&&ke.push(ie),ke}e.$Gj=b;function r(me){if(!me)return"";let be="";const ke=b(me,e.$Fj);if(ke.every(fe=>fe===e.$Ej))be=".*";else{let fe=!1;ke.forEach((de,ie)=>{if(de===e.$Ej){if(fe)return;be+=p(2,ie===ke.length-1)}else{let Se=!1,oe="",x=!1,q="";for(const ne of de){if(ne!=="}"&&Se){oe+=ne;continue}if(x&&(ne!=="]"||!q)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!q?Ie="^":ne===e.$Fj?Ie="":Ie=(0,g.$Ke)(ne),q+=Ie;continue}switch(ne){case"{":Se=!0;continue;case"[":x=!0;continue;case"}":{const Ae=`(?:${b(oe,",").map(Pe=>r(Pe)).join("|")})`;be+=Ae,Se=!1,oe="";break}case"]":{be+="["+q+"]",x=!1,q="";break}case"?":be+=S;continue;case"*":be+=p(1);continue;default:be+=(0,g.$Ke)(ne)}}ie<ke.length-1&&(ke[ie+1]!==e.$Ej||ie+2<ke.length)&&(be+=A)}fe=de===e.$Ej})}return be}const a=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Dc(1e4),s=function(){return!1},u=function(){return null};function d(me,be){if(!me)return u;let ke;typeof me!="string"?ke=me.pattern:ke=me,ke=ke.trim();const fe=`${ke}_${!!be.trimForExclusions}`;let de=i.get(fe);if(de)return m(de,me);let ie;return a.test(ke)?de=k(ke.substr(4),ke):(ie=t.exec(f(ke,be)))?de=F(ie[1],ke):(be.trimForExclusions?o:n).test(ke)?de=v(ke,be):(ie=c.exec(f(ke,be)))?de=y(ie[1].substr(1),ke,!0):(ie=h.exec(f(ke,be)))?de=y(ie[1],ke,!1):de=D(ke),i.set(fe,de),m(de,me)}function m(me,be){if(typeof be=="string")return me;const ke=function(fe,de){return(0,I.$4f)(fe,be.base,!$.$k)?me((0,g.$Pe)(fe.substr(be.base.length),R.sep),de):null};return ke.allBasenames=me.allBasenames,ke.allPaths=me.allPaths,ke.basenames=me.basenames,ke.patterns=me.patterns,ke}function f(me,be){return be.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function k(me,be){return function(ke,fe){return typeof ke=="string"&&ke.endsWith(me)?be:null}}function F(me,be){const ke=`/${me}`,fe=`\\${me}`,de=function(Se,oe){return typeof Se!="string"?null:oe?oe===me?be:null:Se===me||Se.endsWith(ke)||Se.endsWith(fe)?be:null},ie=[me];return de.basenames=ie,de.patterns=[be],de.allBasenames=ie,de}function v(me,be){const ke=Z(me.slice(1,-1).split(",").map(oe=>d(oe,be)).filter(oe=>oe!==u),me),fe=ke.length;if(!fe)return u;if(fe===1)return ke[0];const de=function(oe,x){for(let q=0,ne=ke.length;q<ne;q++)if(ke[q](oe,x))return me;return null},ie=ke.find(oe=>!!oe.allBasenames);ie&&(de.allBasenames=ie.allBasenames);const Se=ke.reduce((oe,x)=>x.allPaths?oe.concat(x.allPaths):oe,[]);return Se.length&&(de.allPaths=Se),de}function y(me,be,ke){const fe=R.sep===R.$gc.sep,de=fe?me:me.replace(l,R.sep),ie=R.sep+de,Se=R.$gc.sep+me;let oe;return ke?oe=function(x,q){return typeof x=="string"&&(x===de||x.endsWith(ie)||!fe&&(x===me||x.endsWith(Se)))?be:null}:oe=function(x,q){return typeof x=="string"&&(x===de||!fe&&x===me)?be:null},oe.allPaths=[(ke?"*/":"./")+me],oe}function D(me){try{const be=new RegExp(`^${r(me)}$`);return function(ke){return be.lastIndex=0,typeof ke=="string"&&be.test(ke)?me:null}}catch{return u}}function N(me,be,ke){return!me||typeof be!="string"?!1:O(me)(be,void 0,ke)}e.$Hj=N;function O(me,be={}){if(!me)return s;if(typeof me=="string"||W(me)){const ke=d(me,be);if(ke===u)return s;const fe=function(de,ie){return!!ke(de,ie)};return ke.allBasenames&&(fe.allBasenames=ke.allBasenames),ke.allPaths&&(fe.allPaths=ke.allPaths),fe}return P(me,be)}e.$Ij=O;function W(me){const be=me;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}e.$Jj=W;function z(me){return me.allBasenames||[]}e.$Kj=z;function V(me){return me.allPaths||[]}e.$Lj=V;function P(me,be){const ke=Z(Object.getOwnPropertyNames(me).map(oe=>C(oe,me[oe],be)).filter(oe=>oe!==u)),fe=ke.length;if(!fe)return u;if(!ke.some(oe=>!!oe.requiresSiblings)){if(fe===1)return ke[0];const oe=function(ne,Ie){let Ae;for(let Pe=0,ae=ke.length;Pe<ae;Pe++){const te=ke[Pe](ne,Ie);if(typeof te=="string")return te;(0,T.$Og)(te)&&(Ae||(Ae=[]),Ae.push(te))}return Ae?(async()=>{for(const Pe of Ae){const ae=await Pe;if(typeof ae=="string")return ae}return null})():null},x=ke.find(ne=>!!ne.allBasenames);x&&(oe.allBasenames=x.allBasenames);const q=ke.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return q.length&&(oe.allPaths=q),oe}const de=function(oe,x,q){let ne,Ie;for(let Ae=0,Pe=ke.length;Ae<Pe;Ae++){const ae=ke[Ae];ae.requiresSiblings&&q&&(x||(x=(0,R.$nc)(oe)),ne||(ne=x.substr(0,x.length-(0,R.$oc)(oe).length)));const te=ae(oe,x,ne,q);if(typeof te=="string")return te;(0,T.$Og)(te)&&(Ie||(Ie=[]),Ie.push(te))}return Ie?(async()=>{for(const Ae of Ie){const Pe=await Ae;if(typeof Pe=="string")return Pe}return null})():null},ie=ke.find(oe=>!!oe.allBasenames);ie&&(de.allBasenames=ie.allBasenames);const Se=ke.reduce((oe,x)=>x.allPaths?oe.concat(x.allPaths):oe,[]);return Se.length&&(de.allPaths=Se),de}function C(me,be,ke){if(be===!1)return u;const fe=d(me,ke);if(fe===u)return u;if(typeof be=="boolean")return fe;if(be){const de=be.when;if(typeof de=="string"){const ie=(Se,oe,x,q)=>{if(!q||!fe(Se,oe))return null;const ne=de.replace("$(basename)",()=>x),Ie=q(ne);return(0,T.$Og)(Ie)?Ie.then(Ae=>Ae?me:null):Ie?me:null};return ie.requiresSiblings=!0,ie}}return fe}function Z(me,be){const ke=me.filter(oe=>!!oe.basenames);if(ke.length<2)return me;const fe=ke.reduce((oe,x)=>{const q=x.basenames;return q?oe.concat(q):oe},[]);let de;if(be){de=[];for(let oe=0,x=fe.length;oe<x;oe++)de.push(be)}else de=ke.reduce((oe,x)=>{const q=x.patterns;return q?oe.concat(q):oe},[]);const ie=function(oe,x){if(typeof oe!="string")return null;if(!x){let ne;for(ne=oe.length;ne>0;ne--){const Ie=oe.charCodeAt(ne-1);if(Ie===47||Ie===92)break}x=oe.substr(ne)}const q=fe.indexOf(x);return q!==-1?de[q]:null};ie.basenames=fe,ie.patterns=de,ie.allBasenames=fe;const Se=me.filter(oe=>!oe.basenames);return Se.push(ie),Se}function ce(me,be){return(0,E.$ub)(me,be,(ke,fe)=>typeof ke=="string"&&typeof fe=="string"?ke===fe:typeof ke!="string"&&typeof fe!="string"?ke.base===fe.base&&ke.pattern===fe.pattern:!1)}e.$Mj=ce}),define(Ce[52],Re([1,0,14,126,25,11,2]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class g{constructor(n="",o=!1){if(this.value=n,typeof this.value!="string")throw(0,E.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(n,o=0){return this.value+=l(this.supportThemeIcons?(0,T.$0j)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,o){return this.value+=`
${p(o,n)}
`,this}appendLink(n,o,c){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,o){const c=new RegExp((0,L.$Ke)(o),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$dk=g;function w(t){return A(t)?!t.value:Array.isArray(t)?t.every(w):!0}e.$ek=w;function A(t){return t instanceof g?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$fk=A;function S(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,I.$wg)(R.URI.from(t.baseUri),R.URI.from(n.baseUri)))}e.$gk=S;function l(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=l;function p(t,n){const o=t.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=o>=3?o+1:3;return[`${"`".repeat(c)}${n}`,t,`${"`".repeat(c)}`].join(`
`)}e.$ik=p;function b(t){return t.replace(/"/g,"&quot;")}e.$jk=b;function r(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$kk=r;function a(t){const n=[],o=t.split("|").map(h=>h.trim());t=o[0];const c=o[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),s=h?h[1]:"",u=i?i[1]:"",d=isFinite(parseInt(u)),m=isFinite(parseInt(s));d&&n.push(`width="${u}"`),m&&n.push(`height="${s}"`)}return{href:t,dimensions:n}}e.$lk=a}),define(Ce[95],Re([1,0,18,46,19,21,25,11]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=void 0;function g(d,m){const{os:f,tildify:k,relative:F}=m;if(F){const D=w(d,F,f);if(typeof D=="string")return D}let v=d.fsPath;if(f===1&&!L.$i?v=v.replace(/\//g,"\\"):f!==1&&L.$i&&(v=v.replace(/\\/g,"/")),f!==1&&k?.userHome){const D=k.userHome.fsPath;let N;d.scheme!==k.userHome.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep?N=k.userHome.with({path:d.path}).fsPath:N=v,v=l(N,D,f)}return(f===1?I.$fc:I.$gc).normalize(A(v,f===1))}e.$Hv=g;function w(d,m,f){const k=f===1?I.$fc:I.$gc,F=f===3?R.$tg:R.$vg,v=m.getWorkspace(),y=(0,E.$Ob)(v.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep&&(d=y.uri.with({path:d.path}));const D=m.getWorkspaceFolder(d);if(!D)return;let N;if(F.isEqual(D.uri,d)?N="":N=F.relativePath(D.uri,d)??"",N&&(N=k.normalize(N)),v.folders.length>1&&!m.noPrefix){const O=D.name?D.name:F.basenameOrAuthority(D.uri);N=N?`${O} \u2022 ${N}`:O}return N}function A(d,m=L.$i){return(0,T.$8f)(d,m)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Iv=A;let S=Object.create(null);function l(d,m,f=L.OS){if(f===1||!d||!m)return d;let k=S.original===m?S.normalized:void 0;k||(k=m,L.$i&&(k=(0,T.$Xf)(k)),k=`${(0,$.$Qe)(k,I.$gc.sep)}${I.$gc.sep}`,S={original:m,normalized:k});let F=d;return L.$i&&(F=(0,T.$Xf)(F)),(f===3?F.startsWith(k):(0,$.$9e)(F,k))?`~/${F.substr(k.length)}`:d}e.$Jv=l;function p(d,m){return d.replace(/^~($|\/|\\)/,`${m}$1`)}e.$Kv=p;const b="\u2026",r="\\\\",a="~";function t(d,m=I.sep){const f=new Array(d.length);let k=!1;for(let F=0;F<d.length;F++){const v=d[F];if(v===""){f[F]=`.${m}`;continue}if(!v){f[F]=v;continue}k=!0;let y="",D=v;D.indexOf(r)===0?(y=D.substr(0,D.indexOf(r)+r.length),D=D.substr(D.indexOf(r)+r.length)):D.indexOf(m)===0?(y=D.substr(0,D.indexOf(m)+m.length),D=D.substr(D.indexOf(m)+m.length)):D.indexOf(a)===0&&(y=D.substr(0,D.indexOf(a)+a.length),D=D.substr(D.indexOf(a)+a.length));const N=D.split(m);for(let O=1;k&&O<=N.length;O++)for(let W=N.length-O;k&&W>=0;W--){k=!1;let z=N.slice(W,W+O).join(m);for(let V=0;!k&&V<d.length;V++)if(V!==F&&d[V]&&d[V].indexOf(z)>-1){const P=W+O===N.length,C=W>0&&d[V].indexOf(m)>-1?m+z:z,Z=d[V].endsWith(C);k=!P||Z}if(!k){let V="";(N[0].endsWith(":")||y!=="")&&(W===1&&(W=0,O++,z=N[0]+m+z),W>0&&(V=N[0]+m),V=y+V),W>0&&(V=V+b+m),V=V+z,W+O<N.length&&(V=V+m+b),f[F]=V}}k&&(f[F]=v)}return f}e.$Lv=t;var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(d,m=Object.create(null)){const f=[];let k=!1,F="";for(const v of d)if(v==="$"||k&&v==="{")F&&f.push({value:F,type:n.TEXT}),F="",k=!0;else if(v==="}"&&k){const y=m[F];if(typeof y=="string")y.length&&f.push({value:y,type:n.VARIABLE});else if(y){const D=f[f.length-1];(!D||D.type!==n.SEPARATOR)&&f.push({value:y.label,type:n.SEPARATOR})}F="",k=!1}else F+=v;return F&&!k&&f.push({value:F,type:n.TEXT}),f.filter((v,y)=>{if(v.type===n.SEPARATOR){const D=f[y-1],N=f[y+1];return[D,N].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(v=>v.value).join("")}e.$Mv=o;function c(d,m){return L.$j||m?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$Nv=c;function h(d,m){return L.$j||m?d.replace(/\(&&\w\)|&&/g,""):L.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Ov=h;function i(d){return d.replace(/&/g,"&&")}e.$Pv=i;function s(d){if(d.endsWith("]")){const m=d.lastIndexOf(" [",d.length-2);if(m!==-1){const f=u(d.substring(0,m));return{name:f.name,parentPath:f.parentPath+d.substring(m)}}}return u(d)}e.$Qv=s;function u(d){const m=d.indexOf("/")!==-1?I.$gc:I.$fc,f=m.basename(d),k=m.dirname(d);return f.length?{name:f,parentPath:k}:{name:k,parentPath:""}}}),define(Ce[139],Re([1,0,24,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=void 0;function I(S){return S.toJSON()}class L{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:I(T.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:I(T.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:T.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Zm=L,e.$1m=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,l,p){if(!S||p>200)return null;if(typeof S=="object"){if(S instanceof T.URI)return l.transformOutgoing(S);for(const b in S)if(Object.hasOwnProperty.call(S,b)){const r=R(S[b],l,p+1);r!==null&&(S[b]=r)}}return null}function $(S,l){const p=R(S,l,0);return p===null?S:p}e.$2m=$;function g(S,l,p,b){if(!S||b>200)return null;if(typeof S=="object"){if(S.$mid===1)return p?T.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof E.$ge)return null;for(const r in S)if(Object.hasOwnProperty.call(S,r)){const a=g(S[r],l,p,b+1);a!==null&&(S[r]=a)}}return null}function w(S,l){const p=g(S,l,!1,0);return p===null?S:p}e.$3m=w;function A(S,l){const p=g(S,l,!0,0);return p===null?S:p}e.$4m=A}),define(Ce[140],Re([1,0,11,21,24]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=e.$Zs=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let $;function g(){return $||($=new TextDecoder("UTF-16BE")),$}let w;function A(){return w||(w=T.$D()?R():g()),w}e.$Zs=A;function S(b,r,a){const t=new Uint16Array(b.buffer,r,a);return a>0&&(t[0]===65279||t[0]===65534)?l(b,r,a):R().decode(t)}e.$1s=S;function l(b,r,a){const t=[];let n=0;for(let o=0;o<a;o++){const c=I.$ie(b,r);r+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class p{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return A().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const a=this.a-this.d;a<=1&&(a===0||E.$_e(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const a=r.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=r;return}for(let t=0;t<a;t++)this.b[this.d++]=r.charCodeAt(t)}}e.$2s=p}),define(Ce[141],Re([1,0,24,140]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=void 0;function I(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,S,l){this.oldPosition=w,this.oldText=A,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,A,S){const l=A.length;E.$le(w,l,S),S+=4;for(let p=0;p<l;p++)E.$je(w,A.charCodeAt(p),S),S+=2;return S}static d(w,A){const S=E.$ke(w,A);return A+=4,(0,T.$1s)(w,A,S)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(w,A){return E.$le(w,this.oldPosition,A),A+=4,E.$le(w,this.newPosition,A),A+=4,A=L.c(w,this.oldText,A),A=L.c(w,this.newText,A),A}static read(w,A,S){const l=E.$ke(w,A);A+=4;const p=E.$ke(w,A);A+=4;const b=L.d(w,A);A+=L.a(b);const r=L.d(w,A);return A+=L.a(r),S.push(new L(l,b,p,r)),A}}e.$3s=L;function R(g,w){return g===null||g.length===0?w:new $(g,w).compress()}e.$4s=R;class ${constructor(w,A){this.a=w,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,A=0,S=this.n(w),l=this.l(A);for(;w<this.f||A<this.h;){if(S===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(S),S=this.n(++w);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++A);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++w);continue}if(l.oldPosition<S.newPosition){const[t,n]=$.r(l,S.newPosition-l.oldPosition);this.k(t),l=n;continue}if(S.newPosition<l.oldPosition){const[t,n]=$.q(S,l.oldPosition-S.newPosition);this.m(t),S=n;continue}let r,a;if(l.oldEnd===S.newEnd)r=S,a=l,S=this.n(++w),l=this.l(++A);else if(l.oldEnd<S.newEnd){const[t,n]=$.q(S,l.oldLength);r=t,a=l,S=n,l=this.l(++A)}else{const[t,n]=$.r(l,S.newLength);r=S,a=t,S=this.n(++w),l=n}this.d[this.e++]=new L(r.oldPosition,r.oldText,a.newPosition,a.newText),this.g+=r.newLength-r.oldLength,this.j+=a.newLength-a.oldLength}const p=$.s(this.d);return $.t(p)}k(w){this.d[this.e++]=$.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=$.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,A){return new L(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static p(w,A){return new L(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static q(w,A){const S=w.newText.substr(0,A),l=w.newText.substr(A);return[new L(w.oldPosition,w.oldText,w.newPosition,S),new L(w.oldEnd,"",w.newPosition+A,l)]}static r(w,A){const S=w.oldText.substr(0,A),l=w.oldText.substr(A);return[new L(w.oldPosition,S,w.newPosition,w.newText),new L(w.oldPosition+A,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const A=[];let S=0,l=w[0];for(let p=1;p<w.length;p++){const b=w[p];l.oldEnd===b.oldPosition?l=new L(l.oldPosition,l.oldText+b.oldText,l.newPosition,l.newText+b.newText):(A[S++]=l,l=b)}return A[S++]=l,A}static t(w){if(w.length===0)return w;const A=[];let S=0;for(let l=0;l<w.length;l++){const p=w[l];p.oldText!==p.newText&&(A[S++]=p)}return A}}}),define(Ce[142],Re([1,0,34,19]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0;function I(L,R,$,g,w,A){if(Array.isArray(L)){let S=0;for(const l of L){const p=I(l,R,$,g,w,A);if(p===10)return p;p>S&&(S=p)}return S}else{if(typeof L=="string")return g?L==="*"?5:L===$?10:0:0;if(L){const{language:S,pattern:l,scheme:p,hasAccessToAllModels:b,notebookType:r}=L;if(!g&&!b)return 0;r&&w&&(R=w);let a=0;if(p)if(p===R.scheme)a=10;else if(p==="*")a=5;else return 0;if(S)if(S===$)a=10;else if(S==="*")a=Math.max(a,5);else return 0;if(r)if(r===A)a=10;else if(r==="*"&&A!==void 0)a=Math.max(a,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$hc)(l.base)},t===R.fsPath||(0,E.$Hj)(t,R.fsPath))a=10;else return 0}return a}else return 0}}e.$ot=I}),define(Ce[143],Re([1,0,5,11,29,93,91,128,141,6]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YB=void 0;class A extends w.$Sc{constructor(l,p,b,r,a,t,n){super(),this.m=this.B(new E.$Sd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!t,this.g=r,this.h=a,this.c=new R.$XB(l,b,n)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const b=l+p,r=this.getPositionAt(l),a=this.getPositionAt(b);return new I.$Hs(r.lineNumber,r.column,a.lineNumber,a.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const b=this.n(p);return this.c.getValueInRange(l,b)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const b=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let a=0;const t=this.n(p),n=this.getEOL();if(t.length!==n.length){const o=t.length-n.length,c=l.endLineNumber-l.startLineNumber;a=o*c}return r-b+a}getCharacterCountInRange(l,p=0){if(this.j){let b=0;const r=l.startLineNumber,a=l.endLineNumber;for(let t=r;t<=a;t++){const n=this.getLineContent(t),o=t===r?l.startColumn-1:0,c=t===a?l.endColumn-1:n.length;for(let h=o;h<c;h++)T.$_e(n.charCodeAt(h))?(b=b+1,h=h+1):b=b+1}return b+=this.n(p).length*(a-r),b}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=T.$We(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=T.$Ye(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,b){let r=this.g,a=this.h,t=this.j,n=!0,o=[];for(let m=0;m<l.length;m++){const f=l[m];n&&f._isTracked&&(n=!1);const k=f.range;if(f.text){let N=!0;t||(N=!T.$kf(f.text),t=N),!r&&N&&(r=T.$jf(f.text)),!a&&N&&(a=T.$mf(f.text))}let F="",v=0,y=0,D=0;if(f.text){let N;[v,y,D,N]=(0,$.$ht)(f.text);const O=this.getEOL();N===0||N===(O===`\r
`?2:1)?F=f.text:F=f.text.replace(/\r\n|\r|\n/g,O)}o[m]={sortIndex:m,identifier:f.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:F,eolCount:v,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}o.sort(A.u);let c=!1;for(let m=0,f=o.length-1;m<f;m++){const k=o[m].range.getEndPosition(),F=o[m+1].range.getStartPosition();if(F.isBeforeOrEqual(k)){if(F.isBefore(k))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const h=b||p?A._getInverseEditRanges(o):[],i=[];if(p)for(let m=0;m<o.length;m++){const f=o[m],k=h[m];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let F=k.startLineNumber;F<=k.endLineNumber;F++){let v="";F===k.startLineNumber&&(v=this.getLineContent(f.range.startLineNumber),T.$We(v)!==-1)||i.push({lineNumber:F,oldContent:v})}}let s=null;if(b){let m=0;s=[];for(let f=0;f<o.length;f++){const k=o[f],F=h[f],v=this.getValueInRange(k.range),y=k.rangeOffset+m;m+=k.text.length-v.length,s[f]={sortIndex:k.sortIndex,identifier:k.identifier,range:F,text:v,textChange:new g.$3s(k.rangeOffset,v,y,k.text)}}c||s.sort((f,k)=>f.sortIndex-k.sortIndex)}this.g=r,this.h=a,this.j=t;const u=this.t(o);let d=null;if(p&&i.length>0){i.sort((m,f)=>f.lineNumber-m.lineNumber),d=[];for(let m=0,f=i.length;m<f;m++){const k=i[m].lineNumber;if(m>0&&i[m-1].lineNumber===k)continue;const F=i[m].oldContent,v=this.getLineContent(k);v.length===0||v===F||T.$We(v)!==-1||d.push(k)}}return this.m.fire(),new L.$4u(s,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const b=l[0].range,r=l[l.length-1].range,a=new I.$Hs(b.startLineNumber,b.startColumn,r.endLineNumber,r.endColumn);let t=b.startLineNumber,n=b.startColumn;const o=[];for(let u=0,d=l.length;u<d;u++){const m=l[u],f=m.range;p=p||m.forceMoveMarkers,o.push(this.getValueInRange(new I.$Hs(t,n,f.startLineNumber,f.startColumn))),m.text.length>0&&o.push(m.text),t=f.endLineNumber,n=f.endColumn}const c=o.join(""),[h,i,s]=(0,$.$ht)(c);return{sortIndex:0,identifier:l[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:s,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let b=0;b<l.length;b++){const r=l[b],a=r.range.startLineNumber,t=r.range.startColumn,n=r.range.endLineNumber,o=r.range.endColumn;if(a===n&&t===o&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new I.$Hs(a,t,n,o);p.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,b,r){return this.c.findMatchesLineByLine(l,p,b,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const b=l.startLineNumber,r=l.startColumn,[a,t,n]=(0,$.$ht)(p);let o;if(p.length>0){const c=a+1;c===1?o=new I.$Hs(b,r,b,r+t):o=new I.$Hs(b,r,b+c-1,n+1)}else o=new I.$Hs(b,r,b,r);return o}static _getInverseEditRanges(l){const p=[];let b=0,r=0,a=null;for(let t=0,n=l.length;t<n;t++){const o=l[t];let c,h;a?a.range.endLineNumber===o.range.startLineNumber?(c=b,h=r+(o.range.startColumn-a.range.endColumn)):(c=b+(o.range.startLineNumber-a.range.endLineNumber),h=o.range.startColumn):(c=o.range.startLineNumber,h=o.range.startColumn);let i;if(o.text.length>0){const s=o.eolCount+1;s===1?i=new I.$Hs(c,h,c,h+o.firstLineLength):i=new I.$Hs(c,h,c+s-1,o.lastLineLength+1)}else i=new I.$Hs(c,h,c,h);b=i.endLineNumber,r=i.endColumn,p.push(i),a=o}return p}static u(l,p){const b=I.$Hs.compareRangesUsingEnds(l.range,p.range);return b===0?l.sortIndex-p.sortIndex:b}static w(l,p){const b=I.$Hs.compareRangesUsingEnds(l.range,p.range);return b===0?p.sortIndex-l.sortIndex:-b}}e.$YB=A}),define(Ce[144],Re([1,0,11,91,143]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZB=void 0;class L{constructor(g,w,A,S,l,p,b,r,a){this.a=g,this.b=w,this.c=A,this.d=S,this.e=l,this.f=p,this.g=b,this.h=r,this.j=a}k(g){const w=this.c+this.d+this.e,A=this.c+this.e;return w===0?g===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create(g){const w=this.k(g),A=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const b=A[l].buffer.replace(/\r\n|\r|\n/g,w),r=(0,T.$TB)(b);A[l]=new T.$WB(b,r)}const S=new I.$YB(A,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$sf(g)&&(this.b=E.$rf,g=g.substr(1));const w=g.charCodeAt(g.length-1);w===13||w>=55296&&w<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=w):(this.m(g,!1),this.c=!1,this.d=w)}m(g,w){!w&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const w=(0,T.$UB)(this.e,g);this.a.push(new T.$WB(g,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$jf(g)),this.k||(this.k=E.$mf(g)))}finish(g=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const w=(0,T.$TB)(g.buffer);g.lineStarts=w,this.d===13&&this.f++}}}e.$ZB=R}),define(Ce[96],Re([1,0,24,21]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$=e.$g$=void 0;var I;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(I||(I={}));function L(S){for(let l=0,p=S.length;l<p;l+=4){const b=S[l+0],r=S[l+1],a=S[l+2],t=S[l+3];S[l+0]=t,S[l+1]=a,S[l+2]=r,S[l+3]=b}}function R(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.$D()||L(l),E.$ge.wrap(l)}function $(S){const l=S.buffer;if(T.$D()||L(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function g(S){const l=new Uint32Array(w(S));let p=0;if(l[p++]=S.id,S.type==="full")l[p++]=1,l[p++]=S.data.length,l.set(S.data,p),p+=S.data.length;else{l[p++]=2,l[p++]=S.deltas.length;for(const b of S.deltas)l[p++]=b.start,l[p++]=b.deleteCount,b.data?(l[p++]=b.data.length,l.set(b.data,p),p+=b.data.length):l[p++]=0}return R(l)}e.$g$=g;function w(S){let l=0;if(l+=1+1,S.type==="full")l+=1+S.data.length;else{l+=1,l+=(1+1+1)*S.deltas.length;for(const p of S.deltas)p.data&&(l+=p.data.length)}return l}function A(S){const l=$(S);let p=0;const b=l[p++];if(l[p++]===1){const n=l[p++],o=l.subarray(p,p+n);return p+=n,{id:b,type:"full",data:o}}const a=l[p++],t=[];for(let n=0;n<a;n++){const o=l[p++],c=l[p++],h=l[p++];let i;h>0&&(i=l.subarray(p,p+h),p+=h),t[n]={start:o,deleteCount:c,data:i}}return{id:b,type:"delta",deltas:t}}e.$h$=A}),define(Ce[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Ce[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class S{constructor(_,pe,Be,Qe){this.id=_,this.name=pe,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,pe){return p(_,pe)}compute(_,pe,Be){return Be}}class l{constructor(_,pe){this.newValue=_,this.didChange=pe}}e.ApplyUpdateResult=l;function p(Y,_){if(typeof Y!="object"||typeof _!="object"||!Y||!_)return new l(_,Y!==_);if(Array.isArray(Y)||Array.isArray(_)){const Be=Array.isArray(Y)&&Array.isArray(_)&&E.$ub(Y,_);return new l(_,!Be)}let pe=!1;for(const Be in _)if(_.hasOwnProperty(Be)){const Qe=p(Y[Be],_[Be]);Qe.didChange&&(Y[Be]=Qe.newValue,pe=!0)}return new l(Y,pe)}class b{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,pe){return p(_,pe)}validate(_){return this.defaultValue}}class r{constructor(_,pe,Be,Qe){this.id=_,this.name=pe,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,pe){return p(_,pe)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,pe,Be){return Be}}function a(Y,_){return typeof Y>"u"?_:Y==="false"?!1:!!Y}e.boolean=a;class t extends r{constructor(_,pe,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(_,pe,Be,Qe)}validate(_){return a(_,this.defaultValue)}}function n(Y,_,pe,Be){if(typeof Y>"u")return _;let Qe=parseInt(Y,10);return isNaN(Qe)?_:(Qe=Math.max(pe,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class o extends r{static clampedInt(_,pe,Be,Qe){return n(_,pe,Be,Qe)}constructor(_,pe,Be,Qe,it,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Qe,rt.maximum=it),super(_,pe,Be,rt),this.minimum=Qe,this.maximum=it}validate(_){return o.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function c(Y,_,pe,Be){if(typeof Y>"u")return _;const Qe=h.float(Y,_);return h.clamp(Qe,pe,Be)}e.clampedFloat=c;class h extends r{static clamp(_,pe,Be){return _<pe?pe:_>Be?Be:_}static float(_,pe){if(typeof _=="number")return _;if(typeof _>"u")return pe;const Be=parseFloat(_);return isNaN(Be)?pe:Be}constructor(_,pe,Be,Qe,it){typeof it<"u"&&(it.type="number",it.default=Be),super(_,pe,Be,it),this.validationFn=Qe}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class i extends r{static string(_,pe){return typeof _!="string"?pe:_}constructor(_,pe,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(_,pe,Be,Qe)}validate(_){return i.string(_,this.defaultValue)}}function s(Y,_,pe,Be){return typeof Y!="string"?_:Be&&Y in Be?Be[Y]:pe.indexOf(Y)===-1?_:Y}e.stringSet=s;class u extends r{constructor(_,pe,Be,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=Be),super(_,pe,Be,it),this.c=Qe}validate(_){return s(_,this.defaultValue,this.c)}}class d extends S{constructor(_,pe,Be,Qe,it,rt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=it,Ne.default=Qe),super(_,pe,Be,Ne),this.c=it,this.d=rt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function m(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,pe,Be){return Be===0?_.accessibilitySupport:Be}}class k extends S{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:$.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertSpace:a(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var F;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(F||(e.TextEditorCursorBlinkingStyle=F={}));function v(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(Y){switch(Y){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function N(Y){switch(Y){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class O extends b{constructor(){super(140)}compute(_,pe,Be){const Qe=["monaco-editor"];return pe.get(39)&&Qe.push(pe.get(39)),_.extraEditorClassName&&Qe.push(_.extraEditorClassName),pe.get(73)==="default"?Qe.push("mouse-default"):pe.get(73)==="copy"&&Qe.push("mouse-copy"),pe.get(110)&&Qe.push("showUnused"),pe.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class W extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(_,pe,Be){return Be&&_.emptySelectionClipboard}}class z extends S{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:$.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:$.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{cursorMoveOnType:a(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(pe.loop,this.defaultValue.loop)}}}class V extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?V.OFF:_==="true"?V.ON:_:_?V.ON:V.OFF}}e.EditorFontLigatures=V;class P extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?P.OFF:_==="true"?P.TRANSLATE:_:_?P.TRANSLATE:P.OFF}compute(_,pe,Be){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class C extends b{constructor(){super(50)}compute(_,pe,Be){return _.fontInfo}}class Z extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(_){const pe=h.float(_,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(_,pe,Be){return _.fontInfo.fontSize}}class ce extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ce.d,maximum:ce.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ce.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(o.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,ce.d,ce.e))}}class me extends S{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class be extends S{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:$.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),delay:o.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:a(pe.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(pe.above,this.defaultValue.above)}}}var ke;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class fe extends b{constructor(){super(143)}compute(_,pe,Be){return fe.computeLayout(pe,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const pe=_.height/_.lineHeight,Be=Math.floor(_.paddingTop/_.lineHeight);let Qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Qe=Math.max(Qe,pe-1));const it=(Be+_.viewLineCount+Qe)/(_.pixelRatio*_.height),rt=Math.floor(_.viewLineCount/it);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:rt}}static c(_,pe){const Be=_.outerWidth,Qe=_.outerHeight,it=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=pe.stableMinimapLayoutInput,Ne=rt&&_.outerHeight===rt.outerHeight&&_.lineHeight===rt.lineHeight&&_.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&_.pixelRatio===rt.pixelRatio&&_.scrollBeyondLastLine===rt.scrollBeyondLastLine&&_.paddingTop===rt.paddingTop&&_.paddingBottom===rt.paddingBottom&&_.minimap.enabled===rt.minimap.enabled&&_.minimap.side===rt.minimap.side&&_.minimap.size===rt.minimap.size&&_.minimap.showSlider===rt.minimap.showSlider&&_.minimap.renderCharacters===rt.minimap.renderCharacters&&_.minimap.maxColumn===rt.minimap.maxColumn&&_.minimap.scale===rt.minimap.scale&&_.verticalScrollbarWidth===rt.verticalScrollbarWidth&&_.isViewportWrapping===rt.isViewportWrapping,Pt=_.lineHeight,Tt=_.typicalHalfwidthCharacterWidth,Ht=_.scrollBeyondLastLine,Bt=_.minimap.renderCharacters;let yt=it>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Kt=_.minimap.maxColumn,Nt=_.minimap.size,Zt=_.minimap.side,jt=_.verticalScrollbarWidth,Rt=_.viewLineCount,Xe=_.remainingWidth,Gt=_.isViewportWrapping,Jt=Bt?2:3;let lt=Math.floor(it*Qe);const $t=lt/it;let zt=!1,Wt=!1,Dt=Jt*yt,dt=yt/it,Ct=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Mt,extraLinesBeyondLastLine:Ee,desiredRatio:Me,minimapLineCount:he}=fe.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Ht,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Qe,lineHeight:Pt,pixelRatio:it});if(Rt/he>1)zt=!0,Wt=!0,yt=1,Dt=1,dt=yt/it;else{let Le=!1,Ue=yt+1;if(Nt==="fit"){const Ze=Math.ceil((Mt+Rt+Ee)*Dt);Gt&&Ne&&Xe<=pe.stableFitRemainingWidth?(Le=!0,Ue=pe.stableFitMaxMinimapScale):Le=Ze>lt}if(Nt==="fill"||Le){zt=!0;const Ze=yt;Dt=Math.min(Pt*it,Math.max(1,Math.floor(1/Me))),Gt&&Ne&&Xe<=pe.stableFitRemainingWidth&&(Ue=pe.stableFitMaxMinimapScale),yt=Math.min(Ue,Math.max(1,Math.floor(Dt/Jt))),yt>Ze&&(Ct=Math.min(2,yt/Ze)),dt=yt/it/Ct,lt=Math.ceil(Math.max(gt,Mt+Rt+Ee)*Dt),Gt?(pe.stableMinimapLayoutInput=_,pe.stableFitRemainingWidth=Xe,pe.stableFitMaxMinimapScale=yt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const xt=Math.floor(Kt*dt),kt=Math.min(xt,Math.max(0,Math.floor((Xe-jt-2)*dt/(Tt+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(it*kt);const Ft=qe/it;qe=Math.floor(qe*Ct);const Vt=Bt?1:2,Qt=Zt==="left"?0:Be-kt-jt;return{renderMinimap:Vt,minimapLeft:Qt,minimapWidth:kt,minimapHeightIsEditorHeight:zt,minimapIsSampling:Wt,minimapScale:yt,minimapLineHeight:Dt,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:$t}}static computeLayout(_,pe){const Be=pe.outerWidth|0,Qe=pe.outerHeight|0,it=pe.lineHeight|0,rt=pe.lineNumbersDigitCount|0,Ne=pe.typicalHalfwidthCharacterWidth,Pt=pe.maxDigitWidth,Tt=pe.pixelRatio,Ht=pe.viewLineCount,Bt=_.get(135),yt=Bt==="inherit"?_.get(134):Bt,Kt=yt==="inherit"?_.get(130):yt,Nt=_.get(133),Zt=pe.isDominatedByLongLines,jt=_.get(57),Rt=_.get(67).renderType!==0,Xe=_.get(68),Gt=_.get(104),Jt=_.get(83),lt=_.get(72),$t=_.get(102),zt=$t.verticalScrollbarSize,Wt=$t.verticalHasArrows,Dt=$t.arrowSize,dt=$t.horizontalScrollbarSize,Ct=_.get(43),xt=_.get(109)!=="never";let kt=_.get(65);Ct&&xt&&(kt+=16);let qe=0;if(Rt){const _e=Math.max(rt,Xe);qe=Math.round(_e*Pt)}let Ft=0;jt&&(Ft=it*pe.glyphMarginDecorationLaneCount);let Vt=0,Qt=Vt+Ft,gt=Qt+qe,Mt=gt+kt;const Ee=Be-Ft-qe-kt;let Me=!1,he=!1,G=-1;yt==="inherit"&&Zt?(Me=!0,he=!0):Kt==="on"||Kt==="bounded"?he=!0:Kt==="wordWrapColumn"&&(G=Nt);const Le=fe.c({outerWidth:Be,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Tt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:zt,viewLineCount:Ht,remainingWidth:Ee,isViewportWrapping:he},pe.memory||new A);Le.renderMinimap!==0&&Le.minimapLeft===0&&(Vt+=Le.minimapWidth,Qt+=Le.minimapWidth,gt+=Le.minimapWidth,Mt+=Le.minimapWidth);const Ue=Ee-Le.minimapWidth,Ze=Math.max(1,Math.floor((Ue-zt-2)/Ne)),Ve=Wt?Dt:0;return he&&(G=Math.max(1,Ze),Kt==="bounded"&&(G=Math.min(G,Nt))),{width:Be,height:Qe,glyphMarginLeft:Vt,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:qe,decorationsLeft:gt,decorationsWidth:kt,contentLeft:Mt,contentWidth:Ue,minimap:Le,viewportColumn:Ze,isWordWrapMinified:Me,isViewportWrapping:he,wrappingColumn:G,verticalScrollbarWidth:zt,horizontalScrollbarHeight:dt,overviewRuler:{top:Ve,width:zt,height:Qe-2*Ve,right:0}}}}e.EditorLayoutInfoComputer=fe;class de extends S{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(_){return s(_,"simple",["simple","advanced"])}compute(_,pe,Be){return pe.get(2)===2?"advanced":Be}}var ie;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class Se extends S{constructor(){const _={enabled:ie.OnCode};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",enum:[ie.Off,ie.OnCode,ie.On],default:_.enabled,enumDescriptions:[$.localize(50,null),$.localize(51,null),$.localize(52,null)],description:$.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:s(_.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class oe extends S{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:$.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:$.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:$.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:$.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class x extends S{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:$.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(59,null),$.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:$.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:$.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:$.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily),padding:a(pe.padding,this.defaultValue.padding)}}}class q extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):o.clampedInt(_,this.defaultValue,0,1e3)}compute(_,pe,Be){return Be<0?o.clampedInt(-Be*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:$.localize(66,null)})}compute(_,pe,Be){return _.fontInfo.lineHeight}}class Ie extends S{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:$.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:$.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(69,null),$.localize(70,null),$.localize(71,null)],default:_.size,description:$.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:$.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:$.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:$.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:$.localize(77,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),autohide:a(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(pe.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(pe.scale,1,1,3),maxColumn:o.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(Y){return Y==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Pe extends S{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(79,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{top:o.clampedInt(pe.top,0,0,1e3),bottom:o.clampedInt(pe.bottom,0,0,1e3)}}}class ae extends S{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:$.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:$.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),cycle:a(pe.cycle,this.defaultValue.cycle)}}}class te extends b{constructor(){super(141)}compute(_,pe,Be){return _.pixelRatio}}class J extends S{constructor(){const _={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(82,null),$.localize(83,null),$.localize(84,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:_.strings,description:$.localize(85,null)},comments:{anyOf:pe,default:_.comments,description:$.localize(86,null)},other:{anyOf:pe,default:_.other,description:$.localize(87,null)}},default:_,markdownDescription:$.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Tt=_?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!_||typeof _!="object")return this.defaultValue;const{other:pe,comments:Be,strings:Qe}=_,it=["on","inline","off"];let rt,Ne,Pt;return typeof pe=="boolean"?rt=pe?"on":"off":rt=s(pe,this.defaultValue.other,it),typeof Be=="boolean"?Ne=Be?"on":"off":Ne=s(Be,this.defaultValue.comments,it),typeof Qe=="boolean"?Pt=Qe?"on":"off":Pt=s(Qe,this.defaultValue.strings,it),{other:rt,comments:Ne,strings:Pt}}}var ee;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class $e extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(89,null),$.localize(90,null),$.localize(91,null),$.localize(92,null)],default:"on",description:$.localize(93,null)})}validate(_){let pe=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(pe=4,Be=_):_==="interval"?pe=3:_==="relative"?pe=2:_==="on"?pe=1:pe=0),{renderType:pe,renderFn:Be}}}function ve(Y){const _=Y.get(97);return _==="editable"?Y.get(90):_!=="on"}e.filterValidationDecorations=ve;class Fe extends S{constructor(){const _=[],pe={type:"number",description:$.localize(94,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:$.localize(95,null),format:"color-hex"}}}]},default:_,description:$.localize(96,null)})}validate(_){if(Array.isArray(_)){const pe=[];for(const Be of _)if(typeof Be=="number")pe.push({column:o.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;pe.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return pe.sort((Be,Qe)=>Be.column-Qe.column),pe}return this.defaultValue}}class le extends S{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function we(Y,_){if(typeof Y!="string")return _;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class M extends S{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(97,null),$.localize(98,null),$.localize(99,null)],default:"auto",description:$.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(101,null),$.localize(102,null),$.localize(103,null)],default:"auto",description:$.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:$.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:$.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:$.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:$.localize(108,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_,Be=o.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:we(pe.vertical,this.defaultValue.vertical),horizontal:we(pe.horizontal,this.defaultValue.horizontal),useShadows:a(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:o.clampedInt(pe.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt(pe.verticalSliderSize,Qe,0,1e3),scrollByPage:a(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends S{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:$.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:$.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:$.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:$.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:$.localize(115,null)}})}applyUpdate(_,pe){let Be=!1;pe.allowedCharacters&&_&&(T.$mn(_.allowedCharacters,pe.allowedCharacters)||(_={..._,allowedCharacters:pe.allowedCharacters},Be=!0)),pe.allowedLocales&&_&&(T.$mn(_.allowedLocales,pe.allowedLocales)||(_={..._,allowedLocales:pe.allowedLocales},Be=!0));const Qe=super.applyUpdate(_,pe);return Be?new l(Qe.newValue,!0):Qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{nonBasicASCII:X(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:X(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:X(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,pe){if(typeof _!="object"||!_)return pe;const Be={};for(const[Qe,it]of Object.entries(_))it===!0&&(Be[Qe]=!0);return Be}}class H extends S{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:$.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(117,null),$.localize(118,null),$.localize(119,null)],description:$.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:$.localize(121,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class U extends S{constructor(){const _={enabled:L.$es.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$es.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:$.localize(123,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends S{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:_.bracketPairs,description:$.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(128,null),$.localize(129,null),$.localize(130,null)],default:_.bracketPairsHorizontal,description:$.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:$.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:$.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(134,null),$.localize(135,null),$.localize(136,null)],default:_.highlightActiveIndentation,description:$.localize(137,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{bracketPairs:X(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:X(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:X(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function X(Y,_,pe){const Be=pe.indexOf(Y);return Be===-1?_:pe[Be]}class ye extends S{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(138,null),$.localize(139,null)],default:_.insertMode,description:$.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:$.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:$.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:$.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(144,null),$.localize(145,null),$.localize(146,null),$.localize(147,null)],default:_.selectionMode,markdownDescription:$.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:$.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:$.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:$.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:$.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:$.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(185,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(pe.showIcons,this.defaultValue.showIcons),showStatusBar:a(pe.showStatusBar,this.defaultValue.showStatusBar),preview:a(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(pe.showMethods,this.defaultValue.showMethods),showFunctions:a(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:a(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(pe.showFields,this.defaultValue.showFields),showVariables:a(pe.showVariables,this.defaultValue.showVariables),showClasses:a(pe.showClasses,this.defaultValue.showClasses),showStructs:a(pe.showStructs,this.defaultValue.showStructs),showInterfaces:a(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:a(pe.showModules,this.defaultValue.showModules),showProperties:a(pe.showProperties,this.defaultValue.showProperties),showEvents:a(pe.showEvents,this.defaultValue.showEvents),showOperators:a(pe.showOperators,this.defaultValue.showOperators),showUnits:a(pe.showUnits,this.defaultValue.showUnits),showValues:a(pe.showValues,this.defaultValue.showValues),showConstants:a(pe.showConstants,this.defaultValue.showConstants),showEnums:a(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:a(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(pe.showKeywords,this.defaultValue.showKeywords),showWords:a(pe.showWords,this.defaultValue.showWords),showColors:a(pe.showColors,this.defaultValue.showColors),showFiles:a(pe.showFiles,this.defaultValue.showFiles),showReferences:a(pe.showReferences,this.defaultValue.showReferences),showFolders:a(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:a(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(pe.showSnippets,this.defaultValue.showSnippets),showUsers:a(pe.showUsers,this.defaultValue.showUsers),showIssues:a(pe.showIssues,this.defaultValue.showIssues)}}}class Te extends S{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(187,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(_.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class He extends S{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(188,null),$.localize(189,null),$.localize(190,null),$.localize(191,null)],description:$.localize(192,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,pe,Be){return pe.get(2)===2?0:Be}}class Ye extends b{constructor(){super(144)}compute(_,pe,Be){const Qe=pe.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class st extends S{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends S{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:$.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(199,null),$.localize(200,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?at:I.$k?ct:tt,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var vt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(201,null)})),acceptSuggestionOnEnter:ze(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(202,null),""],markdownDescription:$.localize(203,null)})),accessibilitySupport:ze(new f),accessibilityPageSize:ze(new o(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(204,null),tags:["accessibility"]})),ariaLabel:ze(new i(4,"ariaLabel",$.localize(205,null))),ariaRequired:ze(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:ze(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingComments:ze(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(210,null),$.localize(211,null),""],description:$.localize(212,null)})),autoClosingDelete:ze(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(213,null),""],description:$.localize(214,null)})),autoClosingOvertype:ze(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(215,null),""],description:$.localize(216,null)})),autoClosingQuotes:ze(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(217,null),$.localize(218,null),""],description:$.localize(219,null)})),autoIndent:ze(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[$.localize(220,null),$.localize(221,null),$.localize(222,null),$.localize(223,null),$.localize(224,null)],description:$.localize(225,null)})),automaticLayout:ze(new t(13,"automaticLayout",!1)),autoSurround:ze(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(226,null),$.localize(227,null),$.localize(228,null),""],description:$.localize(229,null)})),bracketPairColorization:ze(new U),bracketPairGuides:ze(new Q),stickyTabStops:ze(new t(115,"stickyTabStops",!1,{description:$.localize(230,null)})),codeLens:ze(new t(17,"codeLens",!0,{description:$.localize(231,null)})),codeLensFontFamily:ze(new i(18,"codeLensFontFamily","",{description:$.localize(232,null)})),codeLensFontSize:ze(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(233,null)})),colorDecorators:ze(new t(20,"colorDecorators",!0,{description:$.localize(234,null)})),colorDecoratorActivatedOn:ze(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(235,null),$.localize(236,null),$.localize(237,null)],description:$.localize(238,null)})),colorDecoratorsLimit:ze(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(239,null)})),columnSelection:ze(new t(22,"columnSelection",!1,{description:$.localize(240,null)})),comments:ze(new k),contextmenu:ze(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new t(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(241,null)})),cursorBlinking:ze(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:$.localize(242,null)})),cursorSmoothCaretAnimation:ze(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(243,null),$.localize(244,null),$.localize(245,null)],description:$.localize(246,null)})),cursorStyle:ze(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:$.localize(247,null)})),cursorSurroundingLines:ze(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(248,null)})),cursorSurroundingLinesStyle:ze(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(249,null),$.localize(250,null)],markdownDescription:$.localize(251,null)})),cursorWidth:ze(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(252,null)})),disableLayerHinting:ze(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new t(34,"domReadOnly",!1)),dragAndDrop:ze(new t(35,"dragAndDrop",!0,{description:$.localize(253,null)})),emptySelectionClipboard:ze(new W),dropIntoEditor:ze(new st),stickyScroll:ze(new oe),experimentalWhitespaceRendering:ze(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(254,null),$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),extraEditorClassName:ze(new i(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new h(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:$.localize(258,null)})),find:ze(new z),fixedOverflowWidgets:ze(new t(42,"fixedOverflowWidgets",!1)),folding:ze(new t(43,"folding",!0,{description:$.localize(259,null)})),foldingStrategy:ze(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(260,null),$.localize(261,null)],description:$.localize(262,null)})),foldingHighlight:ze(new t(45,"foldingHighlight",!0,{description:$.localize(263,null)})),foldingImportsByDefault:ze(new t(46,"foldingImportsByDefault",!1,{description:$.localize(264,null)})),foldingMaximumRegions:ze(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(265,null)})),unfoldOnClickAfterEndOfLine:ze(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(266,null)})),fontFamily:ze(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(267,null)})),fontInfo:ze(new C),fontLigatures2:ze(new V),fontSize:ze(new Z),fontWeight:ze(new ce),fontVariations:ze(new P),formatOnPaste:ze(new t(55,"formatOnPaste",!1,{description:$.localize(268,null)})),formatOnType:ze(new t(56,"formatOnType",!1,{description:$.localize(269,null)})),glyphMargin:ze(new t(57,"glyphMargin",!0,{description:$.localize(270,null)})),gotoLocation:ze(new me),hideCursorInOverviewRuler:ze(new t(59,"hideCursorInOverviewRuler",!1,{description:$.localize(271,null)})),hover:ze(new be),inDiffEditor:ze(new t(61,"inDiffEditor",!1)),letterSpacing:ze(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>h.clamp(Y,-5,20),{description:$.localize(272,null)})),lightbulb:ze(new Se),lineDecorationsWidth:ze(new q),lineHeight:ze(new ne),lineNumbers:ze(new $e),lineNumbersMinChars:ze(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new t(69,"linkedEditing",!1,{description:$.localize(273,null)})),links:ze(new t(70,"links",!0,{description:$.localize(274,null)})),matchBrackets:ze(new u(71,"matchBrackets","always",["always","near","never"],{description:$.localize(275,null)})),minimap:ze(new Ie),mouseStyle:ze(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new h(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:$.localize(276,null)})),mouseWheelZoom:ze(new t(75,"mouseWheelZoom",!1,{markdownDescription:I.$j?$.localize(277,null):$.localize(278,null)})),multiCursorMergeOverlapping:ze(new t(76,"multiCursorMergeOverlapping",!0,{description:$.localize(279,null)})),multiCursorModifier:ze(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[$.localize(280,null),$.localize(281,null)],markdownDescription:$.localize(282,null)})),multiCursorPaste:ze(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),multiCursorLimit:ze(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(286,null)})),occurrencesHighlight:ze(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(287,null),$.localize(288,null),$.localize(289,null)],markdownDescription:$.localize(290,null)})),overviewRulerBorder:ze(new t(81,"overviewRulerBorder",!0,{description:$.localize(291,null)})),overviewRulerLanes:ze(new o(82,"overviewRulerLanes",3,0,3)),padding:ze(new Pe),pasteAs:ze(new nt),parameterHints:ze(new ae),peekWidgetDefaultFocus:ze(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(292,null),$.localize(293,null)],description:$.localize(294,null)})),definitionLinkOpensInPeek:ze(new t(87,"definitionLinkOpensInPeek",!1,{description:$.localize(295,null)})),quickSuggestions:ze(new J),quickSuggestionsDelay:ze(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(296,null)})),readOnly:ze(new t(90,"readOnly",!1)),readOnlyMessage:ze(new le),renameOnType:ze(new t(92,"renameOnType",!1,{description:$.localize(297,null),markdownDeprecationMessage:$.localize(298,null)})),renderControlCharacters:ze(new t(93,"renderControlCharacters",!0,{description:$.localize(299,null),restricted:!0})),renderFinalNewline:ze(new u(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(300,null)})),renderLineHighlight:ze(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(301,null)],description:$.localize(302,null)})),renderLineHighlightOnlyWhenFocus:ze(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(303,null)})),renderValidationDecorations:ze(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(304,null),$.localize(305,null),$.localize(306,null),""],description:$.localize(307,null)})),revealHorizontalRightPadding:ze(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new t(100,"roundedSelection",!0,{description:$.localize(308,null)})),rulers:ze(new Fe),scrollbar:ze(new M),scrollBeyondLastColumn:ze(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(309,null)})),scrollBeyondLastLine:ze(new t(104,"scrollBeyondLastLine",!0,{description:$.localize(310,null)})),scrollPredominantAxis:ze(new t(105,"scrollPredominantAxis",!0,{description:$.localize(311,null)})),selectionClipboard:ze(new t(106,"selectionClipboard",!0,{description:$.localize(312,null),included:I.$k})),selectionHighlight:ze(new t(107,"selectionHighlight",!0,{description:$.localize(313,null)})),selectOnLineNumbers:ze(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),showUnused:ze(new t(110,"showUnused",!0,{description:$.localize(318,null)})),showDeprecated:ze(new t(138,"showDeprecated",!0,{description:$.localize(319,null)})),inlayHints:ze(new x),snippetSuggestions:ze(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(320,null),$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),smartSelect:ze(new Te),smoothScrolling:ze(new t(113,"smoothScrolling",!1,{description:$.localize(325,null)})),stopRenderingLineAfter:ze(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ye),inlineSuggest:ze(new H),inlineCompletionsAccessibilityVerbose:ze(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(326,null)})),suggestFontSize:ze(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new t(120,"suggestOnTriggerCharacters",!0,{description:$.localize(329,null)})),suggestSelection:ze(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabCompletion:ze(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),tabIndex:ze(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),useShadowDOM:ze(new t(126,"useShadowDOM",!0)),useTabStops:ze(new t(127,"useTabStops",!0,{description:$.localize(342,null)})),wordBreak:ze(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null)],description:$.localize(345,null)})),wordSeparators:ze(new i(129,"wordSeparators",R.$fs,{description:$.localize(346,null)})),wordWrap:ze(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(347,null),$.localize(348,null),$.localize(349,null),$.localize(350,null)],description:$.localize(351,null)})),wordWrapBreakAfterCharacters:ze(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(352,null)})),wordWrapOverride1:ze(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new O),defaultColorDecorators:ze(new t(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(353,null)})),pixelRatio:ze(new te),tabFocusMode:ze(new t(142,"tabFocusMode",!1,{markdownDescription:$.localize(354,null)})),layoutInfo:ze(new fe),wrappingInfo:ze(new Ye),wrappingIndent:ze(new He),wrappingStrategy:ze(new de)}}),define(Ce[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Ce[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Ce[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Ce[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Ce[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Ce[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Ce[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[180],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[181],Re([1,0,14,150]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var I;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(I||(e.TokenType=I={}));function L(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const R=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const S=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const S=this.c.substring(this.d,this.e),l=g.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,S=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const b=this.c.charCodeAt(A);if(S)S=!1;else if(b===47&&!l){A++;break}else b===91?l=!0:b===92?S=!0:b===93&&(l=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=g}),define(Ce[182],Re([1,0,25,31,152,294]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||R.test(t)}e.$Zo=g;function w(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$1o=w;function A(t){if(!t)return null;const n=t.majorBase,o=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let s=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),s=!1);let u=0;if(t.preRelease){const d=$.exec(t.preRelease);if(d){const[,m,f,k]=d;u=Date.UTC(Number(m),Number(f)-1,Number(k))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:s,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$2o=A;function S(t,n,o){let c;typeof t=="string"?c=A(w(t)):c=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof o=="string"?i=A(w(o)):i=o,!c||!i)return!1;const s=c.majorBase,u=c.minorBase,d=c.patchBase;let m=i.majorBase,f=i.minorBase,k=i.patchBase;const F=i.notBefore;let v=i.majorMustEqual,y=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?s>m?!0:s<m?!1:u>f?!0:u<f||h&&h<F?!1:d>=k:(s===1&&m===0&&(!v||!y||!D)&&(m=1,f=0,k=0,v=!0,y=!1,D=!1),s<m?!1:s>m?!v:u<f?!1:u>f?!y:d<k?!1:d>k?!D:!(h&&h<F))}e.$3o=S;function l(t,n,o,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,I.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,I.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,I.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,I.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return i.push([T.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return i.push([T.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,I.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,I.localize(9,null,"main")]),i;{const d=(0,E.$Dg)(o,c.main);(0,E.$xg)(d,o)||i.push([T.default.Warning,I.localize(10,null,d.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,I.localize(11,null,"browser")]),i;{const d=(0,E.$Dg)(o,c.browser);(0,E.$xg)(d,o)||i.push([T.default.Warning,I.localize(12,null,d.path,o.path)])}}if(!L.valid(c.version))return i.push([T.default.Error,I.localize(13,null)]),i;const s=[];if(!p(t,n,c,h,s))for(const d of s)i.push([T.default.Error,d]);return i}e.$4o=l;function p(t,n,o,c,h){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:r(t,n,o.engines.vscode,h)}e.$5o=p;function b(t,n,o){return t==="*"||r(n,o,t)}e.$6o=b;function r(t,n,o,c=[]){const h=A(w(o));if(!h)return c.push(I.localize(14,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(I.localize(15,null,o)),!1}else if(!h.majorMustEqual)return c.push(I.localize(16,null,o)),!1;return S(t,n,h)?!0:(c.push(I.localize(17,null,t,o)),!1)}function a(t){if(!Array.isArray(t))return!1;for(let n=0,o=t.length;n<o;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Ce[69],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class E{constructor(I,L=[],R=!1){this.ctor=I,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Yh=E}),define(Ce[70],Re([1,0,69]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.InstantiationType=void 0;const T=[];var I;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function L($,g,w){g instanceof E.$Yh||(g=new E.$Yh(g,[],!!w)),T.push([$,g])}e.$Kr=L;function R(){return T}e.$Lr=R}),define(Ce[183],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class E{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$pq=E;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const $=this.lookupOrInsertNode(L),g=this.lookupOrInsertNode(R);$.outgoing.set(g.key,g),g.incoming.set($.key,$)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let $=this.a.get(R);return $||($=new E(R,L),this.a.set(R,$)),$}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,$]of this.a)L.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const $=new Set([L]),g=this.c(R,$);if(g)return g}}c(L,R){for(const[$,g]of L.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const w=this.c(g,R);if(w)return w;R.delete($)}}}e.$qq=T}),define(Ce[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(g){return g[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$1h=I("instantiationService");function T(R,$,g){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:g}):($[E.DI_DEPENDENCIES]=[{id:R,index:g}],$[E.DI_TARGET]=$)}function I(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(g,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,g,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$2h=I;function L(R){return R}e.$3h=L}),define(Ce[41],Re([1,0,16,2,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,I.$2h)("configurationService");function L(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$wi=L;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$xi=R;var $;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=g;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$zi=w;function A(t,n){const o=Object.create(null);for(const c in t)S(o,c,t[c],n);return o}e.$Ai=A;function S(t,n,o,c){const h=n.split("."),i=h.pop();let s=t;for(let u=0;u<h.length;u++){const d=h[u];let m=s[d];switch(typeof m){case"undefined":m=s[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(m)}`);return}s=m}if(typeof s=="object"&&s!==null)try{s[i]=o}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$Bi=S;function l(t,n){const o=n.split(".");p(t,o)}e.$Ci=l;function p(t,n){const o=n.shift();if(n.length===0){delete t[o];return}if(Object.keys(t).indexOf(o)!==-1){const c=t[o];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete t[o])}}function b(t,n,o){function c(s,u){let d=s;for(const m of u){if(typeof d!="object"||d===null)return;d=d[m]}return d}const h=n.split("."),i=c(t,h);return typeof i>"u"?o:i}e.$Di=b;function r(t,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Gf(t[c])&&E.$Gf(n[c])?r(t[c],n[c],o):o&&(t[c]=n[c]):t[c]=n[c])})}e.$Ei=r;function a(t){return t.replace(/[\[\]]/g,"")}e.$Fi=a}),define(Ce[35],Re([1,0,21,11,181,4,149,14]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function w(x,q){if(g.get(x)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(x,q)}e.$Xi=w;const A=Object.prototype.hasOwnProperty;var S;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),b=(0,R.localize)(1,null),r=(0,R.localize)(2,null),a=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),o=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=l){this.k=q,this.d=new I.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Ae=Ie.type===17?n:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:I.$Wi.getLexeme(Ie),additionalInfo:Ae}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(16);){const ne=this.o();q.push(ne)}return q.length===1?q[0]:i.or(...q)}o(){const q=[this.s()];for(;this.y(15);){const ne=this.s();q.push(ne)}return q.length===1?q[0]:i.and(...q)}s(){if(this.y(2)){const q=this.D();switch(q.type){case 11:return this.z(),m.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,a),ne?.negate()}case 17:return this.z(),N.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,a),ne}case 17:{const ne=q.lexeme;if(this.z(),this.y(9)){const Ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ae.type!==10)throw this.B("REGEX",Ae);const Pe=Ae.lexeme,ae=Pe.lastIndexOf("/"),te=ae===Pe.length-1?void 0:this.w(Pe.substring(ae+1));let J;try{J=new RegExp(Pe.substring(1,ae),te)}catch{throw this.B("REGEX",Ae)}return C.create(ne,J)}switch(Ae.type){case 10:case 19:{const Pe=[Ae.lexeme];this.z();let ae=this.D(),te=0;for(let Fe=0;Fe<Ae.lexeme.length;Fe++)Ae.lexeme.charCodeAt(Fe)===40?te++:Ae.lexeme.charCodeAt(Fe)===41&&te--;for(;!this.E()&&ae.type!==15&&ae.type!==16;){switch(ae.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Fe=0;Fe<ae.lexeme.length;Fe++)ae.lexeme.charCodeAt(Fe)===40?te++:Ae.lexeme.charCodeAt(Fe)===41&&te--}if(te<0)break;Pe.push(I.$Wi.getLexeme(ae)),this.z(),ae=this.D()}const J=Pe.join(""),ee=J.lastIndexOf("/"),$e=ee===J.length-1?void 0:this.w(J.substring(ee+1));let ve;try{ve=new RegExp(J.substring(1,ee),$e)}catch{throw this.B("REGEX",Ae)}return i.regex(ne,ve)}case 18:{const Pe=Ae.lexeme;this.z();let ae=null;if(!(0,T.$Ge)(Pe)){const te=Pe.indexOf("/"),J=Pe.lastIndexOf("/");if(te!==J&&te>=0){const ee=Pe.slice(te+1,J),$e=Pe[J+1]==="i"?"i":"";try{ae=new RegExp(ee,$e)}catch{throw this.B("REGEX",Ae)}}}if(ae===null)throw this.B("REGEX",Ae);return C.create(ne,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Ae=this.u();return i.notIn(ne,Ae)}switch(this.D().type){case 3:{this.z();const Ae=this.u();if(this.x().type===18)return i.equals(ne,Ae);switch(Ae){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Ae)}}case 4:{this.z();const Ae=this.u();if(this.x().type===18)return i.notEquals(ne,Ae);switch(Ae){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Ae)}}case 5:return this.z(),V.create(ne,this.u());case 6:return this.z(),P.create(ne,this.u());case 7:return this.z(),W.create(ne,this.u());case 8:return this.z(),z.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:o,offset:q.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case 17:case 18:return this.z(),q.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ne){if(this.C(q))return this.z();throw this.B(ne,this.D())}B(q,ne,Ie){const Ae=(0,R.localize)(8,null,q,I.$Wi.getLexeme(ne)),Pe=ne.offset,ae=I.$Wi.getLexeme(ne);return this.h.push({message:Ae,offset:Pe,lexeme:ae,additionalInfo:Ie}),h.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=h;class i{static false(){return m.INSTANCE}static true(){return f.INSTANCE}static has(q){return k.create(q)}static equals(q,ne){return F.create(q,ne)}static notEquals(q,ne){return D.create(q,ne)}static regex(q,ne){return C.create(q,ne)}static in(q,ne){return v.create(q,ne)}static notIn(q,ne){return y.create(q,ne)}static not(q){return N.create(q)}static and(...q){return me.create(q,null,!0)}static or(...q){return be.create(q,null,!0)}static greater(q,ne){return W.create(q,ne)}static greaterEquals(q,ne){return z.create(q,ne)}static smaller(q,ne){return V.create(q,ne)}static smallerEquals(q,ne){return P.create(q,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Zi=i;function s(x){const q=new h({regexParsingWithErrorRecovery:!1});return x.map(ne=>(q.parse(ne),q.lexingErrors.length>0?q.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,R.localize)(9,null,Ie.additionalInfo):(0,R.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$1i=s;function u(x,q){const ne=x?x.substituteConstants():void 0,Ie=q?q.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$2i=u;function d(x,q){return x.cmp(q)}class m{static{this.INSTANCE=new m}constructor(){this.type=0}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return f.INSTANCE}}e.$3i=m;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return m.INSTANCE}}e.$4i=f;class k{static create(q,ne=null){const Ie=g.get(q);return typeof Ie=="boolean"?Ie?f.INSTANCE:m.INSTANCE:new k(q,ne)}constructor(q,ne){this.key=q,this.c=ne,this.type=2}cmp(q){return q.type!==this.type?this.type-q.type:fe(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=g.get(this.key);return typeof q=="boolean"?q?f.INSTANCE:m.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$5i=k;class F{static create(q,ne,Ie=null){if(typeof ne=="boolean")return ne?k.create(q,Ie):N.create(q,Ie);const Ae=g.get(q);return typeof Ae=="boolean"?ne===(Ae?"true":"false")?f.INSTANCE:m.INSTANCE:new F(q,ne,Ie)}constructor(q,ne,Ie){this.c=q,this.d=ne,this.f=Ie,this.type=4}cmp(q){return q.type!==this.type?this.type-q.type:de(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=g.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?f.INSTANCE:m.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$6i=F;class v{static create(q,ne){return new v(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=10,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:de(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.f),Ie=q.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$7i=v;class y{static create(q,ne){return new y(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=11,this.c=v.create(q,ne)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=y;class D{static create(q,ne,Ie=null){if(typeof ne=="boolean")return ne?N.create(q,Ie):k.create(q,Ie);const Ae=g.get(q);return typeof Ae=="boolean"?ne===(Ae?"true":"false")?m.INSTANCE:f.INSTANCE:new D(q,ne,Ie)}constructor(q,ne,Ie){this.c=q,this.d=ne,this.f=Ie,this.type=5}cmp(q){return q.type!==this.type?this.type-q.type:de(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=g.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?m.INSTANCE:f.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$9i=D;class N{static create(q,ne=null){const Ie=g.get(q);return typeof Ie=="boolean"?Ie?m.INSTANCE:f.INSTANCE:new N(q,ne)}constructor(q,ne){this.c=q,this.d=ne,this.type=3}cmp(q){return q.type!==this.type?this.type-q.type:fe(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=g.get(this.c);return typeof q=="boolean"?q?m.INSTANCE:f.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$0i=N;function O(x,q){if(typeof x=="string"){const ne=parseFloat(x);isNaN(ne)||(x=ne)}return typeof x=="string"||typeof x=="number"?q(x):m.INSTANCE}class W{static create(q,ne,Ie=null){return O(ne,Ae=>new W(q,Ae,Ie))}constructor(q,ne,Ie){this.c=q,this.d=ne,this.f=Ie,this.type=12}cmp(q){return q.type!==this.type?this.type-q.type:de(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$$i=W;class z{static create(q,ne,Ie=null){return O(ne,Ae=>new z(q,Ae,Ie))}constructor(q,ne,Ie){this.c=q,this.d=ne,this.f=Ie,this.type=13}cmp(q){return q.type!==this.type?this.type-q.type:de(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$_i=z;class V{static create(q,ne,Ie=null){return O(ne,Ae=>new V(q,Ae,Ie))}constructor(q,ne,Ie){this.c=q,this.d=ne,this.f=Ie,this.type=14}cmp(q){return q.type!==this.type?this.type-q.type:de(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$aj=V;class P{static create(q,ne,Ie=null){return O(ne,Ae=>new P(q,Ae,Ie))}constructor(q,ne,Ie){this.c=q,this.d=ne,this.f=Ie,this.type=15}cmp(q){return q.type!==this.type?this.type-q.type:de(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$bj=P;class C{static create(q,ne){return new C(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=7,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ne=this.f?this.f.source:"",Ie=q.f?q.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(q){if(q.type===this.type){const ne=this.f?this.f.source:"",Ie=q.f?q.f.source:"";return this.d===q.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$cj=C;class Z{static create(q){return new Z(q)}constructor(q){this.c=q,this.type=8}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new Z(this.c.map(q))}negate(){return this.c}}e.$dj=Z;function ce(x){let q=null;for(let ne=0,Ie=x.length;ne<Ie;ne++){const Ae=x[ne].substituteConstants();if(x[ne]!==Ae&&q===null){q=[];for(let Pe=0;Pe<ne;Pe++)q[Pe]=x[Pe]}q!==null&&(q[ne]=Ae)}return q===null?x:q}class me{static create(q,ne,Ie){return me.d(q,ne,Ie)}constructor(q,ne){this.expr=q,this.c=ne,this.type=6}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Ae=d(this.expr[ne],q.expr[ne]);if(Ae!==0)return Ae}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=ce(this.expr);return q===this.expr?this:me.create(q,this.c,!1)}evaluate(q){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(q))return!1;return!0}static d(q,ne,Ie){const Ae=[];let Pe=!1;for(const ae of q)if(ae){if(ae.type===1){Pe=!0;continue}if(ae.type===0)return m.INSTANCE;if(ae.type===6){Ae.push(...ae.expr);continue}Ae.push(ae)}if(Ae.length===0&&Pe)return f.INSTANCE;if(Ae.length!==0){if(Ae.length===1)return Ae[0];Ae.sort(d);for(let ae=1;ae<Ae.length;ae++)Ae[ae-1].equals(Ae[ae])&&(Ae.splice(ae,1),ae--);if(Ae.length===1)return Ae[0];for(;Ae.length>1;){const ae=Ae[Ae.length-1];if(ae.type!==9)break;Ae.pop();const te=Ae.pop(),J=Ae.length===0,ee=be.create(ae.expr.map($e=>me.create([$e,te],null,Ie)),null,J);ee&&(Ae.push(ee),Ae.sort(d))}if(Ae.length===1)return Ae[0];if(Ie){for(let ae=0;ae<Ae.length;ae++)for(let te=ae+1;te<Ae.length;te++)if(Ae[ae].negate().equals(Ae[te]))return m.INSTANCE;if(Ae.length===1)return Ae[0]}return new me(Ae,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new me(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());this.c=be.create(q,this,!0)}return this.c}}e.$ej=me;class be{static create(q,ne,Ie){return be.d(q,ne,Ie)}constructor(q,ne){this.expr=q,this.c=ne,this.type=9}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Ae=d(this.expr[ne],q.expr[ne]);if(Ae!==0)return Ae}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=ce(this.expr);return q===this.expr?this:be.create(q,this.c,!1)}evaluate(q){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(q))return!0;return!1}static d(q,ne,Ie){let Ae=[],Pe=!1;if(q){for(let ae=0,te=q.length;ae<te;ae++){const J=q[ae];if(J){if(J.type===0){Pe=!0;continue}if(J.type===1)return f.INSTANCE;if(J.type===9){Ae=Ae.concat(J.expr);continue}Ae.push(J)}}if(Ae.length===0&&Pe)return m.INSTANCE;Ae.sort(d)}if(Ae.length!==0){if(Ae.length===1)return Ae[0];for(let ae=1;ae<Ae.length;ae++)Ae[ae-1].equals(Ae[ae])&&(Ae.splice(ae,1),ae--);if(Ae.length===1)return Ae[0];if(Ie){for(let ae=0;ae<Ae.length;ae++)for(let te=ae+1;te<Ae.length;te++)if(Ae[ae].negate().equals(Ae[te]))return f.INSTANCE;if(Ae.length===1)return Ae[0]}return new be(Ae,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new be(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());for(;q.length>1;){const ne=q.shift(),Ie=q.shift(),Ae=[];for(const Pe of oe(ne))for(const ae of oe(Ie))Ae.push(me.create([Pe,ae],null,!1));q.unshift(be.create(Ae,null,!1))}this.c=be.create(q,this,!0)}return this.c}}e.$fj=be;class ke extends k{static{this.d=[]}static all(){return ke.d.values()}constructor(q,ne,Ie){super(q,null),this.f=ne,typeof Ie=="object"?ke.d.push({...Ie,key:q}):Ie!==!0&&ke.d.push({key:q,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return F.create(this.key,q)}notEqualsTo(q){return D.create(this.key,q)}}e.$gj=ke,e.$hj=(0,L.$2h)("contextKeyService");function fe(x,q){return x<q?-1:x>q?1:0}function de(x,q,ne,Ie){return x<ne?-1:x>ne?1:q<Ie?-1:q>Ie?1:0}function ie(x,q){if(x.type===0||q.type===1)return!0;if(x.type===9)return q.type===9?Se(x.expr,q.expr):!1;if(q.type===9){for(const ne of q.expr)if(ie(x,ne))return!0;return!1}if(x.type===6){if(q.type===6)return Se(q.expr,x.expr);for(const ne of x.expr)if(ie(ne,q))return!0;return!1}return x.equals(q)}e.$ij=ie;function Se(x,q){let ne=0,Ie=0;for(;ne<x.length&&Ie<q.length;){const Ae=x[ne].cmp(q[Ie]);if(Ae<0)return!1;Ae===0&&ne++,Ie++}return ne===x.length}function oe(x){return x.type===9?x.expr:[x]}}),define(Ce[184],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,E.$2h)("environmentService"),e.$0h=(0,E.$3h)(e.$9h)}),define(Ce[97],Re([1,0,151,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0,e.$_n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ao=new RegExp(e.$_n),e.$bo="__web_extension",e.$co="skipWalkthrough",e.$do="extensionsSync",e.$eo="dependecyOrPackExtensionInstall";function I(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$fo=I;function L(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$go=L;function R(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$ho=R;function $(t,n){return n==="web"&&!t.includes("web")}e.$io=$;function g(t,n,o){return $(n,o)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===o}e.$jo=g;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$ko=w;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var S;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$lo=(0,T.$2h)("extensionGalleryService");var b;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var r;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class a extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$mo=a,e.$no=(0,T.$2h)("extensionManagementService"),e.$oo="extensionsIdentifiers/disabled",e.$po="extensionsIdentifiers/enabled",e.$qo=(0,T.$2h)("IGlobalExtensionEnablementService"),e.$ro=(0,T.$2h)("IExtensionTipsService"),e.$so=(0,E.localize)(0,null),e.$to={value:e.$so,original:"Extensions"},e.$uo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Ce[42],Re([1,0,50,19,11,16,2,153,4,21,12,39]),function(ge,e,E,T,I,L,R,$,g,w,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.FileKind=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.FileOperationResult=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.FileChangeType=e.$Ek=e.FileOperation=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileSystemProviderErrorCode=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileSystemProviderCapabilities=e.$ok=e.FilePermission=e.FileType=e.$nk=e.$mk=void 0,e.$mk=(0,g.$2h)("fileService");function l(ie){return ie.create===!0}e.$nk=l;var p;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var b;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function r(ie){const Se=ie;return!!Se&&typeof Se.onDidChange=="function"}e.$ok=r;var a;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function t(ie){return!!(ie.capabilities&2)}e.$pk=t;function n(ie){return!!(ie.capabilities&8)}e.$qk=n;function o(ie){return!!(ie.capabilities&131072)}e.$rk=o;function c(ie){return!!(ie.capabilities&4)}e.$sk=c;function h(ie){return!!(ie.capabilities&16)}e.$tk=h;function i(ie){return t(ie)?!!(ie.capabilities&16384):!1}e.$uk=i;function s(ie){return t(ie)?!!(ie.capabilities&32768):!1}e.$vk=s;function u(ie){return!!(ie.capabilities&65536)}e.$wk=u;function d(ie){return!!(ie.capabilities&2048)}e.$xk=d;var m;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(m||(e.FileSystemProviderErrorCode=m={}));class f extends Error{static create(Se,oe){const x=new f(Se.toString(),oe);return v(x,oe),x}constructor(Se,oe){super(Se),this.code=oe}}e.$yk=f;function k(ie,Se){return f.create(ie,Se)}e.$zk=k;function F(ie){return ie||k((0,$.localize)(0,null),m.Unknown)}e.$Ak=F;function v(ie,Se){return ie.name=Se?`${Se} (FileSystemError)`:"FileSystemError",ie}e.$Bk=v;function y(ie){if(!ie)return m.Unknown;if(ie instanceof f)return ie.code;const Se=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!Se)return m.Unknown;switch(Se[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.$Ck=y;function D(ie){if(ie instanceof P)return ie.fileOperationResult;switch(y(ie)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 9;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileTooLarge:return 7;default:return 10}}e.$Dk=D;var N;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(Se,oe,x){this.resource=Se,this.operation=oe,this.target=x}isOperation(Se){return this.operation===Se}}e.$Ek=O;var W;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class z{static{this.a=null}constructor(Se,oe){this.c=oe,this.b=void 0,this.d=new S.$V(()=>{const x=E.$8h.forUris(()=>this.c);return x.fill(this.rawAdded.map(q=>[q,!0])),x}),this.f=new S.$V(()=>{const x=E.$8h.forUris(()=>this.c);return x.fill(this.rawUpdated.map(q=>[q,!0])),x}),this.g=new S.$V(()=>{const x=E.$8h.forUris(()=>this.c);return x.fill(this.rawDeleted.map(q=>[q,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of Se){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==z.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(Se,...oe){return this.h(Se,{includeChildren:!1},...oe)}affects(Se,...oe){return this.h(Se,{includeChildren:!0},...oe)}h(Se,oe,...x){if(!Se)return!1;const q=x.length>0;return!!((!q||x.includes(1))&&(this.d.value.get(Se)||oe.includeChildren&&this.d.value.findSuperstr(Se))||(!q||x.includes(0))&&(this.f.value.get(Se)||oe.includeChildren&&this.f.value.findSuperstr(Se))||(!q||x.includes(2))&&(this.g.value.findSubstr(Se)||oe.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$Fk=z;function V(ie,Se,oe){return!ie||!Se||ie===Se||Se.length>ie.length?!1:(Se.charAt(Se.length-1)!==T.sep&&(Se+=T.sep),oe?(0,I.$9e)(ie,Se):ie.indexOf(Se)===0)}e.$Gk=V;class P extends Error{constructor(Se,oe,x){super(Se),this.fileOperationResult=oe,this.options=x}}e.$Hk=P;class C extends P{constructor(Se,oe,x,q){super(Se,oe,q),this.fileOperationResult=oe,this.size=x}}e.$Ik=C;class Z extends P{constructor(Se,oe,x){super(Se,2,x),this.stat=oe}}e.$Jk=Z;var ce;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$Kk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Lk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Mk="files.associations",e.$Nk="files.exclude",e.$Ok="files.readonlyInclude",e.$Pk="files.readonlyExclude",e.$Qk="files.readonlyFromPermissions";var me;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$Rk="";function be(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Sk=be;async function ke(ie,Se){if(!Se.hasProvider(R.URI.from({scheme:ie.scheme})))return new Promise(oe=>{const x=Se.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===ie.scheme&&q.added&&(x.dispose(),oe())})})}e.$Tk=ke;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(Se){return(0,L.$If)(Se)||(Se=0),Se<fe.KB?(0,$.localize)(1,null,Se.toFixed(0)):Se<fe.MB?(0,$.localize)(2,null,(Se/fe.KB).toFixed(2)):Se<fe.GB?(0,$.localize)(3,null,(Se/fe.MB).toFixed(2)):Se<fe.TB?(0,$.localize)(4,null,(Se/fe.GB).toFixed(2)):(0,$.localize)(5,null,(Se/fe.TB).toFixed(2))}}e.$Uk=fe;function de(ie){const Se=typeof ie=="string"||ie?.scheme===A.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===A.Schemas.file?1024*fe.MB:Se?10*fe.MB:w.$o?50*fe.MB:1024*fe.MB}e.$Vk=de}),define(Ce[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class E{constructor(...I){this.a=new Map;for(const[L,R]of I)this.set(L,R)}set(I,L){const R=this.a.get(I);return this.a.set(I,L),R}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Zh=E}),define(Ce[185],Re([1,0,13,14,6,69,183,4,71,186]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;const A=!1;class S extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class l{constructor(a=new g.$Zh,t=!1,n,o=A){this.f=a,this.g=t,this.h=n,this.i=o,this.o=new Set,this.f.set($.$1h,this),this._globalGraph=o?n?._globalGraph??new R.$qq(c=>c):void 0}createChild(a){return new l(a,this.g,this,this.i)}invokeFunction(a,...t){const n=b.traceInvocation(this.i,a);let o=!1;try{return a({get:h=>{if(o)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{o=!0,n.stop()}}createInstance(a,...t){let n,o;return a instanceof L.$Yh?(n=b.traceCreation(this.i,a.ctor),o=this.j(a.ctor,a.staticArguments.concat(t),n)):(n=b.traceCreation(this.i,a),o=this.j(a,t,n)),n.stop(),o}j(a,t=[],n){const o=$._util.getServiceDependencies(a).sort((i,s)=>i.index-s.index),c=[];for(const i of o){const s=this.m(i.id,n);s||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(s)}const h=o.length>0?o[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(a,t.concat(c))}k(a,t){if(this.f.get(a)instanceof L.$Yh)this.f.set(a,t);else if(this.h)this.h.k(a,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const t=this.f.get(a);return!t&&this.h?this.h.l(a):t}m(a,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const n=this.l(a);return n instanceof L.$Yh?this.q(a,n,t.branch(a,!0)):(t.branch(a,!1),n)}q(a,t,n){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,t,n)}finally{this.o.delete(a)}}r(a,t,n){const o=new R.$qq(i=>i.id.toString());let c=0;const h=[{id:a,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(o.lookupOrInsertNode(i),c++>1e3)throw new S(o);for(const s of $._util.getServiceDependencies(i.desc.ctor)){const u=this.l(s.id);if(u||this.u(`[createInstance] ${a} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),u instanceof L.$Yh){const d={id:s.id,desc:u,_trace:i._trace.branch(s.id,!0)};o.insertEdge(i,d),h.push(d)}}}for(;;){const i=o.roots();if(i.length===0){if(!o.isEmpty())throw new S(o);break}for(const{data:s}of i){if(this.l(s.id)instanceof L.$Yh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}o.removeNode(s)}}return this.l(a)}s(a,t,n=[],o,c){if(this.f.get(a)instanceof L.$Yh)return this.t(a,t,n,o,c);if(this.h)return this.h.s(a,t,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(a,t,n=[],o,c){if(o){const h=new l(void 0,this.g,this,this.i);h.c=String(a);const i=new Map,s=new E.$ih(()=>{const u=h.j(t,n,c);for(const[d,m]of i){const f=u[d];if(typeof f=="function")for(const k of m)f.apply(u,k)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let k=i.get(d);return k||(k=new w.$3c,i.set(d,k)),(v,y,D)=>{const N=k.push([v,y,D]);return(0,I.$Qc)(N)}}if(d in u)return u[d];const m=s.value;let f=m[d];return typeof f!="function"||(f=f.bind(m),u[d]=f),f},set(u,d,m){return s.value[d]=m,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(a,t){if(t&&console.warn(a),this.g)throw new Error(a)}}e.$rq=l;var p;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(p||(p={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,t){return a?new b(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(a,t){return a?new b(1,t.name):b.c}static{this.f=0}constructor(a,t){this.type=a,this.name=t,this.g=Date.now(),this.h=[]}branch(a,t){const n=new b(3,a.toString());return this.h.push([a,t,n]),n}stop(){const a=Date.now()-this.g;b.f+=a;let t=!1;function n(c,h){const i=[],s=new Array(c+1).join("	");for(const[u,d,m]of h.h)if(d&&m){t=!0,i.push(`${s}CREATES -> ${u}`);const f=n(c+1,m);f&&i.push(f)}else i.push(`${s}uses -> ${u}`);return i.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(a>2||t)&&b.all.add(o.join(`
`))}}e.$sq=b}),define(Ce[15],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,l.$2h)("logService"),e.$kj=(0,l.$2h)("loggerService");function p(){return new Date().toISOString()}function b(v){return(0,w.$If)(v)}e.$lj=b;var r;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$mj=r.Info;function a(v,y,D){switch(y){case r.Trace:v.trace(D);break;case r.Debug:v.debug(D);break;case r.Info:v.info(D);break;case r.Warning:v.warn(D);break;case r.Error:v.error(D);break;case r.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=a;function t(v,y=!1){let D="";for(let N=0;N<v.length;N++){let O=v[N];if(O instanceof Error&&(O=(0,E.$Mi)(O,y)),typeof O=="object")try{O=JSON.stringify(O)}catch{}D+=(N>0?" ":"")+O}return D}class n extends L.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new T.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==r.Off&&this.b<=y}}e.$oj=n;class o extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...D){this.f(r.Trace)&&this.g(r.Trace,t([y,...D],!0))}debug(y,...D){this.f(r.Debug)&&this.g(r.Debug,t([y,...D]))}info(y,...D){this.f(r.Info)&&this.g(r.Info,t([y,...D]))}warn(y,...D){this.f(r.Warning)&&this.g(r.Warning,t([y,...D]))}error(y,...D){if(this.f(r.Error))if(y instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=y.stack,this.g(r.Error,t(N))}else this.g(r.Error,t([y,...D]))}flush(){}}e.$pj=o;class c extends n{constructor(y=e.$mj){super(),this.setLevel(y),this.g=!$.$i}trace(y,...D){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}debug(y,...D){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}info(y,...D){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}warn(y,...D){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,y,...D):console.warn(`[main ${p()}]`,y,...D))}error(y,...D){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,y,...D):console.error(`[main ${p()}]`,y,...D))}flush(){}}e.$qj=c;class h extends n{constructor(y=e.$mj,D=!0){super(),this.g=D,this.setLevel(y)}trace(y,...D){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...D):console.log(y,...D))}debug(y,...D){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...D):console.log(y,...D))}info(y,...D){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...D):console.log(y,...D))}warn(y,...D){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...D):console.log(y,...D))}error(y,...D){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...D):console.error(y,...D))}flush(){}}e.$rj=h;class i extends n{constructor(y,D=e.$mj){super(),this.g=y,this.setLevel(D)}trace(y,...D){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(y),...D])}debug(y,...D){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(y),...D])}info(y,...D){this.f(r.Info)&&this.g.log(r.Info,[this.h(y),...D])}warn(y,...D){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(y),...D])}error(y,...D){this.f(r.Error)&&this.g.log(r.Error,[this.h(y),...D])}h(y){return typeof y=="string"?y:(0,E.$Mi)(y,this.f(r.Trace))}flush(){}}e.$sj=i;class s extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const D of this.g)D.setLevel(y);super.setLevel(y)}trace(y,...D){for(const N of this.g)N.trace(y,...D)}debug(y,...D){for(const N of this.g)N.debug(y,...D)}info(y,...D){for(const N of this.g)N.info(y,...D)}warn(y,...D){for(const N of this.g)N.warn(y,...D)}error(y,...D){for(const N of this.g)N.error(y,...D)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$tj=s;class u extends L.$Sc{constructor(y,D,N){if(super(),this.h=y,this.j=D,this.b=new R.$Ac,this.c=this.B(new T.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Sd),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(y){return(0,w.$Ef)(y)?[...this.b.values()].find(D=>D.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,D){const N=this.n(y),O=(0,w.$Ef)(y)?y:D?.id??(0,I.$Pi)(N.toString()).toString(16);let W=this.b.get(N)?.logger;const z=D?.logLevel==="always"?r.Trace:D?.logLevel;W||(W=this.s(N,z??this.getLogLevel(N)??this.h,{...D,id:O}));const V={logger:W,info:{resource:N,id:O,logLevel:z,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(V.info),this.b.set(N,V),W}n(y){return(0,w.$Ef)(y)?(0,g.$Dg)(this.j,`${y}.log`):y}setLogLevel(y,D){if(A.URI.isUri(y)){const N=y,O=D,W=this.b.get(N);W&&O!==W.info.logLevel&&(W.info.logLevel=O===this.h?void 0:O,W.logger?.setLevel(O),this.b.set(W.info.resource,W),this.f.fire([N,O]))}else{this.h=y;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,D){const N=this.m(y);N&&D!==!N.info.hidden&&(N.info.hidden=!D,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,D]))}getLogLevel(y){let D;return y&&(D=this.b.get(y)?.info.logLevel),D??this.h}registerLogger(y){const D=this.b.get(y.resource);D?D.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const D=this.b.get(y);D&&(D.logger&&D.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=u;class d{constructor(){this.onDidChangeLogLevel=new T.$Sd().event}setLevel(y){}getLevel(){return r.Info}trace(y,...D){}debug(y,...D){}info(y,...D){}warn(y,...D){}error(y,...D){}critical(y,...D){}dispose(){}flush(){}}e.$vj=d;class m extends d{}e.$wj=m;function f(v){if(v.verbose)return r.Trace;if(typeof v.logLevel=="string"){const y=F(v.logLevel.toLowerCase());if(y!==void 0)return y}return e.$mj}e.$xj=f;function k(v){switch(v){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$yj=k;function F(v){switch(v){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$zj=F,e.$Aj=new S.$gj("logLevel",k(r.Info))}),define(Ce[187],Re([1,0,6,15]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=void 0;class I extends E.$Sc{constructor(R,$=[]){super(),this.a=new T.$tj([R,...$]),this.B(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$cO=I}),define(Ce[99],Re([1,0,31,154,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(g){function w(b,r){return r-b}g.compare=w;const A=Object.create(null);A[g.Error]=(0,T.localize)(0,null),A[g.Warning]=(0,T.localize)(1,null),A[g.Info]=(0,T.localize)(2,null);function S(b){return A[b]||""}g.toString=S;function l(b){switch(b){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function p(b){switch(b){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=p}(R||(e.MarkerSeverity=R={}));var $;(function(g){const w="";function A(l){return S(l,!0)}g.makeKey=A;function S(l,p){const b=[w];return l.source?b.push(l.source.replace("\xA6","\\\xA6")):b.push(w),l.code?typeof l.code=="string"?b.push(l.code.replace("\xA6","\\\xA6")):b.push(l.code.value.replace("\xA6","\\\xA6")):b.push(w),l.severity!==void 0&&l.severity!==null?b.push(R.toString(l.severity)):b.push(w),l.message&&p?b.push(l.message.replace("\xA6","\\\xA6")):b.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?b.push(l.startLineNumber.toString()):b.push(w),l.startColumn!==void 0&&l.startColumn!==null?b.push(l.startColumn.toString()):b.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?b.push(l.endLineNumber.toString()):b.push(w),l.endColumn!==void 0&&l.endColumn!==null?b.push(l.endColumn.toString()):b.push(w),b.push(w),b.join("\xA6")}g.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$nt=(0,I.$2h)("markerService")}),define(Ce[188],Re([1,0,5,31,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ev=e.$dv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$cv=e.Severity=void 0,e.Severity=T.default,e.$cv=(0,I.$2h)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class g{constructor(){this.progress=new w,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$dv=g;class w{infinite(){}done(){}total(S){}worked(S){}}e.$ev=w}),define(Ce[189],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,E.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(ge,e,E,T){var I=arguments.length,L=I<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ge,e,E,T);else for(var $=ge.length-1;$>=0;$--)(R=ge[$])&&(L=(I<3?R(L):I>3?R(e,E,L):R(e,E))||L);return I>3&&L&&Object.defineProperty(e,E,L),L},Ke=this&&this.__param||function(ge,e){return function(E,T){e(E,T,ge)}};define(Ce[72],Re([1,0,13,20,6,4]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProgressLocation=e.$fv=void 0,e.$fv=(0,L.$2h)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$gv=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$hv=$;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$iv=g;let w=class extends I.$Sc{constructor(l,p){super(),this.a=new E.$mh,p.withProgress(l,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,I.$Qc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$jv=w,e.$jv=w=Ge([Ke(1,e.$fv)],w);class A extends I.$Sc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Rc)}start(l){this.stop();const p=++this.a,b=new T.$3d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Qc)(()=>b.cancel())),this.b.add((0,I.$Qc)(()=>this.c?this.c.done():void 0)),{id:p,token:b.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$kv=A,e.$lv=(0,L.$2h)("editorProgressService")}),define(Ce[30],Re([1,0,53,16]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0;class I{constructor(){this.a=new Map}add(R,$){E.ok(T.$Ef(R)),E.ok(T.$Gf($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$un=new I}),define(Ce[73],Re([1,0,5,30]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn={JSONContribution:"base.contributions.json"};function I($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class L{constructor(){this.b=new E.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[I(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;T.$un.add(e.$vn.JSONContribution,R)}),define(Ce[54],Re([1,0,18,5,16,148,41,73,30]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.ConfigurationScope=e.$zn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$zn={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn="vscode://schemas/settings/resourceLanguage",e.$Hn="vscode://schemas/settings/configurationDefaults";const S=g.$un.as($.$vn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Sd,this.onDidSchemaChange=this.i.event,this.j=new T.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$Gn,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const u=new Set;this.n(i,s,u),S.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const s=new Set;this.o(i,s),S.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const u=new Set;this.o(s,u),this.n(i,!1,u),S.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const u=[];for(const{overrides:d,source:m}of i)for(const f in d)if(s.add(f),e.$Jn.test(f)){const k=this.a.get(f),F=k?.valuesSources??new Map;if(m)for(const N of Object.keys(d[f]))F.set(N,m);const v={...k?.value||{},...d[f]};this.a.set(f,{source:m,value:v,valuesSources:F});const y=(0,R.$Fi)(f),D={type:"object",default:v,description:L.localize(1,null,y),$ref:e.$Gn,defaultDefaultValue:v,source:I.$Ef(m)?void 0:m,defaultValueSource:m};u.push(...r(f)),this.d[f]=D,this.b.properties[f]=D}else{this.a.set(f,{value:d[f],source:m});const k=this.d[f];k&&(this.w(f,k),this.r(f,k))}this.m(u)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:u,source:d}of i)for(const m in u){const f=this.a.get(m),k=I.$Ef(d)?d:d?.id,F=I.$Ef(f?.source)?f?.source:f?.source?.id;if(k===F)if(s.add(m),this.a.delete(m),e.$Jn.test(m))delete this.d[m],delete this.b.properties[m];else{const v=this.d[m];v&&(this.w(m,v),this.r(m,v))}}this.u()}deltaConfiguration(i){let s=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,u){i.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,s){const u=d=>{if(d.properties)for(const m in d.properties){s.add(m);const f=this.d[m];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[m],this.s(m,d.properties[m])}d.allOf?.forEach(m=>u(m))};for(const d of i){u(d);const m=this.c.indexOf(d);m!==-1&&this.c.splice(m,1)}}p(i,s=!0,u,d,m=3,f){m=I.$Nf(i.scope)?m:i.scope;const k=i.properties;if(k)for(const v in k){const y=k[v];if(s&&o(v,y)){delete k[v];continue}if(y.source=u,y.defaultDefaultValue=k[v].default,this.w(v,y),e.$Jn.test(v)?y.scope=void 0:(y.scope=I.$Nf(y.scope)?m:y.scope,y.restricted=I.$Nf(y.restricted)?!!d?.includes(v):y.restricted),k[v].hasOwnProperty("included")&&!k[v].included){this.f[v]=k[v],delete k[v];continue}else this.d[v]=k[v],k[v].policy?.name&&this.e.set(k[v].policy.name,v);!k[v].deprecationMessage&&k[v].markdownDeprecationMessage&&(k[v].deprecationMessage=k[v].markdownDeprecationMessage),f.add(v)}const F=i.allOf;if(F)for(const v of F)this.p(v,s,u,d,m,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$An.properties[i]=s,s.scope){case 1:e.$Bn.properties[i]=s;break;case 2:e.$Cn.properties[i]=s;break;case 6:e.$Dn.properties[i]=s;break;case 3:e.$En.properties[i]=s;break;case 4:e.$Fn.properties[i]=s;break;case 5:e.$Fn.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$An.properties[i],s.scope){case 1:delete e.$Bn.properties[i];break;case 2:delete e.$Cn.properties[i];break;case 6:delete e.$Dn.properties[i];break;case 3:delete e.$En.properties[i];break;case 4:case 5:delete e.$Fn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,u={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Gn};this.w(s,u),e.$An.properties[s]=u,e.$Bn.properties[s]=u,e.$Cn.properties[s]=u,e.$Dn.properties[s]=u,e.$En.properties[s]=u,e.$Fn.properties[s]=u}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Gn};e.$An.patternProperties[e.$In]=i,e.$Bn.patternProperties[e.$In]=i,e.$Cn.patternProperties[e.$In]=i,e.$Dn.patternProperties[e.$In]=i,e.$En.patternProperties[e.$In]=i,e.$Fn.patternProperties[e.$In]=i,this.i.fire()}w(i,s){const u=this.a.get(i);let d=u?.value,m=u?.source;I.$Lf(d)&&(d=s.defaultDefaultValue,m=void 0),I.$Lf(d)&&(d=t(s.type)),s.default=d,s.defaultValueSource=m}}const p="\\[([^\\]]+)\\]",b=new RegExp(p,"g");e.$In=`^(${p})+$`,e.$Jn=new RegExp(e.$In);function r(h){const i=[];if(e.$Jn.test(h)){let s=b.exec(h);for(;s?.length;){const u=s[1].trim();u&&i.push(u),s=b.exec(h)}}return(0,E.$Mb)(i)}e.$Kn=r;function a(h){return h.reduce((i,s)=>`${i}[${s}]`,"")}e.$Ln=a;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Mn=t;const n=new l;g.$un.add(e.$zn.Configuration,n);function o(h,i){return h.trim()?e.$Jn.test(h)?L.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$Nn=o;function c(){const h=[],i=n.getConfigurationProperties();for(const s of Object.keys(i))h.push([s,i[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$On=c}),define(Ce[190],Re([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0;function p(s){return Object.isFrozen(s)?s:$.$jn(s)}class b{constructor(u={},d=[],m=[],f){this.b=u,this.c=d,this.d=m,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof b)return d;const m=new r("");return m.parseRaw(d),m.configurationModel});this.f=u.reduce((d,m)=>m===d?m:d.merge(m),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,A.$Di)(this.contents,u):this.contents}inspect(u,d){const m=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,k=d?this.rawConfiguration.override(d).getValue(u):m;return{value:m,override:f,merged:k}}getOverrideValue(u,d){const m=this.i(d);return m?u?(0,A.$Di)(m,u):m:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const m of this.overrides)m.identifiers.includes(u)&&d.push(...m.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Mb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=$.$in(this.contents),m=$.$in(this.overrides),f=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const F of u)if(k.push(...F.raw?.length?F.raw:[F]),!F.isEmpty()){this.h(d,F.contents);for(const v of F.overrides){const[y]=m.filter(D=>E.$ub(D.identifiers,v.identifiers));y?(this.h(y.contents,v.contents),y.keys.push(...v.keys),y.keys=E.$Mb(y.keys)):m.push($.$in(v))}for(const v of F.keys)f.indexOf(v)===-1&&f.push(v)}return new b(d,f,m,k.every(F=>F instanceof b)?void 0:k)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const m={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let k=this.contents[f];const F=d[f];F&&(typeof k=="object"&&typeof F=="object"?(k=$.$in(k),this.h(k,F)):k=F),m[f]=k}return new b(m,this.keys,this.overrides)}h(u,d){for(const m of Object.keys(d)){if(m in u&&g.$Gf(u[m])&&g.$Gf(d[m])){this.h(u[m],d[m]);continue}u[m]=$.$in(d[m])}}i(u){let d=null,m=null;const f=k=>{k&&(m?this.h(m,k):m=$.$in(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===u?d=k.contents:k.identifiers.includes(u)&&f(k.contents);return f(d),m}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,A.$Ci)(this.contents,u),S.$Jn.test(u)&&this.overrides.splice(this.overrides.findIndex(m=>E.$ub(m.identifiers,(0,S.$Kn)(u))),1))}j(u,d,m){(0,A.$Bi)(this.contents,u,d,f=>console.error(f)),m=m||this.keys.indexOf(u)===-1,m&&this.keys.push(u),S.$Jn.test(u)&&this.overrides.push({identifiers:(0,S.$Kn)(u),keys:Object.keys(this.contents[u]),contents:(0,A.$Ai)(this.contents[u],f=>console.error(f))})}}e.$Pn=b;class r{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Nf(u)){const m=this.g(u);this.parseRaw(m,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:m,keys:f,overrides:k,restricted:F,hasExcludedProperties:v}=this.h(u,d);this.b=new b(m,f,k,v?[u]:void 0),this.c=F||[]}g(u){let d={},m=null,f=[];const k=[],F=[];function v(D){Array.isArray(f)?f.push(D):m!==null&&(f[m]=D)}const y={onObjectBegin:()=>{const D={};v(D),k.push(f),f=D,m=null},onObjectProperty:D=>{m=D},onObjectEnd:()=>{f=k.pop()},onArrayBegin:()=>{const D=[];v(D),k.push(f),f=D,m=null},onArrayEnd:()=>{f=k.pop()},onLiteralValue:v,onError:(D,N,O)=>{F.push({error:D,offset:N,length:O})}};if(u)try{I.$fn(u,y),d=f[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return d}h(u,d){const m=l.$un.as(S.$zn.Configuration).getConfigurationProperties(),f=this.i(u,m,!0,d);u=f.raw;const k=(0,A.$Ai)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),F=Object.keys(u),v=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:k,keys:F,overrides:v,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,m,f){let k=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:k};const F={},v=[];for(const y in u)if(S.$Jn.test(y)&&m){const D=this.i(u[y],d,!1,f);F[y]=D.raw,k=k||D.hasExcludedProperties,v.push(...D.restricted)}else{const D=d[y],N=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&v.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(N===void 0||f.scopes===void 0||f.scopes.includes(N))&&!(f.skipRestricted&&D?.restricted))?F[y]=u[y]:k=!0}return{raw:F,restricted:v,hasExcludedProperties:k}}j(u,d){const m=[];for(const f of Object.keys(u))if(S.$Jn.test(f)){const k={};for(const F in u[f])k[F]=u[f][F];m.push({identifiers:(0,S.$Kn)(f),keys:Object.keys(k),contents:(0,A.$Ai)(k,d)})}return m}}e.$Qn=r;class a extends L.$Sc{constructor(u,d,m,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new T.$Sd),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(m.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&m.isEqual(k.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Rn=a;class t{constructor(u,d,m,f,k,F,v,y,D,N,O,W,z){this.a=u,this.b=d,this.c=m,this.overrideIdentifiers=f,this.d=k,this.f=F,this.g=v,this.h=y,this.i=D,this.j=N,this.k=O,this.l=W,this.m=z}get value(){return p(this.c)}n(u,d,m){const f=u.inspect(d,m);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,d,m,f,k=new b,F=new b,v=new R.$Ac,y=new b,D=new R.$Ac){this.c=u,this.d=d,this.f=m,this.g=f,this.h=k,this.i=F,this.j=v,this.l=y,this.m=D,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,d,m){return this.p(u,d,m).getValue(u)}updateValue(u,d,m={}){let f;m.resource?(f=this.m.get(m.resource),f||(f=new b,this.m.set(m.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),m.resource||(this.a=null)}inspect(u,d,m){const f=this.p(u,d,m),k=this.t(d.resource,m),F=d.resource?this.m.get(d.resource)||this.l:this.l,v=new Set;for(const y of f.overrides)for(const D of y.identifiers)f.getOverrideValue(u,D)!==void 0&&v.add(D);return new t(u,d,f.getValue(u),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,m?this.i:void 0,k||void 0,F)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const m=[];if(!d){const{added:f,updated:k,removed:F}=h(this.c,u);d=[...f,...k,...F]}for(const f of d)for(const k of(0,S.$Kn)(f)){const F=this.c.getKeysForOverrideIdentifier(k),v=u.getKeysForOverrideIdentifier(k),y=[...v.filter(D=>F.indexOf(D)===-1),...F.filter(D=>v.indexOf(D)===-1),...F.filter(D=>!$.$mn(this.c.override(k).getValue(D),u.override(k).getValue(D)))];m.push([k,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:m}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:m,removed:f}=h(this.d,u),k=[...d,...m,...f];return k.length&&this.updatePolicyConfiguration(u),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:m,removed:f,overrides:k}=h(this.applicationConfiguration,u),F=[...d,...m,...f];return F.length&&this.updateApplicationConfiguration(u),{keys:F,overrides:k}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:m,removed:f,overrides:k}=h(this.localUserConfiguration,u),F=[...d,...m,...f];return F.length&&this.updateLocalUserConfiguration(u),{keys:F,overrides:k}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:m,removed:f,overrides:k}=h(this.remoteUserConfiguration,u),F=[...d,...m,...f];return F.length&&this.updateRemoteUserConfiguration(u),{keys:F,overrides:k}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:m,removed:f,overrides:k}=h(this.workspaceConfiguration,u),F=[...d,...m,...f];return F.length&&this.updateWorkspaceConfiguration(u),{keys:F,overrides:k}}compareAndUpdateFolderConfiguration(u,d){const m=this.folderConfigurations.get(u),{added:f,updated:k,removed:F,overrides:v}=h(m,d),y=[...f,...k,...F];return(y.length||!m)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:v}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:m,updated:f,removed:k,overrides:F}=h(d,void 0);return{keys:[...m,...f,...k],overrides:F}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,m){let f=this.q(d,m);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let m=this.r();if(d&&u){const f=d.getFolder(u);f&&(m=this.s(f.uri)||m);const k=this.m.get(u);k&&(m=m.merge(k))}return m}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const m=this.r(),f=this.j.get(u);f?(d=m.merge(f),this.b.set(u,d)):d=m}return d}t(u,d){if(d&&u){const m=d.getFolder(u);if(m)return this.j.get(m.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:m,overrides:f,keys:k}=this.j.get(d);return u.push([d,{contents:m,overrides:f,keys:k}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(m=>u.add(m))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(m=>u.add(m))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.i.getKeysForOverrideIdentifier(u).forEach(m=>d.add(m)),this.j.forEach(m=>m.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),m=this.w(u.policy),f=this.w(u.application),k=this.w(u.user),F=this.w(u.workspace),v=u.folders.reduce((y,D)=>(y.set(w.URI.revive(D[0]),this.w(D[1])),y),new R.$Ac);return new n(d,m,f,k,new b,F,v,new b,new R.$Ac)}static w(u){return new b(u.contents,u.keys,u.overrides)}}e.$Sn=n;function o(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,d=new Map;for(const f of s)f.keys.forEach(k=>u.add(k)),f.overrides.forEach(([k,F])=>{const v=(0,R.$xc)(d,k,new Set);F.forEach(y=>v.add(y))});const m=[];return d.forEach((f,k)=>m.push([k,[...f.values()]])),{keys:[...u.values()],overrides:m}}e.$Tn=o;class c{constructor(u,d,m,f){this.change=u,this.f=d,this.g=m,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of u.keys)this.affectedKeys.add(k);for(const[,k]of u.overrides)for(const F of k)this.affectedKeys.add(F);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,d){const m=this.a+u,f=this.d.indexOf(m);if(f<0)return!1;const k=f+m.length;if(k>=this.d.length)return!1;const F=this.d.charCodeAt(k);if(F!==this.b&&F!==this.c)return!1;if(d){const v=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!$.$mn(v,y)}return!0}}e.$Un=c;function h(s,u){const{added:d,removed:m,updated:f}=i(u?.rawConfiguration,s?.rawConfiguration),k=[],F=s?.getAllOverrideIdentifiers()||[],v=u?.getAllOverrideIdentifiers()||[];if(u){const y=v.filter(D=>!F.includes(D));for(const D of y)k.push([D,u.getKeysForOverrideIdentifier(D)])}if(s){const y=F.filter(D=>!v.includes(D));for(const D of y)k.push([D,s.getKeysForOverrideIdentifier(D)])}if(u&&s){for(const y of F)if(v.includes(y)){const D=i({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});k.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:d,removed:m,updated:f,overrides:k}}function i(s,u){const d=s?u?s.keys.filter(k=>u.keys.indexOf(k)===-1):[...s.keys]:[],m=u?s?u.keys.filter(k=>s.keys.indexOf(k)===-1):[...u.keys]:[],f=[];if(s&&u){for(const k of u.keys)if(s.keys.indexOf(k)!==-1){const F=(0,A.$Di)(u.contents,k),v=(0,A.$Di)(s.contents,k);$.$mn(F,v)||f.push(k)}}return{added:d,removed:m,updated:f}}}),define(Ce[100],Re([1,0,14,4]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.RemoteAuthorityResolverErrorCode=e.$6k=e.$5k=e.RemoteConnectionType=e.$4k=void 0,e.$4k=(0,T.$2h)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class L{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$5k=L;class R{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$6k=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class g extends E.$bb{static isNotAvailable(S){return S instanceof g&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof g&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof g&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof g&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof g&&S.isHandled}constructor(S,l=$.Unknown,p){super(S),this._message=S,this._code=l,this._detail=p,this.isHandled=l===$.NotAvailable&&p===!0,Object.setPrototypeOf(this,g.prototype)}}e.$7k=g;function w(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.$8k=w}),define(Ce[55],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0;function T(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$9k=T;function I(w){if(!w)return;const A=w.indexOf("+");return A<0?w:w.substr(0,A)}e.$0k=I;function L(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$$k=L;function R(w){const{host:A,port:S}=g(w);if(typeof S>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:S}}e.$_k=R;function $(w,A){let{host:S,port:l}=g(w);return typeof l>"u"&&(l=A),{host:S,port:l}}e.$al=$;function g(w){const A=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const S=w.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Ce[22],Re([1,0,11,4,55]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.TargetPlatform=e.ExtensionType=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm="extensions.user.cache",e.$cm="extensions.builtin.cache",e.$dm="undefined_publisher",e.$em=["ui","workspace","web"];function L(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$fm=L,e.$gm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class g{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,t){if(typeof a>"u"||a===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof a=="string"||typeof t=="string"){const n=typeof a=="string"?a:a.value,o=typeof t=="string"?t:t.value;return E.$8e(n,o)}return a._lower===t._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$hm=g;class w{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const t of a)this.add(t)}add(a){this.c.add(g.toKey(a))}delete(a){return this.c.delete(g.toKey(a))}has(a){return this.c.has(g.toKey(a))}}e.$im=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(g.toKey(a))}get(a){return this.c.get(g.toKey(a))}has(a){return this.c.has(g.toKey(a))}set(a,t){this.c.set(g.toKey(a),t)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$jm=A;function S(r){return l(r)}e.$km=S;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$lm=l;function p(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$mm=p;function b(r,a){if(a){const t=`onResolveRemoteAuthority:${(0,I.$0k)(a)}`;return!!r.activationEvents?.includes(t)}return!1}e.$nm=b,e.$om=(0,T.$2h)("IBuiltinExtensionsScannerService")}),define(Ce[101],Re([1,0,14,22]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6E=e.$5E=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const g of R){const w=this.readActivationEvents(g);w.length>0&&($[T.$hm.toKey(g.identifier)]=w)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let g=0;g<$.length;g++)$[g]==="onUri"&&($[g]=`onUri:${T.$hm.toKey(R.identifier)}`);if(!R.contributes)return $;for(const g in R.contributes){const w=this.a.get(g);if(!w)continue;const A=R.contributes[g],S=Array.isArray(A)?A:[A];try{w(S,$)}catch(l){(0,E.$1)(l)}}return $}}e.$5E=I,e.$6E=new I}),define(Ce[191],Re([1,0,21,74,33]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=void 0;function L(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function R(g,w,A,S,l,p,b,r,a){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=b,t.sessionID=(0,I.$mg)()+Date.now(),t.commitHash=S,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$dc,t["common.nodeArch"]=A,t["common.product"]=a||"desktop",r&&(t["common.msftInternal"]=r);let n=0;const o=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=L(w);return c&&(t["common.platformDetail"]=c),t}e.$vo=R;function $(g){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return g.some(S=>A===S)}e.$wo=$}),define(Ce[192],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=void 0,e.$ql=(0,E.$2h)("telemetryService"),e.$rl=(0,E.$2h)("customEndpointTelemetryService"),e.$sl="telemetry.currentSessionDate",e.$tl="telemetry.firstSessionDate",e.$ul="telemetry.lastSessionDate",e.$vl="telemetry.machineId",e.$wl="telemetry.sqmId",e.$xl="telemetry",e.$yl="telemetry.telemetryLevel",e.$zl="telemetry.enableCrashReporter",e.$Al="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var I;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ce[56],Re([1,0,26,16,5,41,55,191,192]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;class w{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$xo=w;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yo=A,e.$zo=new A;class S{async publicLog(m,f,k){}async publicLogError(m,f,k){}}e.$Ao=S,e.$Bo="telemetry",e.$Co="extensionTelemetryLog",e.$Do={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,m){return I.Event.debounce(m.onDidChangeConfiguration,(k,F)=>{const v=k?new Set([...k.affectedKeys,...F.affectedKeys]):F.affectedKeys;return{...F,affectedKeys:v}},1e3,!0)(k=>{k.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.$yi)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$Eo=l;function p(d,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!d.enableTelemetry)}e.$Fo=p;function b(d,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$Go=b;function r(d){const m=d.getValue(g.$yl),f=d.getValue(g.$zl);if(d.getValue(g.$Al)===!1||f===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Ho=r;function a(d){const m={},f={},k={};o(d,k);for(let F in k){F=F.length>150?F.substr(F.length-149):F;const v=k[F];typeof v=="number"?f[F]=v:typeof v=="boolean"?f[F]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${F} has been trimmed to 8192, the original length is ${v.length}`),m[F]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(m[F]=v)}return{properties:m,measurements:f}}e.$Io=a;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(d){if(!d)return"none";const m=(0,R.$0k)(d);return t.has(m)?m:"other"}e.$Jo=n;function o(d,m,f=0,k){if(d)for(const F of Object.getOwnPropertyNames(d)){const v=d[F],y=k?k+F:F;Array.isArray(v)?m[y]=(0,E.$nn)(v):v instanceof Date?m[y]=v.toISOString():(0,T.$Gf)(v)?f<2?o(v,m,f+1,y+"."):m[y]=(0,E.$nn)(v):m[y]=v}}function c(d,m){const f=d.msftInternalDomains||[],k=m.getValue("telemetry.internalTesting");return(0,$.$wo)(f)||k}e.$Ko=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Lo=h;function i(d,m){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const k=[];for(const D of m)for(;;){const N=D.exec(d);if(!N)break;k.push([N.index,D.lastIndex])}const F=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const D=v.exec(d);if(!D)break;const N=k.some(([O,W])=>D.index<W&&O<v.lastIndex);!F.test(D[0])&&!N&&(f+=d.substring(y,D.index)+"<REDACTED: user-file-path>",y=v.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function s(d){if(!d)return d;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of m)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,m){return(0,E.$kn)(d,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let k=f.replaceAll("%20"," ");k=i(k,m);for(const F of m)k=k.replace(F,"");return k=s(k),k}})}e.$Mo=u}),define(Ce[193],Re([1,0,11,97,22,21,2,14,74,56]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;function A(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$3e)(u.id,d.id)===0}e.$No=A;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const m=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,m,f)}static parse(d){const m=S.exec(d);return m&&m[1]&&m[2]?new l({id:m[1]},m[2],m[4]||void 0):null}constructor(d,m,f="undefined"){this.version=m,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?A(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Oo=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(u){const d=p.exec(u);return d&&d[1]?[a(d[1]),d[2]]:[a(u),void 0]}e.$Po=b;function r(u,d){return`${u}.${d}`}e.$Qo=r;function a(u){return u.toLowerCase()}e.$Ro=a;function t(u,d){return a(r(u??I.$dm,d))}e.$So=t;function n(u,d){const m=[],f=k=>{for(const F of m)if(F.some(v=>A(d(v),d(k))))return F;return null};for(const k of u){const F=f(k);F?F.push(k):m.push([k])}return m}e.$To=n;function o(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$Uo=o;function c(u){return{id:new w.$xo(u.identifier.id),name:new w.$xo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$Vo=c,e.$Wo=new I.$hm("pprice.better-merge");function h(u,d){const m=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const k=f.shift();if(k&&m.every(F=>!A(F.identifier,{id:k}))){const F=u.filter(v=>A(v.identifier,{id:k}));F.length===1&&(m.push(F[0]),f.push(...F[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.$Xo=h;async function i(u,d){if(!L.$k)return!1;let m;try{m=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){d.debug("Error while getting the os-release file.",(0,$.$0)(k))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(u,d){const m=await i(u,d),f=(0,T.$ho)(m?"alpine":L.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$Yo=s}),define(Ce[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0;function E(g){return[...g.entries()]}e.$yr=E;function T(g){return g?[...g.entries()]:[]}e.$zr=T;function I(g){return new Map(g)}e.$Ar=I;function L(g){return new Map(g??[])}e.$Br=L;function R(g){return Array.from(g.entries()).map(w=>[w[0],E(w[1].map),T(w[1].descriptionMap)])}e.$Cr=R;function $(g){return new Map(g.map(w=>[w[0],{map:I(w[1]),descriptionMap:L(w[2])}]))}e.$Dr=$}),define(Ce[195],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrb=void 0;class E{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,L,R=5){const $=L(g=>{const w=typeof g=="string"?g:g.data;let A=this.a.get(I);if(A){A.data.push(w);return}const S=setTimeout(()=>this.flushBuffer(I),R);A={data:[w],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(I),$.dispose()}},this.a.set(I,A)});return $}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const L=this.a.get(I);L&&(this.a.delete(I),this.b(I,L.data.join("")))}}e.$wrb=E}),define(Ce[196],Re([1,0,13,90,45,5,16,2,155,73,30]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.IconFontDefinition=e.IconContribution=e.$iw=void 0,e.$iw={IconContribution:"base.contributions.icons"};var S;(function(c){function h(i,s){let u=i.defaults;for(;I.ThemeIcon.isThemeIcon(u);){const d=b.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(S||(e.IconContribution=S={}));var l;(function(c){function h(s){return{weight:s.weight,style:s.style,src:s.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(s){const u=d=>(0,R.$Ef)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,R.$Ef)(d.format)&&(0,R.$Ef)(d.location)))return{weight:u(s.weight),style:u(s.style),src:s.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new L.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,s,u){const d=this.b[h];if(d){if(s&&!d.description){d.description=s,this.d.properties[h].markdownDescription=`${s} $(${h})`;const k=this.e.enum.indexOf(h);k!==-1&&(this.e.enumDescriptions[k]=s),this.a.fire()}return d}const m={id:h,description:s,defaults:i,deprecationMessage:u};this.b[h]=m;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),s&&(f.markdownDescription=`${s}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const s=this.f[h];return s||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,m)=>d.id.localeCompare(m.id),i=d=>{for(;I.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(m=>!!m.description).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|${I.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of u.filter(m=>!I.ThemeIcon.isThemeIcon(m.defaults)).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|`);return s.join(`
`)}}const b=new p;A.$un.add(e.$iw.IconContribution,b);function r(c,h,i,s){return b.registerIcon(c,h,i,s)}e.$jw=r;function a(){return b}e.$kw=a;function t(){const c=(0,T.$6j)();for(const h in c){const i="\\"+c[h].toString(16);b.registerIcon(h,{fontCharacter:i})}}t(),e.$lw="vscode://schemas/icons";const n=A.$un.as(w.$vn.JSONContribution);n.registerSchema(e.$lw,b.getIconSchema());const o=new E.$bh(()=>n.notifySchemaChanged(e.$lw),200);b.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$mw=r("widget-close",T.$8j.close,(0,g.localize)(2,null)),e.$nw=r("goto-previous-location",T.$8j.arrowUp,(0,g.localize)(3,null)),e.$ow=r("goto-next-location",T.$8j.arrowDown,(0,g.localize)(4,null)),e.$pw=I.ThemeIcon.modify(T.$8j.sync,"spin"),e.$qw=I.ThemeIcon.modify(T.$8j.loading,"spin")}),define(Ce[197],Re([1,0,5,41,4,15]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.ProvidedOnAutoForward=e.$ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$nv=e.$mv=void 0,e.$mv=(0,I.$2h)("tunnelService"),e.$nv=(0,I.$2h)("sharedTunnelsService");var R;(function(a){a.Http="http",a.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})($||(e.TunnelPrivacyId=$={}));function g(a){return!!a.forwardPort}e.$ov=g;var w;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function A(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(t)return{address:t[1],port:+t[2]}}e.$pv=A,e.$qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(a){return e.$qv.indexOf(a)>=0}e.$rv=S,e.$sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(a){return e.$sv.indexOf(a)>=0}e.$tv=l;function p(a,t,n,o){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return a<1024}e.$uv=p;class b{constructor(t,n,o){this.remoteAddress=t,this.localAddress=n,this.b=o,this.a=new E.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vv=b;let r=class{constructor(t,n){this.j=t,this.k=n,this.a=new E.$Sd,this.onTunnelOpened=this.a.event,this.b=new E.$Sd,this.onTunnelClosed=this.b.event,this.c=new E.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,o,c,h){this.p(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||S(t))&&(t=e.$qv[0]);const o=this.r(t,n);if(o)return++o.refcount,o.value}openTunnel(t,n,o,c,h,i=!1,s,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${h}.`);const d=this.f??t;if(!d)return;if(n||(n="localhost"),c||(c=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.s(d,n,o,c,h,i,s,u);return m?m.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,o),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const o=n.get(t.tunnelRemotePort);o&&(o.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,o))}}}}async o(t,n,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const o=this.e.get(t);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.o(t,n,c)}}p(t,n,o){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:o})}async q(t,n){const o=this.e.get(t);if(o){const c=o.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&o.delete(n),o.size===0&&this.e.delete(t)}}r(t,n){const o=[t];S(t)?(o.push(...e.$qv),o.push(...e.$sv)):l(t)&&o.push(...e.$sv);const c=o.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}t(t,n,o,c,h,i,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const u=o;this.i.add(u);const d=c===void 0?o:c,m={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:i,public:i?i!==$.Private:void 0,protocol:s},k=t.forwardPort(f,m);return k?(this.p(n,o,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),k}};e.$wv=r,e.$wv=r=Ge([Ke(0,L.$jj),Ke(1,T.$vi)],r)}),define(Ce[198],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xv=void 0,e.$xv=(0,E.$2h)("editSessionIdentityService");var T;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Ce[199],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$kK=T;function I(g){if(g.folders.length)return g.folders.every(w=>T(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$lK=I;function L(g){return I(g)?.scheme}e.$mK=L;function R(g){return I(g)?.authority}e.$nK=R;function $(g){return I(g)!==void 0}e.$oK=$}),define(Ce[47],Re([1,0,156,19,50,25,2,4,12]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,$.$2h)("contextService");function w(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.uri)}e.$_h=w;function A(d){return typeof d?.id=="string"&&!w(d)&&!l(d)}e.$ai=A,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function S(d,m){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$nc)(d)}:m?e.$bi:e.$ci;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$di=S;function l(d){const m=d;return typeof m?.id=="string"&&R.URI.isUri(m.configPath)}e.$ei=l;function p(d){const m=d;if(m?.uri)return{id:m.id,uri:R.URI.revive(m.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$fi=p;var b;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function r(d){const m=d;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.$gi=r;function a(d){const m=d;return!!(m&&typeof m=="object"&&R.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.$hi=a;class t{constructor(m,f,k,F,v){this.h=m,this.j=k,this.k=F,this.l=v,this.c=I.$8h.forUris(this.l,()=>!0),this.folders=f}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=I.$8h.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=t;class n{constructor(m,f){this.raw=f,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.$Dg)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=n;function o(d){return new n({uri:d,index:0,name:(0,L.$zg)(d)},{uri:d.toString()})}e.$ki=o,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,E.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function c(d,m){return L.$ug.isEqualOrParent(d,m.untitledWorkspacesHome)}e.$pi=c;function h(d){let m;return R.URI.isUri(d)?m=d:m=d.configuration,m?.scheme===g.Schemas.tmp}e.$qi=h,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$ri}e.$si=i;function s(d,m){return!c(d,m)&&!h(d)}e.$ti=s;function u(d){return(typeof d=="string"?(0,T.$oc)(d):(0,L.$Bg)(d))===e.$mi}e.$ui=u}),define(Ce[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class E{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const L=this.c++;return this.b.set(L,I),this.e(),L}get(I,L){return this.b.has(I)?this.b.get(I)[L]:void 0}delete(I){this.b.delete(I),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$$ec=E}),define(Ce[43],Re([1,0,12,25,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=e.$bfc=void 0;class L{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$sg($=>{const g=this.b.get($.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos($,g){g===null?this.b.delete($.scheme):this.b.set($.scheme,g)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$bfc=L,e.$cfc=(0,I.$2h)("IExtHostFileSystemInfo")}),define(Ce[27],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0,e.$8M=(0,E.$2h)("IExtHostInitDataService")}),define(Ce[200],Re([1,0,161,15,187,27]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;let R=class extends I.$cO{constructor(g,w,A){const S=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=A.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(S,{name:l}))}};e.$ihc=R,e.$ihc=R=Ge([Ke(1,T.$kj),Ke(2,L.$8M)],R)}),define(Ce[201],Re([1,0,13]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;class T{constructor(R,$,g){this.h=new Map,this.a=R,this.b=$,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$bh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of w.values())A.complete()}catch(A){for(const S of w.values())S.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let g=this.f[R];return typeof g>"u"&&(g=$),g}update(R,$){this.f[R]=$;const g=this.h.get(R);if(g!==void 0)return g.p;const w=new E.$mh;return this.h.set(R,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$Wfc=T;class I extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$Xfc=I}),define(Ce[202],Re([1,0,5,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class I{constructor(R){this.c=R,this.a=new E.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,g,w){const S=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged($.value,g,w);this.b.fire(S)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire($.apiNotebook)}}e.$Kgc=I}),define(Ce[17],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0,e.$RM=(0,E.$2h)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$SM=T}),define(Ce[203],Re([1,0,22,5]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class I{#e;constructor(R,$){this.b=new T.$Sd,this.onDidChange=this.b.event,this.a=E.$hm.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$5fc=I}),define(Ce[57],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=void 0,e.$ufc=(0,E.$2h)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$vfc=T}),define(Ce[204],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kb=e.$1kb=void 0;class T{constructor(){this.buffers=[]}add(g){let w=this.buffers.indexOf(g);return w<0&&(w=this.buffers.length,this.buffers.push(g)),w}}function I($,g){if(g.serializeBuffersForPostMessage){const w=new T,S=JSON.stringify($,(p,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b)};if(ArrayBuffer.isView(b)){const r=L(b);if(r)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b.buffer),view:{type:r,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),l=w.buffers.map(p=>{const b=new Uint8Array(p);return E.$ge.wrap(b)});return{message:S,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}e.$1kb=I;function L($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,g){const w=g.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=g.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const b=p,{index:r}=b,a=w[r];if(b.view)switch(b.view.type){case 1:return new Int8Array(a,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return p}:void 0;return{message:JSON.parse($,A),arrayBuffers:w}}e.$2kb=R}),define(Ce[102],Re([1,0,171,16,2,6,4,30,42,12,40,134,31]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PE=e.$OE=e.$NE=e.EditorsOrder=e.$ME=e.CloseDirection=e.$LE=e.$KE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.EditorInputCapabilities=e.$BE=e.SaveReason=e.Verbosity=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=void 0,e.$oE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$pE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$qE="workbench.editor.sidebysideEditor",e.$rE="workbench.editors.textDiffEditor",e.$sE="workbench.editors.binaryResourceDiffEditor";var p;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var b;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function r(oe){const x=oe;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.$tE=r;function a(oe,x,q){for(const ne of q.visibleEditorPanes)if(ne.group.id===x&&oe.matches(ne.input))return ne.getViewState()}e.$uE=a;function t(oe){if(k(oe))return!1;const x=oe;return I.URI.isUri(x?.resource)}e.$vE=t;function n(oe){if(k(oe))return!1;const x=oe;return x?.original!==void 0&&x.modified!==void 0}e.$wE=n;function o(oe){if(k(oe))return!1;const x=oe;return Array.isArray(x?.resources)}e.$xE=o;function c(oe){if(k(oe)||n(oe))return!1;const x=oe;return x?.primary!==void 0&&x.secondary!==void 0}e.$yE=c;function h(oe){if(k(oe))return!1;const x=oe;return x?x.resource===void 0||x.resource.scheme===w.Schemas.untitled||x.forceUntitled===!0:!1}e.$zE=h;function i(oe){if(k(oe))return!1;const x=oe;return I.URI.isUri(x?.base?.resource)&&I.URI.isUri(x?.input1?.resource)&&I.URI.isUri(x?.input2?.resource)&&I.URI.isUri(x?.result?.resource)}e.$AE=i;var s;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var u;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(x,q){let ne=this.a.get(x);return ne||(ne={source:x,label:q},this.a.set(x,ne)),ne.source}getSourceLabel(x){return this.a.get(x)?.label??x}}e.$BE=new d;var m;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(m||(e.EditorInputCapabilities=m={}));class f extends L.$Sc{}e.$CE=f;function k(oe){return oe instanceof f}e.$DE=k;function F(oe){const x=oe;return I.URI.isUri(x?.preferredResource)}function v(oe){const x=oe;return k(x?.primary)&&k(x?.secondary)}e.$EE=v;function y(oe){const x=oe;return k(x?.modified)&&k(x?.original)}e.$FE=y;function D(oe,x,q,ne,Ie){return Se(ne,[(0,S.$Li)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Ae={...q,limits:{size:Number.MAX_VALUE}};oe.openEditor(x,Ae)}}),(0,S.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$GE=D;function N(oe){return k(oe?.editor)}e.$HE=N;function O(oe){const x=oe;return N(oe)&&x?.group!==void 0}e.$IE=O;function W(oe){const x=oe;return typeof x?.groupId=="number"&&k(x.editor)}e.$JE=W;var z;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var V;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(V||(e.GroupModelChangeKind=V={}));var P;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class C{getOriginalUri(x,q){if(!x)return;if(i(x))return e.$LE.getOriginalUri(x.result,q);if(q?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(x);if(Ie&&Ae){if(q?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(Ae,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===P.ANY)return this.getOriginalUri(Ie,{filterByScheme:q.filterByScheme})??this.getOriginalUri(Ae,{filterByScheme:q.filterByScheme});x=q.supportSideBySide===P.PRIMARY?Ie:Ae}}if(n(x)||o(x)||c(x)||i(x))return;const ne=F(x)?x.preferredResource:x.resource;return!ne||!q||!q.filterByScheme?ne:this.b(ne,q.filterByScheme)}a(x){return v(x)||c(x)?{primary:x.primary,secondary:x.secondary}:y(x)||n(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,q){if(!x)return;if(i(x))return e.$LE.getCanonicalUri(x.result,q);if(q?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(x);if(Ie&&Ae){if(q?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(Ae,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===P.ANY)return this.getCanonicalUri(Ie,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(Ae,{filterByScheme:q.filterByScheme});x=q.supportSideBySide===P.PRIMARY?Ie:Ae}}if(n(x)||o(x)||c(x)||i(x))return;const ne=x.resource;return!ne||!q||!q.filterByScheme?ne:this.b(ne,q.filterByScheme)}b(x,q){if(Array.isArray(q)){if(q.some(ne=>x.scheme===ne))return x}else if(q===x.scheme)return x}}var Z;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function ce(oe,x,q,ne){if(!oe.isSticky(x))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return q===Z.MOUSE||q===Z.KEYBOARD;case"mouse":return q===Z.MOUSE;case"keyboard":return q===Z.KEYBOARD}return!1}e.$KE=ce,e.$LE=new C;var me;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class be{constructor(){this.c=new Map,this.d=new Map}start(x){const q=this.a=x.get(R.$1h);for(const[ne,Ie]of this.c)this.e(ne,Ie,q);this.c.clear()}e(x,q,ne){const Ie=ne.createInstance(q);this.d.set(x,Ie)}registerFileEditorFactory(x){if(this.b)throw new Error("Can only register one file editor factory.");this.b=x}getFileEditorFactory(){return(0,T.$Pf)(this.b)}registerEditorSerializer(x,q){if(this.c.has(x)||this.d.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.a?this.e(x,q,this.a):this.c.set(x,q),(0,L.$Qc)(()=>{this.c.delete(x),this.d.delete(x)})}getEditorSerializer(x){return this.d.get(typeof x=="string"?x:x.typeId)}}$.$un.add(e.$oE.EditorFactory,new be);async function ke(oe,x,q){return!oe||!oe.length?[]:await Promise.all(oe.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){q.info("Cannot resolve the path because it is not valid.",ne);return}if(!await x.canHandleResource(Ie)){q.info("Cannot resolve the path because it cannot be handled",ne);return}let Pe=ne.exists,ae=ne.type;if(typeof Pe!="boolean"||typeof ae!="number")try{ae=(await x.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Pe=!0}catch(J){q.error(J),Pe=!1}if(!Pe&&ne.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",ne);return}if(ae===g.FileType.Directory){q.info("Cannot resolve the path because it is a directory",ne);return}const te={...ne.options,pinned:!0};return Pe?{resource:Ie,options:te}:{resource:Ie,options:te,forceUntitled:!0}}))}e.$ME=ke;var fe;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(fe||(e.EditorsOrder=fe={}));function de(oe){const x=oe;if(!x)return!1;const q=x;if(q.modified)return de(q.modified);const ne=x;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$NE=de;function ie(oe){return(0,A.$Ni)(oe)}e.$OE=ie;function Se(oe,x,q){const ne=(0,A.$Oi)(oe,x);return ne.forceMessage=q?.forceMessage,ne.forceSeverity=q?.forceSeverity,ne.allowDialog=q?.allowDialog,ne}e.$PE=Se}),define(Ce[205],Re([1,0,5,172,4,6,28,30,18,26,90,196]),function(ge,e,E,T,I,L,R,$,g,w,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.$XE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$WE=e.$VE=e.ViewContentGroups=e.$UE=e.$TE=e.ViewContainerLocation=e.Extensions=e.$SE=e.$RE=e.$QE=void 0,e.$QE="views",e.$RE=(0,T.localize)(0,null),e.$SE=(0,S.$jw)("default-view-icon",A.$8j.window,(0,T.localize)(1,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$TE=[0,1,2];function b(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$UE=b;class r extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(u,d,m){const f=this.get(u.id);if(f)return f;const k=u;return k.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,R.$xc)(this.g,d,[]).push(k),m?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:d}),k}deregisterViewContainer(u){for(const d of this.g.keys()){const m=this.g.get(d),f=m?.indexOf(u);if(f!==-1){m?.splice(f,1),m.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}$.$un.add(l.ViewContainersRegistry,new r);var a;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(a||(e.ViewContentGroups=a={}));function t(s,u){const d=s.group??a.More,m=u.group??a.More;return d!==m?d.localeCompare(m):(s.order??5)-(u.order??5)}class n extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:m})=>this.r(d,m)),this.c.fire(u)}deregisterViews(u,d){const m=this.s(u,d);m.length&&this.f.fire({views:m,viewContainer:d})}moveViews(u,d){for(const m of this.m.keys())if(m!==d){const f=this.s(u,m);f.length&&(this.r(f,d),this.g.fire({views:f,from:m,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const m=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,L.$Qc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const m=new Map;for(const[f,k]of d)this.n.add(u,k),m.set(f,(0,L.$Qc)(()=>{this.n.delete(u,k),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,m=>d.push(m)),d.sort(t)}r(u,d){let m=this.m.get(d);m||(m=[],this.m.set(d,m),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));m.push(f)}}s(u,d){const m=this.m.get(d);if(!m)return[];const f=[],k=[];for(const F of m)u.includes(F)?f.push(F):k.push(F);return f.length&&(k.length?this.m.set(d,k):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}$.$un.add(l.ViewsRegistry,new n),e.$VE=(0,I.$2h)("viewsService"),e.$WE=(0,I.$2h)("viewDescriptorService");var o;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,w.$ln)(this,u),this.d=!!d,this.resolve=async m=>{if(d&&!this.c){const f=await d(m);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$XE=h;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$YE=i}),define(Ce[206],Re([1,0,2,29,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$PF=e.$OF=void 0;function L(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(T.$Hs.isIRange)}e.$OF=L;function R(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(L)}e.$PF=R;var $;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var g;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(g||(e.ChatAgentCopyKind=g={})),e.$QF=(0,I.$2h)("IChatService")}),define(Ce[207],Re([1,0,5,13,173]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new E.$Sd,this.n=new E.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,g,w,A){const S={command:$};if(g&&Object.keys(g).length>0&&(S.arguments=g),this.s("request",S),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(S.seq);if(p){this.f.delete(S.seq);const b={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,I.localize)(0,null,A,$)};p(b)}},A)}return w&&this.f.set(S.seq,w),S.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,g){return $.type!=="event"||g.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$3g)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const g=$,w=this.f.get(g.request_seq);w&&(this.f.delete(g.request_seq),w(g));break}}}}s($,g){g.type=$,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((g,w)=>$.set(w,g)),await(0,T.$3g)(500),$.forEach((g,w)=>{g({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$ulb=L}),define(Ce[208],Re([1,0,174,35,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$zH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$yH=e.MemoryRangeType=e.$xH=e.State=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0,e.$uG="workbench.view.debug",e.$vG="workbench.debug.variablesView",e.$wG="workbench.debug.watchExpressionsView",e.$xG="workbench.debug.callStackView",e.$yG="workbench.debug.loadedScriptsView",e.$zG="workbench.debug.breakPointsView",e.$AG="workbench.debug.disassemblyView",e.$BG="workbench.panel.repl",e.$CG="workbench.panel.repl.view",e.$DG=new T.$gj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$EG=new T.$gj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$FG=new T.$gj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$GG="debugUx",e.$HG=new T.$gj(e.$GG,"default",{type:"string",description:E.localize(3,null)}),e.$IG=new T.$gj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$JG=new T.$gj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$KG=new T.$gj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$LG=new T.$gj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$MG=new T.$gj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$NG=new T.$gj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$OG=new T.$gj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$PG=new T.$gj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$QG=new T.$gj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$RG=new T.$gj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$SG=new T.$gj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$TG=new T.$gj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$UG=new T.$gj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$VG=new T.$gj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$WG=new T.$gj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$XG=new T.$gj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$YG=new T.$gj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$ZG=new T.$gj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$1G=new T.$gj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$2G=new T.$gj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$3G=new T.$gj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$4G=new T.$gj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$5G=new T.$gj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$6G=new T.$gj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$7G=new T.$gj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$8G=new T.$gj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$9G=new T.$gj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$0G=new T.$gj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$$G=new T.$gj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$_G=new T.$gj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$aH=new T.$gj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$bH=new T.$gj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$cH=new T.$gj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$dH=new T.$gj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$eH=new T.$gj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$fH=new T.$gj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$gH=new T.$gj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$hH=new T.$gj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$iH=new T.$gj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$jH=new T.$gj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$kH=new T.$gj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$lH=new T.$gj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$mH=new T.$gj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$nH=new T.$gj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$oH=new T.$gj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$pH=new T.$gj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$qH=new T.$gj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$rH=new T.$gj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const L=l=>E.localize(52,null,l);e.$sH=L,e.$tH="editor.contrib.debug",e.$uH="editor.contrib.breakpoint",e.$vH="debug",e.$wH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(R||(e.State=R={}));function $(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$xH=$;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$yH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$zH=(0,I.$2h)("debugService");var S;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Ce[209],Re([1,0,11,2,19,26,12,29,20,18]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=void 0;const A=/{([^}]+)}/g;function S(F,v,y){return F.replace(A,function(D,N){return v&&N.length>0&&N[0]!=="_"?D:y&&y.hasOwnProperty(N)?y[N]:D})}e.$VF=S;function l(F){const v={};for(const y of Object.keys(F))y.startsWith("!")||(v[y]=F[y]);return v}e.$WF=l;function p(F){return F.configuration.request==="attach"&&!b(F)&&(!F.parentSession||p(F.parentSession))}e.$XF=p;function b(F){let v=F.configuration.type;if(v)return v==="vslsShare"&&(v=F.configuration.adapterProxy.configuration.type),(0,E.$8e)(v,"extensionhost")||(0,E.$8e)(v,"pwa-extensionhost")?F:F.parentSession?b(F.parentSession):void 0}e.$YF=b;function r(F){return F.type&&(F.label||F.program||F.runtime)}e.$ZF=r;function a(F,v,y){let D,N=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=O.exec(F);){const z=W.index+1,V=z+W[0].length;if(z<=v&&V>=y){D=W[0],N=z;break}}if(D){const z=/\w+/g;let V=null;for(;(V=z.exec(D))&&!(V.index+1+N+V[0].length>=y););V&&(D=D.substring(0,z.lastIndex))}return D?{start:N,end:N+D.length-1}:{start:0,end:0}}e.$1F=a;async function t(F,v,y,D){if(F.evaluatableExpressionProvider.has(v)){const N=F.evaluatableExpressionProvider.ordered(v),O=(0,w.$Hb)(await Promise.all(N.map(async W=>{try{return await W.provideEvaluatableExpression(v,y,D??g.CancellationToken.None)}catch{return}})));if(O.length>0){let W=O[0].expression;const z=O[0].range;return W||(W=v.getLineContent(y.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:W}}}else{const N=v.getLineContent(y.lineNumber),{start:O,end:W}=a(N,y.column,y.column),z=N.substring(O-1,W);return{matchingExpression:z,range:new $.$Hs(y.lineNumber,O,y.lineNumber,O+z.length)}}return null}e.$2F=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(F){return!!(F&&F.match(n))}e.$3F=o;function c(F){if(typeof F.path=="string"&&!(typeof F.sourceReference=="number"&&F.sourceReference>0)){if(o(F.path))return T.URI.parse(F.path);if((0,I.$ic)(F.path))return T.URI.file(F.path)}return F.path}function h(F){if(typeof F.path=="object"){const v=T.URI.revive(F.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return F.path}function i(F,v){const y=v?c:h,D=(0,L.$in)(F);return u(D,(N,O)=>{N&&O&&(O.path=y(O))}),D}e.$4F=i;function s(F,v){const y=v?c:h,D=(0,L.$in)(F);return u(D,(N,O)=>{!N&&O&&(O.path=y(O))}),D}e.$5F=s;function u(F,v){switch(F.type){case"event":{const y=F;switch(y.event){case"output":v(!1,y.body.source);break;case"loadedSource":v(!1,y.body.source);break;case"breakpoint":v(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=F;switch(y.command){case"setBreakpoints":v(!0,y.arguments.source);break;case"breakpointLocations":v(!0,y.arguments.source);break;case"source":v(!0,y.arguments.source);break;case"gotoTargets":v(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>v(!1,D));break;default:break}break}case"response":{const y=F;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>v(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>v(!1,D));break;case"scopes":y.body.scopes.forEach(D=>v(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>v(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>v(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(N=>v(!1,N.location));break;default:break}break}}}function d(F){return F.filter(v=>!v.presentation?.hidden).sort((v,y)=>v.presentation?y.presentation?v.presentation.group?y.presentation.group?v.presentation.group!==y.presentation.group?v.presentation.group.localeCompare(y.presentation.group):m(v.presentation.order,y.presentation.order):-1:y.presentation.group?1:m(v.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$6F=d;function m(F,v){return typeof F!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:F-v}async function f(F,v){const y=F.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(y!=="none"&&(await v.saveAll(),y==="allEditorsInActiveGroup")){const D=v.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:D.input,groupId:D.group.id})}await F.reloadConfiguration()}e.$7F=f;const k=(F,v)=>!F||!v?F===v:F.name===v.name&&F.path===v.path&&F.sourceReference===v.sourceReference;e.$8F=k}),define(Ce[76],Re([1,0,24,34,67,68,12,19,21,35]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.$SI=e.$RI=e.$QI=e.CellStatusbarAlignment=e.$PI=e.$OI=e.$NI=e.NotebookEditorPriority=e.$MI=e.$LI=e.$KI=e.$JI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$II=e.$HI=e.$GI=e.$FI=e.CellKind=e.$EI=e.$DI=e.$CI=void 0,e.$CI="workbench.editor.notebook",e.$DI="workbench.editor.notebookTextDiffEditor",e.$EI="workbench.editor.interactive";var A;(function(C){C[C.Markup=1]="Markup",C[C.Code=2]="Code"})(A||(e.CellKind=A={})),e.$FI=["application/json","application/javascript","text/html","image/svg+xml",L.$4r.latex,L.$4r.markdown,"image/png","image/jpeg",L.$4r.text],e.$GI=[L.$4r.latex,L.$4r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$4r.text],e.$HI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$II="_notAvailable";var S;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var l;(function(C){C[C.Unconfirmed=1]="Unconfirmed",C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(C){C[C.Unconfirmed=1]="Unconfirmed",C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var b;(function(C){C[C.WithHardKernelDependency=0]="WithHardKernelDependency",C[C.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",C[C.Pure=2]="Pure",C[C.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var r;(function(C){C.Always="always",C.Never="never",C.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var a;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.ChangeCellLanguage=5]="ChangeCellLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",C[C.ChangeCellMime=13]="ChangeCellMime",C[C.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var t;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.Move=6]="Move",C[C.OutputItems=7]="OutputItems",C[C.PartialMetadata=8]="PartialMetadata",C[C.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(C){C.scheme=R.Schemas.vscodeNotebookCell;const Z=["W","X","Y","Z","a","b","c","d","e","f"],ce=new RegExp(`^[${Z.join("")}]+`),me=7;function be(oe,x){const q=x.toString(me),Ie=`${q.length<Z.length?Z[q.length-1]:"z"}${q}s${(0,E.$Ae)(E.$ge.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:C.scheme,fragment:Ie})}C.generate=be;function ke(oe){if(oe.scheme!==C.scheme)return;const x=oe.fragment.indexOf("s");if(x<0)return;const q=parseInt(oe.fragment.substring(0,x).replace(ce,""),me),ne=(0,E.$ze)(oe.fragment.substring(x+1)).toString();if(!isNaN(q))return{handle:q,notebook:oe.with({scheme:ne,fragment:null})}}C.parse=ke;function fe(oe,x){return oe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${x??""},${oe.scheme!==R.Schemas.file?oe.scheme:""}`})}C.generateCellOutputUri=fe;function de(oe){if(oe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const x=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!x)return;const q=x[1]&&x[1]!==""?x[1]:void 0,ne=x[2];return{outputId:q,notebook:oe.with({scheme:ne||R.Schemas.file,fragment:null})}}C.parseCellOutputUri=de;function ie(oe,x,q){return C.generate(oe,x).with({scheme:q})}C.generateCellPropertyUri=ie;function Se(oe,x){if(oe.scheme===x)return C.parse(oe.with({scheme:C.scheme}))}C.parseCellPropertyUri=Se})(o||(e.CellUri=o={}));const c=C=>g.$i?C.replace(/\//g,"\\"):C;class h{constructor(Z=[],ce=e.$FI){this.e=ce,this.d=[...new Set(Z)].map(me=>({pattern:me,matches:T.$Ij(c(me))}))}sort(Z){const ce=new Map(I.Iterable.map(Z,be=>[be,c(be)]));let me=[];for(const{matches:be}of this.d)for(const[ke,fe]of ce)if(be(fe)){me.push(ke),ce.delete(ke);break}return ce.size&&(me=me.concat([...ce.keys()].sort((be,ke)=>this.e.indexOf(be)-this.e.indexOf(ke)))),me}prioritize(Z,ce){const me=this.f(Z);if(me===-1){this.d.unshift({pattern:Z,matches:T.$Ij(c(Z))});return}const be=new Set(ce.map(fe=>this.f(fe,me)));be.delete(-1);const ke=Array.from(be).sort();this.d.splice(me+1,0,...ke.map(fe=>this.d[fe]));for(let fe=ke.length-1;fe>=0;fe--)this.d.splice(ke[fe],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,ce=this.d.length){const me=c(Z);for(let be=0;be<ce;be++)if(this.d[be].matches(me))return be;return-1}}e.$JI=h;function i(C,Z,ce,me=(be,ke)=>be===ke){const be=[];function ke(ie,Se,oe){if(Se===0&&oe.length===0)return;const x=be[be.length-1];x&&x.start+x.deleteCount===ie?(x.deleteCount+=Se,x.toInsert.push(...oe)):be.push({start:ie,deleteCount:Se,toInsert:oe})}let fe=0,de=0;for(;;){if(fe===C.length){ke(fe,0,Z.slice(de));break}if(de===Z.length){ke(fe,C.length-fe,[]);break}const ie=C[fe],Se=Z[de];if(me(ie,Se)){fe+=1,de+=1;continue}ce(Se)?(ke(fe,1,[]),fe+=1):(ke(fe,0,[Se]),de+=1)}return be}e.$KI=i,e.$LI=new w.$gj("notebookEditorCursorAtBoundary","none"),e.$MI=new w.$gj("notebookEditorCursorAtLineBoundary","none");var s;(function(C){C.default="default",C.option="option"})(s||(e.NotebookEditorPriority=s={}));function u(C){const Z=C;return!!((typeof Z.include=="string"||T.$Jj(Z.include))&&(typeof Z.exclude=="string"||T.$Jj(Z.exclude)))}e.$NI=u;function d(C,Z,ce){if(Array.isArray(C.viewType)&&C.viewType.indexOf(Z)>=0||C.viewType===Z)return!0;if(C.filenamePattern){const me=u(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,be=u(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(T.$Hj(me,(0,$.$nc)(ce.fsPath).toLowerCase()))return!(be&&T.$Hj(be,(0,$.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$OI=d,e.$PI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var m;(function(C){C[C.Left=1]="Left",C[C.Right=2]="Right"})(m||(e.CellStatusbarAlignment=m={}));class f{static{this.d="notebook/"}static create(Z){return`${f.d}${Z}`}static parse(Z){if(Z.startsWith(f.d))return Z.substring(f.d.length)}}e.$QI=f;function k(C){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(C)}e.$RI=k;const F=new TextDecoder;function v(C){const Z=[];let ce=!1;for(const fe of C)(Z.length===0||ce)&&(Z.push(fe),ce=!0);let me=N(Z);const be=E.$ge.concat(Z.map(fe=>E.$ge.wrap(fe))),ke=P(be);return me=me||ke.byteLength!==be.byteLength,{data:ke,didCompression:me}}e.$SI=v,e.$TI=`${String.fromCharCode(27)}[A`;const y=e.$TI.split("").map(C=>C.charCodeAt(0)),D=10;function N(C){let Z=!1;return C.forEach((ce,me)=>{if(me===0||ce.length<e.$TI.length)return;const be=C[me-1],ke=ce.subarray(0,e.$TI.length);if(ke[0]===y[0]&&ke[1]===y[1]&&ke[2]===y[2]){const fe=be.lastIndexOf(D);if(fe===-1)return;Z=!0,C[me-1]=be.subarray(0,fe),C[me]=ce.subarray(e.$TI.length)}}),Z}function O(C){let Z=C;do C=Z,Z=C.replace(/[^\n]\x08/gm,"");while(Z.length<C.length);return C}function W(C){for(C=C.replace(/\r+\n/gm,`
`);C.search(/\r[^$]/g)>-1;){const Z=C.match(/^(.*)\r+/m)[1];let ce=C.match(/\r+(.*)$/m)[1];ce=ce+Z.slice(ce.length,Z.length),C=C.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return C}const z="\b".charCodeAt(0),V="\r".charCodeAt(0);function P(C){return!C.buffer.includes(z)&&!C.buffer.includes(V)?C:E.$ge.fromString(W(O(F.decode(C.buffer))))}}),define(Ce[7],Re([1,0,18,14,52,28,68,11,16,2,33,22,42,100,76]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b){"use strict";var r,a,t,n,o,c,h,i,s,u,d,m,f,k,F,v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$GM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$FM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.TestRunProfileKind=e.TestResultState=e.$lM=e.$kM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$jM=e.NotebookVariablesRequestKind=e.$iM=e.$hM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$gM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.ColorThemeKind=e.$aM=e.$_L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$$L=e.DebugConsoleMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$5L=e.$4L=e.FileChangeType=e.$3L=e.$2L=e.$1L=e.$ZL=e.InlineCompletionTriggerKind=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.ConfigurationTarget=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$CL=e.ViewBadge=e.ProgressLocation=e.$BL=e.$AL=e.TaskScope=e.ShellQuoting=e.$zL=e.$yL=e.$xL=e.TaskPanelKind=e.TaskRevealKind=e.$wL=e.TerminalLocation=e.$vL=e.$uL=e.$tL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$sL=e.$rL=e.$qL=e.$pL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$oL=e.StatusBarAlignment=e.ViewColumn=e.$nL=e.$mL=e.$lL=e.$kL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$jL=e.$iL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.LanguageStatusSeverity=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.CodeActionTriggerKind=e.$9K=e.$8K=e.SymbolTag=e.SymbolKind=e.$7K=e.$6K=e.DocumentHighlightKind=e.$5K=e.$4K=e.$3K=e.$2K=e.DiagnosticSeverity=e.DiagnosticTag=e.$1K=e.$ZK=e.FileEditType=e.$YK=e.$XK=e.$WK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(B){return Object.assign(B,{apply:function(...se){if(se.length===0)return Reflect.construct(B,[]);{const De=se.length===1?[]:se[1];return Reflect.construct(B,De,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(B,[]);{const[De,...Je]=se;return Reflect.construct(B,Je,De.constructor)}}})}var N;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let W=r=class{static from(...j){let se=j;return new r(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$PK=W,e.$PK=W=r=Ge([D],W);let z=a=class{static Min(...j){if(j.length===0)throw new TypeError;let se=j[0];for(let De=1;De<j.length;De++){const Je=j[De];Je.isBefore(se)&&(se=Je)}return se}static Max(...j){if(j.length===0)throw new TypeError;let se=j[0];for(let De=1;De<j.length;De++){const Je=j[De];Je.isAfter(se)&&(se=Je)}return se}static isPosition(j){if(!j)return!1;if(j instanceof a)return!0;const{line:se,character:De}=j;return typeof se=="number"&&typeof De=="number"}static of(j){if(j instanceof a)return j;if(this.isPosition(j))return new a(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,se){if(j<0)throw(0,T.$7)("line must be non-negative");if(se<0)throw(0,T.$7)("character must be non-negative");this.c=j,this.e=se}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,se=0){if(j===null||se===null)throw(0,T.$7)();let De;return typeof j>"u"?De=0:typeof j=="number"?De=j:(De=typeof j.lineDelta=="number"?j.lineDelta:0,se=typeof j.characterDelta=="number"?j.characterDelta:0),De===0&&se===0?this:new a(this.line+De,this.character+se)}with(j,se=this.character){if(j===null||se===null)throw(0,T.$7)();let De;return typeof j>"u"?De=this.line:typeof j=="number"?De=j:(De=typeof j.line=="number"?j.line:this.line,se=typeof j.character=="number"?j.character:this.character),De===this.line&&se===this.character?this:new a(De,se)}toJSON(){return{line:this.line,character:this.character}}};e.$QK=z,e.$QK=z=a=Ge([D],z);let V=t=class{static isRange(j){return j instanceof t?!0:j?z.isPosition(j.start)&&z.isPosition(j.end):!1}static of(j){if(j instanceof t)return j;if(this.isRange(j))return new t(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,se,De,Je){let xe,ut;if(typeof j=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"?(xe=new z(j,se),ut=new z(De,Je)):z.isPosition(j)&&z.isPosition(se)&&(xe=z.of(j),ut=z.of(se)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(j){return t.isRange(j)?this.contains(j.start)&&this.contains(j.end):z.isPosition(j)?!(z.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const se=z.Max(j.start,this.c),De=z.Min(j.end,this.e);if(!se.isAfter(De))return new t(se,De)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const se=z.Min(j.start,this.c),De=z.Max(j.end,this.end);return new t(se,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,se=this.end){if(j===null||se===null)throw(0,T.$7)();let De;return j?z.isPosition(j)?De=j:(De=j.start||this.start,se=j.end||this.end):De=this.start,De.isEqual(this.c)&&se.isEqual(this.end)?this:new t(De,se)}toJSON(){return[this.start,this.end]}};e.$RK=V,e.$RK=V=t=Ge([D],V);let P=n=class extends V{static isSelection(j){return j instanceof n?!0:j?V.isRange(j)&&z.isPosition(j.anchor)&&z.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,se,De,Je){let xe,ut;if(typeof j=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"?(xe=new z(j,se),ut=new z(De,Je)):z.isPosition(j)&&z.isPosition(se)&&(xe=z.of(j),ut=z.of(se)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$SK=P,e.$SK=P=n=Ge([D],P);const C=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class Z{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,se,De){if(typeof j!="string"||j.length===0)throw(0,T.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,T.$7)("port");typeof De<"u"&&C(De),this.host=j,this.port=Math.round(se),this.connectionToken=De}}e.$TK=Z;class ce{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,se){this.makeConnection=j,this.connectionToken=se,typeof se<"u"&&C(se)}}e.$UK=ce;class me extends Error{static NotAvailable(j,se){return new me(j,p.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(j){return new me(j,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,se=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(j),this._message=j,this._code=se,this._detail=De,Object.setPrototypeOf(this,me.prototype)}}e.$VK=me;var be;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(be||(e.EndOfLine=be={}));var ke;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let fe=o=class{static isTextEdit(j){return j instanceof o?!0:j?V.isRange(j)&&typeof j.newText=="string":!1}static replace(j,se){return new o(j,se)}static insert(j,se){return o.replace(new V(j,j),se)}static delete(j){return o.replace(j,"")}static setEndOfLine(j){const se=new o(new V(new z(0,0),new z(0,0)),"");return se.newEol=j,se}get range(){return this.c}set range(j){if(j&&!V.isRange(j))throw(0,T.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,T.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,T.$7)("newEol");this.f=j}constructor(j,se){this.c=j,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$WK=fe,e.$WK=fe=o=Ge([D],fe);let de=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?ei.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,se){return new c(j,se)}static insertCells(j,se){return new c(new ei(j,j),se)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,se){const De=new c(new ei(j,j),[]);return De.newCellMetadata=se,De}static updateNotebookMetadata(j){const se=new c(new ei(0,0),[]);return se.newNotebookMetadata=j,se}constructor(j,se){this.range=j,this.newCells=se}};e.$XK=de,e.$XK=de=c=Ge([D],de);class ie{static isSnippetTextEdit(j){return j instanceof ie?!0:j?V.isRange(j.range)&&x.isSnippetString(j.snippet):!1}static replace(j,se){return new ie(j,se)}static insert(j,se){return ie.replace(new V(j,j),se)}constructor(j,se){this.range=j,this.snippet=se}}e.$YK=ie;var Se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,se,De,Je){this.c.push({_type:1,from:j,to:se,options:De,metadata:Je})}createFile(j,se,De){this.c.push({_type:1,from:void 0,to:j,options:se,metadata:De})}deleteFile(j,se,De){this.c.push({_type:1,from:j,to:void 0,options:se,metadata:De})}e(j,se,De){this.c.push({_type:3,metadata:De,uri:j,edit:{editType:5,metadata:se},notebookMetadata:se})}f(j,se,De,Je){const xe=se.start,ut=se.end;(xe!==ut||De.length>0)&&this.c.push({_type:5,uri:j,index:xe,count:ut-xe,cells:De,metadata:Je})}g(j,se,De,Je){this.c.push({_type:3,metadata:Je,uri:j,edit:{editType:3,index:se,metadata:De}})}replace(j,se,De,Je){this.c.push({_type:2,uri:j,edit:new fe(se,De),metadata:Je})}insert(j,se,De,Je){this.replace(j,new V(se,se),De,Je)}delete(j,se,De){this.replace(j,se,"",De)}has(j){return this.c.some(se=>se._type===2&&se.uri.toString()===j.toString())}set(j,se){if(se)for(const De of se){if(!De)continue;let Je,xe;Array.isArray(De)?(Je=De[0],xe=De[1]):Je=De,de.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(j,Je.range.start,Je.newCellMetadata,xe):Je.newNotebookMetadata?this.e(j,Je.newNotebookMetadata,xe):this.f(j,Je.range,Je.newCells,xe):ie.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:j,range:Je.range,edit:Je.snippet,metadata:xe}):this.c.push({_type:2,uri:j,edit:Je,metadata:xe})}else{for(let De=0;De<this.c.length;De++){const Je=this.c[De];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===j.toString()&&(this.c[De]=void 0);break}}(0,E.$Ib)(this.c)}}get(j){const se=[];for(const De of this.c)De._type===2&&De.uri.toString()===j.toString()&&se.push(De.edit);return se}entries(){const j=new L.$Ac;for(const se of this.c)if(se._type===2){let De=j.get(se.uri);De||(De=[se.uri,[]],j.set(se.uri,De)),De[1].push(se.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$ZK=oe,e.$ZK=oe=Ge([D],oe);let x=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,se=this.e++){if(typeof j=="function"){const De=new h;De.e=this.e,j(De),this.e=De.e,j=De.value}else j=h.c(j);return this.value+="${",this.value+=se,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,se=this.e++){const De=j.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(j,se){if(typeof se=="function"){const De=new h;De.e=this.e,se(De),this.e=De.e,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$1K=x,e.$1K=x=h=Ge([D],x);var q;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=i=class{static isLocation(j){return j instanceof i?!0:j?V.isRange(j.range)&&w.URI.isUri(j.uri):!1}constructor(j,se){if(this.uri=j,se)if(V.isRange(se))this.range=V.of(se);else if(z.isPosition(se))this.range=new V(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$2K=Ie,e.$2K=Ie=i=Ge([D],Ie);let Ae=class{static is(j){return j?typeof j.message=="string"&&j.location&&V.isRange(j.location.range)&&w.URI.isUri(j.location.uri):!1}constructor(j,se){this.location=j,this.message=se}static isEqual(j,se){return j===se?!0:!j||!se?!1:j.message===se.message&&j.location.range.isEqual(se.location.range)&&j.location.uri.toString()===se.location.uri.toString()}};e.$3K=Ae,e.$3K=Ae=Ge([D],Ae);let Pe=class{constructor(j,se,De=ne.Error){if(!V.isRange(j))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=j,this.message=se,this.severity=De}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,se){return j===se?!0:!j||!se?!1:j.message===se.message&&j.severity===se.severity&&j.code===se.code&&j.severity===se.severity&&j.source===se.source&&j.range.isEqual(se.range)&&(0,E.$ub)(j.tags,se.tags)&&(0,E.$ub)(j.relatedInformation,se.relatedInformation,Ae.isEqual)}};e.$4K=Pe,e.$4K=Pe=Ge([D],Pe);let ae=class{constructor(j,se){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=se}};e.$5K=ae,e.$5K=ae=Ge([D],ae);var te;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let J=class{constructor(j,se=te.Text){this.range=j,this.kind=se}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$6K=J,e.$6K=J=Ge([D],J);let ee=class{constructor(j,se){this.uri=j,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$7K=ee,e.$7K=ee=Ge([D],ee);var $e;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var ve;(function(B){B[B.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Fe=s=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,se,De,Je,xe){this.name=j,this.kind=se,this.containerName=xe,typeof De=="string"&&(this.containerName=De),Je instanceof Ie?this.location=Je:De instanceof V&&(this.location=new Ie(Je,De)),s.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$8K=Fe,e.$8K=Fe=s=Ge([D],Fe);let le=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(u.validate)}constructor(j,se,De,Je,xe){this.name=j,this.detail=se,this.kind=De,this.range=Je,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$9K=le,e.$9K=le=u=Ge([D],le);var we;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let M=class{constructor(j,se){this.title=j,this.kind=se}};e.$0K=M,e.$0K=M=Ge([D],M);let K=class{static{d=this}static{this.c="."}constructor(j){this.value=j}append(j){return new d(this.value?this.value+d.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+d.c)}};e.$$K=K,e.$$K=K=d=Ge([D],K),K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let H=class{constructor(j,se){if(this.range=j,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$_K=H,e.$_K=H=Ge([D],H);class U{constructor(j,se,De,Je,xe,ut){this.kind=j,this.name=se,this.detail=De,this.uri=Je,this.range=xe,this.selectionRange=ut}}e.$aL=U;class Q{constructor(j,se){this.fromRanges=se,this.from=j}}e.$bL=Q;class X{constructor(j,se){this.fromRanges=se,this.to=j}}e.$cL=X;var ye;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ye||(e.LanguageStatusSeverity=ye={}));let Te=class{constructor(j,se){this.range=j,this.command=se}get isResolved(){return!!this.command}};e.$dL=Te,e.$dL=Te=Ge([D],Te);let We=m=class{#e;static isMarkdownString(j){return j instanceof m?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,se=!1){this.#e=new I.$dk(j,{supportThemeIcons:se})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,se){return this.#e.appendCodeblock(se??"",j),this}};e.$eL=We,e.$eL=We=m=Ge([D],We);let He=class{constructor(j,se){this.label=j,this.documentation=se}};e.$fL=He,e.$fL=He=Ge([D],He);let Ye=class{constructor(j,se){this.label=j,this.documentation=se,this.parameters=[]}};e.$gL=Ye,e.$gL=Ye=Ge([D],Ye);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$hL=st,e.$hL=st=Ge([D],st);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let at=class{constructor(j){this.value=j}};e.$iL=at,e.$iL=at=Ge([D],at);let ct=class{constructor(j,se,De){this.position=j,this.label=se,this.kind=De}};e.$jL=ct,e.$jL=ct=Ge([D],ct);var ze;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var Y;(function(B){B[B.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let _=class{constructor(j,se){this.label=j,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$kL=_,e.$kL=_=Ge([D],_);let pe=class{constructor(j=[],se=!1){this.items=j,this.isIncomplete=se}};e.$lL=pe,e.$lL=pe=Ge([D],pe);let Be=class{constructor(j,se,De){this.insertText=j,this.range=se,this.command=De}};e.$mL=Be,e.$mL=Be=Ge([D],Be);let Qe=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$nL=Qe,e.$nL=Qe=Ge([D],Qe);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Ne(B,j){return`${S.$hm.toKey(B)}.${j}`}e.$oL=Ne;var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Tt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Ht;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Bt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var Kt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(B){function j(se){switch(se){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Nt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Nt||(e.SyntaxTokenType=Nt={})),function(B){function j(se){switch(se){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Nt||(e.SyntaxTokenType=Nt={}));let Zt=class{constructor(j,se){if(se&&!w.URI.isUri(se))throw(0,T.$7)("target");if(!V.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.target=se}};e.$pL=Zt,e.$pL=Zt=Ge([D],Zt);let jt=class{constructor(j,se,De,Je){this.red=j,this.green=se,this.blue=De,this.alpha=Je}};e.$qL=jt,e.$qL=jt=Ge([D],jt);let Rt=class{constructor(j,se){if(se&&!(se instanceof jt))throw(0,T.$7)("color");if(!V.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.color=se}};e.$rL=Rt,e.$rL=Rt=Ge([D],Rt);let Xe=class{constructor(j){if(!j||typeof j!="string")throw(0,T.$7)("label");this.label=j}};e.$sL=Xe,e.$sL=Xe=Ge([D],Xe);var Gt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(j,se,De){if(this.startIndex=j,this.length=se,this.tooltip=De,typeof j!="number"||j<0)throw(0,T.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,T.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,T.$7)("tooltip")}}e.$tL=$t;class zt{constructor(j){this.uri=j}}e.$uL=zt;class Wt{constructor(j){this.terminalCommand=j}}e.$vL=Wt;var Dt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class dt{constructor(j){if(this.options=j,typeof j!="object")throw(0,T.$7)("options")}}e.$wL=dt;var Ct;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let kt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(j){switch(j){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(j,se){if(this.label=se,typeof j!="string"||typeof se!="string")throw(0,T.$7)("name");this.c=j}get id(){return this.c}};e.$xL=kt,e.$xL=kt=f=Ge([D],kt);function qe(B){let j="";for(let se=0;se<B.length;se++)j+=B[se].replace(/,/g,",,")+",";return j}let Ft=class{constructor(j,se,De){if(typeof j!="string")throw(0,T.$7)("process");this.e=[],this.c=j,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=De):this.f=se)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,T.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const se of this.e)j.push(se);return qe(j)}};e.$yL=Ft,e.$yL=Ft=Ge([D],Ft);let Vt=class{constructor(j,se,De){if(this.f=[],Array.isArray(se)){if(!j)throw(0,T.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j,this.f=se,this.g=De}else{if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j,this.g=se}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)j.push(typeof se=="string"?se:se.value);return qe(j)}};e.$zL=Vt,e.$zL=Vt=Ge([D],Vt);var Qt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var gt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Mt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,A.$mg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$AL=Mt;let Ee=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,se,De,Je,xe,ut){this.k=!1,this.l=this.definition=j;let ft;typeof se=="string"?(this.n=this.name=se,this.u=this.source=De,this.execution=Je,ft=xe,this.k=!0):se===gt.Global||se===gt.Workspace?(this.target=se,this.n=this.name=De,this.u=this.source=Je,this.execution=xe,ft=ut):(this.target=se,this.n=this.name=De,this.u=this.source=Je,this.execution=xe,ft=ut),typeof ft=="string"?(this.q=[ft],this.r=!0):Array.isArray(ft)?(this.q=ft,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Ft?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof Vt?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof Mt?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,A.$mg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=j}get scope(){return this.m}set target(j){this.A(),this.m=j}get name(){return this.n}set name(j){if(typeof j!="string")throw(0,T.$7)("name");this.A(),this.n=j}get execution(){return this.o}set execution(j){j===null&&(j=void 0),this.A(),this.o=j;const se=this.l.type;(k.g===se||k.e===se||k.f===se||k.c===se)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(j){if(Array.isArray(j))this.A(),this.q=j,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.A(),this.t=j}get source(){return this.u}set source(j){if(typeof j!="string"||j.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=j}get group(){return this.w}set group(j){j===null&&(j=void 0),this.A(),this.w=j}get detail(){return this.z}set detail(j){j===null&&(j=void 0),this.z=j}get presentationOptions(){return this.x}set presentationOptions(j){j==null&&(j=Object.create(null)),this.A(),this.x=j}get runOptions(){return this.y}set runOptions(j){j==null&&(j=Object.create(null)),this.A(),this.y=j}};e.$BL=Ee,e.$BL=Ee=k=Ge([D],Ee);var Me;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Me||(e.ProgressLocation=Me={}));var he;(function(B){function j(se){const De=se;return(0,g.$If)(De.value)?De.tooltip&&!(0,g.$Ef)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=j})(he||(e.ViewBadge=he={}));let G=F=class{static isTreeItem(j,se){const De=j;if(De.checkboxState!==void 0){const Je=(0,g.$If)(De.checkboxState)?De.checkboxState:(0,g.$Gf)(De.checkboxState)&&(0,g.$If)(De.checkboxState.state)?De.checkboxState.state:void 0,xe=!(0,g.$If)(De.checkboxState)&&(0,g.$Gf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Ue.Checked&&Je!==Ue.Unchecked||xe!==void 0&&!(0,g.$Ef)(xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(j instanceof F)return!0;if(De.label!==void 0&&!(0,g.$Ef)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$Ef)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$Ef)(De.iconPath)&&!w.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$Ef)(De.iconPath.id))){const Je=De.iconPath;if(!Je||!(0,g.$Ef)(Je.light)&&!w.URI.isUri(Je.light)&&!(0,g.$Ef)(Je.dark)&&!w.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$Ef)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!w.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$Ef)(De.tooltip)&&!(De.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Le.None&&De.collapsibleState>Le.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$Ef)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(j,se=Le.None){this.collapsibleState=se,w.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$CL=G,e.$CL=G=F=Ge([D],G);var Le;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Le||(e.TreeItemCollapsibleState=Le={}));var Ue;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ue||(e.TreeItemCheckboxState=Ue={}));let Ze=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$DL=Ze,e.$DL=Ze=Ge([D],Ze);class Ve extends Ze{}e.$EL=Ve;class _e extends Ve{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$FL=_e;class mt{constructor(j,se,De,Je){this.name=j,this.uri=se,this._itemId=De,this.c=Je}data(){return this.c()}}e.$GL=mt;let Ut=class{#e=new Map;constructor(j){for(const[se,De]of j??[]){const Je=this.#e.get(this.#t(se));Je?Je.push(De):this.#e.set(this.#t(se),[De])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,se){this.#e.set(this.#t(j),[se])}forEach(j,se){for(const[De,Je]of this.#e)for(const xe of Je)j.call(se,xe,De,this)}*[Symbol.iterator](){for(const[j,se]of this.#e)for(const De of se)yield[j,De]}#t(j){return j.toLowerCase()}};e.$HL=Ut,e.$HL=Ut=Ge([D],Ut);let Et=class{constructor(j){this.insertText=j}};e.$IL=Et,e.$IL=Et=Ge([D],Et);let St=class{constructor(j,se){this.label=se,this.insertText=j}};e.$JL=St,e.$JL=St=Ge([D],St);let wt=class{constructor(j,se){this.id=j,this.color=se}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$KL=wt,e.$KL=wt=Ge([D],wt),wt.File=new wt("file"),wt.Folder=new wt("folder");let gi=class{constructor(j){this.id=j}};e.$LL=gi,e.$LL=gi=Ge([D],gi);var At;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Si=class{get base(){return this.c}set base(j){this.c=j,this.e=w.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,se){if(typeof j!="string"&&(!j||!w.URI.isUri(j)&&!w.URI.isUri(j.uri)))throw(0,T.$7)("base");if(typeof se!="string")throw(0,T.$7)("pattern");typeof j=="string"?this.baseUri=w.URI.file(j):w.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ML=Si,e.$ML=Si=Ge([D],Si);const Hi=new WeakMap;function It(B,j){Hi.set(B,j)}e.$NL=It;let ri=class{constructor(j,se,De,Je){this.enabled=typeof j=="boolean"?j:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Hi.get(this)??(0,A.$mg)()),this.c}};e.$OL=ri,e.$OL=ri=Ge([D],ri);let mi=class extends ri{constructor(j,se,De,Je,xe){if(super(se,De,Je,xe),j===null)throw(0,T.$7)("location");this.location=j}};e.$PL=mi,e.$PL=mi=Ge([D],mi);let ci=class extends ri{constructor(j,se,De,Je,xe){super(se,De,Je,xe),this.functionName=j}};e.$QL=ci,e.$QL=ci=Ge([D],ci);let Ii=class extends ri{constructor(j,se,De,Je,xe,ut,ft){if(super(Je,xe,ut,ft),!se)throw(0,T.$7)("dataId");this.label=j,this.dataId=se,this.canPersist=De}};e.$RL=Ii,e.$RL=Ii=Ge([D],Ii);let Ci=class{constructor(j,se,De){this.command=j,this.args=se||[],this.options=De}};e.$SL=Ci,e.$SL=Ci=Ge([D],Ci);let Ot=class{constructor(j,se){this.port=j,this.host=se}};e.$TL=Ot,e.$TL=Ot=Ge([D],Ot);let $i=class{constructor(j){this.path=j}};e.$UL=$i,e.$UL=$i=Ge([D],$i);let Pi=class{constructor(j){this.implementation=j}};e.$VL=Pi,e.$VL=Pi=Ge([D],Pi);let ui=class{constructor(j,se,De){this.session=j,this.threadId=se,this.frameId=De}};e.$WL=ui,e.$WL=ui=Ge([D],ui);let li=class{constructor(j,se){this.session=j,this.threadId=se}};e.$XL=li,e.$XL=li=Ge([D],li);let ht=class{constructor(j,se){this.range=j,this.expression=se}};e.$YL=ht,e.$YL=ht=Ge([D],ht);var Gi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Gi||(e.InlineCompletionTriggerKind=Gi={}));let _t=class{constructor(j,se){this.range=j,this.text=se}};e.$ZL=_t,e.$ZL=_t=Ge([D],_t);let si=class{constructor(j,se,De=!0){this.range=j,this.variableName=se,this.caseSensitiveLookup=De}};e.$1L=si,e.$1L=si=Ge([D],si);let pi=class{constructor(j,se){this.range=j,this.expression=se}};e.$2L=pi,e.$2L=pi=Ge([D],pi);let Ri=class{constructor(j,se){this.frameId=j,this.stoppedLocation=se}};e.$3L=Ri,e.$3L=Ri=Ge([D],Ri);var Ji;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ji||(e.FileChangeType=Ji={}));let Ai=v=class extends Error{static FileExists(j){return new v(j,l.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(j){return new v(j,l.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(j){return new v(j,l.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(j){return new v(j,l.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(j){return new v(j,l.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(j){return new v(j,l.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(j,se=l.FileSystemProviderErrorCode.Unknown,De){super(w.URI.isUri(j)?j.toString(!0):j),this.code=De?.name??"Unknown",(0,l.$Bk)(this,se),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$4L=Ai,e.$4L=Ai=v=Ge([D],Ai);let vi=class{constructor(j,se,De){this.start=j,this.end=se,this.kind=De}};e.$5L=vi,e.$5L=vi=Ge([D],vi);var Qi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Qi||(e.FoldingRangeKind=Qi={}));var Li;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Zi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var bi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Fi{constructor(j,se=[]){this.tokenTypes=j,this.tokenModifiers=se}}e.$6L=Fi;function cn(B){return typeof B>"u"||(0,g.$Ff)(B)}class Mi{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let se=0,De=j.tokenTypes.length;se<De;se++)this.k.set(j.tokenTypes[se],se);for(let se=0,De=j.tokenModifiers.length;se<De;se++)this.l.set(j.tokenModifiers[se],se)}}push(j,se,De,Je,xe){if(typeof j=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(j,se,De,Je,xe);if(V.isRange(j)&&typeof se=="string"&&cn(De))return this.n(j,se,De);throw(0,T.$7)()}n(j,se,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Je=j.start.line,xe=j.start.character,ut=j.end.character-j.start.character,ft=this.k.get(se);let qt=0;if(De)for(const Xt of De){if(!this.l.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Xt);qt|=1<<ii>>>0}this.o(Je,xe,ut,ft,qt)}o(j,se,De,Je,xe){if(this.f&&(j<this.c||j===this.c&&se<this.e)){this.f=!1;const qt=this.g.length/5|0;let Xt=0,ii=0;for(let ni=0;ni<qt;ni++){let ai=this.g[5*ni],qi=this.g[5*ni+1];ai===0?(ai=Xt,qi+=ii):ai+=Xt,this.g[5*ni]=ai,this.g[5*ni+1]=qi,Xt=ai,ii=qi}}let ut=j,ft=se;this.f&&this.j>0&&(ut-=this.c,ut===0&&(ft-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=ft,this.g[this.j++]=De,this.g[this.j++]=Je,this.g[this.j++]=xe,this.c=j,this.e=se}static q(j){const se=[],De=j.length/5|0;for(let ft=0;ft<De;ft++)se[ft]=ft;se.sort((ft,qt)=>{const Xt=j[5*ft],ii=j[5*qt];if(Xt===ii){const ni=j[5*ft+1],ai=j[5*qt+1];return ni-ai}return Xt-ii});const Je=new Uint32Array(j.length);let xe=0,ut=0;for(let ft=0;ft<De;ft++){const qt=5*se[ft],Xt=j[qt+0],ii=j[qt+1],ni=j[qt+2],ai=j[qt+3],qi=j[qt+4],In=Xt-xe,On=In===0?ii-ut:ii,Ki=5*ft;Je[Ki+0]=In,Je[Ki+1]=On,Je[Ki+2]=ni,Je[Ki+3]=ai,Je[Ki+4]=qi,xe=Xt,ut=ii}return Je}build(j){return this.f?new oi(new Uint32Array(this.g),j):new oi(Mi.q(this.g),j)}}e.$7L=Mi;class oi{constructor(j,se){this.resultId=se,this.data=j}}e.$8L=oi;class un{constructor(j,se,De){this.start=j,this.deleteCount=se,this.data=De}}e.$9L=un;class ln{constructor(j,se){this.resultId=se,this.edits=j}}e.$0L=ln;var Yi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let di=class{static{this.Back={iconPath:new wt("arrow-left")}}constructor(){}};e.$$L=di,e.$$L=di=Ge([D],di);var Xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var wi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(wi||(e.ExtensionKind=wi={}));class _i{static validate(j){if(typeof j.badge=="string"){let se=(0,$.$ff)(j.badge,0);if(se<j.badge.length&&(se+=(0,$.$ff)(j.badge,se)),j.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!wt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,se,De){this.badge=j,this.tooltip=se,this.color=De}}e.$_L=_i;let Ti=class{constructor(j){this.kind=j}};e.$aM=Ti,e.$aM=Ti=Ge([D],Ti);var Ni;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(j){return j instanceof ei?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,se){if(j<0)throw(0,T.$7)("start must be positive");if(se<0)throw(0,T.$7)("end must be positive");j<=se?(this.c=j,this.e=se):(this.c=se,this.e=j)}with(j){let se=this.c,De=this.e;return j.start!==void 0&&(se=j.start),j.end!==void 0&&(De=j.end),se===this.c&&De===this.e?this:new ei(se,De)}}e.$bM=ei;class yi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(se=>yi.isNotebookCellData(se))}static isNotebookCellData(j){return!0}constructor(j,se,De,Je,xe,ut,ft){this.kind=j,this.value=se,this.languageId=De,this.mime=Je,this.outputs=xe??[],this.metadata=ut,this.executionSummary=ft,yi.validate(this)}}e.$cM=yi;class hn{constructor(j){this.cells=j}}e.$dM=hn;class Yt{static isNotebookCellOutputItem(j){return j instanceof Yt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const se={name:j.name,message:j.message,stack:j.stack};return Yt.json(se,"application/vnd.code.notebook.error")}static stdout(j){return Yt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Yt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,se="application/octet-stream"){return new Yt(j,se)}static#e=new TextEncoder;static text(j,se=R.$4r.text){const De=Yt.#e.encode(String(j));return new Yt(De,se)}static json(j,se="text/x-json"){const De=JSON.stringify(j,void 0,"	");return Yt.text(De,se)}constructor(j,se){this.data=j,this.mime=se;const De=(0,R.$8r)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$eM=Yt;class Ei{static isNotebookCellOutput(j){return j instanceof Ei?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,se=!1){const De=new Set,Je=new Set;for(let xe=0;xe<j.length;xe++){const ut=j[xe],ft=(0,R.$8r)(ut.mime);if(!De.has(ft)||(0,b.$RI)(ft)){De.add(ft);continue}Je.add(xe),se&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Je.size===0?j:j.filter((xe,ut)=>!Je.has(ut))}constructor(j,se,De){this.items=Ei.ensureUniqueMimeTypes(j,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,A.$mg)(),this.metadata=se??De)}}e.$fM=Ei;var Di;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Di||(e.NotebookCellKind=Di={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var je;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(je||(e.NotebookCellStatusBarAlignment=je={}));var ti;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class en{constructor(j,se){this.text=j,this.alignment=se}}e.$gM=en;var et;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(et||(e.NotebookControllerAffinity=et={}));var pt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(pt||(e.NotebookControllerAffinity2=pt={}));class dn{constructor(j,se=[]){this.uri=j,this.provides=(0,E.$3b)(se)}}e.$hM=dn;class fn{constructor(j){this.label=j}}e.$iM=fn;var ji;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(ji||(e.NotebookVariablesRequestKind=ji={}));let zi=class{constructor(j,se){this.label=j,this.timestamp=se}};e.$jM=zi,e.$jM=zi=Ge([D],zi);var fi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var tn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(tn||(e.ExtensionRuntime=tn={}));var nn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(nn||(e.StandardTokenType=nn={}));class gn{constructor(j,se){this.ranges=j,this.wordPattern=se}}e.$kM=gn;class rn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$lM=rn;var sn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(sn||(e.TestResultState=sn={}));var on;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(on||(e.TestRunProfileKind=on={}));let Ui=class{constructor(j=void 0,se=void 0,De=void 0,Je=!1){this.include=j,this.exclude=se,this.profile=De,this.continuous=Je}};e.$mM=Ui,e.$mM=Ui=Ge([D],Ui);let Bi=y=class{static diff(j,se,De){const Je=new y(j);return Je.expectedOutput=se,Je.actualOutput=De,Je}constructor(j){this.message=j}};e.$nM=Bi,e.$nM=Bi=y=Ge([D],Bi);let Wi=class{constructor(j){this.id=j}};e.$oM=Wi,e.$oM=Wi=Ge([D],Wi);class ki{constructor(j,se){this.covered=j,this.total=se}}e.$pM=ki;class Vi{static fromDetails(j,se){const De=new ki(0,0),Je=new ki(0,0),xe=new ki(0,0);for(const ft of se)if("branches"in ft){De.total+=1,De.covered+=ft.executionCount>0?1:0;for(const qt of ft.branches)Je.total+=1,Je.covered+=qt.executionCount>0?1:0}else xe.total+=1,xe.covered+=ft.executionCount>0?1:0;const ut=new Vi(j,De,Je.total>0?Je:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=se,ut}constructor(j,se,De,Je){this.uri=j,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=Je}}e.$qM=Vi;class mn{constructor(j,se,De=[]){this.executionCount=j,this.location=se,this.branches=De}}e.$rM=mn;class $n{constructor(j,se){this.executionCount=j,this.location=se}}e.$sM=$n;class pn{constructor(j,se,De){this.name=j,this.executionCount=se,this.location=De}}e.$tM=pn;var re;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(re||(e.ExternalUriOpenerPriority=re={}));var ue;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ue||(e.WorkspaceTrustState=ue={}));var Oe;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Oe||(e.PortAutoForwardAction=Oe={}));class ot{constructor(j,se,De,Je,xe,ut){this.kind=j,this.name=se,this.detail=De,this.uri=Je,this.range=xe,this.selectionRange=ut}}e.$uM=ot;class bt{constructor(j){this.uri=j}}e.$vM=bt;class Lt{constructor(j,se){this.original=j,this.modified=se}}e.$wM=Lt;class an{constructor(j,se,De,Je){this.base=j,this.input1=se,this.input2=De,this.result=Je}}e.$xM=an;class Cn{constructor(j,se){this.uri=j,this.viewType=se}}e.$yM=Cn;class Pn{constructor(j){this.viewType=j}}e.$zM=Pn;class Rn{constructor(j,se){this.uri=j,this.notebookType=se}}e.$AM=Rn;class An{constructor(j,se,De){this.original=j,this.modified=se,this.notebookType=De}}e.$BM=An;class Ln{constructor(){}}e.$CM=Ln;class Fn{constructor(j,se){this.uri=j,this.inputBoxUri=se}}e.$DM=Fn;class Mn{constructor(j){this.providerId=j}}e.$EM=Mn;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Tn{constructor(j,se){this.label=j,this.values=se}}e.$FM=Tn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class Nn{constructor(j,se){this.role=j,this.content=se}}e.$GM=Nn;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));var kn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Ce[103],Re([1,0,53,12,11,295,147,7,18]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=void 0;const w=new Map;function A(b,r){r?w.set(b,r):w.delete(b)}e.$TM=A;function S(b){return w.get(b)}class l extends L.$$u{constructor(r,a,t,n,o,c,h,i){super(a,t,n,o),this.c=r,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,g.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===T.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(a){return a?r.s(a):r.getText()},get eol(){return r.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(a){return r.t(a)},offsetAt(a){return r.u(a)},positionAt(a){return r.v(a)},validateRange(a){return r.w(a)},validatePosition(a){return r.x(a)},getWordRangeAtPosition(a,t){return r.y(a,t)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,E.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,E.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const a=this.w(r);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const t=this.g,n=a.start.line,o=a.end.line,c=[];c.push(this.f[n].substring(a.start.character));for(let h=n+1;h<o;h++)c.push(this.f[h]);return c.push(this.f[o].substring(0,a.end.character)),c.join(t)}t(r){let a;if(r instanceof $.$QK?a=r.line:typeof r=="number"&&(a=r),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new p(a,this.f[a],a===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const a=this.j.getIndexOf(r),t=this.f[a.index].length;return new $.$QK(a.index,Math.min(a.remainder,t))}w(r){if(!(r instanceof $.$RK))throw new Error("Invalid argument");const a=this.x(r.start),t=this.x(r.end);return a===r.start&&t===r.end?r:new $.$RK(a.line,a.character,t.line,t.character)}x(r){if(!(r instanceof $.$QK))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:a,character:t}=r,n=!1;if(a<0)a=0,t=0,n=!0;else if(a>=this.f.length)a=this.f.length-1,t=this.f[a].length,n=!0;else{const o=this.f[a].length;t<0?(t=0,n=!0):t>o&&(t=o,n=!0)}return n?new $.$QK(a,t):r}y(r,a){const t=this.x(r);if(!a)a=S(this.m);else if((0,I.$Ue)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const n=(0,R.$js)(t.character+1,(0,R.$hs)(a),this.f[t.line],0);if(n)return new $.$RK(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$UM=l;class p{constructor(r,a,t){this.a=r,this.b=a,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$RK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$RK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$VM=p}),define(Ce[210],Re([1,0,7,17,5]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;let L=class{constructor($){this.a=new E.$aM(E.ColorThemeKind.Dark),this.b=new I.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange($){let g;switch($){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$aM(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$9gc=L,e.$9gc=L=Ge([Ke(0,T.$RM)],L)}),define(Ce[211],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.CellExecutionUpdateType=void 0;var T;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$VI=(0,E.$2h)("INotebookExecutionService")}),define(Ce[212],Re([1,0,6,29,144,94]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Pb=void 0;class R extends E.$Sc{constructor(g,w,A){super(),this._source=g,this.b=w,this.c=A,this.a=void 0}f(g){const w=g.getLineCount();return new T.$Hs(1,1,w,this.g(g,w))}g(g,w){if(w<1||w>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const g=new I.$ZB;g.acceptChunk(this._source);const w=g.finish(!0),{textBuffer:A,disposable:S}=w.create(1);this.b=A,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const w=new I.$ZB;w.acceptChunk(g);const A=w.finish(!0),{textBuffer:S,disposable:l}=A.create(1);return this.B(l),S})),this.a}findInInputs(g){const A=new L.$NB(g,!1,!1,null).parseSearchRequest();if(!A)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,A,!0,5e3)}findInOutputs(g){const A=new L.$NB(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),A,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$7Pb=R}),define(Ce[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(L){L.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class I{static fromExtHostTestItem(R,$,g=R.parent){if(R._isRoot)return new I([$]);const w=[R.id];for(let A=g;A&&A.id!==$;A=A.parent)w.push(A.id);return w.push($),new I(w.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new I(R.split("\0"))}static join(R,$){return new I([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:I.isChild(R,$)?2:I.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new I(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$FJ=I}),define(Ce[58],Re([1,0,2,92,29,48]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$MJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$LJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KJ=e.$JJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$IJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HJ=e.$GJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var $;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})($||(e.ExtTestRunProfileKind=$={}));var g;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$GJ=[2,4,8,16,32,64];const w=P=>"runId"in P;e.$HJ=w;var A;(function(P){P.serialize=C=>({range:C.range.toJSON(),uri:C.uri.toJSON()}),P.deserialize=(C,Z)=>({range:I.$Hs.lift(Z.range),uri:C.asCanonicalUri(E.URI.revive(Z.uri))})})(A||(e.IRichLocation=A={}));var S;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(P){P.serialize=C=>({message:C.message,type:0,expected:C.expected,actual:C.actual,contextValue:C.contextValue,location:C.location&&A.serialize(C.location)}),P.deserialize=(C,Z)=>({message:Z.message,type:0,expected:Z.expected,actual:Z.actual,contextValue:Z.contextValue,location:Z.location&&A.deserialize(C,Z.location)})})(l||(e.ITestErrorMessage=l={}));const p=(P,C)=>`${C?"s":"e"}${P}`;e.$IJ=p;var b;(function(P){P.serialize=C=>({message:C.message,type:1,offset:C.offset,length:C.length,location:C.location&&A.serialize(C.location)}),P.deserialize=(C,Z)=>({message:Z.message,type:1,offset:Z.offset,length:Z.length,location:Z.location&&A.deserialize(C,Z.location)})})(b||(e.ITestOutputMessage=b={}));var r;(function(P){P.serialize=C=>C.type===0?l.serialize(C):b.serialize(C),P.deserialize=(C,Z)=>Z.type===0?l.deserialize(C,Z):b.deserialize(C,Z)})(r||(e.ITestMessage=r={}));var a;(function(P){P.serializeWithoutMessages=C=>({state:C.state,duration:C.duration,messages:[]}),P.serialize=C=>({state:C.state,duration:C.duration,messages:C.messages.map(r.serialize)}),P.deserialize=(C,Z)=>({state:Z.state,duration:Z.duration,messages:Z.messages.map(ce=>r.deserialize(C,ce))})})(a||(e.ITestTaskState=a={}));const t="\0",n=(P,C)=>P+t+C;e.$JJ=n;const o=P=>{const C=P.indexOf(t);return{ctrlId:P.slice(0,C),tagId:P.slice(C+1)}};e.$KJ=o;var c;(function(P){P.serialize=C=>({extId:C.extId,label:C.label,tags:C.tags,busy:C.busy,children:void 0,uri:C.uri?.toJSON(),range:C.range?.toJSON()||null,description:C.description,error:C.error,sortText:C.sortText}),P.deserialize=(C,Z)=>({extId:Z.extId,label:Z.label,tags:Z.tags,busy:Z.busy,children:void 0,uri:Z.uri?C.asCanonicalUri(E.URI.revive(Z.uri)):void 0,range:Z.range?I.$Hs.lift(Z.range):null,description:Z.description,error:Z.error,sortText:Z.sortText})})(c||(e.ITestItem=c={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(P){P.serialize=C=>({expand:C.expand,item:c.serialize(C.item)}),P.deserialize=(C,Z)=>({controllerId:L.$FJ.root(Z.item.extId),expand:Z.expand,item:c.deserialize(C,Z.item)})})(i||(e.InternalTestItem=i={}));var s;(function(P){P.serialize=C=>{let Z;return C.item&&(Z={},C.item.label!==void 0&&(Z.label=C.item.label),C.item.tags!==void 0&&(Z.tags=C.item.tags),C.item.busy!==void 0&&(Z.busy=C.item.busy),C.item.uri!==void 0&&(Z.uri=C.item.uri?.toJSON()),C.item.range!==void 0&&(Z.range=C.item.range?.toJSON()),C.item.description!==void 0&&(Z.description=C.item.description),C.item.error!==void 0&&(Z.error=C.item.error),C.item.sortText!==void 0&&(Z.sortText=C.item.sortText)),{extId:C.extId,expand:C.expand,item:Z}},P.deserialize=C=>{let Z;return C.item&&(Z={},C.item.label!==void 0&&(Z.label=C.item.label),C.item.tags!==void 0&&(Z.tags=C.item.tags),C.item.busy!==void 0&&(Z.busy=C.item.busy),C.item.range!==void 0&&(Z.range=C.item.range?I.$Hs.lift(C.item.range):null),C.item.description!==void 0&&(Z.description=C.item.description),C.item.error!==void 0&&(Z.error=C.item.error),C.item.sortText!==void 0&&(Z.sortText=C.item.sortText)),{extId:C.extId,expand:C.expand,item:Z}}})(s||(e.ITestItemUpdate=s={}));const u=(P,C)=>{C.expand!==void 0&&(P.expand=C.expand),C.item!==void 0&&(P.item=P.item?Object.assign(P.item,C.item):C.item)};e.$LJ=u;var d;(function(P){P.serializeWithoutMessages=C=>({...i.serialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(a.serializeWithoutMessages)}),P.serialize=C=>({...i.serialize(C),ownComputedState:C.ownComputedState,computedState:C.computedState,tasks:C.tasks.map(a.serialize)}),P.deserialize=(C,Z)=>({...i.deserialize(C,Z),ownComputedState:Z.ownComputedState,computedState:Z.computedState,tasks:Z.tasks.map(ce=>a.deserialize(C,ce)),retired:!0})})(d||(e.TestResultItem=d={}));var m;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(C,Z)=>{C.covered+=Z.covered,C.total+=Z.total}})(m||(e.ICoveredCount=m={}));var f;(function(P){P.serialize=C=>({statement:C.statement,branch:C.branch,function:C.function,details:C.details?.map(y.serialize),uri:C.uri.toJSON()}),P.deserialize=(C,Z)=>({statement:Z.statement,branch:Z.branch,function:Z.function,details:Z.details?.map(y.deserialize),uri:C.asCanonicalUri(E.URI.revive(Z.uri))})})(f||(e.IFileCoverage=f={}));function k(P){return{...P,location:P.location?.toJSON()}}function F(P){return P.location=P.location?T.$Gs.isIPosition(P.location)?T.$Gs.lift(P.location):I.$Hs.lift(P.location):void 0,P}e.$MJ=3;var v;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(v||(e.DetailType=v={}));var y;(function(P){P.serialize=C=>C.type===0?N.serialize(C):O.serialize(C),P.deserialize=C=>C.type===0?N.deserialize(C):O.deserialize(C)})(y||(e.CoverageDetails=y={}));var D;(function(P){P.serialize=k,P.deserialize=F})(D||(e.IBranchCoverage=D={}));var N;(function(P){P.serialize=k,P.deserialize=F})(N||(e.IFunctionCoverage=N={}));var O;(function(P){P.serialize=C=>({...k(C),branches:C.branches?.map(D.serialize)}),P.deserialize=C=>({...F(C),branches:C.branches?.map(D.deserialize)})})(O||(e.IStatementCoverage=O={}));var W;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var z;(function(P){P.deserialize=(C,Z)=>Z.op===0?{op:Z.op,item:i.deserialize(C,Z.item)}:Z.op===1?{op:Z.op,item:s.deserialize(Z.item)}:Z.op===2?{op:Z.op,uri:C.asCanonicalUri(E.URI.revive(Z.uri)),docv:Z.docv}:Z,P.serialize=C=>C.op===0?{op:C.op,item:i.serialize(C.item)}:C.op===1?{op:C.op,item:s.serialize(C.item)}:C})(z||(e.TestsDiffOp=z={}));class V{constructor(C){this.k=C,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(C){const Z=this.v();for(const ce of C)switch(ce.op){case 0:this.l(i.deserialize(this.k,ce.item),Z);break;case 1:this.o(s.deserialize(ce.item),Z);break;case 3:this.p(ce.itemId,Z);break;case 5:this.q(ce.itemId);break;case 4:this.updatePendingRoots(ce.amount);break;case 6:this.c.set(ce.tag.id,ce.tag);break;case 7:this.c.delete(ce.id);break}Z.complete?.()}l(C,Z){const ce=L.$FJ.parentId(C.item.extId)?.toString();let me;if(!ce)me=this.w(C),this.g.add(me),this.f.set(C.item.extId,me);else if(this.f.has(ce)){const be=this.f.get(ce);be.children.add(C.item.extId),me=this.w(C,be),this.f.set(C.item.extId,me)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(C)}`);return}return Z.add?.(me),C.expand===2&&this.h++,me}o(C,Z){const ce=this.f.get(C.extId);if(ce)return C.expand!==void 0&&(ce.expand===2&&this.h--,C.expand===2&&this.h++),(0,e.$LJ)(ce,C),Z.update?.(ce),ce}p(C,Z){const ce=this.f.get(C);if(!ce)return;const me=L.$FJ.parentId(ce.item.extId)?.toString();me?this.f.get(me).children.delete(ce.item.extId):this.g.delete(ce);const be=[[C]];for(;be.length;)for(const ke of be.pop()){const fe=this.f.get(ke);fe&&(be.push(fe.children),this.f.delete(ke),Z.remove?.(fe,fe!==ce),fe.expand===2&&this.h--)}}q(C){}updatePendingRoots(C){this.j+=C}v(){return{}}}e.$NJ=V}),define(Ce[77],Re([1,0,13,5,6,53,58,48]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const w=(n,o)=>n===o,S=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),l=(n,o)=>{let c;for(const[h,i]of S)i(n[h],o[h])||(c?c[h]=o[h]:c={[h]:o[h]});return c};class p extends I.$Sc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new E.$bh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,R.$LJ)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,R.$LJ)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const h=this.tree.get(o);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(o,c){switch(c.op){case 3:this.O($.$FJ.joinToString(o.fullId,c.id));break;case 0:this.z(c.item,o);break;case 5:for(const h of c.ops)this.w(o,h);break;case 1:this.C(c.new,c.old,o.fullId.toString());break;case 2:this.J(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.y(o.actual.uri);break;default:(0,L.$5c)(c)}}y(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}z(o,c){const h=$.$FJ.fromExtHostTestItem(o,this.root.id,c?.actual),i=this.s.getApiFor(o);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(o.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(o)}}),this.I(o,s,c);return}if(s.actual===o){this.H(o,s,c);return}if(s.actual.uri?.toString()!==o.uri?.toString())return this.O(h.toString()),this.z(o,c);const u=this.s.getChildren(s.actual),d=s.actual,m=l(this.s.toITestItem(d),this.s.toITestItem(o));this.s.getApiFor(d).listener=void 0,s.actual=o,s.expand=0,m&&(m.hasOwnProperty("tags")&&(this.C(o.tags,d.tags,h.toString()),delete m.tags),this.w(s,{op:4,update:m})),this.I(o,s,c);for(const[f,k]of u)this.s.getChildren(o).get(k.id)||this.O($.$FJ.joinToString(h,k.id));this.y(s.actual.uri)}C(o,c,h){const i=new Set(c.map(s=>s.id));for(const s of o)i.delete(s.id)||this.D(s);this.pushDiff({op:1,item:{extId:h,item:{tags:o.map(s=>(0,R.$JJ)(this.s.controllerId,s.id))}}}),i.forEach(this.F,this)}D(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$JJ)(this.s.controllerId,o.id)}}))}F(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,R.$JJ)(this.s.controllerId,o)}))}G(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}H(o,c,h){this.G(o,h);const i=this.s.getApiFor(o);i.parent=h?.actual,i.listener=s=>this.w(c,s),this.J(c)}I(o,c,h){this.H(o,c,h);for(const[i,s]of this.s.getChildren(o))this.z(s,c)}J(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.M(o))}L(o,c){if(c<0)return;const h=[];for(const[i,s]of this.s.getChildren(o.actual)){const u=this.expand($.$FJ.joinToString(o.fullId,s.id),c);(0,E.$Og)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}M(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const s=new E.$1g;return s.open(),s}o.expand=2,this.N(o);const c=o.resolveBarrier=new E.$1g,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(o.actual===this.root?void 0:o.actual)}catch(s){h(s)}return(0,E.$Og)(i)?i.catch(h).then(()=>{c.open(),this.J(o)}):(c.open(),this.J(o)),o.resolveBarrier}N(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}O(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.F(s.id);this.tree.delete(i.fullId.toString());for(const[s,u]of this.s.getChildren(i.actual))h.push(this.tree.get($.$FJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$HM=p;class b extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$IM=b;class r extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$JM=r;class a extends Error{constructor(o,c,h){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$KM=a;const t=(n,o,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,s){for(const u of h.values())i.call(s,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const s=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const m of i){if(!(m instanceof c))throw new r(m.id);const f=o(m).controllerId;if(f!==n.controllerId)throw new a(m.id,f,n.controllerId);if(s.has(m.id))throw new b(m.id);s.set(m.id,m),u.delete(m.id),d.ops.push({op:0,item:m})}for(const m of u.keys())d.ops.push({op:3,id:m});n.listener?.(d),h=s},add(i){if(!(i instanceof c))throw new r(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$LM=t}),define(Ce[104],Re([1,0,77]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0;const T=new WeakMap,I=(R,$)=>{const g={controllerId:$};return T.set(R,g),g};e.$MM=I;const L=R=>{const $=T.get(R);if(!$)throw new E.$JM(R?.id||"<unknown>");return $};e.$NM=L}),define(Ce[78],Re([1,0,12,2]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jvb=e.$ivb=e.$hvb=e.$gvb=e.$fvb=void 0,e.$fvb="vscode-cdn.net",e.$gvb=`vscode-resource.${e.$fvb}`,e.$hvb=`'self' https://*.${e.$fvb}`;function I($,g){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(g&&g.authority&&g.isRemote&&$.scheme===E.Schemas.file&&($=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:$.path})),T.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${L($.authority)}.${e.$gvb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$ivb=I;function L($){return $.replace(/./g,g=>{const w=g.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?g:"-"+w.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(g,w)=>String.fromCharCode(parseInt(w,16)))}e.$jvb=R}),define(Ce[213],Re([1,0,5,6,78]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class L{constructor($,g,w){this.d=$,this.e=g,this.f=w,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const S of this.c.values())A.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,g,w,A,S){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===$){l=o;break}if(!l)throw new Error("not a visible editor");const p=this,b=this.a++,r=new E.$Sd,a=new E.$Sd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,I.$ivb)(o,p.f)}get cspSource(){return I.$hvb}set options(o){this.b=o,p.d.$setOptions(b,o)}get options(){return this.b}set html(o){this.a=o,p.d.$setHtml(b,o)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(o){return p.d.$postMessage(b,o)}},n=new class{constructor(){this.editor=$,this.line=g,this.height=w,this.webview=t,this.onDidDispose=a.event}dispose(){p.c.has(b)&&(p.c.delete(b),p.d.$disposeEditorInset(b),a.fire(),a.dispose(),r.dispose())}};return this.d.$createEditorInset(b,l.id,l.value.document.uri,g+1,w,A||{},S.identifier,S.extensionLocation),this.c.set(b,{editor:$,inset:n,onDidReceiveMessage:r}),n}$onDidDispose($){const g=this.c.get($);g&&g.inset.dispose()}$onDidReceiveMessage($,g){this.c.get($)?.onDidReceiveMessage.fire(g)}}e.$sfc=L}),define(Ce[214],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.VariableKind=e.$DN=void 0,e.$DN=(0,E.$2h)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator",L.PathSeparatorAlias="/"})(T||(e.VariableKind=T={}));class I extends Error{constructor(R,$){super($),this.variable=R}}e.$EN=I}),define(Ce[215],Re([1,0,19,74,16,26,21,95,177,214,11]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,b,r,a){this.h=new Map,this.a=p,this.b=b,this.g=r,a&&(this.c=a.then(t=>this.i(t)))}i(p){if(R.$i){const b=Object.create(null);return Object.keys(p).forEach(r=>{b[r.toLowerCase()]=p[r]}),b}return p}resolveWithEnvironment(p,b,r){return this.l({env:this.i(p),userHome:void 0},b?b.uri:void 0,r)}async resolveAsync(p,b){const r={env:await this.c,userHome:await this.g};return this.l(r,p?p.uri:void 0,b)}async j(p,b,r,a){const t=L.$in(b);R.$i&&t.windows?Object.keys(t.windows).forEach(o=>t[o]=t.windows[o]):R.$j&&t.osx?Object.keys(t.osx).forEach(o=>t[o]=t.osx[o]):R.$k&&t.linux&&Object.keys(t.linux).forEach(o=>t[o]=t.linux[o]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,t,r,a)}async resolveAnyAsync(p,b,r){return this.j(p,b,r)}async resolveAnyMap(p,b,r){const a=new Map;return{newConfig:await this.j(p,b,r,a),resolvedVariables:a}}resolveWithInteractionReplace(p,b,r,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,b,r,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,b){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,b)}async l(p,b,r,a,t){if(I.$Ef(r))return this.m(p,b,r,a,t);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(p,b,n,a,t)));if(I.$Gf(r)){const n=Object.create(null),o=await Promise.all(Object.keys(r).map(async c=>[await this.m(p,b,c,a,t),await this.l(p,b,r[c],a,t)]));for(const[c,h]of o)n[c]=h;return n}return r}m(p,b,r,a,t){return(0,A.$Ze)(r,S.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(S.VARIABLE_LHS))return n;let c=await this.o(p,n,o,b,a);return t?.set(o,c),c!==n&&I.$Ef(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(p,b,c,a,t)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,b,r,a,t){let n;const o=r.split(":");o.length>1&&(r=o[0],n=o[1]);const c=s=>{const u=this.a.getFilePath();if(u)return(0,$.$Iv)(u);throw new w.$EN(s,(0,g.localize)(0,null,b))},h=s=>{const u=c(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$Iv)(d)}throw new w.$EN(s,(0,g.localize)(1,null,b,E.$nc(u)))},i=s=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new w.$EN(s,(0,g.localize)(2,null,b,n))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new w.$EN(s,(0,g.localize)(3,null,b)):new w.$EN(s,(0,g.localize)(4,null,b))};switch(r){case"env":if(n){if(p.env){const s=p.env[R.$i?n.toLowerCase():n];if(I.$Ef(s))return s}return""}throw new w.$EN(w.VariableKind.Env,(0,g.localize)(5,null,b));case"config":if(n){const s=this.a.getConfigurationValue(a,n);if(I.$Nf(s))throw new w.$EN(w.VariableKind.Config,(0,g.localize)(6,null,b,n));if(I.$Gf(s))throw new w.$EN(w.VariableKind.Config,(0,g.localize)(7,null,b,n));return s}throw new w.$EN(w.VariableKind.Config,(0,g.localize)(8,null,b));case"command":return this.p(w.VariableKind.Command,b,n,t,"command");case"input":return this.p(w.VariableKind.Input,b,n,t,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new w.$EN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,b,n));return this.n(s.extensionLocation)}throw new w.$EN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,b));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,$.$Iv)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return a||n?(0,$.$Iv)(this.n(i(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Iv)(E.$nc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new w.$EN(w.VariableKind.UserHome,(0,g.localize)(11,null,b))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new w.$EN(w.VariableKind.LineNumber,(0,g.localize)(12,null,b))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new w.$EN(w.VariableKind.SelectedText,(0,g.localize)(13,null,b))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||n?E.$lc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$mc(c(w.VariableKind.RelativeFileDirname));if(a||n){const u=E.$lc(this.n(i(w.VariableKind.RelativeFileDirname)),s);return u.length===0?".":u}return s}case"fileDirname":return E.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$nc(c(w.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$oc(s).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||b}case"execInstallFolder":{const s=this.a.getAppRoot();return s||b}case"pathSeparator":case"/":return E.sep;default:try{const s=n?`${r}:${n}`:r;return this.p(w.VariableKind.Unknown,b,s,t,void 0)}catch{return b}}}}p(p,b,r,a,t){if(r&&a){const n=t===void 0?a[r]:a[t+":"+r];if(typeof n=="string")return n;throw new w.$EN(p,(0,g.localize)(14,null,b))}return b}}e.$SN=S}),define(Ce[105],Re([1,0,4,102]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=e.$VC=e.OpenEditorContext=e.GroupsOrder=e.$UC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$TC=void 0,e.$TC=(0,E.$2h)("editorGroupsService");var I;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var L;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var g;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function w(b){const r=b;return(0,T.$DE)(r?.editor)&&(0,T.$DE)(r?.replacement)}e.$UC=w;var A;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var S;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(b){const r=b;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$VC=l;function p(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$WC=p}),define(Ce[216],Re([1,0,4,105]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=void 0,e.$XC=(0,E.$2h)("editorService"),e.$YC=-1,e.$ZC=-2,e.$1C=-3;function I(L){const R=L;return typeof L=="number"||(0,T.$VC)(R)}e.$2C=I}),define(Ce[217],Re([1,0,4,184]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=void 0,e.$$J=(0,E.$3h)(T.$9h)}),define(Ce[106],Re([1,0,22,5,19,6]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=e.$m7b=e.$l7b=e.$k7b=e.$j7b=void 0;class R{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$j7b=R;class ${static isHostExtension(t,n,o){if(n.getExtensionDescription(t))return!1;const c=o.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(b),this.f=new E.$jm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=r(this.e,n),this.e=this.e.concat(t);const o=$.l(this.e);return this.e=r(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,u){this.addNode(s),this.addNode(u),this.c.has(s)?this.c.get(s).push(u):this.c.set(s,[u])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,u){const d=n.getArcs(s);for(let m=0;m<d.length;m++)if(!u.has(d[m]))return!1;return!0}getNodes(){return this.e}},o=new E.$jm;for(const s of t)if(o.set(s.identifier,s),s.extensionDependencies)for(const u of s.extensionDependencies)n.addArc(E.$hm.toKey(s.identifier),E.$hm.toKey(u));const c=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>c.add(s));const h=n.getNodes().filter(s=>!c.has(s));let i;do{i=!1;for(let s=0;s<h.length;s++){const u=h[s];n.hasOnlyGoodArcs(u,c)&&(h.splice(s,1),s--,c.add(u),i=!0)}}while(i);return h.map(s=>o.get(s))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$k7b=$;class g{constructor(t,n){this.versionId=t,this.extensions=n}}e.$l7b=g;class w{constructor(t){this.d=new l,this.c=new $(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new A(this,n)}deltaExtensions(t,n,o){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$m7b=w;class A extends L.$Sc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$n7b=A;class S{constructor(t){this.name=t,this.promise=new Promise((n,o)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new S(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};t.resolve((0,L.$Qc)(c))}}var p;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(p||(p={}));function b(a,t){const n=a.isBuiltin?0:a.isUnderDevelopment?2:1,o=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=I.$gc.basename(a.extensionLocation.path),h=I.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function r(a,t){const n=new E.$im(t);return a.filter(o=>!n.has(o.identifier))}}),define(Ce[79],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$qm=e.$pm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var I;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var L;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(w){const A=E.$ge.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$pm=R;function $(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$qm=$;var g;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Ce[59],Re([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.$0M=e.$9M=void 0;let p=class extends S.$Sc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$Co,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,I.$lj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,o){const c=this.getTelemetryDetails(),h=new b(n,o,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,o){this.f=t,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$0k)((0,g.$Jo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const h=o.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$9M=p,e.$9M=p=Ge([Ke(0,L.$8M),Ke(1,I.$kj)],p);class b{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,o,c,h,i,s){this.g=o,this.h=c,this.i=h,this.j=i,this.a=new T.$Sd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,g.$Mo)(n,[]),this.c&&(n=(0,w.$ln)(n,this.c)),this.b||(n=(0,w.$ln)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const o={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Mo)(o,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$0M=b;function r(a){const t=Date.now()-new Date(a).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$$M=r,e.$_M=(0,E.$2h)("IExtHostTelemetry")}),define(Ce[23],Re([1,0,5,2,193,101,22,4]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tF=e.$sF=e.$rF=e.ActivationKind=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.ExtensionHostStartup=e.$lF=e.$kF=e.$jF=e.$iF=void 0,e.$iF=Object.freeze({identifier:new R.$hm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$jF="extensions.webWorker",e.$kF=(0,$.$2h)("extensionService");class g{constructor(h){this.dependency=h}}e.$lF=g;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,s){this.c=h,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$6E.createActivationEventsMap(this.d)}}set(h,i,s){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],m=[],f=[],k=S(this.d),F=S(i),v=(W,z)=>W.extensionLocation.toString()===z.extensionLocation.toString()||W.isBuiltin===z.isBuiltin||W.isUserBuiltin===z.isUserBuiltin||W.isUnderDevelopment===z.isUnderDevelopment;for(const W of this.d){const z=F.get(W.identifier);if(!z){u.push(W.identifier),k.delete(W.identifier);continue}if(!v(W,z)){u.push(W.identifier),k.delete(W.identifier);continue}}for(const W of i){const z=k.get(W.identifier);if(!z){d.push(W);continue}if(!v(z,W)){u.push(z.identifier),k.delete(z.identifier);continue}}const y=new R.$im(this.e),D=new R.$im(s);for(const W of this.e)D.has(W)||m.push(W);for(const W of s)y.has(W)||f.push(W);const N=L.$6E.createActivationEventsMap(d),O={versionId:h,toRemove:u,toAdd:d,addActivationEvents:N,myToRemove:m,myToAdd:f};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:u,myToAdd:d}=h,m=new R.$im(i),f=new R.$im(u);for(let k=0;k<this.d.length;k++)m.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)f.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of s)this.d.push(k);for(const k of d)this.e.push(k);return this.f=null,h}containsExtension(h){for(const i of this.e)if(R.$hm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=L.$6E.readActivationEvents(i);for(const u of s)h.add(u)}return h}}e.$mF=A;function S(c){const h=new R.$jm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$nF=l;function p(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$oF=p;class b{constructor(h,i,s,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=u}}e.$pF=b;class r{constructor(h,i){this.description=h,this.value=i}}e.$qF=r;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.$So)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$rF=t;function n(c,h){return{identifier:new R.$hm((0,I.$Qo)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$sF=n;class o{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$tF=o}),define(Ce[218],Re([1,0,14,106,22,23,15,13]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=e.$Sfc=e.$Rfc=e.$Qfc=e.$Pfc=e.$Ofc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,n,o,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$Ofc=g;class w{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Pfc=w;class A{constructor(t,n,o,c,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=h,this.subscriptions=i}}e.$Qfc=A;class S extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Rfc=S;class l extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Sfc=l;class p extends A{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(t,n,o,c){this.g=c,this.a=t,this.b=n,this.c=o,this.d=new I.$jm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,o]of this.d)t.push(o.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const o=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const o=this.a.getExtensionDescription(t);if(!o)throw new Error(`Extension '${t}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(t){const n=t.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new p(h));return this.c.onExtensionActivationError(t.id,h,new L.$lF(t.id.value)),i}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){o.push(i);continue}if(this.l(h)){o.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;o.push(this.j({id:s.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),m=this.k(t,n.displayName,[],new p(d));return this.c.onExtensionActivationError(n.identifier,d,new L.$lF(h)),m}return this.k(t,n.displayName,o,null)}k(t,n,o,c){const h=new r(t.id,n,t.reason,o,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$k7b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$Tfc=b,e.$Tfc=b=Ge([Ke(3,R.$jj)],b);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,o,c,h,i,s){this.c=t,this.d=n,this.f=o,this.g=c,this.h=h,this.j=i,this.k=s,this.a=new $.$1g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new p(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new p(n),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};r=Ge([Ke(6,R.$jj)],r)}),define(Ce[8],Re([1,0,18,24,127,219,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,216,7,23]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$QM=e.$PM=e.MarkdownString=e.$OM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ee){function Me(G){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:Ze,positionColumn:Ve}=G,_e=new s.$QK(Le-1,Ue-1),mt=new s.$QK(Ze-1,Ve-1);return new s.$SK(_e,mt)}Ee.to=Me;function he(G){const{anchor:Le,active:Ue}=G;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ee.from=he})(d||(e.Selection=d={}));var m;(function(Ee){function Me(G){if(!G)return;const{start:Le,end:Ue}=G;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ee.from=Me;function he(G){if(!G)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:Ze,endColumn:Ve}=G;return new s.$RK(Le-1,Ue-1,Ze-1,Ve-1)}Ee.to=he})(m||(e.Range=m={}));var f;(function(Ee){function Me(he){switch(he){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ee.to=Me})(f||(e.TokenType=f={}));var k;(function(Ee){function Me(G){return new s.$QK(G.lineNumber-1,G.column-1)}Ee.to=Me;function he(G){return{lineNumber:G.line+1,column:G.character+1}}Ee.from=he})(k||(e.Position=k={}));var F;(function(Ee){function Me(Le,Ue,Ze){return(0,E.$Hb)((0,E.$3b)(Le).map(Ve=>he(Ve,Ue,Ze)))}Ee.from=Me;function he(Le,Ue,Ze){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ze?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:G(Le.scheme,Ue),pattern:Y.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ze?.isBuiltin}}function G(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(F||(e.DocumentSelector=F={}));var v;(function(Ee){function Me(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ee.from=Me;function he(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(v||(e.DiagnosticTag=v={}));var y;(function(Ee){function Me(G){let Le;return G.code&&((0,l.$Ef)(G.code)||(0,l.$If)(G.code)?Le=String(G.code):Le={value:String(G.code.value),target:G.code.target}),{...m.from(G.range),message:G.message,source:G.source,code:Le,severity:N.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(D.from),tags:Array.isArray(G.tags)?(0,E.$Hb)(G.tags.map(v.from)):void 0}}Ee.from=Me;function he(G){const Le=new s.$4K(m.to(G),G.message,N.to(G.severity));return Le.source=G.source,Le.code=(0,l.$Ef)(G.code)?G.code:G.code?.value,Le.relatedInformation=G.relatedInformation&&G.relatedInformation.map(D.to),Le.tags=G.tags&&(0,E.$Hb)(G.tags.map(v.to)),Le}Ee.to=he})(y||(e.Diagnostic=y={}));var D;(function(Ee){function Me(G){return{...m.from(G.location.range),message:G.message,resource:G.location.uri}}Ee.from=Me;function he(G){return new s.$3K(new s.$2K(G.resource,m.to(G)),G.message)}Ee.to=he})(D||(e.DiagnosticRelatedInformation=D={}));var N;(function(Ee){function Me(G){switch(G){case s.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}Ee.from=Me;function he(G){switch(G){case a.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ee.to=he})(N||(e.DiagnosticSeverity=N={}));var O;(function(Ee){function Me(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?i.$ZC:i.$YC}Ee.from=Me;function he(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(O||(e.ViewColumn=O={}));function W(Ee){return typeof Ee.range<"u"}function z(Ee){return Ee.length===0?!0:!!W(Ee[0])}e.$OM=z;var V;(function(Ee){function Me(Ve){return Ve.map(Ee.from)}Ee.fromMany=Me;function he(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let _e;if(he(Ve)){const{language:St,value:wt}=Ve;_e={value:"```"+St+`
`+wt+"\n```\n"}}else s.$eL.isMarkdownString(Ve)?_e={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?_e={value:Ve}:_e={value:""};const mt=Object.create(null);_e.uris=mt;const Ut=St=>{try{let wt=p.URI.parse(St,!0);wt=wt.with({query:Le(wt.query,mt)}),mt[St]=wt}catch{}return""},Et=new g.marked.Renderer;return Et.link=Ut,Et.image=St=>typeof St=="string"?Ut(R.$lk(St).href):"",(0,g.marked)(_e.value,{renderer:Et}),_e}Ee.from=G;function Le(Ve,_e){if(!Ve)return Ve;let mt;try{mt=(0,w.$xh)(Ve)}catch{}if(!mt)return Ve;let Ut=!1;return mt=(0,S.$kn)(mt,Et=>{if(p.URI.isUri(Et)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[St]=Et,Ut=!0,St}else return}),Ut?JSON.stringify(mt):Ve}function Ue(Ve){const _e=new s.$eL(Ve.value,Ve.supportThemeIcons);return _e.isTrusted=Ve.isTrusted,_e.supportHtml=Ve.supportHtml,_e.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,_e}Ee.to=Ue;function Ze(Ve){if(Ve)return typeof Ve=="string"?Ve:Ee.from(Ve)}Ee.fromStrict=Ze})(V||(e.MarkdownString=V={}));function P(Ee){return z(Ee)?Ee.map(Me=>({range:m.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?V.fromMany(Me.hoverMessage):Me.hoverMessage?V.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ee.map(Me=>({range:m.from(Me)}))}e.$PM=P;function C(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?p.URI.file(Ee):Ee}e.$QM=C;var Z;(function(Ee){function Me(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?C(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=Me})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var ce;(function(Ee){function Me(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?C(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?Z.from(he.before):void 0,after:he.after?Z.from(he.after):void 0}}Ee.from=Me})(ce||(e.ThemableDecorationRenderOptions=ce={}));var me;(function(Ee){function Me(he){if(typeof he>"u")return he;switch(he){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Me})(me||(e.DecorationRangeBehavior=me={}));var be;(function(Ee){function Me(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?me.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?ce.from(he.light):void 0,dark:he.dark?ce.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?C(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?Z.from(he.before):void 0,after:he.after?Z.from(he.after):void 0}}Ee.from=Me})(be||(e.DecorationRenderOptions=be={}));var ke;(function(Ee){function Me(G){return{text:G.newText,eol:G.newEol&&tt.from(G.newEol),range:m.from(G.range)}}Ee.from=Me;function he(G){const Le=new s.$WK(m.to(G.range),G.text);return Le.newEol=typeof G.eol>"u"?void 0:tt.to(G.eol),Le}Ee.to=he})(ke||(e.TextEdit=ke={}));var fe;(function(Ee){function Me(G,Le){const Ue={edits:[]};if(G instanceof s.$ZK){const Ze=new $.$Bc;for(const Ve of G._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let _e;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?_e={type:"base64",value:(0,T.$Ae)(T.$ge.wrap(Ve.options.contents))}:_e={type:"dataTransferItem",id:Ve.options.contents._itemId}),Ue.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:_e},metadata:Ve.metadata})}else Ve._type===2?Ue.edits.push({resource:Ve.uri,textEdit:ke.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:Le?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?Ue.edits.push({resource:Ve.uri,textEdit:{range:m.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:Le?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Pt.from)}})}return Ue}Ee.from=Me;function he(G){const Le=new s.$ZK,Ue=new $.$Ac;for(const Ze of G.edits)if(Ze.textEdit){const Ve=Ze,_e=p.URI.revive(Ve.resource),mt=m.to(Ve.textEdit.range),Ut=Ve.textEdit.text,Et=Ve.textEdit.insertAsSnippet;let St;Et?St=s.$YK.replace(mt,new s.$1K(Ut)):St=s.$WK.replace(mt,Ut);const wt=Ue.get(_e);wt?wt.push(St):Ue.set(_e,[St])}else Le.renameFile(p.URI.revive(Ze.oldResource),p.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ve]of Ue)Le.set(Ze,Ve);return Le}Ee.to=he})(fe||(e.WorkspaceEdit=fe={}));var de;(function(Ee){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function he(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ee.from=he;function G(Le){for(const Ue in Me)if(Me[Ue]===Le)return Number(Ue);return s.SymbolKind.Property}Ee.to=G})(de||(e.SymbolKind=de={}));var ie;(function(Ee){function Me(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Ee.from=Me;function he(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Ee.to=he})(ie||(e.SymbolTag=ie={}));var Se;(function(Ee){function Me(G){return{name:G.name,kind:de.from(G.kind),tags:G.tags&&G.tags.map(ie.from),containerName:G.containerName,location:Ie.from(G.location)}}Ee.from=Me;function he(G){const Le=new s.$8K(G.name,de.to(G.kind),G.containerName,Ie.to(G.location));return Le.tags=G.tags&&G.tags.map(ie.to),Le}Ee.to=he})(Se||(e.WorkspaceSymbol=Se={}));var oe;(function(Ee){function Me(G){const Le={name:G.name||"!!MISSING: name!!",detail:G.detail,range:m.from(G.range),selectionRange:m.from(G.selectionRange),kind:de.from(G.kind),tags:G.tags?.map(ie.from)??[]};return G.children&&(Le.children=G.children.map(Me)),Le}Ee.from=Me;function he(G){const Le=new s.$9K(G.name,G.detail,de.to(G.kind),m.to(G.range),m.to(G.selectionRange));return(0,E.$Lb)(G.tags)&&(Le.tags=G.tags.map(ie.to)),G.children&&(Le.children=G.children.map(he)),Le}Ee.to=he})(oe||(e.DocumentSymbol=oe={}));var x;(function(Ee){function Me(G){const Le=new s.$aL(de.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),m.to(G.range),m.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Ee.to=Me;function he(G,Le,Ue){if(Le=Le??G._sessionId,Ue=Ue??G._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:G.name,detail:G.detail,kind:de.from(G.kind),uri:G.uri,range:m.from(G.range),selectionRange:m.from(G.selectionRange),tags:G.tags?.map(ie.from)}}Ee.from=he})(x||(e.CallHierarchyItem=x={}));var q;(function(Ee){function Me(he){return new s.$bL(x.to(he.from),he.fromRanges.map(G=>m.to(G)))}Ee.to=Me})(q||(e.CallHierarchyIncomingCall=q={}));var ne;(function(Ee){function Me(he){return new s.$cL(x.to(he.to),he.fromRanges.map(G=>m.to(G)))}Ee.to=Me})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Ie;(function(Ee){function Me(G){return{range:G.range&&m.from(G.range),uri:G.uri}}Ee.from=Me;function he(G){return new s.$2K(p.URI.revive(G.uri),m.to(G.range))}Ee.to=he})(Ie||(e.location=Ie={}));var Ae;(function(Ee){function Me(G){const Le=G,Ue=G;return{originSelectionRange:Le.originSelectionRange?m.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:m.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?m.from(Le.targetSelectionRange):void 0}}Ee.from=Me;function he(G){return{targetUri:p.URI.revive(G.uri),targetRange:m.to(G.range),targetSelectionRange:G.targetSelectionRange?m.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?m.to(G.originSelectionRange):void 0}}Ee.to=he})(Ae||(e.DefinitionLink=Ae={}));var Pe;(function(Ee){function Me(G){return{range:m.from(G.range),contents:V.fromMany(G.contents)}}Ee.from=Me;function he(G){return new s.$5K(G.contents.map(V.to),m.to(G.range))}Ee.to=he})(Pe||(e.Hover=Pe={}));var ae;(function(Ee){function Me(G){return{range:m.from(G.range),expression:G.expression}}Ee.from=Me;function he(G){return new s.$YL(m.to(G.range),G.expression)}Ee.to=he})(ae||(e.EvaluatableExpression=ae={}));var te;(function(Ee){function Me(G){if(G instanceof s.$ZL)return{type:"text",range:m.from(G.range),text:G.text};if(G instanceof s.$1L)return{type:"variable",range:m.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$2L)return{type:"expression",range:m.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Me;function he(G){switch(G.type){case"text":return{range:m.to(G.range),text:G.text};case"variable":return{range:m.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:m.to(G.range),expression:G.expression}}}Ee.to=he})(te||(e.InlineValue=te={}));var J;(function(Ee){function Me(G){return{frameId:G.frameId,stoppedLocation:m.from(G.stoppedLocation)}}Ee.from=Me;function he(G){return new s.$3L(G.frameId,m.to(G.stoppedLocation))}Ee.to=he})(J||(e.InlineValueContext=J={}));var ee;(function(Ee){function Me(G){return{range:m.from(G.range),kind:G.kind}}Ee.from=Me;function he(G){return new s.$6K(m.to(G.range),G.kind)}Ee.to=he})(ee||(e.DocumentHighlight=ee={}));var $e;(function(Ee){function Me(G){return{uri:G.uri,highlights:G.highlights.map(ee.from)}}Ee.from=Me;function he(G){return new s.$7K(p.URI.revive(G.uri),G.highlights.map(ee.to))}Ee.to=he})($e||(e.MultiDocumentHighlight=$e={}));var ve;(function(Ee){function Me(he){switch(he){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ee.to=Me})(ve||(e.CompletionTriggerKind=ve={}));var Fe;(function(Ee){function Me(he){return{triggerKind:ve.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=Me})(Fe||(e.CompletionContext=Fe={}));var le;(function(Ee){function Me(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Ee.from=Me;function he(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Ee.to=he})(le||(e.CompletionItemTag=le={}));var we;(function(Ee){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function he(Ue){return Me.get(Ue)??9}Ee.from=he;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(Ue){return G.get(Ue)??s.CompletionItemKind.Property}Ee.to=Le})(we||(e.CompletionItemKind=we={}));var M;(function(Ee){function Me(he,G){const Le=new s.$kL(he.label);return Le.insertText=he.insertText,Le.kind=we.to(he.kind),Le.tags=he.tags?.map(le.to),Le.detail=he.detail,Le.documentation=R.$fk(he.documentation)?V.to(he.documentation):he.documentation,Le.sortText=he.sortText,Le.filterText=he.filterText,Le.preselect=he.preselect,Le.commitCharacters=he.commitCharacters,b.$Hs.isIRange(he.range)?Le.range=m.to(he.range):typeof he.range=="object"&&(Le.range={inserting:m.to(he.range.insert),replacing:m.to(he.range.replace)}),Le.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?Le.insertText=new s.$1K(he.insertText):(Le.insertText=he.insertText,Le.textEdit=Le.range instanceof s.$RK?new s.$WK(Le.range,Le.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Le.additionalTextEdits=he.additionalTextEdits.map(Ue=>ke.to(Ue))),Le.command=G&&he.command?G.fromInternal(he.command):void 0,Le}Ee.to=Me})(M||(e.CompletionItem=M={}));var K;(function(Ee){function Me(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:V.fromStrict(G.documentation)}}Ee.from=Me;function he(G){return{label:G.label,documentation:R.$fk(G.documentation)?V.to(G.documentation):G.documentation}}Ee.to=he})(K||(e.ParameterInformation=K={}));var H;(function(Ee){function Me(G){return{label:G.label,documentation:V.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(K.from):[],activeParameter:G.activeParameter}}Ee.from=Me;function he(G){return{label:G.label,documentation:R.$fk(G.documentation)?V.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(K.to):[],activeParameter:G.activeParameter}}Ee.to=he})(H||(e.SignatureInformation=H={}));var U;(function(Ee){function Me(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.from):[]}}Ee.from=Me;function he(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.to):[]}}Ee.to=he})(U||(e.SignatureHelp=U={}));var Q;(function(Ee){function Me(he,G){const Le=new s.$jL(k.to(G.position),typeof G.label=="string"?G.label:G.label.map(X.to.bind(void 0,he)),G.kind&&ye.to(G.kind));return Le.textEdits=G.textEdits&&G.textEdits.map(ke.to),Le.tooltip=R.$fk(G.tooltip)?V.to(G.tooltip):G.tooltip,Le.paddingLeft=G.paddingLeft,Le.paddingRight=G.paddingRight,Le}Ee.to=Me})(Q||(e.InlayHint=Q={}));var X;(function(Ee){function Me(he,G){const Le=new s.$iL(G.label);return Le.tooltip=R.$fk(G.tooltip)?V.to(G.tooltip):G.tooltip,r.Command.is(G.command)&&(Le.command=he.fromInternal(G.command)),G.location&&(Le.location=Ie.to(G.location)),Le}Ee.to=Me})(X||(e.InlayHintLabelPart=X={}));var ye;(function(Ee){function Me(G){return G}Ee.from=Me;function he(G){return G}Ee.to=he})(ye||(e.InlayHintKind=ye={}));var Te;(function(Ee){function Me(G){return{range:m.from(G.range),url:G.target,tooltip:G.tooltip}}Ee.from=Me;function he(G){let Le;if(G.url)try{Le=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new s.$pL(m.to(G.range),Le)}Ee.to=he})(Te||(e.DocumentLink=Te={}));var We;(function(Ee){function Me(G){const Le=new s.$sL(G.label);return G.textEdit&&(Le.textEdit=ke.to(G.textEdit)),G.additionalTextEdits&&(Le.additionalTextEdits=G.additionalTextEdits.map(Ue=>ke.to(Ue))),Le}Ee.to=Me;function he(G){return{label:G.label,textEdit:G.textEdit?ke.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Le=>ke.from(Le)):void 0}}Ee.from=he})(We||(e.ColorPresentation=We={}));var He;(function(Ee){function Me(G){return new s.$qL(G[0],G[1],G[2],G[3])}Ee.to=Me;function he(G){return[G.red,G.green,G.blue,G.alpha]}Ee.from=he})(He||(e.Color=He={}));var Ye;(function(Ee){function Me(G){return{range:m.from(G.range)}}Ee.from=Me;function he(G){return new s.$_K(m.to(G.range))}Ee.to=he})(Ye||(e.SelectionRange=Ye={}));var st;(function(Ee){function Me(he){switch(he){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ee.to=Me})(st||(e.TextDocumentSaveReason=st={}));var nt;(function(Ee){function Me(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Me;function he(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ee.to=he})(nt||(e.TextEditorLineNumbersStyle=nt={}));var tt;(function(Ee){function Me(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Ee.from=Me;function he(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Ee.to=he})(tt||(e.EndOfLine=tt={}));var at;(function(Ee){function Me(he){if(typeof he=="object")return he.viewId;switch(he){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Me})(at||(e.ProgressLocation=at={}));var ct;(function(Ee){function Me(G){const Le={start:G.start+1,end:G.end+1};return G.kind&&(Le.kind=ze.from(G.kind)),Le}Ee.from=Me;function he(G){const Le={start:G.start-1,end:G.end-1};return G.kind&&(Le.kind=ze.to(G.kind)),Le}Ee.to=he})(ct||(e.FoldingRange=ct={}));var ze;(function(Ee){function Me(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return r.$xt.Comment;case s.FoldingRangeKind.Imports:return r.$xt.Imports;case s.FoldingRangeKind.Region:return r.$xt.Region}}Ee.from=Me;function he(G){if(G)switch(G.value){case r.$xt.Comment.value:return s.FoldingRangeKind.Comment;case r.$xt.Imports.value:return s.FoldingRangeKind.Imports;case r.$xt.Region.value:return s.FoldingRangeKind.Region}}Ee.to=he})(ze||(e.FoldingRangeKind=ze={}));var vt;(function(Ee){function Me(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?m.from(he.selection):void 0,override:typeof he.override=="boolean"?n.$pE.id:void 0}}Ee.from=Me})(vt||(e.TextEditorOpenOptions=vt={}));var Y;(function(Ee){function Me(Ue){return Ue instanceof s.$ML?Ue.toJSON():typeof Ue=="string"?Ue:he(Ue)||G(Ue)?new s.$ML(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ee.from=Me;function he(Ue){const Ze=Ue;return Ze?p.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function G(Ue){const Ze=Ue;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new s.$ML(p.URI.revive(Ue.baseUri),Ue.pattern)}Ee.to=Le})(Y||(e.GlobPattern=Y={}));var _;(function(Ee){function Me(he){if(he){if(Array.isArray(he))return he.map(Me);if(typeof he=="string")return he;{const G=he;return{language:G.language,scheme:G.scheme,pattern:Y.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ee.from=Me})(_||(e.LanguageSelector=_={}));var pe;(function(Ee){function Me(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Le=>Array.isArray(Le)&&Le.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ze=>Ze instanceof s.$RK)))}Ee.is=Me;function he(G){return{documents:G.documents.map(Le=>Le.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ze=>m.from(Ze))})))}}Ee.from=he})(pe||(e.MappedEditsContext=pe={}));var Be;(function(Ee){function Me(G){return{start:G.start,end:G.end}}Ee.from=Me;function he(G){return new s.$bM(G.start,G.end)}Ee.to=he})(Be||(e.NotebookRange=Be={}));var Qe;(function(Ee){function Me(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ee.to=Me;function he(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ee.from=he})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var it;(function(Ee){function Me(he){if(he===o.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(he===o.NotebookCellExecutionState.Pending)return;if(he===o.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Ee.to=Me})(it||(e.NotebookCellExecutionState=it={}));var rt;(function(Ee){function Me(G){switch(G){case s.NotebookCellKind.Markup:return o.CellKind.Markup;case s.NotebookCellKind.Code:default:return o.CellKind.Code}}Ee.from=Me;function he(G){switch(G){case o.CellKind.Markup:return s.NotebookCellKind.Markup;case o.CellKind.Code:default:return s.NotebookCellKind.Code}}Ee.to=he})(rt||(e.NotebookCellKind=rt={}));var Ne;(function(Ee){function Me(G){const Le={metadata:G.metadata??Object.create(null),cells:[]};for(const Ue of G.cells)s.$cM.validate(Ue),Le.cells.push(Pt.from(Ue));return Le}Ee.from=Me;function he(G){const Le=new s.$dM(G.cells.map(Pt.to));return(0,l.$Rf)(G.metadata)||(Le.metadata=G.metadata),Le}Ee.to=he})(Ne||(e.NotebookData=Ne={}));var Pt;(function(Ee){function Me(G){return{cellKind:rt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Qe.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ht.from):[]}}Ee.from=Me;function he(G){return new s.$cM(rt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ht.to):void 0,G.metadata,G.internalMetadata?Qe.to(G.internalMetadata):void 0)}Ee.to=he})(Pt||(e.NotebookCellData=Pt={}));var Tt;(function(Ee){function Me(G){return{mime:G.mime,valueBytes:T.$ge.wrap(G.data)}}Ee.from=Me;function he(G){return new s.$eM(G.valueBytes.buffer,G.mime)}Ee.to=he})(Tt||(e.NotebookCellOutputItem=Tt={}));var Ht;(function(Ee){function Me(G){return{outputId:G.id,items:G.items.map(Tt.from),metadata:G.metadata}}Ee.from=Me;function he(G){const Le=G.items.map(Tt.to);return new s.$fM(Le,G.outputId,G.metadata)}Ee.to=he})(Ht||(e.NotebookCellOutput=Ht={}));var Bt;(function(Ee){function Me(Le){return G(Le)?{include:Y.from(Le.include)??void 0,exclude:Y.from(Le.exclude)??void 0}:Y.from(Le)??void 0}Ee.from=Me;function he(Le){return G(Le)?{include:Y.to(Le.include),exclude:Y.to(Le.exclude)}:Y.to(Le)}Ee.to=he;function G(Le){const Ue=Le;return Ue?!(0,l.$Nf)(Ue.include)&&!(0,l.$Nf)(Ue.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var yt;(function(Ee){function Me(he,G,Le){const Ue=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Ue,Le),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=Me})(yt||(e.NotebookStatusBarItem=yt={}));var Kt;(function(Ee){function Me(he,G,Le){const Ue=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:G.toInternal(Ue,Le),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}Ee.from=Me})(Kt||(e.NotebookKernelSourceAction=Kt={}));var Nt;(function(Ee){function Me(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}Ee.from=Me})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Zt;(function(Ee){function Me(G){return{uri:G.uri,provides:G.provides}}Ee.from=Me;function he(G){return new s.$hM(p.URI.revive(G.uri),G.provides)}Ee.to=he})(Zt||(e.NotebookRendererScript=Zt={}));var jt;(function(Ee){function Me(G){return{message:V.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:m.from(G.location.range),uri:G.location.uri}}}Ee.from=Me;function he(G){const Le=new s.$nM(typeof G.message=="string"?G.message:V.to(G.message));return Le.actualOutput=G.actual,Le.expectedOutput=G.expected,Le.contextValue=G.contextValue,Le.location=G.location?Ie.to(G.location):void 0,Le}Ee.to=he})(jt||(e.TestMessage=jt={}));var Rt;(function(Ee){Ee.namespace=h.$JJ,Ee.denamespace=h.$KJ})(Rt||(e.TestTag=Rt={}));var Xe;(function(Ee){function Me(G){const Le=(0,t.$NM)(G).controllerId;return{extId:c.$FJ.fromExtHostTestItem(G,Le).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Ue=>Rt.namespace(Le,Ue.id)),range:b.$Hs.lift(m.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&V.fromStrict(G.error)||null}}Ee.from=Me;function he(G){return{parent:void 0,error:void 0,id:c.$FJ.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Le=>{const{tagId:Ue}=Rt.denamespace(Le);return new s.$oM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:m.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ee.toPlain=he})(Xe||(e.TestItem=Xe={})),function(Ee){function Me(G){return{id:G.id}}Ee.from=Me;function he(G){return new s.$oM(G.id)}Ee.to=he}(Rt||(e.TestTag=Rt={}));var Gt;(function(Ee){const Me=(G,Le)=>{const Ue=[];for(const[Ve,_e]of Le)c.$FJ.compare(_e.item.extId,Ve)===2&&(Le.delete(Ve),Ue.push(_e));const Ze={...Xe.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(_e=>_e.type===0).map(jt.to)})),children:Ue.map(Ve=>Me(Ve,Le))};for(const Ve of Ze.children)Ve.parent=Ze;return Ze};function he(G){const Le=[],Ue=new Map;for(const Ze of G.items){Ue.set(Ze.item.extId,Ze);const Ve=c.$FJ.root(Ze.item.extId);G.request.targets.some(_e=>_e.controllerId===Ve&&_e.testIds.includes(Ze.item.extId))&&Le.push(Ze)}return{completedAt:G.completedAt,results:Le.map(Ze=>Me(Ze,Ue))}}Ee.to=he})(Gt||(e.TestResults=Gt={}));var Jt;(function(Ee){function Me(Ue){return{covered:Ue.covered,total:Ue.total}}function he(Ue){return"line"in Ue?k.from(Ue):m.from(Ue)}function G(Ue){return"branches"in Ue?{count:Ue.executionCount,location:he(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&he(Ze.location)})):void 0}:{type:0,name:Ue.name,count:Ue.executionCount,location:he(Ue.location)}}Ee.fromDetailed=G;function Le(Ue){return{uri:Ue.uri,statement:Me(Ue.statementCoverage),branch:Ue.branchCoverage&&Me(Ue.branchCoverage),function:Ue.functionCoverage&&Me(Ue.functionCoverage),details:Ue.detailedCoverage?.map(G)}}Ee.fromFile=Le})(Jt||(e.TestCoverage=Jt={}));var lt;(function(Ee){function Me(he){switch(he){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ee.to=Me})(lt||(e.CodeActionTriggerKind=lt={}));var $t;(function(Ee){function Me(G){const Le=new s.$uM(de.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),m.to(G.range),m.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Ee.to=Me;function he(G,Le,Ue){if(Le=Le??G._sessionId,Ue=Ue??G._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:de.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:m.from(G.range),selectionRange:m.from(G.selectionRange),tags:G.tags?.map(ie.from)}}Ee.from=he})($t||(e.TypeHierarchyItem=$t={}));var zt;(function(Ee){function Me(he){if(he)return{value:he.value,tooltip:he.tooltip}}Ee.from=Me})(zt||(e.ViewBadge=zt={}));var Wt;(function(Ee){function Me(Ue,Ze,Ve){const _e=Ze.fileData;return _e?new s.$FL(new s.$GL(_e.name,p.URI.revive(_e.uri),_e.id,(0,L.$db)(()=>Ve(_e.id)))):Ue===A.$4r.uriList&&Ze.uriListData?new s.$EL(Le(Ze.uriListData)):new s.$EL(Ze.asString)}Ee.to=Me;async function he(Ue,Ze){const Ve=await Ze.asString();if(Ue===A.$4r.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const _e=Ze.asFile();return{asString:Ve,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Ee.from=he;function G(Ue){return I.$et.split(Ue).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return p.URI.parse(Ze)}catch{}return Ze})}function Le(Ue){return I.$et.create(Ue.map(Ze=>typeof Ze=="string"?Ze:p.URI.revive(Ze)))}})(Wt||(e.DataTransferItem=Wt={}));var Dt;(function(Ee){function Me(G,Le){const Ue=G.items.map(([Ze,Ve])=>[Ze,Wt.to(Ze,Ve,Le)]);return new s.$HL(Ue)}Ee.toDataTransfer=Me;async function he(G){const Le={items:[]},Ue=[];for(const[Ze,Ve]of G)Ue.push((async()=>{Le.items.push([Ze,await Wt.from(Ze,Ve)])})());return await Promise.all(Ue),Le}Ee.from=he})(Dt||(e.DataTransfer=Dt={}));var dt;(function(Ee){function Me(he){return{kind:"reply",message:he.message,title:he.title,tooltip:he.tooltip}}Ee.from=Me})(dt||(e.ChatReplyFollowup=dt={}));var Ct;(function(Ee){function Me(he){return typeof he=="string"?{title:he,message:he,kind:"reply"}:"commandId"in he?{kind:"command",title:he.title??"",commandId:he.commandId??"",when:he.when??"",args:he.args}:dt.from(he)}Ee.from=Me})(Ct||(e.ChatFollowup=Ct={}));var xt;(function(Ee){function Me(G){const Le=new s.$GM(kt.to(G.role),G.content);return Le.name=G.name,Le}Ee.to=Me;function he(G){return{role:kt.from(G.role),content:G.content,name:G.name}}Ee.from=he})(xt||(e.ChatMessage=xt={}));var kt;(function(Ee){function Me(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ee.to=Me;function he(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ee.from=he})(kt||(e.ChatMessageRole=kt={}));var qe;(function(Ee){function Me(Le){const Ue={};for(const Ze of Object.keys(Le))Ue[Ze]=Le[Ze].map(Ee.to);return Ue}Ee.objectTo=Me;function he(Le){return{level:Ft.to(Le.level),kind:Le.kind,value:(0,w.$yh)(Le.value),description:Le.description}}Ee.to=he;function G(Le){return{level:Ft.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Ee.from=G})(qe||(e.ChatVariable=qe={}));var Ft;(function(Ee){function Me(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ee.to=Me;function he(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ee.from=he})(Ft||(e.ChatVariableLevel=Ft={}));var Vt;(function(Ee){function Me(he){switch(he){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Me})(Vt||(e.InteractiveEditorResponseFeedbackKind=Vt={}));var Qt;(function(Ee){function Me(he,G){return"placeholder"in G&&"resolvedContent"in G?{content:G.placeholder,kind:"asyncContent"}:"markdownContent"in G?((0,u.$oF)(he,"chatAgents2Additions"),{content:V.from(G.markdownContent),kind:"markdownContent"}):"content"in G?"vulnerabilities"in G&&G.vulnerabilities?((0,u.$oF)(he,"chatAgents2Additions"),{content:G.content,vulnerabilities:G.vulnerabilities,kind:"vulnerability"}):typeof G.content=="string"?{content:G.content,kind:"content"}:((0,u.$oF)(he,"chatAgents2Additions"),{content:V.from(G.content),kind:"markdownContent"}):"documents"in G?{documents:G.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(Ue=>m.from(Ue))})),kind:"usedContext"}:"reference"in G?{reference:"uri"in G.reference?{uri:G.reference.uri,range:m.from(G.reference.range)}:G.reference,kind:"reference"}:"inlineReference"in G?{inlineReference:"uri"in G.inlineReference?{uri:G.inlineReference.uri,range:m.from(G.inlineReference.range)}:G.inlineReference,name:G.title,kind:"inlineReference"}:"agentName"in G?((0,u.$oF)(he,"chatAgents2Additions"),{agentName:G.agentName,command:G.command,kind:"agentDetection"}):"treeData"in G?{treeData:G.treeData,kind:"treeData"}:"message"in G?{content:G.message,kind:"progressMessage"}:void 0}Ee.from=Me})(Qt||(e.ChatResponseProgress=Qt={}));var gt;(function(Ee){function Me(he){return{label:he.label,values:he.values.map(qe.from),insertText:he.insertText,detail:he.detail,documentation:he.documentation}}Ee.from=Me})(gt||(e.ChatAgentCompletionItem=gt={}));var Mt;(function(Ee){function Me(he,G,Le){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:G.toInternal(he,Le)}Ee.from=Me})(Mt||(e.TerminalQuickFix=Mt={}))}),define(Ce[220],Re([1,0,2,14,7,8,186]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class ${constructor(w,A,S,l={timeout:1500,errors:3}){this.c=w,this.d=A,this.f=S,this.g=l,this.a=new R.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(A,S,l)=>{const b={dispose:this.a.push([A,S,w])};return Array.isArray(l)&&l.push(b),b}}async $participateInSave(w,A){const S=E.URI.revive(w);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),b=[];try{for(const r of[...this.a]){if(l)break;const a=this.d.getDocument(S),t=await this.h(r,{document:a,reason:L.TextDocumentSaveReason.to(A)});b.push(t)}}finally{clearTimeout(p)}return b}h([w,A,S],l){const p=this.b.get(w);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(S,w,A,l).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const r=this.b.get(w);this.b.set(w,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,A,S,l){const p=[],b=Date.now(),{document:r,reason:a}=l,{version:t}=r,n=Object.freeze({document:r,reason:a,waitUntil(o){if(Object.isFrozen(p))throw(0,T.$8)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{A.apply(S,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(h),o(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(o=>{const c={edits:[]};for(const h of o)if(Array.isArray(h)&&h.every(i=>i instanceof I.$WK))for(const{newText:i,newEol:s,range:u}of h)c.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:u&&L.Range.from(u),text:i,eol:s&&L.EndOfLine.from(s)}});if(c.edits.length!==0)return t===r.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$ngc=$}),define(Ce[221],Re([1,0,12,2,8,7,76]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0;class ${constructor(S,l,p,b){this.start=S,this.deletedCount=l,this.deletedItems=p,this.items=b}asApiEvent(){return{range:new L.$bM(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(S,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,l,p){this.notebook=S,this.h=l,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(I.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(b){S.g=b},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(p)}return this.f}setOutputs(S){this.a=S.map(I.NotebookCellOutput.to)}setOutputItems(S,l,p){const b=p.map(I.NotebookCellOutputItem.to),r=this.a.find(a=>a.id===S);if(r&&(l||(r.items.length=0),r.items.push(...b),r.items.length>1&&r.items.every(a=>R.$RI(a.mime)))){const a=new Map,t=[];r.items.forEach(n=>{let o;a.has(n.mime)?o=a.get(n.mime):(o=[],a.set(n.mime,o),t.push(n.mime)),o.push(n.data)}),r.items.length=0,t.forEach(n=>{const o=R.$SI(a.get(n));r.items.push({mime:n,data:o.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$sgc=g;class w{static{this.a=0}constructor(S,l,p,b,r){this.k=S,this.l=l,this.m=p,this.uri=b,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(p){return p=S.n(p),S.b[p].apiCell},getCells(p){return(p?S.p(p):S.b).map(r=>r.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,p){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const b={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},r=[];for(const t of S.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,b.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,b.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),r.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),r.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const a=new Map;for(let t=0;t<r.length;t++){const n=r[t],o=a.get(n.cell);if(o===void 0){const c=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});a.set(n.cell,c-1)}else b.cellChanges[o]={...b.cellChanges[o],...n}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,p=S.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),S.with({start:l,end:p})}p(S){S=this.o(S);const l=[];for(let p=S.start;p<S.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,p){if(this.j)return;const b=[],r=[],a=[];if(S.reverse().forEach(t=>{const o=t[2].map(i=>{const s=new g(this,this.l,i);return l||r.push(g.asModelAddData(this.apiNotebook,i)),s}),c=new $(t[0],t[1],[],o),h=this.b.splice(t[0],t[1],...o);for(const i of h)a.push(i.uri),c.deletedItems.push(i.apiCell);b.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:a}),p)for(const t of b)p.push(t.asApiEvent())}s(S,l,p,b){const r=this.b.splice(S,l);this.b.splice(p,0,...r);const a=[new $(S,l,r.map(t=>t.apiCell),[]),new $(p,0,[],r)];for(const t of a)b.push(t.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,p,b){this.b[S].setOutputItems(l,p,b)}v(S,l){const p=this.b[S];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(S,l){const p=this.b[S];p.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$tgc=w}),define(Ce[222],Re([1,0,5,2,8,7]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class R{constructor(g,w,A,S={timeout:1500,errors:3}){this.b=g,this.c=w,this.d=A,this.f=S,this.a=new E.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(w,A,S)=>{const l=function(b){w.call(A,b)};return l.extension=g,this.a.event(l,void 0,S)}}async $participateInSave(g,w,A){const S=T.URI.revive(g),l=this.c.getNotebookDocument(S);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(w)},A,async(r,a)=>{const t=Date.now(),n=await await Promise.resolve(r);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof L.$ZK?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const b={edits:[]};for(const r of p){const{edits:a}=I.WorkspaceEdit.from(r);b.edits=b.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$Jgc=R}),define(Ce[107],Re([1,0,14,8,7]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor($,g,w,A,S,l){this.id=$,this.f=g,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=A,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(g){this.selections=[g]},get selections(){return $.a},set selections(g){if(!Array.isArray(g)||!g.every(I.$bM.isNotebookRange))throw(0,E.$7)("selections");$.a=g,$.g(g)},get visibleRanges(){return $.b},revealRange(g,w){$.f.$tryRevealRange($.id,T.NotebookRange.from(g),w??I.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$ugc=L}),define(Ce[223],Re([1,0,5,15,8]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let L=class{constructor($,g){this.c=$,this.d=g,this.a=new E.$Sd,this.b=new E.$Sd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,g);const w=this.d.getEditorById($);g.visibleRanges&&w._acceptVisibleRanges(g.visibleRanges.ranges.map(I.NotebookRange.to)),g.selections&&w._acceptSelections(g.selections.selections.map(I.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns($){for(const g in $)this.d.getEditorById(g)._acceptViewColumn(I.ViewColumn.to($[g]))}};e.$Lgc=L,e.$Lgc=L=Ge([Ke(0,T.$jj)],L)}),define(Ce[224],Re([1,0,8,72,163,20,66,14]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;class g{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,p,b){const r=this.b++,{title:a,location:t,cancellable:n}=p,o={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(r,{location:E.ProgressLocation.from(t),title:a,source:o,cancellable:n},l.isUnderDevelopment?void 0:l.identifier.value).catch($.$2),this.d(r,b,!!n)}d(l,p,b){let r;b&&(r=new L.$3d,this.c.set(l,r));const a=n=>{this.a.$progressEnd(n),this.c.delete(n),r?.dispose()};let t;try{t=p(new A(this.a,l),b&&r?r.token:L.CancellationToken.None)}catch(n){throw a(l),n}return t.then(n=>a(l),n=>a(l)),t}$acceptProgressCanceled(l){const p=this.c.get(l);p&&(p.cancel(),this.c.delete(l))}}e.$Sgc=g;function w(S,l){return S.message=l.message,typeof l.increment=="number"&&(typeof S.increment=="number"?S.increment+=l.increment:S.increment=l.increment),S}class A extends T.$hv{constructor(l,p){super(b=>this.throttledReport(b)),this.c=l,this.d=p}throttledReport(l){this.c.$progressReport(this.d,l)}}Ge([(0,R.$vh)(100,(S,l)=>w(S,l),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ce[108],Re([1,0,29,104,48,77,58,8,2]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=e.$5M=e.$4M=void 0;const w=(o,c,h,i)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(u){if(!h(s,u)){const d=s;s=u,o.listener?.(i(u,d))}}}},A=(o,c)=>o===c,S={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(o,c)=>!(o.length!==c.length||o.some(h=>!c.find(i=>h.id===i.id)))},l=o=>c=>({op:4,update:o(c)}),p=(o,c)=>({range:(()=>{let h;const i=l(s=>({range:E.$Hs.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){o.listener?.({op:6}),S.range(h,s)||(h=s,o.listener?.(i(s)))}}})(),label:w(o,c,S.label,l(h=>({label:h}))),description:w(o,void 0,S.description,l(h=>({description:h}))),sortText:w(o,void 0,S.sortText,l(h=>({sortText:h}))),canResolveChildren:w(o,!1,S.canResolveChildren,h=>({op:2,state:h})),busy:w(o,!1,S.busy,l(h=>({busy:h}))),error:w(o,void 0,S.error,l(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:w(o,[],S.tags,(h,i)=>({op:1,new:h.map($.TestTag.from),old:i.map($.TestTag.from)}))}),b=o=>{const c=I.$FJ.fromString(o.extId),h=new a(c.controllerId,c.localId,o.label,g.URI.revive(o.uri)||void 0);return h.range=$.Range.to(o.range||void 0),h.description=o.description||void 0,h.sortText=o.sortText||void 0,h.tags=o.tags.map(i=>$.TestTag.to({id:(0,R.$KJ)(i).tagId})),h},r=o=>{let c;for(const h of o.tests){const i=b(h.item);(0,T.$NM)(i).parent=c,c=i}return c};e.$4M=r;class a{constructor(c,h,i,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,T.$MM)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,L.$LM)(u,T.$NM,a),enumerable:!0,writable:!1},...p(u,i)})}}e.$5M=a;class t extends a{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$6M=t;class n extends L.$HM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:T.$NM,getChildren:s=>s.children,root:new t(c,h),toITestItem:$.TestItem.from})}}e.$7M=n}),define(Ce[109],Re([1,0,53,14,89,8,7]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.$YM=void 0;class ${static{this.c=new I.$WM("TextEditorDecorationType")}constructor(l,p,b){const r=$.c.nextId();l.$registerTextEditorDecorationType(p.identifier,r,L.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$YM=$;class g{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let b=null;if(l instanceof R.$QK)b=new R.$RK(l,l);else if(l instanceof R.$RK)b=l;else throw new Error("Unrecognized location");this.l(b,p,!1)}insert(l,p){this.k(),this.l(new R.$RK(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof R.$RK)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,b){const r=this.c.validateRange(l);this.g.push({range:r,text:p,forceMoveMarkers:b})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=l}}class w{constructor(l,p,b,r){this.c=l,this.d=p,this._accept(b),this.e=r;const a=this;this.value={get tabSize(){return a.f},set tabSize(t){a.n(t)},get indentSize(){return a.g},set indentSize(t){a.p(t)},get insertSpaces(){return a.j},set insertSpaces(t){a.s(t)},get cursorStyle(){return a.k},set cursorStyle(t){a.t(t)},get lineNumbers(){return a.l},set lineNumbers(t){a.u(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}n(l){const p=this.m(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}p(l){const p=this.o(l);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const p=this.q(l);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let b=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(b=!0,p.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,b=!0,p.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(b=!0,p.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,b=!0,p.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(b=!0,p.insertSpaces=r):this.j!==r&&(this.j=r,b=!0,p.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,b=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,b=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(l.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(l,p){p.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(b)})}}e.$ZM=w;class A{constructor(l,p,b,r,a,t,n,o){this.id=l,this.j=p,this.k=b,this.g=!1,this.h=new Set,this.c=a,this.d=new w(this.j,this.id,t,b),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$SK))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof R.$SK)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new g(r.value,i);return h(s),c.m(s)},insertSnippet(h,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>L.Range.from(d));else if(i instanceof R.$QK){const{lineNumber:d,column:m}=L.Position.from(i);u=[{startLineNumber:d,startColumn:m,endLineNumber:d,endColumn:m}]}else if(i instanceof R.$RK)u=[L.Range.from(i)];else{u=[];for(const d of i)if(d instanceof R.$RK)u.push(L.Range.from(d));else{const{lineNumber:m,column:f}=L.Position.from(d);u.push({startLineNumber:m,startColumn:f,endLineNumber:m,endColumn:f})}}return p.$tryInsertSnippet(l,r.value.version,h.value,u,s)},setDecorations(h,i){const s=i.length===0;s&&!c.h.has(h.key)||(s?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(L.$OM(i))return p.$trySetDecorations(l,h.key,L.$PM(i));{const u=new Array(4*i.length);for(let d=0,m=i.length;d<m;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return p.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>p.$tryRevealRange(l,L.Range.from(h),i||R.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(l,L.ViewColumn.from(h))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const b=p.edits.map(a=>a.range);b.sort((a,t)=>a.end.line===t.end.line?a.end.character===t.end.character?a.start.line===t.start.line?a.start.character-t.start.character:a.start.line-t.start.line:a.end.character-t.end.character:a.end.line-t.end.line);for(let a=0,t=b.length-1;a<t;a++){const n=b[a].end;if(b[a+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=p.edits.map(a=>({range:L.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,r,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$1M=A}),define(Ce[225],Re([1,0,167,25,2,5,6,205,13,7,16,18,8,52,20,132,23]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;function t(c,h){if((0,A.$Ef)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends R.$Sc{constructor(h,i,s){super(),this.f=h,this.g=i,this.h=s,this.a=new Map,this.b=new r.$07;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(m=>u(m)?this.r(m):m):d})}registerTreeDataProvider(h,i,s){const u=this.createTreeView(h,{treeDataProvider:i},s);return{dispose:()=>u.dispose()}}createTreeView(h,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],m=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,k=this.m(h,i,s),F={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:m,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(h,F),y={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,a.$oF)(s,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,a.$oF)(s,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(D){(0,p.$fk)(D)&&(0,a.$oF)(s,"treeViewMarkdownMessage"),k.message=D},get title(){return k.title},set title(D){k.title=D},get description(){return k.description},set description(D){k.description=D},get badge(){return k.badge},set badge(D){D!==void 0&&w.ViewBadge.isViewBadge(D)?k.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(k.badge=void 0)},reveal:(D,N)=>k.reveal(D,N),dispose:async()=>{await v,this.a.delete(h),k.dispose()}};return this.B(y),y}$getChildren(h,i){const s=this.a.get(h);return s?s.getChildren(i):Promise.reject(new $.$YE(h))}async $handleDrop(h,i,s,u,d,m,f,k){const F=this.a.get(h);if(!F)return Promise.reject(new $.$YE(h));const v=l.DataTransfer.toDataTransfer(s,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&k&&await this.j(v,F,k,d,m),F.onDrop(v,u,d)}async j(h,i,s,u,d){const m=this.b.removeDragOperationTransfer(d);if(m)(await m)?.forEach((f,k)=>{f&&h.set(k,f)});else if(d&&i.handleDrag){const f=i.handleDrag(s,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,s,u){const d=this.a.get(h);if(!d)return Promise.reject(new $.$YE(h));const m=await this.j(new w.$HL,d,i,u,s);if(!(!m||u.isCancellationRequested))return l.DataTransfer.from(m)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new $.$YE(h);return i.hasResolve}$resolve(h,i,s){const u=this.a.get(h);if(!u)throw new $.$YE(h);return u.resolveTreeItem(i,s)}$setExpanded(h,i,s){const u=this.a.get(h);if(!u)throw new $.$YE(h);u.setExpanded(i,s)}$setSelectionAndFocus(h,i,s){const u=this.a.get(h);if(!u)throw new $.$YE(h);u.setSelectionAndFocus(i,s)}$setVisible(h,i){const s=this.a.get(h);if(!s){if(!i)return;throw new $.$YE(h)}s.setVisible(i)}$changeCheckboxState(h,i){const s=this.a.get(h);if(!s)throw new $.$YE(h);s.setCheckboxState(i)}m(h,i,s){const u=this.B(new o(h,i,this.f,this.g.converter,this.h,s));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$_gc=n;class o extends R.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Nf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,s,u,d,m){if(super(),this.I=h,this.J=s,this.L=u,this.M=d,this.N=m,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$3d,m.contributes&&m.contributes.views)for(const v in m.contributes.views)for(const y of m.contributes.views[v])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let f,k;const F=L.Event.debounce(this.F.event,(v,y)=>(v||(v={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(D=>k=D),this.G=this.G.then(()=>f)),Array.isArray(y.element)?v.elements.push(...y.element):v.elements.push(y.element)),y.message&&(v.message=!0),v),200,!0);this.B(F(({message:v,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=k;return f=null,this.$(y).then(()=>D())})),v&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.X(h);return s||(s=await this.Y(i)),s?s.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const s=(0,A.$Nf)(i.select)?!0:i.select,u=(0,A.$Nf)(i.focus)?!1:i.focus,d=(0,A.$Nf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(m=>this.W(h,m[m.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:m.map(k=>k.item)},{select:s,focus:u,expand:d})),m=>this.M.error(m)):this.J.$reveal(this.I,void 0,{select:s,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const s=this.getExtensionElement(h);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(h,i){const s=!(0,S.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,i,s){const u=[];for(const d of h){const m=this.getExtensionElement(d);m&&u.push(m)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,s){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Ug)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(h);if(s){const u=this.m.get(s);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,s,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Ug)(()=>this.f.getParent(h))}W(h,i){const s=this.m.get(h);return s?Promise.resolve(s):(0,g.$Ug)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const m=this.m.get(d);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const s=this.getExtensionElement(h);i=s?this.m.get(s):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new b.$3d(this.Z.token);try{const s=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=(0,S.$Hb)(u||[]),m=await Promise.all((0,S.$Hb)(d).map(k=>this.f.getTreeItem(k)));if(i.token.isCancellationRequested)return;const f=m.map((k,F)=>k?this.db(d[F],k,s):null);return(0,S.$Hb)(f)}finally{i.dispose()}}$(h){if(h.some(s=>!s))return this.Z.dispose(!0),this.Z=new b.$3d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(h);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(h){const i=new Set,s=h.map(d=>this.m.get(d));for(const d of s)if(d&&!i.has(d.item.handle)){let m=d;for(;m&&m.parent&&s.findIndex(f=>m&&m.parent&&f&&f.item.handle===m.parent.item.handle)===-1;){const f=this.j.get(m.parent.item.handle);m=f?this.m.get(f):void 0}m&&!m.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const m=this.j.get(d);if(m){const f=this.m.get(m);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(s=>this.cb(s).then(u=>{u&&(i[s]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,g.$Ug)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,s.parent);return this.pb(i,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,s){const u=this.ib(h,i,s);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,s),u}eb(h){return w.$eL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,s,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,s=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:u}}hb(h){if(!w.$CL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,s){this.hb(i);const u=this.B(new R.$Rc),d=this.kb(h,i,s),m=this.lb(i);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:m,iconDark:this.mb(i)||m,themeIcon:this.jb(i),collapsibleState:(0,A.$Nf)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof w.$KL?h.iconPath:void 0}kb(h,{id:i,label:s,resourceUri:u},d,m){if(i)return`${o.b}/${i}`;const f=t(s,this.N),k=d?d.item.handle:o.a;let F=f?f.label:u?(0,T.$Ag)(u):"";F=F.indexOf("/")!==-1?F.replace("/","//"):F;const v=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let D,N=0;do{if(D=`${k}/${N}:${F}`,m||!this.j.has(D)||v===D)break;N++}while(N<=y.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$KL))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$KL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return I.URI.isUri(h)?h:I.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,s,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(h,i);const d=this.X(u)||[],m=d.filter(f=>f.item.handle===s.item.handle)[0];m&&d.splice(d.indexOf(m),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[226],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[227],Re([1,0,179,14,31,97,73,30,22,226,189,101]),function(ge,e,E,T,I,L,R,$,g,w,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=void 0;const l=$.$un.as(R.$vn.JSONContribution);class p{constructor(h,i,s){this.a=h,this.b=i,this.c=s}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(I.default.Error,h)}warn(h){this.d(I.default.Warning,h)}info(h){this.d(I.default.Info,h)}}e.$cF=p;class b{static a(h){const i=new g.$im;for(let s=0,u=h.length;s<u;s++)i.add(h[s].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new b(i,[]);if(!i||!i.length)return new b([],h);const s=this.a(h),u=this.a(i),d=i.filter(f=>!s.has(f.description.identifier)),m=h.filter(f=>!u.has(f.description.identifier));return new b(d,m)}constructor(h,i){this.added=h,this.removed=i}}e.$dF=b;class r{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=b.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$eF=r;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$fF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$gm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$_n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$_n}},extensionKind:{description:E.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&S.$6E.register(h.extensionPoint,h.activationEventsGenerator),e.$fF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$fF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$gF=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};$.$un.add(o.ExtensionsRegistry,new n),e.$hF=$.$un.as(o.ExtensionsRegistry),l.registerSchema(t,e.$fF),l.registerSchema(A.$Cj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Ce[228],Re([1,0,175,16,26,227,35,5]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function(l){function p(b,r,a){if(!b)return;const t=T.$Ef(b.type)?b.type:void 0;if(!t||t.length===0){a.error(E.localize(3,null));return}const n=[];if(Array.isArray(b.required))for(const o of b.required)T.$Ef(o)&&n.push(o);return{extensionId:r.value,taskType:t,required:n,properties:b.properties?I.$in(b.properties):{},when:b.when?R.$Zi.deserialize(b.when):void 0}}l.from=p})(w||(w={}));const A=L.$hF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const b of l)b.type&&p.push(`onTaskType:${b.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class S{constructor(){this.d=new $.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,b)=>{A.setHandler((r,a)=>{this.c=void 0;try{for(const t of a.removed){const n=t.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const t of a.added){const n=t.value;for(const o of n){const c=w.from(o,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const b of this.all()){const r={type:"object",additionalProperties:!1};b.required.length>0&&(r.required=b.required.slice(0)),b.properties!==void 0?r.properties=I.$in(b.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[b.taskType]},p.push(r)}this.c={oneOf:p}}return this.c}}e.$jG=new S}),define(Ce[229],Re([1,0,176,16,25,26,35,228]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$tG=e.JsonSchemaVersion=e.ExecutionEngine=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$nG=e.ShellQuoting=e.$mG=e.$lG=e.$kG=void 0,e.$kG="settings",e.$lG=new R.$gj("taskRunning",!1,E.localize(0,null)),e.$mG={value:E.localize(1,null),original:"Tasks"};var g;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$nG="$customized",function(P){function C(Z){if(!Z)return P.Strong;switch(Z.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=C}(g||(e.ShellQuoting=g={}));var w;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(A||(e.RevealKind=A={})),function(P){function C(Z){switch(Z.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=C}(A||(e.RevealKind=A={}));var S;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(P){function C(Z){switch(Z.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=C}(S||(e.RevealProblemKind=S={}));var l;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(l||(e.PanelKind=l={})),function(P){function C(Z){switch(Z.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=C}(l||(e.PanelKind=l={}));var p;(function(P){P.defaults={echo:!0,reveal:A.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var b;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(P){function C(ce){switch(ce.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=C;function Z(ce){switch(ce){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=Z}(b||(e.RuntimeType=b={}));var r;(function(P){function C(Z){return T.$Ef(Z)?Z:Z.value}P.value=C})(r||(e.CommandString=r={}));var a;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function C(ce){return ce===P.Clean._id||ce===P.Build._id||ce===P.Rebuild._id||ce===P.Test._id}P.is=C;function Z(ce){if(ce!==void 0)return T.$Ef(ce)?C(ce)?{_id:ce,isDefault:!1}:void 0:ce}P.from=Z})(a||(e.TaskGroup=a={}));var t;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function C(Z){switch(Z){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=C})(n||(e.TaskSourceKind=n={}));var o;(function(P){P.parallel="parallel",P.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(C,Z,ce,me,be,ke){this._label="",this._id=C,Z&&(this._label=Z),ce&&(this.type=ce),this.runOptions=me,this.configurationProperties=be,this._source=ke}getDefinition(C){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const C={folder:this.d(),id:this._id};return JSON.stringify(C)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(C,Z=!1){if(C===void 0)return!1;if(T.$Ef(C))return C===this._label||C===this.configurationProperties.identifier||Z&&C===this._id;const ce=this.getDefinition(!0);return ce!==void 0&&ce._key===C._key}getQualifiedLabel(){const C=this.getWorkspaceFolder();return C?`${this._label} (${C.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(C){this.c===void 0&&(this.c=[]),C&&(this.c=this.c.concat(C))}get taskLoadMessages(){return this.c}}e.$oG=i;class s extends i{constructor(C,Z,ce,me,be,ke,fe,de){super(C,ce,void 0,fe,de,Z),this.command={},this._source=Z,this.hasDefinedMatchers=ke,be&&(this.command=be)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(C=!1){if(C&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case b.Shell:Z="shell";break;case b.Process:Z="process";break;case b.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(C){return C instanceof s}getMapKey(){const C=this._source.config.workspaceFolder;return C?`${C.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$kG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const C=this.d();if(!C)return;let Z=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(Z+=this._source.kind);const ce={type:e.$nG,folder:C,id:Z};return JSON.stringify(ce)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Ag(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(C){return new s(C._id,C._source,C._label,C.type,C.command,C.hasDefinedMatchers,C.runOptions,C.configurationProperties)}}e.$pG=s;class u extends i{constructor(C,Z,ce,me,be,ke,fe){super(C,ce,me,ke,fe,Z),this._source=Z,this.configures=be}static is(C){return C instanceof u}f(C){return C}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Ag(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$kG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const C=this.d();if(!C)return;let Z=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(Z+=this._source.kind);const ce={type:e.$nG,folder:C,id:Z};return JSON.stringify(ce)}}e.$qG=u;class d extends i{constructor(C,Z,ce,me,be,ke,fe,de,ie){super(C,ce,me,de,ie,Z),this.defines=be,this.hasDefinedMatchers=fe,this.command=ke,this.icon=ie.icon,this.hide=ie.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(C){return C instanceof d}getMapKey(){const C=this._source.workspaceFolder;return C?`${this._source.scope.toString()}|${C.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const C={type:"contributed",scope:this._source.scope,id:this._id};return C.folder=this.d(),JSON.stringify(C)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(C){return new d(C._id,C._source,C._label,C.type,C.defines,C.command,C.hasDefinedMatchers,C.runOptions,C.configurationProperties)}}e.$rG=d;class m extends i{constructor(C,Z,ce,me,be,ke){super(C,ce,me,be,ke,Z),this._source=Z}clone(){return new m(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(C){return C instanceof m}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(C){return new m(C._id,C._source,C._label,C.type,C.runOptions,C.configurationProperties)}}e.$sG=m;var f;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(P){P._default=P.Terminal}(f||(e.ExecutionEngine=f={}));var k;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class F{constructor(C){this.c=new Map;for(let Z=0;Z<C.length;Z++)this.c.set(C[Z].uri.toString(),Z)}compare(C,Z){const ce=C.getWorkspaceFolder(),me=Z.getWorkspaceFolder();if(ce&&me){let be=this.c.get(ce.uri.toString());be=be===void 0?0:be+1;let ke=this.c.get(me.uri.toString());return ke=ke===void 0?0:ke+1,be===ke?C._label.localeCompare(Z._label):be-ke}else return!ce&&me?-1:ce&&!me?1:0}}e.$tG=F;var v;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(v||(e.TaskEventKind=v={}));var y;(function(P){P.SingleRun="singleRun",P.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var N;(function(P){function C(de){return{taskId:de._id,taskName:de.configurationProperties.name,runType:de.configurationProperties.isBackground?"background":"singleRun",group:de.configurationProperties.group,__task:de}}function Z(de,ie,Se){return{...C(de),kind:"start",terminalId:ie,resolvedVariables:Se}}P.start=Z;function ce(de,ie,Se){return{...C(de),kind:"processStarted",terminalId:ie,processId:Se}}P.processStarted=ce;function me(de,ie,Se){return{...C(de),kind:"processEnded",terminalId:ie,exitCode:Se}}P.processEnded=me;function be(de,ie,Se){return{...C(de),kind:"terminated",exitReason:Se,terminalId:ie}}P.terminated=be;function ke(de,ie,Se){return{...C(ie),kind:de,terminalId:Se}}P.general=ke;function fe(){return{kind:"changed"}}P.changed=fe})(N||(e.TaskEvent=N={}));var O;(function(P){function C(ce){const me=Object.keys(ce).sort();let be="";for(const ke of me){let fe=ce[ke];fe instanceof Object?fe=C(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),be+=ke+","+fe+","}return be}function Z(ce){const be={_key:C(ce),type:ce.taskType};return Object.assign(be,ce),be}P.create=Z})(O||(e.KeyedTaskIdentifier=O={}));var W;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var z;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var V;(function(P){function C(Z,ce){const me=$.$jG.get(Z.type);if(me===void 0){const de=L.$in(Z);return delete de._key,O.create(de)}const be=Object.create(null);be.type=me.taskType;const ke=new Set;me.required.forEach(de=>ke.add(de));const fe=me.properties;for(const de of Object.keys(fe)){const ie=Z[de];if(ie!=null)be[de]=ie;else if(ke.has(de)){const Se=fe[de];if(Se.default!==void 0)be[de]=L.$in(Se.default);else switch(Se.type){case"boolean":be[de]=!1;break;case"number":case"integer":be[de]=0;break;case"string":be[de]="";break;default:ce.error(E.localize(2,null,JSON.stringify(Z,void 0,0),de));return}}}return O.create(be)}P.createTaskIdentifier=C})(V||(e.TaskDefinition=V={}))}),define(Ce[230],Re([1,0,14]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=e.$o7b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$1)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$o7b=T;class I extends T{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$p7b=I}),define(Ce[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$Cv=E;const T=[];function I($){const g=new E($);return T[g.nid]=g,g}e.$Dv=I;function L($){return T[$].sid}e.$Ev=L;class R{constructor(g){this.value=g}}e.$Fv=R}),define(Ce[3],Re([1,0,49]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$NK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$MK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var L;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var g;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var w;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class S{static{this.a=0}static mixin(a){return a._id=S.a++,a}}e.$MK=S;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var b;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$NK={MainThreadAuthentication:(0,E.$Dv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Dv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Dv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Dv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Dv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Dv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Dv)("MainThreadCommands"),MainThreadComments:(0,E.$Dv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Dv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Dv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Dv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Dv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Dv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Dv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Dv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Dv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Dv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Dv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Dv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Dv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Dv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Dv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Dv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Dv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Dv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Dv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Dv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Dv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Dv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Dv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Dv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Dv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Dv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Dv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Dv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Dv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Dv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Dv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Dv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Dv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Dv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Dv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Dv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Dv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Dv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Dv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Dv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Dv)("MainThreadSCM"),MainThreadSearch:(0,E.$Dv)("MainThreadSearch"),MainThreadShare:(0,E.$Dv)("MainThreadShare"),MainThreadTask:(0,E.$Dv)("MainThreadTask"),MainThreadWindow:(0,E.$Dv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Dv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Dv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Dv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Dv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Dv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Dv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Dv)("MainThreadInteractive"),MainThreadChat:(0,E.$Dv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Dv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Dv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Dv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Dv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Dv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Dv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Dv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Dv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Dv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Dv)("MainThreadIssueReporter")},e.$OK={ExtHostCommands:(0,E.$Dv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Dv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Dv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Dv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Dv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Dv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Dv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Dv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Dv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Dv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Dv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Dv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Dv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Dv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Dv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Dv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Dv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Dv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Dv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Dv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Dv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Dv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Dv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Dv)("ExtHostSCM"),ExtHostSearch:(0,E.$Dv)("ExtHostSearch"),ExtHostTask:(0,E.$Dv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Dv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Dv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Dv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Dv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Dv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Dv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Dv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Dv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Dv)("ExtHostProgress"),ExtHostComments:(0,E.$Dv)("ExtHostComments"),ExtHostSecretState:(0,E.$Dv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Dv)("ExtHostStorage"),ExtHostUrls:(0,E.$Dv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Dv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Dv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Dv)("ExtHostOutputService"),ExtHostLabelService:(0,E.$Dv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Dv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Dv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Dv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Dv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Dv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Dv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Dv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Dv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Dv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Dv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Dv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Dv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Dv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Dv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Dv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Dv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Dv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Dv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Dv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Dv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Dv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Dv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Dv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Dv)("ExtHostIssueReporter")}}),define(Ce[231],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$NK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,g){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(R);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation($,g)??[]}getRelatedInformation(R,$,g){return this.c.$getAiRelatedInformation($,g)}registerRelatedInformationProvider(R,$,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiRelatedInformationProvider(w,$),new T.$PK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$_ec=I}),define(Ce[81],Re([1,0,4,15,3,17]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=e.$ffc=void 0,e.$ffc=(0,E.$2h)("IExtHostApiDeprecationService");let R=class{constructor(g,w){this.c=w,this.a=new Set,this.b=g.getProxy(I.$NK.MainThreadTelemetry)}report(g,w,A){const S=this.d(g,w);this.a.has(S)||(this.a.add(S),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:g}))}d(g,w){return`${g}-${w.identifier.value}`}};e.$gfc=R,e.$gfc=R=Ge([Ke(0,L.$RM),Ke(1,T.$jj)],R),e.$hfc=Object.freeze(new class{report($,g,w){}})}),define(Ce[232],Re([1,0,5,3,7,22]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class R{constructor(w){this.b=new Map,this.c=[],this.d=new E.$Sd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=w.getProxy(T.$NK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,A,S,l={}){const p=L.$hm.toKey(w.identifier),b=[...S].sort().join(" ");return await this.f.getOrCreate(`${p} ${A} ${b}`,async()=>{await this.a.$ensureProvider(A);const r=w.displayName||w.name;return this.a.$getSession(A,S,p,r,l)})}async getSessions(w,A,S){const l=L.$hm.toKey(w.identifier),p=[...S].sort().join(" ");return await this.g.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const b=w.displayName||w.name;return this.a.$getSessions(A,S,l,b)})}async removeSession(w,A){const S=this.b.get(w);return S?S.provider.removeSession(A):this.a.$removeSession(w,A)}registerAuthenticationProvider(w,A,S,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:A,provider:S,options:l??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===w)||this.c.push({id:w,label:A});const p=S.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(w,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(w,A,l?.supportsMultipleAccounts??!1),new I.$PK(()=>{p.dispose(),this.b.delete(w);const b=this.c.findIndex(r=>r.id===w);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,A,S){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(A,S));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const S=this.b.get(w);if(S)return Promise.resolve(S.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const S=this.b.get(w);if(S)return Promise.resolve(S.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this.d.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.$kfc=R;class ${constructor(){this.a=new Map}getOrCreate(w,A){const S=this.a.get(w);if(S)return S;const l=A().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Ce[233],Re([1,0,3,17,8]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;let L=class{constructor($,g){this.a=$.getProxy(E.$NK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>g.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,g,w){const A=I.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.$lfc=L,e.$lfc=L=Ge([Ke(0,T.$RM)],L)}),define(Ce[234],Re([1,0,67,6,3,8]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class R{static{this.a=0}constructor(w,A){this.extension=w,this.provider=A,this.handle=R.a++}}class ${static{this.a=0}constructor(w){this.b=new Map,this.c=new Map,this.d=w.getProxy(I.$NK.MainThreadChat)}registerChatProvider(w,A,S){const l=new R(w,S);return this.b.set(l.handle,l),this.d.$registerChatProvider(l.handle,A),(0,T.$Qc)(()=>{this.d.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(w,A){const S=E.Iterable.find(this.c.keys(),l=>this.c.get(l)===w)??0;typeof S=="number"&&this.d.$transferChatSession(S,A)}sendInteractiveRequestToProvider(w,A){this.d.$sendRequestToProvider(w,A)}async $prepareChat(w,A){const S=this.b.get(w);if(!S)return;const l=await S.provider.prepareSession(A);if(!l)return;const p=$.a++;return this.c.set(p,l),{id:p,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $provideWelcomeMessage(w,A){const S=this.b.get(w);if(!S||!S.provider.provideWelcomeMessage)return;const l=await S.provider.provideWelcomeMessage(A);if(l)return l.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(b=>L.ChatReplyFollowup.from(b)):L.MarkdownString.from(p))}async $provideSampleQuestions(w,A){const S=this.b.get(w);if(!S||!S.provider.provideSampleQuestions)return;const l=await S.provider.provideSampleQuestions(A);if(l)return l?.map(p=>L.ChatReplyFollowup.from(p))}$releaseSession(w){this.c.delete(w)}}e.$mfc=$}),define(Ce[235],Re([1,0,13,20,40,5,60,16,2,157,72,3,8,7,206,23]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class a{static{this.a=0}constructor(o,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=o.getProxy(S.$NK.MainThreadChatAgents2)}createChatAgent(o,c,h){const i=a.a++,s=new t(o,c,this.d,i,h);return this.b.set(i,s),this.d.$registerAgent(i,c,{}),s.apiAgent}async $invokeAgent(o,c,h,i,s,u){this.g.delete(c);const d=this.b.get(o);if(!d)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let m=!1;function f(){if(m)throw new Error("Only valid while executing the command")}const k=new E.$mh;u.onCancellationRequested(()=>k.complete()),this.i.allowListExtensionWhile(d.extension.identifier,k.p);const F=i.command?await d.validateSlashCommand(i.command):void 0,v=R.$Od.create(!1);let y;try{const D=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:F},{history:s.history.map(l.ChatMessage.to)},new A.$hv(N=>{f(),typeof y>"u"&&"content"in N&&(y=v.elapsed());const O=l.ChatResponseProgress.from(d.extension,N);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(N));return}if("placeholder"in N&&"resolvedContent"in N){const W=Promise.all([this.d.$handleProgressChunk(h,O),N.resolvedContent]);(0,E.$Qg)(W,u).then(z=>{if(!z)return;const[V,P]=z,C=l.ChatResponseProgress.from(d.extension,P);if(!C){this.j.error("Unknown progress type: "+JSON.stringify(P));return}this.d.$handleProgressChunk(h,C,V??void 0)})}else this.d.$handleProgressChunk(h,O)}),u);return await(0,E.$Qg)(Promise.resolve(D).then(N=>{if(N){this.g.set(c,N);let O=this.h.get(c);O||(O=new Map,this.h.set(c,O)),O.set(h,N);const W={firstProgress:y,totalElapsed:v.elapsed()};return{errorDetails:N.errorDetails,timings:W}}else this.g.delete(c)}),u)}catch(D){return this.j.error(D,d.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,I.$Mi)(D)),responseIsIncomplete:!0}}}finally{m=!0,k.complete()}}$releaseSession(o){this.g.delete(o),this.h.delete(o)}async $provideSlashCommands(o,c){const h=this.b.get(o);return h?h.provideSlashCommand(c):[]}$provideFollowups(o,c,h){const i=this.b.get(o);if(!i)return Promise.resolve([]);const s=this.g.get(c);return s?i.provideFollowups(s,h):Promise.resolve([])}$acceptFeedback(o,c,h,i,s){const u=this.b.get(o);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let m;switch(i){case b.InteractiveSessionVoteDirection.Down:m=p.ChatAgentResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:m=p.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(s?{result:d,kind:m,reportIssue:s}:{result:d,kind:m}))}$acceptAction(o,c,h,i){const s=this.b.get(o);if(!s)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:i.action,result:u}))}async $invokeCompletionProvider(o,c,h){const i=this.b.get(o);return i?(await i.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$ofc=a;class t{constructor(o,c,h,i,s){this.extension=o,this.t=c,this.u=h,this.w=i,this.x=s,this.o=new L.$Sd,this.q=new L.$Sd}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.q.fire(o)}async invokeCompletionProvider(o,c){return this.s?await this.s.provider.provideCompletionItems(o,c)??[]:[]}async validateSlashCommand(o){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Of)(this.b));const c=this.b.find(h=>h.name===o);if(!c)throw new Error(`Unknown slashCommand: ${o}`);return c}async provideSlashCommand(o){if(!this.a)return[];const c=await this.a.provideSlashCommands(o);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(o,c){if(!this.d)return[];const h=await this.d.provideFollowups(o,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let o=!1,c=!1;const h=()=>{o||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$KL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(s){i.g=s,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(s){i.h=s,h()},get iconPath(){return i.i},set iconPath(s){i.i=s,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(s){i.a=s,h()},get followupProvider(){return i.d},set followupProvider(s){i.d=s,h()},get isDefault(){return(0,r.$oF)(i.extension,"defaultChatAgent"),i.j},set isDefault(s){(0,r.$oF)(i.extension,"defaultChatAgent"),i.j=s,h()},get helpTextPrefix(){return(0,r.$oF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(s){if((0,r.$oF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=s,h()},get helpTextPostfix(){return(0,r.$oF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(s){if((0,r.$oF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=s,h()},get isSecondary(){return(0,r.$oF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(s){(0,r.$oF)(i.extension,"defaultChatAgent"),i.n=s,h()},get sampleRequest(){return i.m},set sampleRequest(s){i.m=s,h()},get supportIssueReporting(){return(0,r.$oF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(s){(0,r.$oF)(i.extension,"chatAgents2Additions"),i.r=s,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(s){if(i.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,s.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,r.$nF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){o=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(o,c,h,i){return this.x(o,c,h,i)}}}),define(Ce[236],Re([1,0,20,6,3,8,72,22,13,5]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class A{constructor(b,r){this.stream=new g.$sh,this.stream=r??new g.$sh;const a=this;this.apiObj={option:b,response:a.stream.asyncIterable}}}class S{constructor(b,r){this.a=new w.$Sd,this.b=new Map,this.c=new g.$sh,this.d=!1;const a=this;this.apiObject={result:b,response:a.c.asyncIterable,onDidStartResponseStream:a.a.event,cancel(){r.cancel()}},b.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(b){if(this.d)return;let r=this.b.get(b.index);r||(this.b.size===0?r=new A(b.index,this.c):r=new A(b.index),this.b.set(b.index,r),this.a.fire(r.apiObj)),r.stream.emitOne(b.part)}}class l{static{this.a=1}constructor(b,r){this.d=r,this.c=new Map,this.e=new Map,this.f=new $.$jm,this.b=b.getProxy(I.$NK.MainThreadChatProvider)}registerProvider(b,r,a,t){const n=l.a++;return this.c.set(n,{extension:b,provider:a}),this.b.$registerProvider(n,r,{extension:b,model:t.name??""}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(b,r,a,t,n){const o=this.c.get(b);if(!o)return;const c=new R.$hv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:h.index,part:h.part})});return o.provider.provideChatResponse(a.map(L.ChatMessage.to),t,c,n)}allowListExtensionWhile(b,r){this.f.set(b,r),r.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,r){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const a=await this.b.$prepareChatAccess(r);if(!a)throw new Error(`ChatAccess '${r}' NOT found`);const t=this;return{get model(){return a.model},get isRevoked(){return!t.f.has(b)},makeRequest(n,o,c){if(!t.f.has(b))throw new Error("Access to chat has been revoked");const h=new E.$3d(c),i=Math.random()*1e6|0,s=t.b.$fetchResponse(b,r,i,n.map(L.ChatMessage.from),o??{},h.token),u=new S(s,h);return t.e.set(i,{res:u}),s.finally(()=>{t.e.delete(i)}),u.apiObject}}}async $handleResponseFragment(b,r){const a=this.e.get(b);a&&a.res.handleFragment(r)}}e.$nfc=l}),define(Ce[237],Re([1,0,6,3,14,8]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class R{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$NK.MainThreadChatVariables)}async $resolveVariable(g,w,A){const S=this.b.get(g);if(S)try{const l=await S.resolver.resolve(S.data.name,{message:w},A);if(l)return l.map(L.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(g,w,A,S){const l=R.a++;return this.b.set(l,{extension:g.identifier,data:{name:w,description:A},resolver:S}),this.c.$registerVariable(l,{name:w,description:A}),(0,E.$Qc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$pfc=R}),define(Ce[238],Re([1,0,3]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class T{constructor(L){const R=L.getProxy(E.$NK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$qfc=T}),define(Ce[32],Re([1,0,16,7,8,26,3,18,15,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=void 0;let u=class{#e;#t;#i;constructor(v,y,D){this.b=new Map,this.c=new Map,this.#e=v.getProxy(R.$NK.MainThreadCommands),this.d=y,this.#i=D,this.#t=v.getProxy(R.$NK.MainThreadTelemetry),this.converter=new d(this,N=>{const O=this.c.get(N);return O?.result===f.Void?O:void 0},y),this.f=[{processArgument(N){return(0,w.$yh)(N)}},{processArgument(N){return(0,L.$kn)(N,function(O){if(A.$Hs.isIRange(O))return I.Range.to(O);if(S.$Gs.isIPosition(O))return I.Position.to(O);if(A.$Hs.isIRange(O.range)&&l.URI.isUri(O.uri))return I.location.to(O);if(O instanceof t.$ge)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const y=this.registerCommand(!1,v.id,async(...D)=>{const N=v.args.map((W,z)=>{if(!W.validate(D[z]))throw new Error(`Invalid argument '${W.name}' when running '${v.id}', received: ${typeof D[z]=="object"?JSON.stringify(D[z],null,"	"):D[z]} `);return W.convert(D[z])}),O=await this.executeCommand(v.internalId,...N);return v.result.convert(O,D,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$PK(()=>{y.dispose(),this.c.delete(v.id)})}registerCommand(v,y,D,N,O,W){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:N,metadata:O,extension:W}),v&&this.#e.$registerCommand(y),new T.$PK(()=>{this.b.delete(y)&&v&&this.#e.$unregisterCommand(y)})}executeCommand(v,...y){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,y,!0)}async g(v,y,D){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,y,!1);{let N=!1;const O=(0,L.$kn)(y,function(W){if(W instanceof T.$QK)return I.Position.from(W);if(W instanceof T.$RK)return I.Range.from(W);if(W instanceof T.$2K)return I.location.from(W);if(T.$bM.isNotebookRange(W))return I.NotebookRange.from(W);if(W instanceof ArrayBuffer)return N=!0,t.$ge.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return N=!0,t.$ge.wrap(W);if(W instanceof t.$ge)return N=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(v,N?new n.$Fv(O):O,D);return(0,w.$yh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(v,y,!1);throw W}}}async h(v,y,D){const N=this.b.get(v);if(!N)throw new Error("Unknown command");const{callback:O,thisArg:W,metadata:z}=N;if(z?.args)for(let P=0;P<z.args.length;P++)try{(0,E.$Vf)(y[P],z.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${z.args[P].name}' - ${z.args[P].description}`)}const V=c.$Od.create();try{return await O.apply(W,y)}catch(P){if(v===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...y);C&&(v=C.command)}if(this.d.error(P,v,N.extension?.identifier),!D)throw P;if(N.extension?.identifier){const C=this.#i.onExtensionError(N.extension.identifier,P);this.d.trace("forwarded error to extension?",C,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Mi)(P)),this.id=v,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,v,V.elapsed())}}j(v,y,D){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new h.$xo(y),duration:D})}$executeContributedCommand(v,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const D=this.b.get(v);return D?(y=y.map(N=>this.f.reduce((O,W)=>W.processArgument(O,D.extension?.identifier),N)),this.h(v,y,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(y=>(v&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[y,D]of this.b){const{metadata:N}=D;N&&(v[y]=N)}return Promise.resolve(v)}};e.$aN=u,e.$aN=u=Ge([Ke(0,r.$RM),Ke(1,g.$jj),Ke(2,i.$_M)],u),e.$bN=(0,b.$2h)("IExtHostCommands");class d{constructor(v,y,D){this.d=v,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,s.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,y){if(!v)return;const D={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return D;const N=this.f(v.command);if(N)D.id=N.internalId,D.arguments=N.args.map((O,W)=>O.convert(v.arguments&&v.arguments[W]));else if((0,$.$Lb)(v.arguments)){const O=`${v.command} /${++this.c}`;this.b.set(O,v),y.add((0,p.$Qc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),D.$ident=O,D.id=this.delegatingCommandId,D.arguments=[O],this.g.trace("CommandsConverter#CREATE",v.command,O)}return D}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const y=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$cN=d;class m{static{this.Uri=new m("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v)}static{this.Position=new m("position","A position in a text document",v=>T.$QK.isPosition(v),I.Position.from)}static{this.Range=new m("range","A range in a text document",v=>T.$RK.isRange(v),I.Range.from)}static{this.Selection=new m("selection","A selection in a text document",v=>T.$SK.isSelection(v),I.Selection.from)}static{this.Number=new m("number","",v=>typeof v=="number",v=>v)}static{this.String=new m("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=m.Arr(m.String)}static Arr(v){return new m(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,y=>Array.isArray(y)&&y.every(D=>v.validate(D)),y=>y.map(D=>v.convert(D)))}static{this.CallHierarchyItem=new m("item","A call hierarchy item",v=>v instanceof T.$aL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new m("item","A type hierarchy item",v=>v instanceof T.$uM,I.TypeHierarchyItem.from)}static{this.TestItem=new m("testItem","A VS Code TestItem",v=>v instanceof a.$5M,I.TestItem.from)}constructor(v,y,D,N){this.name=v,this.description=y,this.validate=D,this.convert=N}optional(){return new m(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,y){return new m(v??this.name,y??this.description,this.validate,this.convert)}}e.$dN=m;class f{static{this.Void=new f("no result",v=>v)}constructor(v,y){this.description=v,this.convert=y}}e.$eN=f;class k{constructor(v,y,D,N,O){this.id=v,this.internalId=y,this.description=D,this.args=N,this.result=O}}e.$fN=k}),define(Ce[239],Re([1,0,18,12,2,80,96,35,32,8,7]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;const S=[new g.$fN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of DocumentHighlight-instances.",p(w.DocumentHighlight.to))),new g.$fN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$dN.Uri],new g.$eN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if((0,E.$Kb)(r))return;class t extends A.$8K{static to(o){const c=new t(o.name,w.SymbolKind.to(o.kind),o.containerName||"",new A.$2K(a[0],w.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=w.Range.to(o.selectionRange),c.children=o.children?o.children.map(t.to):[],c}}return r.map(t.to)})),new g.$fN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$dN.Uri,new g.$dN("options","Formatting options",r=>!0,r=>r)],new g.$eN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$fN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$dN.Uri,g.$dN.Range,new g.$dN("options","Formatting options",r=>!0,r=>r)],new g.$eN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$fN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$dN.Uri,g.$dN.Position,new g.$dN("ch","Trigger character",r=>typeof r=="string",r=>r),new g.$dN("options","Formatting options",r=>!0,r=>r)],new g.$eN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$fN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$fN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$fN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$fN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$fN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Location-instances.",p(w.location.to))),new g.$fN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of Hover-instances.",p(w.Hover.to))),new g.$fN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$dN.Uri,new g.$dN("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>A.$QK.isPosition(a)),r=>r.map(w.Position.from))],new g.$eN("A promise that resolves to an array of ranges.",r=>r.map(a=>{let t;for(const n of a.reverse())t=new A.$_K(w.Range.to(n),t);return t}))),new g.$fN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$dN.String.with("query","Search string")],new g.$eN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(w.WorkspaceSymbol.to))),new g.$fN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(w.CallHierarchyItem.to))),new g.$fN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$dN.CallHierarchyItem],new g.$eN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(w.CallHierarchyIncomingCall.to))),new g.$fN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$dN.CallHierarchyItem],new g.$eN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(w.CallHierarchyOutgoingCall.to))),new g.$fN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:w.Range.to(r.range),placeholder:r.text}})),new g.$fN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$dN.Uri,g.$dN.Position,g.$dN.String.with("newName","The new symbol name")],new g.$eN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return w.WorkspaceEdit.to(r)}})),new g.$fN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$dN.Uri,g.$dN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$eN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(w.DocumentLink.to))),new g.$fN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$dN.Uri],new g.$eN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$6L(r.tokenTypes,r.tokenModifiers)})),new g.$fN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$dN.Uri],new g.$eN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,R.$h$)(r);if(a.type==="full")return new A.$8L(a.data,void 0)})),new g.$fN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$dN.Uri,g.$dN.Range.optional()],new g.$eN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$6L(r.tokenTypes,r.tokenModifiers)})),new g.$fN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$dN.Uri,g.$dN.Range],new g.$eN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,R.$h$)(r);if(a.type==="full")return new A.$8L(a.data,void 0)})),new g.$fN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$dN.Uri,g.$dN.Position,g.$dN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$dN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$eN("A promise that resolves to a CompletionList-instance.",(r,a,t)=>{if(!r)return new A.$lL([]);const n=r.suggestions.map(o=>w.CompletionItem.to(o,t));return new A.$lL(n,r.incomplete)})),new g.$fN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$dN.Uri,g.$dN.Position,g.$dN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$eN("A promise that resolves to SignatureHelp.",r=>{if(r)return w.SignatureHelp.to(r)})),new g.$fN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$dN.Uri,g.$dN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$eN("A promise that resolves to an array of CodeLens-instances.",(r,a,t)=>p(n=>new A.$dL(w.Range.to(n.range),n.command&&t.fromInternal(n.command)))(r))),new g.$fN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$dN.Uri,new g.$dN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.$RK.isRange(r),r=>A.$SK.isSelection(r)?w.Selection.from(r):w.Range.from(r)),g.$dN.String.with("kind","Code action kind to return code actions for").optional(),g.$dN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$eN("A promise that resolves to an array of Command-instances.",(r,a,t)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const o=new A.$0K(n.title,n.kind?new A.$$K(n.kind):void 0);return n.edit&&(o.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(o.command=t.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(r))),new g.$fN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$dN.Uri],new g.$eN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new A.$rL(w.Range.to(a.range),w.Color.to(a.color))):[])),new g.$fN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$dN("color","The color to show and insert",r=>r instanceof A.$qL,w.Color.from),new g.$dN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:w.Range.from(r.range)}))],new g.$eN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(w.ColorPresentation.to):[])),new g.$fN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$dN.Uri,g.$dN.Range],new g.$eN("A promise that resolves to an array of Inlay objects",(r,a,t)=>r.map(w.InlayHint.to.bind(void 0,t)))),new g.$fN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$dN.Uri],new g.$eN("A promise that resolves to an array of FoldingRange objects",(r,a)=>{if(r)return r.map(w.FoldingRange.to)})),new g.$fN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$eN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>w.NotebookExclusiveDocumentPattern.to(a))})))),new g.$fN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$dN.Uri,g.$dN.Range,new g.$dN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof A.$RK,r=>w.InlineValueContext.from(r))],new g.$eN("A promise that resolves to an array of InlineValue objects",r=>r.map(w.InlineValue.to))),new g.$fN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$dN("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,T.$bg)(r,T.Schemas.http,T.Schemas.https),r=>r),new g.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional(),g.$dN.String.with("label","").optional()],g.$eN.Void),new g.$fN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$dN.Uri.with("resource","Resource to open"),g.$dN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional()],g.$eN.Void),new g.$fN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$dN.Uri.with("left","Left-hand side resource of the diff editor"),g.$dN.Uri.with("right","Right-hand side resource of the diff editor"),g.$dN.String.with("title","Human readable title for the diff editor").optional(),new g.$dN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)]).optional()],g.$eN.Void),new g.$fN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$dN.String.with("title","Human readable title for the changes editor"),new g.$dN("resourceList","List of resources to compare",r=>{for(const a of r){if(a.length!==3)return!1;const[t,n,o]=a;if(!I.URI.isUri(t)||!I.URI.isUri(n)&&n!==void 0&&n!==null||!I.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},r=>r)],g.$eN.Void),new g.$fN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$dN.Uri,g.$dN.Position],new g.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$fN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$dN.TypeHierarchyItem],new g.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$fN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$dN.TypeHierarchyItem],new g.$eN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$fN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$dN.TestItem],g.$eN.Void),new g.$fN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$dN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$eN.Void),new g.$fN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$dN.String.with("name","The context key name"),new g.$dN("value","The context key value",()=>!0,r=>r)],g.$eN.Void),new g.$fN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$dN.Uri,g.$dN.StringArray,new g.$dN("MappedEditsContext","Mapped Edits Context",r=>w.MappedEditsContext.is(r),r=>w.MappedEditsContext.from(r))],new g.$eN("A promise that resolves to a workspace edit or null",r=>r?w.WorkspaceEdit.to(r):null))];class l{static register(a){S.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",$.$1i)}}e.$jfc=l;function p(r){return a=>{if(Array.isArray(a))return a.map(r)}}function b(r){if(!Array.isArray(r))return;const a=[];for(const t of r)L.$tt(t)?a.push(w.DefinitionLink.to(t)):a.push(w.location.to(t));return a}}),define(Ce[240],Re([1,0,13,66,5,6,2,80,22,8,7,3,23]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;function p(b,r,a){const t=b.getProxy(S.$NK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$jm,r.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const k=this.b.get(f.handle);return k?k.value:f}else if(f&&f.$mid===7){const k=this.b.get(f.commentControlHandle);if(!k)return f;const F=k.getCommentThread(f.commentThreadHandle);return F?F.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const F=k.getCommentThread(f.thread.commentThreadHandle);return F?f.$mid===8?F.value:{thread:F.value,text:f.text}:f}else if(f&&f.$mid===10){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const F=k.getCommentThread(f.thread.commentThreadHandle);if(!F)return f;const v=f.commentUniqueId,y=F.getCommentByUniqueId(v);return y||f}else if(f&&f.$mid===11){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const F=k.getCommentThread(f.thread.commentThreadHandle);if(!F)return f;const v=f.text,y=f.commentUniqueId,D=F.getCommentByUniqueId(y);return D?(typeof D.body=="string"?D.body=v:D.body=new A.$eL(v),D):f}return f}})}createCommentController(f,k,F){const v=n.a++,y=new c(f,v,k,F);this.b.set(y.handle,y);const D=this.c.get(f.identifier)||[];return D.push(y),this.c.set(f.identifier,D),y.value}async $createCommentThreadTemplate(f,k,F){const v=this.b.get(f);v&&v.$createCommentThreadTemplate(k,F)}async $updateCommentThreadTemplate(f,k,F){const v=this.b.get(f);v&&v.$updateCommentThreadTemplate(k,F)}$deleteCommentThread(f,k){this.b.get(f)?.$deleteCommentThread(k)}$provideCommentingRanges(f,k,F){const v=this.b.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const y=a.getDocument(R.URI.revive(k));return(0,E.$Ug)(async()=>{const D=await v.commentingRangeProvider.provideCommentingRanges(y,F);let N;return Array.isArray(D)?N={ranges:D,fileComments:!1}:D?N={ranges:D.ranges||[],fileComments:D.fileComments||!1}:N=D??void 0,N}).then(D=>{let N;return D&&(N={ranges:D.ranges.map(O=>w.Range.from(O)),fileComments:D.fileComments}),N})}$toggleReaction(f,k,F,v,y){const D=this.b.get(f);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,E.$Ug)(()=>{const N=D.getCommentThread(k);if(N){const O=N.getCommentByUniqueId(v.uniqueIdInThread);if(D!==void 0&&O&&D.reactionHandler)return D.reactionHandler(O,s(y))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,k,F,v,y,D,N,O){this.m=k,this.n=F,this.o=v,this.p=y,this.q=D,this.extensionDescription=N,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Tc,this.l.value=new L.$Rc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(k,this.handle,this.n,this.o,w.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{t.$deleteCommentThread(k,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(z){W.range=z},get comments(){return W.comments},set comments(z){W.comments=z},get collapsibleState(){return W.collapsibleState},set collapsibleState(z){W.collapsibleState=z},get canReply(){return W.canReply},set canReply(z){W.canReply=z},get contextValue(){return W.contextValue},set contextValue(z){W.contextValue=z},get label(){return W.label},set label(z){W.label=z},get state(){return W.state},set state(z){W.state=z},dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Rc);const f=F=>Object.prototype.hasOwnProperty.call(this.b,F),k={};f("range")&&(k.range=w.Range.from(this.p)),f("label")&&(k.label=this.label),f("contextValue")&&(k.contextValue=this.contextValue??null),f("comments")&&(k.comments=this.q.map(F=>h(this,F,this.k,this.extensionDescription))),f("collapsibleState")&&(k.collapseState=u(this.g)),f("canReply")&&(k.canReply=this.canReply),f("state")&&(k.state=d(this.h)),f("isTemplate")&&(k.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(f){for(const k of this.k){const F=k[0],v=k[1];if(f===v)return F}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Ge([(0,T.$uh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,k,F,v){this.f=f,this.g=k,this.h=F,this.i=v,this.a=new Map,t.$registerCommentController(this.handle,F,v,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(D){y.options=D},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(D){y.commentingRangeProvider=D},get reactionHandler(){return y.reactionHandler},set reactionHandler(D){y.reactionHandler=D},createCommentThread(D,N,O){return y.createCommentThread(D,N,O).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,k,F){k===void 0&&(0,l.$oF)(this.f,"fileComments");const v=new o(this.id,this.handle,void 0,f,k,F,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(f,k){const F=new o(this.id,this.handle,void 0,R.URI.revive(f),w.Range.to(k),[],this.f,!0);return F.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(F.handle,F),F}$updateCommentThreadTemplate(f,k){const F=this.a.get(f);F&&(F.range=w.Range.to(k))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(m,f,k,F){let v=k.get(f);return v||(v=++m.commentHandle,k.set(f,v)),f.state!==void 0&&(0,l.$oF)(F,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:v,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(m){return{label:m.label,iconPath:m.iconPath?w.$QM(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted}}function s(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?R.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1}}function u(m){if(m!==void 0)switch(m){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(m){if(m!==void 0)switch(m){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$tfc=p}),define(Ce[241],Re([1,0,26,3,27,17]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let R=class{constructor(A,S){this.a=A.getProxy(T.$NK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,S){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,S,p,arguments)}})}e(A,S,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:g(p,this.b)}),this.c&&this.f(A,l,p)}};e.$hhc=R,e.$hhc=R=Ge([Ke(0,L.$RM),Ke(1,I.$8M)],R);const $=1e5;function g(w,A){const S=[];if(w.length)for(let l=0;l<w.length;l++){let p=w[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const b=p;b.stack?p=b.stack:p=b.toString()}S.push(p)}if(A){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$nn)(S);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ce[110],Re([1,0,2,3,7,4,17,15,18,11,19,23]),function(ge,e,E,T,I,L,R,$,g,w,A,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,a){this.h=a,this.f=new Map,this.g=r.getProxy(T.$NK.MainThreadDecorations)}registerFileDecorationProvider(r,a){const t=l.c++;this.f.set(t,{provider:r,extensionDescription:a}),this.g.$registerDecorationProvider(t,a.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(o);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,w.$Le)(u.path,"/")})),i=(0,g.$zb)(h,(u,d)=>u.rank-d.rank||(0,w.$1e)(u.uri.path,d.uri.path)),s=[];e:for(const u of i){let d;for(const m of u){const f=(0,A.$mc)(m.uri.path);if(d!==f&&(d=f,s.push(m.uri)>=l.d))break e}}this.g.$onDidChange(t,s)});return new I.$PK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(r,a,t){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(r);return await Promise.all(a.map(async h=>{try{const{uri:i,id:s}=h,u=await Promise.resolve(o.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{I.$_L.validate(u),u.badge&&typeof u.badge!="string"&&(0,S.$oF)(c,"codiconDecoration"),n[s]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),n}};e.$jgc=p,e.$jgc=p=l=Ge([Ke(0,R.$RM),Ke(1,$.$jj)],p),e.$kgc=(0,L.$2h)("IExtHostDecorations")}),define(Ce[242],Re([1,0,158,99,2,3,7,8,5,15,28,43]),function(ge,e,E,T,I,L,R,$,g,w,A,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=void 0;class p{#e;#t;#i;constructor(a,t,n,o,c,h,i,s){this.d=a,this.e=t,this.f=n,this.g=o,this.h=c,this.c=!1,this.f=Math.max(o,n),this.#i=new A.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,t){if(!a){this.clear();return}this.j();let n=[];if(I.URI.isUri(a)){if(!t){this.delete(a);return}this.#i.set(a,t.slice()),n=[a]}else if(Array.isArray(a)){n=[];let h;a=[...a].sort(p.k);for(const i of a){const[s,u]=i;if((!h||s.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=s,n.push(s),this.#i.set(s,[])),u)this.#i.get(s)?.push(...u);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const h of n){let i=[];const s=this.#i.get(h);if(s)if(s.length>this.g){i=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const m of s)if(m.severity===u[d]&&i.push({...$.Diagnostic.from(m),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(u=>({...$.Diagnostic.from(u),modelVersionId:this.h(h)}));if(o.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,o)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,t){this.j();for(const[n,o]of this)a.call(t,n,o,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const t=this.#i.get(a);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,t){return a[0].toString()<t[0].toString()?-1:a[0].toString()>t[0].toString()?1:0}}e.$dfc=p;let b=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(a){const t=new A.$Ac;for(const n of a)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(a,t,n,o){this.j=t,this.k=n,this.l=o,this.g=new Map,this.h=new g.$Wd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=a.getProxy(L.$NK.MainThreadDiagnostics)}createDiagnosticCollection(a,t){const{g:n,f:o,h:c,j:h,k:i,l:s}=this,u=new class{$changeMany(f,k){o.$changeMany(f,k),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,f,k.length===0?"CLEARING":k)}$clear(f){o.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,f)}dispose(){o.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!n.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(n.has(d))}return new class extends p{constructor(){super(t,d,l.e,l.d,f=>s.getDocument(f)?.version,i.extUri,u,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(a){if(a)return this.m(a);{const t=new Map,n=[];for(const o of this.g.values())o.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(a){let t=[];for(const n of this.g.values())n.has(a)&&(t=t.concat(n.get(a)));return t}$acceptMarkersChange(a){if(!this.n){const t="_generated_mirror",n=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of a)this.n.set(I.URI.revive(t),n.map($.Diagnostic.to))}};e.$efc=b,e.$efc=b=l=Ge([Ke(1,w.$jj),Ke(2,S.$cfc)],b)}),define(Ce[243],Re([1,0,2,3,23]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class L{constructor($){this.a=$.getProxy(T.$NK.MainThreadDialogs)}showOpenDialog($,g){return g?.allowUIResources&&(0,I.$oF)($,"showLocal"),this.a.$showOpenDialog(g).then(w=>w?w.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(g=>g?E.URI.revive(g):void 0)}}e.$lgc=L}),define(Ce[244],Re([1,0,14,2,7,3,12,20,11]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class w{static{this.a=0}constructor(S,l,p){this.d=l,this.e=p,this.b=new Map,this.c=S.getProxy(L.$NK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const p=w.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,S);let b;if(typeof l.onDidChange=="function"){let r;b=l.onDidChange(async a=>{if(a.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;r&&await r;const t=this.$provideTextDocumentContent(p,a).then(async n=>{if(!n&&typeof n!="string")return;const o=this.d.getDocument(a);if(!o)return;const c=(0,g.$Ve)(n);if(!o.equalLines(c))return this.c.$onVirtualDocumentChange(a,n)}).catch(E.$1).finally(()=>{r===t&&(r=void 0)});r=t})}return new I.$PK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(S,l){const p=this.b.get(S);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$mgc=w}),define(Ce[245],Re([1,0,5,6,2,3,103,8,16,26,7]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class S{constructor(p,b){this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=p.getProxy(L.$NK.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(r=>{for(const a of r)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const a of r)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const b=this.g.getDocument(p);if(b)return b}getDocument(p){const b=this.getDocumentData(p);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return b.document}ensureDocumentData(p){const b=this.g.getDocument(p);if(b)return Promise.resolve(b);let r=this.h.get(p.toString());return r||(r=this.f.$tryOpenDocument(p).then(a=>{this.h.delete(p.toString());const t=I.URI.revive(a);return(0,g.$Pf)(this.g.getDocument(t))},a=>(this.h.delete(p.toString()),Promise.reject(a))),this.h.set(p.toString(),r)),r}createDocumentData(p){return this.f.$tryCreateDocument(p).then(b=>I.URI.revive(b))}$acceptModelLanguageChanged(p,b){const r=I.URI.revive(p),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(b),this.a.fire(a.document)}$acceptModelSaved(p){const b=I.URI.revive(p),r=this.g.getDocument(b);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(p,b){const r=I.URI.revive(p),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(b),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,b,r){const a=I.URI.revive(p),t=this.g.getDocument(a);if(!t)throw new Error("unknown document");t._acceptIsDirty(r),t.onEvents(b);let n;b.isUndoing?n=A.TextDocumentChangeReason.Undo:b.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,w.$jn)({document:t.document,contentChanges:b.changes.map(o=>({range:$.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(p,b){(0,R.$TM)(p,b)}}e.$afc=S}),define(Ce[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,15,28,12,67,39]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new T.$Sd,this.e=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],s=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=L.URI.revive(u),m=this.c.get(d);m?.unref()&&(this.c.delete(d),h.push(m.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=L.URI.revive(u.uri);let m=this.c.get(d);if(m&&d.scheme!==b.Schemas.vscodeNotebookCell&&d.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);m||(m=new t(new g.$UM(this.h.getProxy($.$NK.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,m),i.push(m.value)),m.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&s.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=L.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const m=this.c.get(d).value,f=new A.$1M(u.id,this.h.getProxy($.$NK.MainThreadTextEditors),this.i,new a.$V(()=>m.document),u.selections.map(S.Selection.to),u.options,u.visibleRanges.map(k=>S.Range.to(k)),typeof u.editorPosition=="number"?S.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,I.$Nc)(h),(0,I.$Nc)(s),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$2M=n,e.$2M=n=Ge([Ke(0,w.$RM),Ke(1,l.$jj)],n),e.$3M=(0,R.$2h)("IExtHostDocumentsAndEditors")}),define(Ce[62],Re([1,0,246,5,16,2,4,3,17,8,7]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0,e.$Mfc=(0,R.$2h)("IExtHostEditorTabs");class S{constructor(a,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,t={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$vM(L.URI.revive(this.b.input.uri));case 2:return new A.$wM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new A.$xM(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new A.$yM(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$zM(this.b.input.viewType);case 4:return new A.$AM(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$BM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$CM;case 9:return new A.$DM(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$EM(this.b.input.providerId);default:return}}}class l{constructor(a,t){this.c=[],this.d="",this.b=a,this.e=t;for(const n of a.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,t={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return w.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(n=>n.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const n=new S(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,n),a.tabDto.isActive&&(this.d=n.tabId),n}else if(a.kind===1){const n=this.c.splice(a.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(a.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,n),n}const t=this.c.find(n=>n.tabId===a.tabDto.id);if(!t)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(a.tabDto),t}activeTabId(){return this.d}}let p=class{constructor(a){this.b=new T.$Sd,this.c=new T.$Sd,this.e=[],this.a=a.getProxy($.$NK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,t={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(n=>n.apiObject))},get activeTabGroup(){const n=a.d;return(0,I.$Pf)(a.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?b(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(a){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(a.map(u=>u.groupId)),o=(0,E.$L)(t,n),c=this.e.filter(u=>o.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=a.map(u=>{const d=new l(u,()=>this.d);return o.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const s=(0,I.$Pf)(a.find(u=>u.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(a){const t=this.e.find(n=>n.groupId===a.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const t=this.e.find(o=>o.groupId===a.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(a){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===a)return n}h(a){return this.e.find(t=>t.apiObject===a)}async i(a,t){const n=[];for(const o of a){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(a,t){const n=[];for(const o of a){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$Nfc=p,e.$Nfc=p=Ge([Ke(0,g.$RM)],p);function b(r){return r.tabs!==void 0}}),define(Ce[247],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$NK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(R);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector($,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiEmbeddingVectorProvider($,w),new T.$PK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$ogc=I}),define(Ce[248],Re([1,0,2,3,6,7,8,296,11,24,23,52]),function(ge,e,E,T,I,L,R,$,g,w,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const a=this.a.indexOf(r);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),a=[];let t,n,o=14,c=14;for(const h of r){let i=t?(0,g.$0e)(t,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(o=c,c=9):c+=1,a.push([n,h.toUpperCase().charCodeAt(i),c]),a.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;t=h,c=o}a.push([9,58,10]),a.push([10,47,12]),this.b=new $.$lZ(a)}}provideDocumentLinks(r){this.c();const a=[],t=$.$mZ.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of t){const o=R.DocumentLink.to(n);o.target&&a.push(o)}return a}}class p{constructor(r,a){this.i=a,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(T.$NK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,a,t,n={}){if(p.j(t),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const o=this.h++;this.b.add(a),this.d.add(a),this.c.set(o,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$oF)(r,"fsChunks"),c+=4);let h;n.isReadonly&&(0,S.$fk)(n.isReadonly)&&((0,A.$oF)(r,"readonlyMessage"),h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,a,c,h).catch(s=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${a}`),console.error(s)});const i=t.onDidChangeFile(s=>{const u=[];for(const d of s){const{uri:m,type:f}=d;if(m.scheme!==a)continue;let k;switch(f){case L.FileChangeType.Changed:k=0;break;case L.FileChangeType.Created:k=1;break;case L.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:m,type:k})}this.a.$onFileSystemChange(o,u)});return(0,I.$Qc)(()=>{i.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:a,ctime:t,mtime:n,size:o,permissions:c}=r;return{type:a,ctime:t,mtime:n,size:o,permissions:c}}$stat(r,a){return Promise.resolve(this.l(r).stat(E.URI.revive(a))).then(t=>p.k(t))}$readdir(r,a){return Promise.resolve(this.l(r).readDirectory(E.URI.revive(a)))}$readFile(r,a){return Promise.resolve(this.l(r).readFile(E.URI.revive(a))).then(t=>w.$ge.wrap(t))}$writeFile(r,a,t,n){return Promise.resolve(this.l(r).writeFile(E.URI.revive(a),t.buffer,n))}$delete(r,a,t){return Promise.resolve(this.l(r).delete(E.URI.revive(a),t))}$rename(r,a,t,n){return Promise.resolve(this.l(r).rename(E.URI.revive(a),E.URI.revive(t),n))}$copy(r,a,t,n){const o=this.l(r);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(E.URI.revive(a),E.URI.revive(t),n))}$mkdir(r,a){return Promise.resolve(this.l(r).createDirectory(E.URI.revive(a)))}$watch(r,a,t,n){const o=this.l(r).watch(E.URI.revive(t),n);this.f.set(a,o)}$unwatch(r,a){const t=this.f.get(a);t&&(t.dispose(),this.f.delete(a))}$open(r,a,t){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(a),t))}$close(r,a){const t=this.l(r);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(a))}$read(r,a,t,n){const o=this.l(r);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$ge.alloc(n);return Promise.resolve(o.read(a,t,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(r,a,t,n){const o=this.l(r);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(a,t,n.buffer,0,n.byteLength))}l(r){const a=this.c.get(r);if(!a){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return a}}e.$pgc=p}),define(Ce[63],Re([1,0,3,42,7,24,4,17,43,6,13,25,12]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=void 0;let b=p=class{constructor(a,t){this.b=new Map,this.c=new A.$$g,this.a=a.getProxy(E.$NK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const h=n.b.get(o.scheme);return h?(await n.a.$ensureActivation(o.scheme),c=await h.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return p.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return p.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return p.e(c)}},async writeFile(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(o)),await n.c.queueFor(o).queue(()=>Promise.resolve(h.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,L.$ge.wrap(c))}catch(h){return p.e(h)}},async delete(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await h.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return p.e(h)}},async rename(o,c,h){try{return await n.a.$rename(o,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},async copy(o,c,h){try{return await n.a.$copy(o,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},isWritableFileSystem(o){const c=t.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(a,t,n){const o=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await a.stat(n)).type&T.FileType.Directory))throw I.$4L.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$Ck(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(t.basename(n)),n=t.dirname(n)}for(let c=o.length-1;c>=0;c--){n=t.joinPath(n,o[c]);try{await a.createDirectory(n)}catch(h){if(T.$Ck(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(a){if(a instanceof I.$4L)throw a;if(a instanceof T.$yk)switch(a.code){case T.FileSystemProviderErrorCode.FileExists:throw I.$4L.FileExists(a.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$4L.FileNotFound(a.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$4L.FileNotADirectory(a.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$4L.FileIsADirectory(a.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$4L.NoPermissions(a.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$4L.Unavailable(a.message);default:throw new I.$4L(a.message,a.name)}if(!(a instanceof Error))throw new I.$4L(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw I.$4L.Unavailable(a.message);switch(a.name){case T.FileSystemProviderErrorCode.FileExists:throw I.$4L.FileExists(a.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$4L.FileNotFound(a.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$4L.FileNotADirectory(a.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$4L.FileIsADirectory(a.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$4L.NoPermissions(a.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$4L.Unavailable(a.message);default:throw new I.$4L(a.message,a.name)}}addFileSystemProvider(a,t,n){return this.b.set(a,{impl:t,extUri:n?.isCaseSensitive?S.$tg:S.$vg,isReadonly:!!n?.isReadonly}),(0,w.$Qc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??S.$tg}};e.$Bfc=b,e.$Bfc=b=p=Ge([Ke(0,$.$RM),Ke(1,g.$cfc)],b),e.$Cfc=(0,R.$2h)("IExtHostConsumerFileSystem")}),define(Ce[249],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,b,r,a,t,n){this.a=Math.random(),this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$Ij)(t),c=typeof t=="string",h=n?.correlate,i=a(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(h&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const u of s.created){const d=I.URI.revive(u);o(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const u of s.changed){const d=I.URI.revive(u);o(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const u of s.deleted){const d=I.URI.revive(u);o(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$PK.from(this.i(p,r,t,n,n?.correlate),this.b,this.c,this.d,i)}i(p,b,r,a,t){const n=$.$PK.from();if(typeof r=="string")return n;const o=p.getProxy(L.$NK.MainThreadFileSystemEventService);let c=!1;return(r.pattern.includes(T.$Ej)||r.pattern.includes(T.$Fj))&&(c=!0),o.$watch(b.identifier.value,this.a,r.baseUri,{recursive:c,excludes:a?.excludes??[]},!!t),$.$PK.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(I.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(p,b,r){this.j=p,this.k=b,this.l=r,this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.g=new E.$Ud,this.h=new E.$Ud,this.i=new E.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,b,r,a){return new w(this.j,p,b,this.a.event,R.GlobPattern.from(r),a)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,b){switch(p){case 2:this.b.fire(Object.freeze({files:b.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:b.map(r=>I.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:b.map(r=>I.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,b){return(r,a,t)=>{const n=function(c){r.call(a,c)};return n.extension=p,b.event(n,void 0,t)}}async $onWillRunFileOperation(p,b,r,a){switch(p){case 2:return await this.n(this.g,{files:b.map(t=>({oldUri:I.URI.revive(t.source),newUri:I.URI.revive(t.target)}))},r,a);case 1:return await this.n(this.i,{files:b.map(t=>I.URI.revive(t.target))},r,a);case 0:case 3:return await this.n(this.h,{files:b.map(t=>I.URI.revive(t.target))},r,a)}}async n(p,b,r,a){const t=new Set,n=[];if(await p.fireAsync(b,a,async(c,h)=>{const i=Date.now(),s=await Promise.resolve(c);s instanceof $.$ZK&&(n.push([h.extension,s]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(h)}return{edit:o,extensionNames:Array.from(t)}}}e.$qgc=S}),define(Ce[250],Re([1,0,6,2,3,8,7,32,13]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class w{static{this.a=0}constructor(p,b){this.extension=p,this.provider=b,this.handle=w.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class S{static{this.a=0}constructor(p,b,r,a){this.f=r,this.g=a,this.b=new Map,this.d=new Map,this.e=p.getProxy(I.$NK.MainThreadInlineChat),b.registerApiCommand(new $.$fN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$dN("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?L.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?L.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?L.Position.from(t.position):void 0}})],$.$eN.Void))}registerProvider(p,b,r){const a=new w(p,b);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,r?.label??p.displayName??p.name,p.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function",typeof b.provideFollowups=="function",r?.supportReportIssue??!1),(0,E.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(p,b,r,a){const t=this.b.get(p);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(b)),o=L.Selection.to(r),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:o},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=S.a++;return this.d.set(h,new A(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:L.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,b,r,a){const t=this.b.get(p);if(!t)return;const n=this.d.get(b.id);if(!n)return;const o={prompt:r.prompt,selection:L.Selection.to(r.selection),wholeRange:L.Range.to(r.wholeRange),attempt:r.attempt,live:r.live};let c=!1;const h={report:async F=>{if(!r.live&&F.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:F.message,edits:F.edits?.map(L.TextEdit.from),editsShouldBeInstant:F.editsShouldBeInstant,slashCommand:F.slashCommand?.command,markdownFragment:R.$eL.isMarkdownString(F.content)?F.content.value:F.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,o,h,a));let s;try{s=await(0,g.$Qg)(i,a)}finally{c=!0}if(!s)return;const u=n.responses.push(s)-1,d={wholeRange:L.Range.from(s.wholeRange),placeholder:s.placeholder};if(!S.h(s))return{...d,id:u,type:"editorEdit",message:L.MarkdownString.from(s.contents),edits:[]};const{edits:m,contents:f}=s,k=f!==void 0?L.MarkdownString.from(f):void 0;return m instanceof R.$ZK?{...d,id:u,type:"bulkEdit",edits:L.WorkspaceEdit.from(m),message:k}:{...d,id:u,type:"editorEdit",edits:m.map(L.TextEdit.from),message:k}}async $provideFollowups(p,b,r,a){const t=this.b.get(p),n=this.d.get(b),o=n?.responses[r];if(t&&o&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,o,a));return(await(0,g.$Qg)(c,a))?.map(L.ChatReplyFollowup.from)}}$handleFeedback(p,b,r,a){const t=this.b.get(p),n=this.d.get(b),o=n?.responses[r];if(t&&o){const c=L.InteractiveEditorResponseFeedbackKind.to(a);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession(p,b){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$rgc=S}),define(Ce[251],Re([1,0,2,32]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class I{constructor(R,$,g,w,A){this.a=$,this.b=g,this.c=w;const S=new T.$fN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$dN("showOptions","Show Options",l=>!0,l=>l),new T.$dN("resource","Interactive resource Uri",l=>!0,l=>l),new T.$dN("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$dN("title","Interactive editor title",l=>!0,l=>l)],new T.$eN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,$,g,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:g,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Egc=I}),define(Ce[252],Re([1,0,3,7]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class I{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$NK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(R);if(!g)throw new Error("Issue request handler not found");const w=await g.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueData($);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueTemplate($);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(R,$){const g=R.identifier.value;return this.a.set(g,$),this.c.$registerIssueUriRequestHandler(g),new T.$PK(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(R,$){const g=R.identifier.value;return this.b.set(g,$),this.c.$registerIssueDataProvider(g),new T.$PK(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$Fgc=I}),define(Ce[253],Re([1,0,6,3]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class I{constructor(R){this.b=0,this.a=R.getProxy(T.$NK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Ggc=I}),define(Ce[254],Re([1,0,2,26,8,7,80,3,11,29,18,16,297,20,22,6,96,89,75,60,14,13,23,160]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class u{constructor(M,K){this.d=M,this.e=K}async provideDocumentSymbols(M,K){const H=this.d.getDocument(M),U=await this.e.provideDocumentSymbols(H,K);if(!(0,A.$Kb)(U))return U[0]instanceof L.$9K?U.map(I.DocumentSymbol.from):u.f(U)}static f(M){M=M.slice(0).sort((U,Q)=>{let X=U.location.range.start.compareTo(Q.location.range.start);return X===0&&(X=Q.location.range.end.compareTo(U.location.range.end)),X});const K=[],H=[];for(const U of M){const Q={name:U.name||"!!MISSING: name!!",kind:I.SymbolKind.from(U.kind),tags:U.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:U.containerName,range:I.Range.from(U.location.range),selectionRange:I.Range.from(U.location.range),children:[]};for(;;){if(H.length===0){H.push(Q),K.push(Q);break}const X=H[H.length-1];if(w.$Hs.containsRange(X.range,Q.range)&&!w.$Hs.equalsRange(X.range,Q.range)){X.children?.push(Q),H.push(Q);break}H.pop()}}return K}}class d{constructor(M,K,H,U,Q,X){this.f=M,this.g=K,this.h=H,this.j=U,this.k=Q,this.l=X,this.d=new n.$$ec("CodeLens"),this.e=new Map}async provideCodeLenses(M,K){const H=this.f.getDocument(M),U=await this.h.provideCodeLenses(H,K);if(!U||K.isCancellationRequested)return;const Q=this.d.add(U),X=new r.$Rc;this.e.set(Q,X);const ye={cacheId:Q,lenses:[]};for(let Te=0;Te<U.length;Te++)ye.lenses.push({cacheId:[Q,Te],range:I.Range.from(U[Te].range),command:this.g.toInternal(U[Te].command,X)});return ye}async resolveCodeLens(M,K){const H=M.cacheId&&this.d.get(...M.cacheId);if(!H)return;let U;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?U=H:U=await this.h.resolveCodeLens(H,K),U||(U=H),K.isCancellationRequested)return;const Q=M.cacheId&&this.e.get(M.cacheId[0]);if(Q){if(!U.command){const X=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,X),this.l.error(X);return}return M.command=this.g.toInternal(U.command,Q),M}}releaseCodeLenses(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}}function m(we){return Array.isArray(we)?we.map(I.DefinitionLink.from):we?[I.DefinitionLink.from(we)]:[]}class f{constructor(M,K){this.d=M,this.e=K}async provideDefinition(M,K,H){const U=this.d.getDocument(M),Q=I.Position.to(K),X=await this.e.provideDefinition(U,Q,H);return m(X)}}class k{constructor(M,K){this.d=M,this.e=K}async provideDeclaration(M,K,H){const U=this.d.getDocument(M),Q=I.Position.to(K),X=await this.e.provideDeclaration(U,Q,H);return m(X)}}class F{constructor(M,K){this.d=M,this.e=K}async provideImplementation(M,K,H){const U=this.d.getDocument(M),Q=I.Position.to(K),X=await this.e.provideImplementation(U,Q,H);return m(X)}}class v{constructor(M,K){this.d=M,this.e=K}async provideTypeDefinition(M,K,H){const U=this.d.getDocument(M),Q=I.Position.to(K),X=await this.e.provideTypeDefinition(U,Q,H);return m(X)}}class y{constructor(M,K){this.d=M,this.e=K}async provideHover(M,K,H){const U=this.d.getDocument(M),Q=I.Position.to(K),X=await this.e.provideHover(U,Q,H);if(!(!X||(0,A.$Kb)(X.contents)))return X.range||(X.range=U.getWordRangeAtPosition(Q)),X.range||(X.range=new L.$RK(Q,Q)),I.Hover.from(X)}}class D{constructor(M,K){this.d=M,this.e=K}async provideEvaluatableExpression(M,K,H){const U=this.d.getDocument(M),Q=I.Position.to(K),X=await this.e.provideEvaluatableExpression(U,Q,H);if(X)return I.EvaluatableExpression.from(X)}}class N{constructor(M,K){this.d=M,this.e=K}async provideInlineValues(M,K,H,U){const Q=this.d.getDocument(M),X=await this.e.provideInlineValues(Q,I.Range.to(K),I.InlineValueContext.to(H),U);if(Array.isArray(X))return X.map(ye=>I.InlineValue.from(ye))}}class O{constructor(M,K){this.d=M,this.e=K}async provideDocumentHighlights(M,K,H){const U=this.d.getDocument(M),Q=I.Position.to(K),X=await this.e.provideDocumentHighlights(U,Q,H);if(Array.isArray(X))return X.map(I.DocumentHighlight.from)}}class W{constructor(M,K){this.d=M,this.e=K}async provideMultiDocumentHighlights(M,K,H,U){const Q=this.d.getDocument(M),X=H.map(We=>this.d.getDocument(We)),ye=I.Position.to(K),Te=await this.e.provideMultiDocumentHighlights(Q,ye,X,U);if(Array.isArray(Te))return Te.map(I.MultiDocumentHighlight.from)}}class z{constructor(M,K){this.d=M,this.e=K}async provideLinkedEditingRanges(M,K,H){const U=this.d.getDocument(M),Q=I.Position.to(K),X=await this.e.provideLinkedEditingRanges(U,Q,H);if(X&&Array.isArray(X.ranges))return{ranges:(0,A.$Hb)(X.ranges.map(I.Range.from)),wordPattern:X.wordPattern}}}class V{constructor(M,K){this.d=M,this.e=K}async provideReferences(M,K,H,U){const Q=this.d.getDocument(M),X=I.Position.to(K),ye=await this.e.provideReferences(Q,X,H,U);if(Array.isArray(ye))return ye.map(I.location.from)}}class P{static{this.d=1e3}constructor(M,K,H,U,Q,X,ye){this.g=M,this.h=K,this.j=H,this.k=U,this.l=Q,this.m=X,this.n=ye,this.e=new n.$$ec("CodeAction"),this.f=new Map}async provideCodeActions(M,K,H,U){const Q=this.g.getDocument(M),X=l.$Js.isISelection(K)?I.Selection.to(K):I.Range.to(K),ye=[];for(const nt of this.j.getDiagnostics(M))if(X.intersection(nt.range)&&ye.push(nt)>P.d)break;const Te={diagnostics:ye,only:H.only?new L.$$K(H.only):void 0,triggerKind:I.CodeActionTriggerKind.to(H.trigger)},We=await this.k.provideCodeActions(Q,X,Te,U);if(!(0,A.$Lb)(We)||U.isCancellationRequested)return;const He=this.e.add(We),Ye=new r.$Rc;this.f.set(He,Ye);const st=[];for(let nt=0;nt<We.length;nt++){const tt=We[nt];tt&&(P.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Ye)})):(Te.only&&(tt.kind?Te.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[He,nt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Ye),diagnostics:tt.diagnostics&&tt.diagnostics.map(I.Diagnostic.from),edit:tt.edit&&I.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,i.$nF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:He,actions:st}}async resolveCodeAction(M,K){const[H,U]=M,Q=this.e.get(H,U);if(!Q||P.o(Q))return{};if(!this.k.resolveCodeAction)return{};const X=await this.k.resolveCodeAction(Q,K)??Q;let ye;X.edit&&(ye=I.WorkspaceEdit.from(X.edit,void 0));let Te;if(X.command){const We=this.f.get(H);We&&(Te=this.h.toInternal(X.command,We))}return{edit:ye,command:Te}}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static o(M){return typeof M.command=="string"&&typeof M.title=="string"}}class C{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,H,U,Q){this.d=M,this.e=K,this.f=H,this.g=U,this.h=Q}async prepareDocumentPaste(M,K,H,U){if(!this.f.prepareDocumentPaste)return;const Q=this.e.getDocument(M),X=K.map(We=>I.Range.to(We)),ye=I.DataTransfer.toDataTransfer(H,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(Q,X,ye,U),U.isCancellationRequested)return;const Te=Array.from(ye).filter(([,We])=>!(We instanceof L.$EL));return I.DataTransfer.from(Te)}async providePasteEdits(M,K,H,U,Q){if(!this.f.provideDocumentPasteEdits)return;const X=this.e.getDocument(K),ye=H.map(He=>I.Range.to(He)),Te=I.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolvePasteFileData(this.g,M,He)).buffer),We=await this.f.provideDocumentPasteEdits(X,ye,Te,Q);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:C.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class Z{constructor(M,K){this.d=M,this.e=K}async provideDocumentFormattingEdits(M,K,H){const U=this.d.getDocument(M),Q=await this.e.provideDocumentFormattingEdits(U,K,H);if(Array.isArray(Q))return Q.map(I.TextEdit.from)}}class ce{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeFormattingEdits(M,K,H,U){const Q=this.d.getDocument(M),X=I.Range.to(K),ye=await this.e.provideDocumentRangeFormattingEdits(Q,X,H,U);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,K,H,U){(0,S.$Of)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this.d.getDocument(M),X=K.map(I.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Q,X,H,U);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}}class me{constructor(M,K){this.d=M,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,K,H,U,Q){const X=this.d.getDocument(M),ye=I.Position.to(K),Te=await this.e.provideOnTypeFormattingEdits(X,ye,H,U,Q);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class be{constructor(M,K){this.e=M,this.f=K,this.d=new n.$$ec("WorkspaceSymbols")}async provideWorkspaceSymbols(M,K){const H=await this.e.provideWorkspaceSymbols(M,K);if(!(0,A.$Lb)(H))return{symbols:[]};const U=this.d.add(H),Q={cacheId:U,symbols:[]};for(let X=0;X<H.length;X++){const ye=H[X];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Q.symbols.push({...I.WorkspaceSymbol.from(ye),cacheId:[U,X]})}return Q}async resolveWorkspaceSymbol(M,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const H=this.d.get(...M.cacheId);if(H){const U=await this.e.resolveWorkspaceSymbol(H,K);return U&&(0,T.$ln)(M,I.WorkspaceSymbol.from(U),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class ke{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,K,H){this.d=M,this.e=K,this.f=H}async provideRenameEdits(M,K,H,U){const Q=this.d.getDocument(M),X=I.Position.to(K);try{const ye=await this.e.provideRenameEdits(Q,X,H,U);return ye?I.WorkspaceEdit.from(ye):void 0}catch(ye){const Te=ke.g(ye);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(M,K,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const U=this.d.getDocument(M),Q=I.Position.to(K);try{const X=await this.e.prepareRename(U,Q,H);let ye,Te;if(L.$RK.isRange(X)?(ye=X,Te=U.getText(X)):(0,S.$Gf)(X)&&(ye=X.range,Te=X.placeholder),!ye||!Te)return;if(ye.start.line>Q.line||ye.end.line<Q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ye),text:Te}}catch(X){const ye=ke.g(X);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(X)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class fe{constructor(M,K){this.resultId=M,this.tokens=K}}class de{constructor(M,K){this.f=M,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,K,H){const U=this.f.getDocument(M),Q=K!==0?this.d.get(K):null;let X=typeof Q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(U,Q.resultId,H):await this.g.provideDocumentSemanticTokens(U,H);return Q&&this.d.delete(K),X?(X=de.h(X),this.o(de.n(Q,X),X)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return de.j(M)?de.k(M)?M:new L.$8L(new Uint32Array(M.data),M.resultId):de.l(M)?de.m(M)?M:new L.$0L(M.edits.map(K=>new L.$9L(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const K of M.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(M,K){if(!de.j(K)||!M||!M.tokens)return K;const H=M.tokens,U=H.length,Q=K.data,X=Q.length;let ye=0;const Te=Math.min(U,X);for(;ye<Te&&H[ye]===Q[ye];)ye++;if(ye===U&&ye===X)return new L.$0L([],K.resultId);let We=0;const He=Te-ye;for(;We<He&&H[U-We-1]===Q[X-We-1];)We++;return new L.$0L([{start:ye,deleteCount:U-ye-We,data:Q.subarray(ye,X-We)}],K.resultId)}o(M,K){if(de.j(M)){const H=this.e++;return this.d.set(H,new fe(M.resultId,M.data)),(0,a.$g$)({id:H,type:"full",data:M.data})}if(de.l(M)){const H=this.e++;return de.j(K)?this.d.set(H,new fe(K.resultId,K.data)):this.d.set(H,new fe(M.resultId)),(0,a.$g$)({id:H,type:"delta",deltas:(M.edits||[]).map(U=>({start:U.start,deleteCount:U.deleteCount,data:U.data}))})}return null}}class ie{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeSemanticTokens(M,K,H){const U=this.d.getDocument(M),Q=await this.e.provideDocumentRangeSemanticTokens(U,I.Range.to(K),H);return Q?this.f(Q):null}f(M){return(0,a.$g$)({id:0,type:"full",data:M.data})}}class Se{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,K,H,U,Q){this.f=M,this.g=K,this.h=H,this.j=U,this.k=Q,this.d=new n.$$ec("CompletionItem"),this.e=new Map}async provideCompletionItems(M,K,H,U){const Q=this.f.getDocument(M),X=I.Position.to(K),ye=Q.getWordRangeAtPosition(X)||new L.$RK(X,X),Te=ye.with({end:X}),We=new o.$Od,He=await this.h.provideCompletionItems(Q,X,U,I.CompletionContext.to(H));if(!He||U.isCancellationRequested)return;const Ye=Array.isArray(He)?new L.$lL(He):He,st=Se.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),nt=new r.$Rc;this.e.set(st,nt);const tt=[],at={x:st,b:tt,a:{replace:I.Range.from(ye),insert:I.Range.from(Te)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let ct=0;ct<Ye.items.length;ct++){const ze=Ye.items[ct],vt=this.l(ze,[st,ct],Te,ye);tt.push(vt)}return at}async resolveCompletionItem(M,K){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...M);if(!H)return;const U=this.l(H,M),Q=await this.h.resolveCompletionItem(H,K);if(!Q)return;const X=this.l(Q,M);return(U.h!==X.h||U.i!==X.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(U.n!==X.n||U.o!==X.o||!(0,T.$mn)(U.p,X.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...U,d:X.d,c:X.c,l:X.l,h:X.h,i:X.i,n:X.n,o:X.o,p:X.p}}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K,H,U){const Q=this.e.get(K[0]);if(!Q)throw Error("DisposableStore is missing...");const X=this.g.toInternal(M.command,Q),ye={x:K,a:M.label,b:M.kind!==void 0?I.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(I.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:I.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(I.TextEdit.from),n:X?.$ident,o:X?.id,p:X?.$ident?void 0:X?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=M.textEdit.newText):typeof M.insertText=="string"?ye.h=M.insertText:M.insertText instanceof L.$1K&&(ye.h=M.insertText.value,ye.i|=4);let Te;return M.textEdit?Te=M.textEdit.range:M.range&&(Te=M.range),L.$RK.isRange(Te)?ye.j=I.Range.from(Te):Te&&(!H?.isEqual(Te.inserting)||!U?.isEqual(Te.replacing))&&(ye.j={insert:I.Range.from(Te.inserting),replace:I.Range.from(Te.replacing)}),ye}}class oe{async provideInlineCompletions(M,K,H,U){}disposeCompletions(M){}handleDidShowCompletionItem(M,K,H){}handlePartialAccept(M,K,H){}}class x extends oe{constructor(M,K,H,U){super(),this.f=M,this.g=K,this.h=H,this.j=U,this.d=new q,this.e=(0,i.$nF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$nF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,K,H,U){const Q=this.g.getDocument(M),X=I.Position.to(K),ye=await this.h.provideInlineCompletionItems(Q,X,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:I.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},U);if(!ye||U.isCancellationRequested)return;const Te=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],He=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:Te}),items:Te.map((nt,tt)=>{let at;nt.command&&(Ye||(Ye=new r.$Rc),at=this.j.toInternal(nt.command,Ye));const ct=nt.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:nt.filterText,range:nt.range?I.Range.from(nt.range):void 0,command:at,idx:tt,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:We.map(nt=>(Ye||(Ye=new r.$Rc),this.j.toInternal(nt,Ye))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,K,H){const U=this.d.get(M)?.items[K];U&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(U,H)}handlePartialAccept(M,K,H){const U=this.d.get(M)?.items[K];U&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(U,H)}}class q{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const K=this.e++;return this.d.set(K,M),K}disposeReferenceId(M){const K=this.d.get(M);return this.d.delete(M),K}get(M){return this.d.get(M)}}class ne{constructor(M,K){this.e=M,this.f=K,this.d=new n.$$ec("SignatureHelp")}async provideSignatureHelp(M,K,H,U){const Q=this.e.getDocument(M),X=I.Position.to(K),ye=this.g(H),Te=await this.f.provideSignatureHelp(Q,X,U,ye);if(Te){const We=this.d.add([Te]);return{...I.SignatureHelp.from(Te),id:We}}}g(M){let K;if(M.activeSignatureHelp){const H=I.SignatureHelp.to(M.activeSignatureHelp),U=this.d.get(M.activeSignatureHelp.id,0);U?(K=U,K.activeSignature=H.activeSignature,K.activeParameter=H.activeParameter):K=H}return{...M,activeSignatureHelp:K}}releaseSignatureHelp(M){this.d.delete(M)}}class Ie{constructor(M,K,H,U,Q){this.f=M,this.g=K,this.h=H,this.j=U,this.k=Q,this.d=new n.$$ec("InlayHints"),this.e=new Map}async provideInlayHints(M,K,H){const U=this.f.getDocument(M),Q=I.Range.to(K),X=await this.h.provideInlayHints(U,Q,H);if(!Array.isArray(X)||X.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`);return}if(H.isCancellationRequested)return;const ye=this.d.add(X);this.e.set(ye,new r.$Rc);const Te={hints:[],cacheId:ye};for(let We=0;We<X.length;We++)this.l(X[We],Q)&&Te.hints.push(this.m(X[We],[ye,We]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`),Te}async resolveInlayHint(M,K){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...M);if(!H)return;const U=await this.h.resolveInlayHint(H,K);if(U&&this.l(U))return this.m(U,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K){return M.label.length===0||Array.isArray(M.label)&&M.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(K&&!K.contains(M.position))}m(M,K){const H=this.e.get(K[0]);if(!H)throw Error("DisposableStore is missing...");const U={label:"",cacheId:K,tooltip:I.MarkdownString.fromStrict(M.tooltip),position:I.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(I.TextEdit.from),kind:M.kind&&I.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};if(typeof M.label=="string")U.label=M.label;else{const Q=[];U.label=Q;for(const X of M.label){if(!X.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ye={label:X.value,tooltip:I.MarkdownString.fromStrict(X.tooltip)};L.$2K.isLocation(X.location)&&(ye.location=I.location.from(X.location)),X.command&&(ye.command=this.g.toInternal(X.command,H)),Q.push(ye)}}return U}}class Ae{constructor(M,K){this.e=M,this.f=K,this.d=new n.$$ec("DocumentLink")}async provideLinks(M,K){const H=this.e.getDocument(M),U=await this.f.provideDocumentLinks(H,K);if(!(!Array.isArray(U)||U.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:U.filter(Ae.g).map(I.DocumentLink.from)};{const Q=this.d.add(U),X={links:[],cacheId:Q};for(let ye=0;ye<U.length;ye++){if(!Ae.g(U[ye]))continue;const Te=I.DocumentLink.from(U[ye]);Te.cacheId=[Q,ye],X.links.push(Te)}return X}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,K){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...M);if(!H)return;const U=await this.f.resolveDocumentLink(H,K);if(!(!U||!Ae.g(U)))return I.DocumentLink.from(U)}releaseLinks(M){this.d.delete(M)}}class Pe{constructor(M,K){this.d=M,this.e=K}async provideColors(M,K){const H=this.d.getDocument(M),U=await this.e.provideDocumentColors(H,K);return Array.isArray(U)?U.map(X=>({color:I.Color.from(X.color),range:I.Range.from(X.range)})):[]}async provideColorPresentations(M,K,H){const U=this.d.getDocument(M),Q=I.Range.to(K.range),X=I.Color.to(K.color),ye=await this.e.provideColorPresentations(X,{document:U,range:Q},H);if(Array.isArray(ye))return ye.map(I.ColorPresentation.from)}}class ae{constructor(M,K){this.d=M,this.e=K}async provideFoldingRanges(M,K,H){const U=this.d.getDocument(M),Q=await this.e.provideFoldingRanges(U,K,H);if(Array.isArray(Q))return Q.map(I.FoldingRange.from)}}class te{constructor(M,K,H){this.d=M,this.e=K,this.f=H}async provideSelectionRanges(M,K,H){const U=this.d.getDocument(M),Q=K.map(I.Position.to),X=await this.e.provideSelectionRanges(U,Q,H);if(!(0,A.$Lb)(X))return[];if(X.length!==Q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let Te=0;Te<Q.length;Te++){const We=[];ye.push(We);let He=Q[Te],Ye=X[Te];for(;;){if(!Ye.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(Ye)),!Ye.parent)break;He=Ye.range,Ye=Ye.parent}}return ye}}class J{constructor(M,K){this.f=M,this.g=K,this.d=new t.$WM(""),this.e=new Map}async prepareSession(M,K,H){const U=this.f.getDocument(M),Q=I.Position.to(K),X=await this.g.prepareCallHierarchy(U,Q,H);if(!X)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(X)?X.map(Te=>this.h(ye,Te)):[this.h(ye,X)]}async provideCallsTo(M,K,H){const U=this.j(M,K);if(!U)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyIncomingCalls(U,H);if(Q)return Q.map(X=>({from:this.h(M,X.from),fromRanges:X.fromRanges.map(ye=>I.Range.from(ye))}))}async provideCallsFrom(M,K,H){const U=this.j(M,K);if(!U)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyOutgoingCalls(U,H);if(Q)return Q.map(X=>({to:this.h(M,X.to),fromRanges:X.fromRanges.map(ye=>I.Range.from(ye))}))}releaseSession(M){this.e.delete(M)}h(M,K){const H=this.e.get(M),U=I.CallHierarchyItem.from(K,M,H.size.toString(36));return H.set(U._itemId,K),U}j(M,K){return this.e.get(M)?.get(K)}}class ee{constructor(M,K){this.f=M,this.g=K,this.d=new t.$WM(""),this.e=new Map}async prepareSession(M,K,H){const U=this.f.getDocument(M),Q=I.Position.to(K),X=await this.g.prepareTypeHierarchy(U,Q,H);if(!X)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(X)?X.map(Te=>this.h(ye,Te)):[this.h(ye,X)]}async provideSupertypes(M,K,H){const U=this.j(M,K);if(!U)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySupertypes(U,H);if(Q)return Q.map(X=>this.h(M,X))}async provideSubtypes(M,K,H){const U=this.j(M,K);if(!U)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySubtypes(U,H);if(Q)return Q.map(X=>this.h(M,X))}releaseSession(M){this.e.delete(M)}h(M,K){const H=this.e.get(M),U=I.TypeHierarchyItem.from(K,M,H.size.toString(36));return H.set(U._itemId,K),U}j(M,K){return this.e.get(M)?.get(K)}}class $e{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,H,U,Q){this.d=M,this.e=K,this.f=H,this.g=U,this.h=Q}async provideDocumentOnDropEdits(M,K,H,U,Q){const X=this.e.getDocument(K),ye=I.Position.to(H),Te=I.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,He)).buffer),We=await this.f.provideDocumentDropEdits(X,ye,Te,Q);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:$e.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ve{constructor(M,K){this.d=M,this.e=K}async provideMappedEdits(M,K,H,U){const Q=E.URI.revive(M),X=this.d.getDocument(Q),ye=H.documents.map(He=>He.map(Ye=>({uri:E.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(st=>I.Range.to(st))}))),Te={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(X,K,Te,U);return We?I.WorkspaceEdit.from(We):null}}class Fe{constructor(M,K){this.adapter=M,this.extension=K}}class le{static{this.d=0}constructor(M,K,H,U,Q,X,ye,Te){this.g=K,this.h=H,this.j=U,this.k=Q,this.l=X,this.m=ye,this.n=Te,this.f=new Map,this.e=M.getProxy($.$NK.MainThreadLanguageFeatures)}o(M,K){return I.DocumentSelector.from(M,this.g,K)}p(M){return new L.$PK(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return le.d++}async s(M,K,H,U,Q,X=!1){const ye=this.f.get(M);if(!ye||!(ye.adapter instanceof K))return U;const Te=Date.now();X||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const We=H(ye.adapter,ye.extension);return Promise.resolve(We).catch(He=>{(0,c.$4)(He)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(ye.extension.identifier,He))}).finally(()=>{X||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(Q)?(0,h.$Rg)(We,Q):We}t(M,K){const H=this.q();return this.f.set(H,new Fe(M,K)),H}static u(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,K,H,U){const Q=this.t(new u(this.h,H),M),X=U&&U.label||le.u(M);return this.e.$registerDocumentSymbolProvider(Q,this.o(K,M),X),this.p(Q)}$provideDocumentSymbols(M,K,H){return this.s(M,u,U=>U.provideDocumentSymbols(E.URI.revive(K),H),void 0,H)}registerCodeLensProvider(M,K,H){const U=this.q(),Q=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(U,new Fe(new d(this.h,this.j.converter,H,M,this.n,this.l),M)),this.e.$registerCodeLensSupport(U,this.o(K,M),Q);let X=this.p(U);if(Q!==void 0){const ye=H.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(Q));X=L.$PK.from(X,ye)}return X}$provideCodeLenses(M,K,H){return this.s(M,d,U=>U.provideCodeLenses(E.URI.revive(K),H),void 0,H)}$resolveCodeLens(M,K,H){return this.s(M,d,U=>U.resolveCodeLens(K,H),void 0,void 0)}$releaseCodeLenses(M,K){this.s(M,d,H=>Promise.resolve(H.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(M,K,H){const U=this.t(new f(this.h,H),M);return this.e.$registerDefinitionSupport(U,this.o(K,M)),this.p(U)}$provideDefinition(M,K,H,U){return this.s(M,f,Q=>Q.provideDefinition(E.URI.revive(K),H,U),[],U)}registerDeclarationProvider(M,K,H){const U=this.t(new k(this.h,H),M);return this.e.$registerDeclarationSupport(U,this.o(K,M)),this.p(U)}$provideDeclaration(M,K,H,U){return this.s(M,k,Q=>Q.provideDeclaration(E.URI.revive(K),H,U),[],U)}registerImplementationProvider(M,K,H){const U=this.t(new F(this.h,H),M);return this.e.$registerImplementationSupport(U,this.o(K,M)),this.p(U)}$provideImplementation(M,K,H,U){return this.s(M,F,Q=>Q.provideImplementation(E.URI.revive(K),H,U),[],U)}registerTypeDefinitionProvider(M,K,H){const U=this.t(new v(this.h,H),M);return this.e.$registerTypeDefinitionSupport(U,this.o(K,M)),this.p(U)}$provideTypeDefinition(M,K,H,U){return this.s(M,v,Q=>Q.provideTypeDefinition(E.URI.revive(K),H,U),[],U)}registerHoverProvider(M,K,H,U){const Q=this.t(new y(this.h,H),M);return this.e.$registerHoverProvider(Q,this.o(K,M)),this.p(Q)}$provideHover(M,K,H,U){return this.s(M,y,Q=>Q.provideHover(E.URI.revive(K),H,U),void 0,U)}registerEvaluatableExpressionProvider(M,K,H,U){const Q=this.t(new D(this.h,H),M);return this.e.$registerEvaluatableExpressionProvider(Q,this.o(K,M)),this.p(Q)}$provideEvaluatableExpression(M,K,H,U){return this.s(M,D,Q=>Q.provideEvaluatableExpression(E.URI.revive(K),H,U),void 0,U)}registerInlineValuesProvider(M,K,H,U){const Q=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,X=this.t(new N(this.h,H),M);this.e.$registerInlineValuesProvider(X,this.o(K,M),Q);let ye=this.p(X);if(Q!==void 0){const Te=H.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Q));ye=L.$PK.from(ye,Te)}return ye}$provideInlineValues(M,K,H,U,Q){return this.s(M,N,X=>X.provideInlineValues(E.URI.revive(K),H,U,Q),void 0,Q)}registerDocumentHighlightProvider(M,K,H){const U=this.t(new O(this.h,H),M);return this.e.$registerDocumentHighlightProvider(U,this.o(K,M)),this.p(U)}registerMultiDocumentHighlightProvider(M,K,H){const U=this.t(new W(this.h,H),M);return this.e.$registerMultiDocumentHighlightProvider(U,this.o(K,M)),this.p(U)}$provideDocumentHighlights(M,K,H,U){return this.s(M,O,Q=>Q.provideDocumentHighlights(E.URI.revive(K),H,U),void 0,U)}$provideMultiDocumentHighlights(M,K,H,U,Q){return this.s(M,W,X=>X.provideMultiDocumentHighlights(E.URI.revive(K),H,U.map(ye=>E.URI.revive(ye)),Q),void 0,Q)}registerLinkedEditingRangeProvider(M,K,H){const U=this.t(new z(this.h,H),M);return this.e.$registerLinkedEditingRangeProvider(U,this.o(K,M)),this.p(U)}$provideLinkedEditingRanges(M,K,H,U){return this.s(M,z,async Q=>{const X=await Q.provideLinkedEditingRanges(E.URI.revive(K),H,U);if(X)return{ranges:X.ranges,wordPattern:X.wordPattern?le.w(X.wordPattern):void 0}},void 0,U)}registerReferenceProvider(M,K,H){const U=this.t(new V(this.h,H),M);return this.e.$registerReferenceSupport(U,this.o(K,M)),this.p(U)}$provideReferences(M,K,H,U,Q){return this.s(M,V,X=>X.provideReferences(E.URI.revive(K),H,U,Q),void 0,Q)}registerCodeActionProvider(M,K,H,U){const Q=new r.$Rc,X=this.t(new P(this.h,this.j.converter,this.k,H,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(X,this.o(K,M),{providedKinds:U?.providedCodeActionKinds?.map(ye=>ye.value),documentation:U?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Q)}))},le.u(M),!!H.resolveCodeAction),Q.add(this.p(X)),Q}$provideCodeActions(M,K,H,U,Q){return this.s(M,P,X=>X.provideCodeActions(E.URI.revive(K),H,U,Q),void 0,Q)}$resolveCodeAction(M,K,H){return this.s(M,P,U=>U.resolveCodeAction(K,H),{},void 0)}$releaseCodeActions(M,K){this.s(M,P,H=>Promise.resolve(H.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(M,K,H){const U=this.t(new Z(this.h,H),M);return this.e.$registerDocumentFormattingSupport(U,this.o(K,M),M.identifier,M.displayName||M.name),this.p(U)}$provideDocumentFormattingEdits(M,K,H,U){return this.s(M,Z,Q=>Q.provideDocumentFormattingEdits(E.URI.revive(K),H,U),void 0,U)}registerDocumentRangeFormattingEditProvider(M,K,H){const U=typeof H.provideDocumentRangesFormattingEdits=="function",Q=this.t(new ce(this.h,H),M);return this.e.$registerRangeFormattingSupport(Q,this.o(K,M),M.identifier,M.displayName||M.name,U),this.p(Q)}$provideDocumentRangeFormattingEdits(M,K,H,U,Q){return this.s(M,ce,X=>X.provideDocumentRangeFormattingEdits(E.URI.revive(K),H,U,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(M,K,H,U,Q){return this.s(M,ce,X=>X.provideDocumentRangesFormattingEdits(E.URI.revive(K),H,U,Q),void 0,Q)}registerOnTypeFormattingEditProvider(M,K,H,U){const Q=this.t(new me(this.h,H),M);return this.e.$registerOnTypeFormattingSupport(Q,this.o(K,M),U,M.identifier),this.p(Q)}$provideOnTypeFormattingEdits(M,K,H,U,Q,X){return this.s(M,me,ye=>ye.provideOnTypeFormattingEdits(E.URI.revive(K),H,U,Q,X),void 0,X)}registerWorkspaceSymbolProvider(M,K){const H=this.t(new be(K,this.l),M);return this.e.$registerNavigateTypeSupport(H,typeof K.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(M,K,H){return this.s(M,be,U=>U.provideWorkspaceSymbols(K,H),{symbols:[]},H)}$resolveWorkspaceSymbol(M,K,H){return this.s(M,be,U=>U.resolveWorkspaceSymbol(K,H),void 0,void 0)}$releaseWorkspaceSymbols(M,K){this.s(M,be,H=>H.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(M,K,H){const U=this.t(new ke(this.h,H,this.l),M);return this.e.$registerRenameSupport(U,this.o(K,M),ke.supportsResolving(H)),this.p(U)}$provideRenameEdits(M,K,H,U,Q){return this.s(M,ke,X=>X.provideRenameEdits(E.URI.revive(K),H,U,Q),void 0,Q)}$resolveRenameLocation(M,K,H,U){return this.s(M,ke,Q=>Q.resolveRenameLocation(E.URI.revive(K),H,U),void 0,U)}registerDocumentSemanticTokensProvider(M,K,H,U){const Q=this.t(new de(this.h,H),M),X=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Q,this.o(K,M),U,X);let ye=this.p(Q);if(X){const Te=H.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(X));ye=L.$PK.from(ye,Te)}return ye}$provideDocumentSemanticTokens(M,K,H,U){return this.s(M,de,Q=>Q.provideDocumentSemanticTokens(E.URI.revive(K),H,U),null,U)}$releaseDocumentSemanticTokens(M,K){this.s(M,de,H=>H.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,K,H,U){const Q=this.t(new ie(this.h,H),M);return this.e.$registerDocumentRangeSemanticTokensProvider(Q,this.o(K,M),U),this.p(Q)}$provideDocumentRangeSemanticTokens(M,K,H,U){return this.s(M,ie,Q=>Q.provideDocumentRangeSemanticTokens(E.URI.revive(K),H,U),null,U)}registerCompletionItemProvider(M,K,H,U){const Q=this.t(new Se(this.h,this.j.converter,H,this.m,M),M);return this.e.$registerCompletionsProvider(Q,this.o(K,M),U,Se.supportsResolving(H),M.identifier),this.p(Q)}$provideCompletionItems(M,K,H,U,Q){return this.s(M,Se,X=>X.provideCompletionItems(E.URI.revive(K),H,U,Q),void 0,Q)}$resolveCompletionItem(M,K,H){return this.s(M,Se,U=>U.resolveCompletionItem(K,H),void 0,H)}$releaseCompletionItems(M,K){this.s(M,Se,H=>H.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(M,K,H,U){const Q=new x(M,this.h,H,this.j.converter),X=this.t(Q,M);return this.e.$registerInlineCompletionsSupport(X,this.o(K,M),Q.supportsHandleEvents,b.$hm.toKey(M.identifier.value),U?.yieldTo?.map(ye=>b.$hm.toKey(ye))||[]),this.p(X)}$provideInlineCompletions(M,K,H,U,Q){return this.s(M,oe,X=>X.provideInlineCompletions(E.URI.revive(K),H,U,Q),void 0,Q)}$handleInlineCompletionDidShow(M,K,H,U){this.s(M,oe,async Q=>{Q.handleDidShowCompletionItem(K,H,U)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,K,H,U){this.s(M,oe,async Q=>{Q.handlePartialAccept(K,H,U)},void 0,void 0)}$freeInlineCompletionsList(M,K){this.s(M,oe,async H=>{H.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(M,K,H,U){const Q=Array.isArray(U)?{triggerCharacters:U,retriggerCharacters:[]}:U,X=this.t(new ne(this.h,H),M);return this.e.$registerSignatureHelpProvider(X,this.o(K,M),Q),this.p(X)}$provideSignatureHelp(M,K,H,U,Q){return this.s(M,ne,X=>X.provideSignatureHelp(E.URI.revive(K),H,U,Q),void 0,Q)}$releaseSignatureHelp(M,K){this.s(M,ne,H=>H.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(M,K,H){const U=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,Q=this.t(new Ie(this.h,this.j.converter,H,this.l,M),M);this.e.$registerInlayHintsProvider(Q,this.o(K,M),typeof H.resolveInlayHint=="function",U,le.u(M));let X=this.p(Q);if(U!==void 0){const ye=H.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(U));X=L.$PK.from(X,ye)}return X}$provideInlayHints(M,K,H,U){return this.s(M,Ie,Q=>Q.provideInlayHints(E.URI.revive(K),H,U),void 0,U)}$resolveInlayHint(M,K,H){return this.s(M,Ie,U=>U.resolveInlayHint(K,H),void 0,H)}$releaseInlayHints(M,K){this.s(M,Ie,H=>H.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(M,K,H){const U=this.t(new Ae(this.h,H),M);return this.e.$registerDocumentLinkProvider(U,this.o(K,M),typeof H.resolveDocumentLink=="function"),this.p(U)}$provideDocumentLinks(M,K,H){return this.s(M,Ae,U=>U.provideLinks(E.URI.revive(K),H),void 0,H,K.scheme==="output")}$resolveDocumentLink(M,K,H){return this.s(M,Ae,U=>U.resolveLink(K,H),void 0,void 0,!0)}$releaseDocumentLinks(M,K){this.s(M,Ae,H=>H.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(M,K,H){const U=this.t(new Pe(this.h,H),M);return this.e.$registerDocumentColorProvider(U,this.o(K,M)),this.p(U)}$provideDocumentColors(M,K,H){return this.s(M,Pe,U=>U.provideColors(E.URI.revive(K),H),[],H)}$provideColorPresentations(M,K,H,U){return this.s(M,Pe,Q=>Q.provideColorPresentations(E.URI.revive(K),H,U),void 0,U)}registerFoldingRangeProvider(M,K,H){const U=this.q(),Q=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(U,new Fe(new ae(this.h,H),M)),this.e.$registerFoldingRangeProvider(U,this.o(K,M),M.identifier,Q);let X=this.p(U);if(Q!==void 0){const ye=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Q));X=L.$PK.from(X,ye)}return X}$provideFoldingRanges(M,K,H,U){return this.s(M,ae,Q=>Q.provideFoldingRanges(E.URI.revive(K),H,U),void 0,U)}registerSelectionRangeProvider(M,K,H){const U=this.t(new te(this.h,H,this.l),M);return this.e.$registerSelectionRangeProvider(U,this.o(K,M)),this.p(U)}$provideSelectionRanges(M,K,H,U){return this.s(M,te,Q=>Q.provideSelectionRanges(E.URI.revive(K),H,U),[],U)}registerCallHierarchyProvider(M,K,H){const U=this.t(new J(this.h,H),M);return this.e.$registerCallHierarchyProvider(U,this.o(K,M)),this.p(U)}$prepareCallHierarchy(M,K,H,U){return this.s(M,J,Q=>Promise.resolve(Q.prepareSession(E.URI.revive(K),H,U)),void 0,U)}$provideCallHierarchyIncomingCalls(M,K,H,U){return this.s(M,J,Q=>Q.provideCallsTo(K,H,U),void 0,U)}$provideCallHierarchyOutgoingCalls(M,K,H,U){return this.s(M,J,Q=>Q.provideCallsFrom(K,H,U),void 0,U)}$releaseCallHierarchy(M,K){this.s(M,J,H=>Promise.resolve(H.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(M,K,H){const U=this.t(new ee(this.h,H),M);return this.e.$registerTypeHierarchyProvider(U,this.o(K,M)),this.p(U)}$prepareTypeHierarchy(M,K,H,U){return this.s(M,ee,Q=>Promise.resolve(Q.prepareSession(E.URI.revive(K),H,U)),void 0,U)}$provideTypeHierarchySupertypes(M,K,H,U){return this.s(M,ee,Q=>Q.provideSupertypes(K,H,U),void 0,U)}$provideTypeHierarchySubtypes(M,K,H,U){return this.s(M,ee,Q=>Q.provideSubtypes(K,H,U),void 0,U)}$releaseTypeHierarchy(M,K){this.s(M,ee,H=>Promise.resolve(H.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(M,K,H,U){const Q=this.q();this.f.set(Q,new Fe(new $e(this.e,this.h,H,Q,M),M));const X=(0,i.$nF)(M,"dropMetadata")&&U?$e.toInternalProviderId(M.identifier.value,U.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Q,this.o(K,M),X,(0,i.$nF)(M,"dropMetadata")?U:void 0),this.p(Q)}$provideDocumentOnDropEdits(M,K,H,U,Q,X){return this.s(M,$e,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(K,E.URI.revive(H),U,Q,X)),void 0,void 0)}registerMappedEditsProvider(M,K,H){const U=this.t(new ve(this.h,H),M);return this.e.$registerMappedEditsProvider(U,this.o(K,M)),this.p(U)}$provideMappedEdits(M,K,H,U,Q){return this.s(M,ve,X=>Promise.resolve(X.provideMappedEdits(K,H,U,Q)),null,Q)}registerDocumentPasteEditProvider(M,K,H,U){const Q=this.q();this.f.set(Q,new Fe(new C(this.e,this.h,H,Q,M),M));const X=C.toInternalProviderId(M.identifier.value,U.id);return this.e.$registerPasteEditProvider(Q,this.o(K,M),X,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:U.copyMimeTypes,pasteMimeTypes:U.pasteMimeTypes}),this.p(Q)}$prepareDocumentPaste(M,K,H,U,Q){return this.s(M,C,X=>X.prepareDocumentPaste(E.URI.revive(K),H,U,Q),void 0,Q)}$providePasteEdits(M,K,H,U,Q,X){return this.s(M,C,ye=>ye.providePasteEdits(K,E.URI.revive(H),U,Q,X),void 0,X)}static w(M){return{pattern:M.source,flags:M.flags}}static y(M){return{decreaseIndentPattern:le.w(M.decreaseIndentPattern),increaseIndentPattern:le.w(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?le.w(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?le.w(M.unIndentedLinePattern):void 0}}static z(M){return{beforeText:le.w(M.beforeText),afterText:M.afterText?le.w(M.afterText):void 0,previousLineText:M.previousLineText?le.w(M.previousLineText):void 0,action:M.action}}static B(M){return M.map(le.z)}static C(M){return{open:M.open,close:M.close,notIn:M.notIn?M.notIn.map(K=>L.SyntaxTokenType.toString(K)):void 0}}static D(M){return M.map(le.C)}setLanguageConfiguration(M,K,H){const{wordPattern:U}=H;if(U&&(0,g.$Ue)(U))throw new Error(`Invalid language configuration: wordPattern '${U}' is not allowed to match the empty string.`);U?this.h.setWordDefinitionFor(K,U):this.h.setWordDefinitionFor(K,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const Q=this.q(),X={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?le.w(H.wordPattern):void 0,indentationRules:H.indentationRules?le.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?le.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?le.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Q,K,X),this.p(Q)}$setWordDefinitions(M){for(const K of M)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$ifc=le}),define(Ce[255],Re([1,0,3,8,7,31,13,6,23]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class w{constructor(S,l,p,b){this.c=l,this.d=p,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$NK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const p=this.c.getDocumentData(S);if(!p)throw new Error(`document '${S.toString()}' NOT found`);return p.document}async tokenAtPosition(S,l){const p=S.version,b=T.Position.from(l),r=await this.a.$tokensAtPosition(S.uri,b),a={type:I.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new I.$RK(l.line,l.character,l.line,l.character)};if(!r)return a;const t={range:T.Range.to(r.range),type:T.TokenType.to(r.type)};return!t.range.contains(l)||p!==S.version?a:t}createLanguageStatusItem(S,l,p){const b=this.f++,r=this.a,a=this.g,t=`${S.identifier.value}/${l}`;if(a.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);a.add(t);const n={selector:p,id:l,name:S.displayName??S.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new $.$Rc,h=()=>{if(o?.dispose(),!a.has(t)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,R.$4g)(()=>{c.clear(),this.a.$setLanguageStatus(b,{id:t,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===I.LanguageStatusSeverity.Error?L.default.Error:n.severity===I.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),o?.dispose(),r.$removeLanguageStatus(b),a.delete(t)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,h()},get selector(){return n.selector},set selector(s){n.selector=s,h()},get text(){return n.text},set text(s){n.text=s,h()},set text2(s){(0,g.$oF)(S,"languageStatusText"),n.text=s,h()},get text2(){return(0,g.$oF)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,h()},get severity(){return n.severity},set severity(s){n.severity=s,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,h()},get command(){return n.command},set command(s){n.command=s,h()},get busy(){return n.busy},set busy(s){n.busy=s,h()}};return h(),i}}e.$Hgc=w}),define(Ce[82],Re([1,0,21,11,2,4,15,3,27,17]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=e.$6fc=void 0;let A=class{constructor(l,p,b){this.f=b,this.d=new Map,this.a=p.getProxy($.$NK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,p){const{message:b,args:r,comment:a}=p;if(this.c)return(0,T.$Ie)(b,r??{});let t=b;a&&a.length>0&&(t+=`/${Array.isArray(a)?a.join(""):a}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$Ie)(n??b,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const b=await this.g(l);if(!b){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(b),a=JSON.parse(r);p=l.isBuiltin?a.contents?.bundle:a}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${b}: ${r.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:b})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive(p)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$6fc=A,e.$6fc=A=Ge([Ke(0,g.$8M),Ke(1,w.$RM),Ke(2,R.$jj)],A),e.$7fc=(0,L.$2h)("IExtHostLocalizationService")}),define(Ce[256],Re([1,0,15,3,27,17,2,51]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let g=class extends E.$uj{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,$.$yh)(p))),this.r=S.getProxy(T.$NK.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(R.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,p){return new w(this.r,S,l,p)}};e.$ghc=g,e.$ghc=g=Ge([Ke(0,L.$RM),Ke(1,I.$8M)],g);class w extends E.$pj{constructor(S,l,p,b){super(b?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,b).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const p=[[S,l]];this.m?this.u(p):this.n.push(...p)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Ce[83],Re([1,0,3,4,6,17,24]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0,e.$8fc=(0,T.$2h)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$NK.MainThreadManagedSockets)}setFactory(S,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,p=await this.c.makeConnection(),b=new I.$Rc;return this.d.set(l,new w(l,p,b)),b.add((0,I.$Qc)(()=>this.d.delete(l))),b.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),b.dispose()})),b.add(p.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),b.dispose()})),b.add(p.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$ge.wrap(r)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$9fc=$,e.$9fc=$=Ge([Ke(0,L.$RM)],$);class g{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class w extends I.$Sc{constructor(S,l,p){super(),this.socketId=S,this.actual=l,this.B(p)}}}),define(Ce[257],Re([1,0,3,15,23]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;function L($){return $&&$.title}let R=class{constructor(g,w){this.b=w,this.a=g.getProxy(E.$NK.MainThreadMessageService)}showMessage(g,w,A,S,l){const p={source:{identifier:g.identifier,label:g.displayName||g.name}};let b;typeof S=="string"||L(S)?b=[S,...l]:(p.modal=S?.modal,p.useCustom=S?.useCustom,p.detail=S?.detail,b=l),p.useCustom&&(0,I.$oF)(g,"resolvers");const r=[];let a=!1;for(let t=0;t<b.length;t++){const n=b[t];if(typeof n=="string")r.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:o,isCloseAffordance:c}=n;r.push({title:o,isCloseAffordance:!!c,handle:t}),c&&(a?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,n):a=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,n)}return this.a.$showMessage(w,A,p,r).then(t=>{if(typeof t=="number")return b[t]})}};e.$Igc=R,e.$Igc=R=Ge([Ke(1,T.$jj)],R)}),define(Ce[258],Re([1,0,18,13,20,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0;let o=class{constructor(f,k,F,v,y){this.m=k,this.n=F,this.o=v,this.q=y,this.b=new $.$Ac,this.c=new $.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=f.getProxy(S.$NK.MainThreadNotebookKernels);const D=new l.$fN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$dN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],l.$eN.Void);this.o.registerApiCommand(D)}createNotebookController(f,k,F,v,y,D){for(const ie of this.j.values())if(ie.controller.id===k&&w.$hm.equals(f.identifier,ie.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${f.identifier.value}, ${k}`);const W=()=>console.warn(`NO execute handler from notebook controller '${C.id}' of extension: '${f.identifier}'`);let z=!1;const V=new L.$Sd,P=new L.$Sd,C={id:d(f.identifier,k),notebookType:F,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:v||f.identifier.value,preloads:D?D.map(p.NotebookRendererScript.from):[]};let Z=y??W,ce,me;this.a.$addKernel(N,C).catch(ie=>{console.log(ie),z=!0});let be=0;const ke=()=>{if(z)return;const ie=++be;Promise.resolve().then(()=>{ie===be&&this.a.$updateKernel(N,C)})},fe=new $.$Ac,de={get id(){return k},get notebookType(){return C.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return C.label},set label(ie){C.label=ie??f.displayName??f.name,ke()},get detail(){return C.detail??""},set detail(ie){C.detail=ie,ke()},get description(){return C.description??""},set description(ie){C.description=ie,ke()},get supportedLanguages(){return C.supportedLanguages},set supportedLanguages(ie){C.supportedLanguages=ie,ke()},get supportsExecutionOrder(){return C.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){C.supportsExecutionOrder=ie,ke()},get rendererScripts(){return C.preloads?C.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(ie){Z=ie??W},get interruptHandler(){return ce},set interruptHandler(ie){ce=ie,C.supportsInterrupt=!!ie,ke()},set variableProvider(ie){(0,t.$oF)(f,"notebookVariableProvider"),me=ie,C.hasVariableProvider=!!ie,ie?.onDidChangeVariables(Se=>O.a.$variablesUpdated(Se.uri)),ke()},get variableProvider(){return me},createNotebookCellExecution(ie){if(z)throw new Error("notebook controller is DISPOSED");if(!fe.has(ie.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(fe.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return O._createNotebookCellExecution(ie,d(f.identifier,this.id))},createNotebookExecution(ie){if((0,t.$oF)(f,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!fe.has(ie.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(fe.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.uri.toString()}`);return O._createNotebookExecution(ie,d(f.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${N}], DISPOSED`),z=!0,this.j.delete(N),V.dispose(),P.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ie,Se){Se===b.NotebookControllerAffinity2.Hidden&&(0,t.$oF)(f,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,ie.uri,Se)},onDidReceiveMessage:P.event,postMessage(ie,Se){return(0,t.$oF)(f,"notebookMessaging"),O.a.$postMessage(N,Se&&O.n.getIdByEditor(Se),ie)},asWebviewUri(ie){return(0,t.$oF)(f,"notebookMessaging"),(0,r.$ivb)(ie,O.m.remote)}};return this.j.set(N,{extensionId:f.identifier,controller:de,onDidReceiveMessage:P,onDidChangeSelection:V,associatedNotebooks:fe}),de}getIdByController(f){for(const[k,F]of this.j)if(F.controller===f)return d(F.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,k){const F=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${F}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(F,k);const y={dispose:()=>{this.f.delete(F),v.a.$removeKernelDetectionTask(F)}};return this.f.set(F,y),y}registerKernelSourceActionProvider(f,k,F){const v=this.i++,y=typeof F.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,D=this;this.h.set(v,F),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,k);let N;return y!==void 0&&(N=F.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(v),D.a.$removeKernelSourceActionProvider(v,v),N?.dispose()}}}async $provideKernelSourceActions(f,k){const F=this.h.get(f);if(F){const v=new R.$Rc;return(await F.provideNotebookKernelSourceActions(k)??[]).map(D=>p.NotebookKernelSourceAction.from(D,this.o.converter,v))}return[]}$acceptNotebookAssociation(f,k,F){const v=this.j.get(f);if(v){const y=this.n.getNotebookDocument(g.URI.revive(k));F?v.associatedNotebooks.set(y.uri,!0):v.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),F),v.onDidChangeSelection.fire({selected:F,notebook:y.apiNotebook})}}async $executeCells(f,k,F){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(k)),D=[];for(const N of F){const O=y.getCell(N);O&&D.push(O.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),D.length),await v.controller.executeHandler.call(v.controller,D,y.apiNotebook,v.controller)}catch(N){this.q.error(`NotebookController[${f}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(f,k,F){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument(g.URI.revive(k));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,y.apiNotebook);else for(const D of F){const N=y.getCell(D);N&&this.b.get(N.uri)?.cancel()}if(v.controller.interruptHandler){const D=this.c.get(y.uri);F.length&&Array.isArray(D)&&D.length&&D.forEach(N=>N.dispose())}}async $provideVariables(f,k,F,v,y,D,N){const O=this.j.get(f);if(!O)return;const W=this.n.getNotebookDocument(g.URI.revive(F)),z=O.controller.variableProvider;if(!z)return;const V=v?{name:v,value:""}:void 0,P=y==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,C=z.provideVariables(W.apiNotebook,V,P,D,N);for await(const Z of C){if(N.isCancellationRequested)return;this.a.$receiveVariable(k,Z)}}$acceptKernelMessageFromRenderer(f,k,F){const v=this.j.get(f);if(!v)return;const y=this.n.getEditorById(k);v.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:F}))}$cellExecutionChanged(f,k,F){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(k);if(y){const D=F?p.NotebookCellExecutionState.to(F):b.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:y.apiCell,state:D})}}_createNotebookCellExecution(f,k){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const y=new h(k,v,this.a);this.b.set(v.uri,y);const D=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),D.dispose(),this.b.delete(v.uri))});return y.asApiObject()}_createNotebookExecution(f,k){const F=this.n.getNotebookDocument(f.uri),v=f.getCells().find(N=>{const O=F.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(F.uri))throw new Error(`duplicate notebook execution for ${F.uri}`);const y=new s(k,F,this.a),D=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),D.dispose(),this.c.delete(F.uri))});return this.c.set(F.uri,[y,D]),y.asApiObject()}};e.$Mgc=o,e.$Mgc=o=Ge([Ke(4,A.$jj)],o);var c;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(c||(c={}));class h extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(f,k,F){super(),this.m=k,this.n=F,this.b=h.a++,this.c=new L.$Sd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new I.$3d),this.h=new u(10,v=>this.s(v)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const k=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Fv(k))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let k=this.m;if(f&&(k=this.m.notebook.getCellFromApiCell(f)),!k)throw new Error("INVALID cell");return k.handle}y(f){return f.map(k=>{const F=b.$fM.ensureUniqueMimeTypes(k.items,!0);return F===k.items?p.NotebookCellOutput.from(k):p.NotebookCellOutput.from({items:F,id:k.id,metadata:k.metadata})})}async z(f,k,F){const v=this.w(k),y=this.y((0,E.$3b)(f));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:v,append:F,outputs:y})}async C(f,k,F){return f=b.$fM.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:f.map(p.NotebookCellOutputItem.from),outputId:k.id,append:F})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(F){f.j=F,f.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(F){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:F})},end(F,v){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new n.$Fv({runEndTime:v,lastRunSuccess:F}))},clearOutput(F){return f.t(),f.z([],F,!1)},appendOutput(F,v){return f.t(),f.z(F,v,!0)},replaceOutput(F,v){return f.t(),f.z(F,v,!1)},appendOutputItems(F,v){return f.t(),f.C(F,v,!0)},replaceOutputItems(F,v){return f.t(),f.C(F,v,!1)}})}}var i;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(i||(i={}));class s extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(f,k,F){super(),this.h=k,this.j=F,this.b=s.a++,this.c=new L.$Sd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new I.$3d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,k){this.f=f,this.g=k,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$mh,this.b=Date.now(),(0,T.$3g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>f.complete())}}function d(m,f){return`${m.value}/${f}`}e.$Ngc=d}),define(Ce[259],Re([1,0,5,3,107]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;class L{constructor($,g){this.c=g,this.a=new Map,this.b=$.getProxy(T.$NK.MainThreadNotebookRenderers)}$postRendererMessage($,g,w){const A=this.c.getEditorById($);this.a.get(g)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging($,g){if(!$.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,S,l)=>this.d(g).event(A,S,l),postMessage:(A,S)=>{I.$ugc.apiEditorsToExtHost.has(A)&&([A,S]=[S,A]);const l=S&&I.$ugc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,g,A)}}}d($){let g=this.a.get($);return g||(g=new E.$Sd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete($)}}),this.a.set($,g),g)}}e.$Ogc=L}),define(Ce[260],Re([1,0,6,16,2,23,3]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;class ${constructor(w){this.b=new Map,this.a=w.getProxy(R.$NK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,A,S){if((0,L.$oF)(w,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,S),this.a.$registerProfileContentHandler(A,S.name,S.description,w.identifier.value),(0,E.$Qc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,S,l){const p=this.b.get(w);if(!p)throw new Error(`Unknown handler with id: ${w}`);return p.saveProfile(A,S,l)}async $readProfile(w,A,S){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,T.$Ef)(A)?A:I.URI.revive(A),S)}}e.$Rgc=$}),define(Ce[261],Re([1,0,2,3,13,8]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class R{static{this.a=0}constructor(g,w){this.d=w,this.c=new Map,this.b=g.getProxy(T.$NK.MainThreadQuickDiff)}$provideOriginalResource(g,w,A){const S=E.URI.revive(w),l=this.c.get(g);return l?(0,I.$Ug)(()=>l.provideOriginalResource(S,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(g,w,A,S){const l=R.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,L.DocumentSelector.from(g,this.d),A,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Tgc=R}),define(Ce[262],Re([1,0,20,5,6,3,2,7,14,18,31,45,23,8]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;function b(r,a,t){const n=r.getProxy(L.$NK.MainThreadQuickOpen);class o{constructor(k,F){this.e=new Map,this.f=0,this.a=k,this.b=F}showQuickPick(k,F,v,y=E.CancellationToken.None){this.c=void 0;const D=Promise.resolve(F),N=++this.f,O=n.$show(N,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},y),W={},z=O.then(()=>W);return Promise.race([z,D]).then(V=>{if(V===W)return;const P=(0,l.$nF)(k,"quickPickItemTooltip");return D.then(C=>{const Z=[];for(let ce=0;ce<C.length;ce++){const me=C[ce];if(typeof me=="string")Z.push({label:me,handle:ce});else if(me.kind===$.QuickPickItemKind.Separator)Z.push({type:"separator",label:me.label});else{me.tooltip&&!P&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const be=me.iconPath?u(me.iconPath):void 0;Z.push({label:me.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(me.tooltip):void 0,handle:ce})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=ce=>{v.onDidSelectItem(C[ce])}),n.$setItems(N,Z),O.then(ce=>{if(typeof ce=="number")return C[ce];if(Array.isArray(ce))return ce.map(me=>C[me])})})}).then(void 0,V=>{if(!(0,g.$4)(V))return n.$setError(N,V),Promise.reject(V)})}$onItemSelected(k){this.c?.(k)}showInput(k,F=E.CancellationToken.None){return this.d=k?.validateInput,n.$input(k,typeof this.d=="function",F).then(void 0,v=>{if(!(0,g.$4)(v))return Promise.reject(v)})}async $validateInput(k){if(!this.d)return;const F=await this.d(k);if(!F||typeof F=="string")return F;let v;switch(F.severity){case $.InputBoxValidationSeverity.Info:v=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=F.message?A.default.Error:A.default.Ignore;break}return{content:F.message,severity:v}}async showWorkspaceFolderPick(k,F=E.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!v)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===v.uri.toString())}createQuickPick(k){const F=new d(k,()=>this.e.delete(F._id));return this.e.set(F._id,F),F}createInputBox(k){const F=new m(k,()=>this.e.delete(F._id));return this.e.set(F._id,F),F}$onDidChangeValue(k,F){this.e.get(k)?._fireDidChangeValue(F)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,F){const v=this.e.get(k);v instanceof d&&v._fireDidChangeActive(F)}$onDidChangeSelection(k,F){const v=this.e.get(k);v instanceof d&&v._fireDidChangeSelection(F)}$onDidTriggerButton(k,F){this.e.get(k)?._fireDidTriggerButton(F)}$onDidTriggerItemButton(k,F,v){const y=this.e.get(k);y instanceof d&&y._fireDidTriggerItemButton(F,v)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class c{static{this.a=1}constructor(k,F){this.x=k,this.y=F,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Sd,this.q=new T.$Sd,this.r=new T.$Sd,this.s=new T.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((F,v)=>{const y=F===$.$$L.Back?-1:v;this.o.set(y,F)}),this.z({buttons:k.map((F,v)=>({...u(F.iconPath),tooltip:F.tooltip,handle:F===$.$$L.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const F=this.o.get(k);F&&this.r.fire(F)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(k){if(!this.v){for(const F of Object.keys(k)){const v=k[F];this.u[F]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof $.$KL)return{id:f.id};const k=s(f),F=i(f);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof F=="string"?R.URI.file(F):F}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const k=h(f);let F,v;return"id"in k?v=S.ThemeIcon.asClassName(k):F=k,{iconPath:F,iconClass:v}}class d extends c{constructor(k,F){super(k.identifier,F),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Sd,this.L=[],this.M=new T.$Sd,this.N=new T.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const F=(0,l.$nF)(this.O,"quickPickItemTooltip"),v=[];for(let y=0;y<k.length;y++){const D=k[y];if(D.kind===$.QuickPickItemKind.Separator)v.push({type:"separator",label:D.label});else{D.tooltip&&!F&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=D.iconPath?u(D.iconPath):void 0;v.push({handle:y,label:D.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:F?p.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((O,W)=>({...u(O.iconPath),tooltip:O.tooltip,handle:W}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(F=>this.D.has(F)),this.z({activeItems:this.J.map(F=>this.D.get(F))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(F=>this.D.has(F)),this.z({selectedItems:this.L.map(F=>this.D.get(F))})}_fireDidChangeActive(k){const F=(0,w.$Hb)(k.map(v=>this.C.get(v)));this.J=F,this.K.fire(F)}_fireDidChangeSelection(k){const F=(0,w.$Hb)(k.map(v=>this.C.get(v)));this.L=F,this.M.fire(F)}_fireDidTriggerItemButton(k,F){const v=this.C.get(k);if(!v||!v.buttons||!v.buttons.length)return;const y=v.buttons[F];y&&this.N.fire({button:y,item:v})}}class m extends c{constructor(k,F){super(k.identifier,F),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:A.default.Error}):this.z({validationMessage:k.message,severity:k.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new o(a,t)}e.$Ugc=b}),define(Ce[263],Re([1,0,2,5,66,6,13,3,18,138,15,22,45,8,23,12,21]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0;function n(N){return N instanceof E.URI}function o(N,O){return N.scheme===r.Schemas.file&&O.scheme===r.Schemas.file&&a.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function c(N){if(N)return typeof N.iconPath=="string"?E.URI.file(N.iconPath):E.URI.isUri(N.iconPath)||l.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function h(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(l.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function i(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const W=typeof N.iconPath=="string"?N.iconPath:E.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,z=typeof O.iconPath=="string"?O.iconPath:E.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,w.$Fq)(W,z)}function s(N,O){let W=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(W=i(N,O),W!==0)return W;if(N.light&&O.light)W=i(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(W!==0)return W;if(N.dark&&O.dark)W=i(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return W}function u(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let W=0;W<N.arguments.length;W++){const z=N.arguments[W],V=O.arguments[W];if(z!==V&&!(n(z)&&n(V)&&o(z,V)))return z<V?-1:1}return 0}function d(N,O){let W=(0,w.$Fq)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(W!==0)return W;if(N.command&&O.command)W=u(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(W!==0)return W;if(N.decorations&&O.decorations)W=s(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}return W}function m(N,O){for(let W=0;W<N.length;W++)if(N[W]!==O[W])return!1;return!0}function f(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?m(N.arguments,O.arguments):N.arguments===O.arguments)}function k(N,O){return(0,g.$ub)(N,O,f)}class F{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,b.$oF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,b.$oF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,b.$oF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,W,z,V,P){this.k=O,this.l=V,this.m=P,this.d="",this.e=new T.$Sd,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=z}showValidationMessage(O,W){(0,b.$oF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,W)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Vgc=F;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,W,z,V,P){this.q=O,this.s=W,this.t=z,this.u=V,this.v=P,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,W){const z=this.h.get(O);return z?(0,R.$Ug)(()=>this.s.executeCommand(z.command,...z.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(d),z=(0,g.$Db)(this.o,O,d).map(C=>{const Z=C.toInsert.map(ce=>{const me=this.e++;this.g.set(me,ce);const be=ce.resourceUri;let ke;if(ce.command)if(ce.command.command==="vscode.open"||ce.command.command==="vscode.diff"||ce.command.command==="vscode.changes"){const Ae=new L.$Rc;ke=this.s.converter.toInternal(ce.command,Ae),this.j.set(me,Ae)}else this.h.set(me,ce.command);const fe=c(ce.decorations),de=ce.decorations&&c(ce.decorations.light)||fe,ie=ce.decorations&&c(ce.decorations.dark)||fe,Se=[de,ie],oe=ce.decorations&&ce.decorations.tooltip||"",x=ce.decorations&&!!ce.decorations.strikeThrough,q=ce.decorations&&!!ce.decorations.faded,ne=ce.contextValue||"";return{rawResource:[me,be,Se,oe,x,q,ne,ke],handle:me}});return{start:C.start,deleteCount:C.deleteCount,toInsert:Z}}),V=z.map(({start:C,deleteCount:Z,toInsert:ce})=>[C,Z,ce.map(me=>me.rawResource)]),P=z.reverse();for(const{start:C,deleteCount:Z,toInsert:ce}of P){const me=ce.map(ke=>ke.handle),be=this.n.splice(C,Z,...me);for(const ke of be)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=O,V}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let W;(0,b.$nF)(this.x,"quickDiffProvider")&&(W=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:W})}get historyProvider(){return(0,b.$oF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,b.$oF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new L.$Rc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new L.$Rc,this.o=O;const W=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,b.$oF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,b.$oF)(this.x,"scmActionButton"),this.p.value=new L.$Rc,this.q=O;const W=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(z=>z.map(V=>this.y.converter.toInternal(V,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&k(this.t,O))return;this.s.value=new L.$Rc,this.t=O;const W=(O||[]).map(z=>this.y.converter.toInternal(z,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(O,W,z,V,P,C,Z){this.x=O,this.y=V,this.z=P,this.A=C,this.B=Z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Tc,this.m=void 0,this.n=new L.$Tc,this.o=void 0,this.p=new L.$Tc,this.s=new L.$Tc,this.t=void 0,this.u=!1,this.v=new T.$Sd,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=z;const ce=E.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${P}/scm${this.w}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this.f=new F(O,W,this.#e,this.w,ce),this.#e.$registerSourceControl(this.w,P,C,Z,ce)}createResourceGroup(O,W){const z=new v(this.#e,this.y,this.w,O,W),V=T.Event.once(z.onDidDispose)(()=>this.C.delete(z));return this.C.set(z,V),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const O=[],W=[];for(const[z,V]of this.C){V.dispose();const P=z.onDidUpdateResourceStates(()=>{this.D.add(z),this.eventuallyUpdateResourceStates()});T.Event.once(z.onDidDispose)(()=>{this.D.delete(z),P.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.w,z.handle)}),O.push([z.handle,z.id,z.label,z.features]);const C=z._takeResourceStateSnapshot();C.length>0&&W.push([z.handle,C]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.w,O,W),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(W=>{const z=W._takeResourceStateSnapshot();z.length!==0&&O.push([W.handle,z])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,I.$uh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Ge([(0,I.$uh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,W,z,V){this.l=W,this.m=z,this.n=V,this.g=new Map,this.h=new S.$jm,this.j=new T.$Sd,this.e=O.getProxy($.$NK.MainThreadSCM),this.f=O.getProxy($.$NK.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const C=this.g.get(P.sourceControlHandle);if(!C)return P;const Z=C.getResourceGroup(P.groupHandle);return Z?Z.getResourceState(P.handle):P}else if(P&&P.$mid===4){const C=this.g.get(P.sourceControlHandle);return C?C.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const C=this.g.get(P.handle);return C||P}return P}})}createSourceControl(O,W,z,V){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,W,z,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const P=t.d++,C=new y(O,this.m,this.e,this.l,W,z,V);this.g.set(P,C);const Z=this.h.get(O.identifier)||[];return Z.push(C),this.h.set(O.identifier,Z),C}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const W=this.h.get(O.identifier),z=W&&W[W.length-1];return z&&z.inputBox}$provideOriginalResource(O,W,z){const V=E.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",O,V.toString());const P=this.g.get(O);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ug)(()=>P.quickDiffProvider.provideOriginalResource(V,z)).then(C=>C||null)}$onInputBoxValueChange(O,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const z=this.g.get(O);return z&&z.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(O,W,z,V){this.n.trace("ExtHostSCM#$executeResourceCommand",O,W,z);const P=this.g.get(O);if(!P)return Promise.resolve(void 0);const C=P.getResourceGroup(W);return C?C.$executeResourceCommand(z,V):Promise.resolve(void 0)}$validateInput(O,W,z){this.n.trace("ExtHostSCM#$validateInput",O);const V=this.g.get(O);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ug)(()=>V.inputBox.validateInput(W,z)).then(P=>{if(!P)return Promise.resolve(void 0);const C=p.MarkdownString.fromStrict(P.message);return C?Promise.resolve([C,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,W,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(W,z)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,W,z,V){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,z,V)??void 0}async $provideHistoryItems(O,W,z,V){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(W,z,V))?.map(Z=>({...Z,icon:h(Z)}))??void 0}async $provideHistoryItemChanges(O,W,z){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(W,z)??void 0}};e.$Wgc=D,e.$Wgc=D=t=Ge([Ke(3,A.$jj)],D)}),define(Ce[84],Re([1,0,3,5,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=void 0;class L{constructor($){this.b=new T.$Sd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$NK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,g){return this.a.$getPassword($,g)}store($,g,w){return this.a.$setPassword($,g,w)}delete($,g){return this.a.$deletePassword($,g)}}e.$3fc=L,e.$4fc=(0,I.$2h)("IExtHostSecretState")}),define(Ce[264],Re([1,0,3,8,2]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class L{static{this.a=0}constructor($,g){this.d=g,this.c=new Map,this.b=$.getProxy(E.$NK.MainThreadShare)}async $provideShare($,g,w){return await this.c.get($)?.provideShare({selection:T.Range.to(g.selection),resourceUri:I.URI.revive(g.resourceUri)},w)??void 0}registerShareProvider($,g){const w=L.a++;return this.c.set(w,g),this.b.$registerShareProvider(w,T.DocumentSelector.from($,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Xgc=L}),define(Ce[265],Re([1,0,20,6,3]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class L{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(I.$NK.MainThreadSpeech)}async $createSpeechToTextSession($,g){const w=this.c.get($);if(!w)return;const A=new T.$Rc,S=new E.$3d;this.d.set(g,S);const l=A.add(w.provideSpeechToTextSession(S.token));A.add(l.onDidChange(p=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,p)})),A.add(S.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,g,w){const A=L.a++;return this.c.set(A,w),this.b.$registerProvider(A,g,{extension:$,displayName:$.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Ygc=L}),define(Ce[266],Re([1,0,7,3,164,6,8,16]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$LL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$LL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,b,r,a,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new L.$Rc,this.#e=l,this.#t=p,a&&r){this.c=(0,E.$oL)(r.identifier,a);const o=b.get(this.c);o&&(t=o.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(g.a++);this.e=r,this.f=a,this.g=t,this.h=this.u(n)}u(l){if((0,$.$If)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new L.$Rc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,I.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=g.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,r,this.r?.internal,b,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Zgc=g;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new E.$PK(()=>{const b=this.b.indexOf(p);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,p){this.e=new Map,this.a=l.getProxy(T.$NK.MainThreadStatusBar),this.b=p,this.c=new w(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,b,r){return new g(this.a,this.b,this.e,l,p,b,r)}setStatusBarMessage(l,p){const b=this.c.setMessage(l);let r;return typeof p=="number"?r=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new E.$PK(()=>{b.dispose(),clearTimeout(r)})}}e.$1gc=A}),define(Ce[85],Re([1,0,3,5,4]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=e.$Ufc=void 0;class L{constructor($,g){this.c=g,this.b=new T.$Sd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$NK.MainThreadStorage)}registerExtensionStorageKeysToSync($,g){this.a.$registerExtensionStorageKeysToSync($,g)}async initializeExtensionStorage($,g,w){const A=await this.a.$initializeExtensionStorage($,g);let S;return A&&(S=this.d($,g,A)),S||w}setValue($,g,w){return this.a.$setValue($,g,w)}$acceptValue($,g,w){const A=this.d($,g,w);A&&this.b.fire({shared:$,key:g,value:A})}d($,g,w){try{return JSON.parse(w)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${$}): ${A}`)}}}e.$Ufc=L,e.$Vfc=(0,I.$2h)("IExtHostStorage")}),define(Ce[86],Re([1,0,4,27,15,63,2]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0,e.$Dfc=(0,E.$2h)("IExtensionStoragePaths");let $=class{constructor(w,A,S){this.d=A,this.f=S,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return R.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,A=await this.g(w);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(w){if(this.c)return R.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return R.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Efc=$,e.$Efc=$=Ge([Ke(0,T.$8M),Ke(1,I.$jj),Ke(2,L.$Cfc)],$)}),define(Ce[64],Re([1,0,5,3,4,2,17,6,7,166,14,194,20,33,195,45,13,8,32]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=e.$Zfc=e.$Yfc=void 0,e.$Yfc=(0,I.$2h)("IExtHostTerminalService");class o{constructor(v,y,D,N){this.l=v,this._id=y,this.m=D,this.n=N,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(W=>this.f=W);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(W,z=!0){O.q(),O.l.$sendText(O._id,W,z)},show(W){O.q(),O.l.$show(O._id,W)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(v,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??y?.cwd??void 0,env:v.env??void 0,icon:m(v.iconPath)??void 0,color:r.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(v.location,y?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,y,D,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:N,color:r.ThemeColor.isThemeColor(O)?O.id:void 0,location:y?.location||this.o(v,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,y){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in v?{viewColumn:t.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,y){this.h=Object.freeze({code:v,reason:y})}setDimensions(v,y){return v===this.d&&y===this.g||v===0||y===0?!1:(this.d=v,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(y=>{y!==v&&(this.b=Promise.resolve(v))})}}e.$Zfc=o;class c{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new E.$Sd,this.onProcessData=this.a.event,this.b=new E.$Sd,this.d=new E.$Sd,this.onDidChangeProperty=this.d.event,this.f=new E.$Sd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,y){this.g.setDimensions?.({columns:v,rows:y})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends $.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Sd,this.onDidChangeShell=this.N.event,this.O=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(T.$NK.MainThreadTerminalService),this.y=new b.$wrb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:N=>{const O=W=>{const z=W;return this.W(z.instanceId)?.value};switch(N?.$mid){case 15:return O(N);default:{if(Array.isArray(N))for(let W=0;W<N.length&&N[W].$mid===15;W++)N[W]=O(N[W]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,y){const D=new o(this.a,(0,p.$mg)(),v,v.name),N=new c(v.pty);return D.createExtensionTerminal(v.location,y,this.R(v,y).resolvedExtHostIdentifier,m(v.iconPath),f(v.color)).then(O=>{const W=this.S(O,N);this.h[O]=W}),this.f.push(D),D.value}R(v,y){if(y=y||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const D=v.location.parentTerminal;if(D){const N=this.f.find(O=>O.value===D);N&&(y.resolvedExtHostIdentifier=N._id)}}else v.location&&typeof v.location!="object"?y.location=v.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(v,y){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const N=new c(y),O=this.S(v,N);this.h[v]=O}async $acceptActiveTerminalChanged(v){const y=this.b;if(v===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.W(v);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,y){const D=this.W(v);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions(v,y,D){const N=this.W(v);N&&N.setDimensions(y,D)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(v,y){const D=this.W(v);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions(v,y,D){this.g.get(v)?.resize(y,D)}async $acceptTerminalTitleChange(v,y){const D=this.W(v);D&&(D.name=y)}async $acceptTerminalClosed(v,y,D){const N=this.Y(this.f,v);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(y,D),this.H.fire(O.value)}}$acceptTerminalOpened(v,y,D,N){if(y){const z=this.Y(this.f,y);if(z!==null){this.f[z]._id=v,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:L.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},W=new o(this.a,v,O,D);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(v,y){this.W(v)?._setProcessId(y)}async $startExtensionTerminal(v,y){const D=this.W(v);if(!D)return{message:(0,w.localize)(0,null,v)};D.isOpen||await new Promise(O=>{const W=this.onDidOpenTerminal(async z=>{z===D.value&&(W.dispose(),O())})});const N=this.g.get(v);N?N.startSendingEvents(y):this.j[v]={initialDimensions:y}}S(v,y){const D=new $.$Rc;D.add(y.onProcessReady(O=>this.a.$sendProcessReady(v,O.pid,O.cwd,O.windowsPty))),D.add(y.onDidChangeProperty(O=>this.a.$sendProcessProperty(v,O))),this.y.startBuffering(v,y.onProcessData),D.add(y.onProcessExit(O=>this.U(v,O))),this.g.set(v,y);const N=this.j[v];return N&&y instanceof c&&(y.startSendingEvents(N.initialDimensions),delete this.j[v]),D}$acceptProcessAckDataEvent(v,y){this.g.get(v)?.acknowledgeDataEvent(y)}$acceptProcessInput(v,y){this.g.get(v)?.input(y)}$acceptTerminalInteraction(v){const y=this.W(v);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(v,y){this.W(v)?.setSelection(y)}$acceptProcessResize(v,y,D){try{this.g.get(v)?.resize(y,D)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(v,y){this.g.get(v)?.shutdown(y)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(y=>this.a.$sendProcessProperty(v,{type:"cwd",value:y}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new g.$PK(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,v.identifier.value),new g.$PK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(v,y,D){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,D),this.a.$registerQuickFixProvider(v,y),new g.$PK(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,y){const D=new l.$3d().token;if(D.isCancellationRequested)return;const N=this.D.get(v);if(!N)return;const O=await N.provideTerminalQuickFixes(y,D);if(O===null||Array.isArray(O)&&O.length===0)return;const W=new $.$Rc;if(this.w.value=W,!Array.isArray(O))return O?t.TerminalQuickFix.from(O,this.Q.converter,W):void 0;const z=[];for(const V of O){const P=t.TerminalQuickFix.from(V,this.Q.converter,W);P&&z.push(P)}return z}async $createContributedProfileTerminal(v,y){const D=new l.$3d().token;let N=await this.C.get(v)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,y);return}this.createTerminalFromOptions(N.options,y)}}async $provideLinks(v,y){const D=this.W(v);if(!D)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const O=new l.$3d;this.G.set(v,O);const W=[],z={terminal:D.value,line:y},V=[];for(const Z of this.z)V.push(a.Promises.withAsyncBody(async ce=>{O.token.onCancellationRequested(()=>ce({provider:Z,links:[]}));const me=await Z.provideTerminalLinks(z,O.token)||[];O.token.isCancellationRequested||ce({provider:Z,links:me})}));const P=await Promise.all(V);if(O.token.isCancellationRequested)return[];const C=new Map;for(const Z of P)Z&&Z.links.length>0&&W.push(...Z.links.map(ce=>{const me={id:h++,startIndex:ce.startIndex,length:ce.length,label:ce.tooltip};return C.set(me.id,{provider:Z.provider,link:ce}),me}));return this.F.set(v,C),W}$activateLink(v,y){const D=this.F.get(v)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U(v,y){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const D=this.h[v];D&&(D.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,y)}W(v){return this.X(this.f,v)}X(v,y){const D=this.Y(v,y);return D!==null?v[D]:null}Y(v,y){const D=v.findIndex(N=>N._id===y);return D===-1?null:D}getEnvironmentVariableCollection(v){let y=this.n.get(v.identifier.value);return y||(y=new s,this.$(v.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(v,y){const D=(0,S.$yr)(y.map),N=(0,S.$zr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(v,y.persistent,D.length===0?void 0:D,N)}$initEnvironmentVariableCollections(v){v.forEach(y=>{const D=y[0],N=new s(y[1]);this.$(D,N)})}$acceptDefaultProfile(v,y){const D=this.s;this.s=v,this.u=y,D?.path!==v.path&&this.N.fire(v.path)}$(v,y){this.n.set(v,y),y.onDidChangeCollection(()=>{this.Z(v,y)})}};e.$1fc=i,e.$1fc=i=Ge([Ke(1,n.$bN),Ke(2,R.$RM)],i);class s{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Sd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const y=this.h(v);let D=this.a.get(y);return D||(D=new u(this,v),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:N})}append(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:N})}prepend(v,y,D,N){this.f(v,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:N})}f(v,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(v,y.scope),N=this.map.get(D),O=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==y.value||N.type!==y.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const W=this.g(v,y.scope),z={variable:v,...y,options:O};this.map.set(W,z),this.d.fire()}}get(v,y){const D=this.g(v,y),N=this.map.get(D);return N?k(N):void 0}g(v,y){const D=this.h(y);return D.length?`${v}:::${D}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const y=new Map;for(const[D,N]of this.map)this.h(N.scope)===this.h(v)&&y.set(N.variable,k(N));return y}delete(v,y){const D=this.g(v,y);this.map.delete(D),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(y);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,y){const D=this.h(y),N=this.descriptionMap.get(D);if(!N||N.description!==v){let O;typeof v=="string"?O=v:O=v?.value.split(`

`)[0];const W={description:O,scope:y};this.descriptionMap.set(D,W),this.d.fire()}}getDescription(v){const y=this.h(v);return this.descriptionMap.get(y)?.description}k(v){const y=this.h(v);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,y){this.b=v,this.d=y,this.a=new E.$Sd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,y,D){this.b.replace(v,y,D,this.d)}append(v,y,D){this.b.append(v,y,D,this.d)}prepend(v,y,D){this.b.prepend(v,y,D,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,y){this.b.getVariableMap(this.d).forEach((D,N)=>v.call(y,N,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(v,y){super(!1,v,y)}createTerminal(v,y,D){throw new A.$_}createTerminalFromOptions(v,y){throw new A.$_}};e.$2fc=d,e.$2fc=d=Ge([Ke(0,n.$bN),Ke(1,R.$RM)],d);function m(F){if(!(!F||typeof F=="string"))return"id"in F?{id:F.id,color:F.color}:F}function f(F){return r.ThemeColor.isThemeColor(F)?F:void 0}function k(F){const v={...F};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Ce[267],Re([1,0,13,24,20,5,219,98,6,26,16,33,3,17,108,8,7,48,77,58,23]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=e.$6gc=e.$5gc=void 0;let h=class extends g.$Sc{constructor(W,z,V){super(),this.w=V,this.f=this.B(new L.$Sd),this.g=new Map,this.s=this.B(new L.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=W.getProxy(l.$NK.MainThreadTesting),this.m=new y(this.h),this.j=new d(this.h),z.registerArgumentProcessor({processArgument:P=>{switch(P?.$mid){case 16:{const C=P,Z=C.tests[C.tests.length-1].item.extId;return this.g.get(t.$FJ.root(Z))?.collection.tree.get(Z)?.actual??(0,b.$4M)(P)}case 18:{const{extId:C,message:Z}=P;return{test:this.g.get(t.$FJ.root(C))?.collection.tree.get(C)?.actual,message:r.TestMessage.to(Z)}}default:return P}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const P=await z.executeCommand("_testing.getExplorerSelection"),C=Z=>{const ce=this.g.get(t.$FJ.root(Z));if(ce)return t.$FJ.isRoot(Z)?ce.controller:ce.collection.tree.get(Z)?.actual};return{include:P?.include.map(C).filter(A.$Mf)||[],exclude:P?.exclude.map(C).filter(A.$Mf)||[]}})}createTestController(W,z,V,P){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const C=new g.$Rc,Z=C.add(new b.$7M(z,V,this.w));Z.root.label=V;const ce=new Map,me=new Set,be=this.h,ke={items:Z.root.children,get label(){return V},set label(de){V=de,Z.root.label=de,be.$updateController(z,{label:V})},get refreshHandler(){return P},set refreshHandler(de){P=de,be.$updateController(z,{canRefresh:!!de})},get id(){return z},createRunProfile:(de,ie,Se,oe,x,q)=>{let ne=(0,$.$Pi)(de);for(;ce.has(ne);)ne++;return new D(this.h,ce,W,me,this.s.event,z,ne,de,ie,Se,oe,x,q)},createTestItem(de,ie,Se){return new b.$5M(z,de,ie,Se)},createTestRun:(de,ie,Se=!0)=>this.j.createTestRun(W,z,Z,de,ie,Se),invalidateTestResults:de=>{if(de===void 0)this.h.$markTestRetired(void 0);else{const ie=de instanceof Array?de:[de];this.h.$markTestRetired(ie.map(Se=>t.$FJ.fromExtHostTestItem(Se,z).toString()))}},set resolveHandler(de){Z.resolveHandler=de},get resolveHandler(){return Z.resolveHandler},dispose:()=>{C.dispose()}};be.$registerTestController(z,V,!!P),C.add((0,g.$Qc)(()=>be.$unregisterTestController(z)));const fe={controller:ke,collection:Z,profiles:ce,extension:W,activeProfiles:me};return this.g.set(z,fe),C.add((0,g.$Qc)(()=>this.g.delete(z))),C.add(Z.onDidGenerateDiff(de=>be.$publishDiff(z,de.map(o.TestsDiffOp.serialize)))),ke}createTestObserver(){return this.m.checkout()}async runTests(W,z=I.CancellationToken.None){const V=m(W);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const P=this.g.get(V.controllerId);if(!P)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:W.include?.map(C=>t.$FJ.fromExtHostTestItem(C,P.collection.root.id).toString())??[P.collection.root.id],profileGroup:N[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:W.exclude?.map(C=>C.id)},z)}$syncTests(){for(const{collection:W}of this.g.values())W.flushDiff();return Promise.resolve()}async $provideFileCoverage(W,z,V){return await this.j.getCoverageReport(W,z)?.provideFileCoverage(V)??[]}async $resolveFileCoverage(W,z,V,P){return await this.j.getCoverageReport(W,z)?.resolveFileCoverage(V,P)??[]}$configureRunProfile(W,z){this.g.get(W)?.profiles.get(z)?.configureHandler?.()}$setActiveRunProfiles(W){const z=new Map;for(const[V,P]of Object.entries(W)){const C=this.g.get(V);if(!C)continue;const Z=new Map,ce=P.filter(be=>!C.activeProfiles.has(be)),me=[...C.activeProfiles].filter(be=>!P.includes(be));for(const be of ce)Z.set(be,!0),C.activeProfiles.add(be);for(const be of me)Z.set(be,!1),C.activeProfiles.delete(be);Z.size&&z.set(V,Z)}this.s.fire(z)}async $refreshTests(W,z){await this.g.get(W)?.controller.refreshHandler?.(z)}$publishTestResults(W){this.results=Object.freeze(W.map(z=>(0,w.$jn)(r.TestResults.to(z))).concat(this.results).sort((z,V)=>V.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(W,z){const V=this.g.get(t.$FJ.fromString(W).controllerId)?.collection;V&&(await V.expand(W,z<0?1/0:z),V.flushDiff())}$acceptDiff(W){this.m.applyDiff(W.map(z=>o.TestsDiffOp.deserialize({asCanonicalUri:V=>V},z)))}async $runControllerTests(W,z){return Promise.all(W.map(V=>this.y(V,!1,z)))}async $startContinuousRun(W,z){const V=new I.$3d(z),P=await Promise.all(W.map(C=>this.y(C,!0,V.token)));return!z.isCancellationRequested&&!P.some(C=>C.error)&&await new Promise(C=>z.onCancellationRequested(C)),V.dispose(!0),P}async y(W,z,V){const P=this.g.get(W.controllerId);if(!P)return{};const{collection:C,profiles:Z,extension:ce}=P,me=Z.get(W.profileId);if(!me)return{};const be=W.testIds.map(ie=>C.tree.get(ie)).filter(A.$Mf),ke=W.excludeExtIds.map(ie=>P.collection.tree.get(ie)).filter(A.$Mf).filter(ie=>be.some(Se=>Se.fullId.compare(ie.fullId)===2));if(!be.length)return{};const fe=new a.$mM(be.some(ie=>ie.actual instanceof b.$6M)?void 0:be.map(ie=>ie.actual),ke.map(ie=>ie.actual),me,z),de=(0,o.$HJ)(W)&&this.j.prepareForMainThreadTestRun(fe,f.fromInternal(W,P.collection),ce,V);try{return await me.runHandler(fe,V),{}}catch(ie){return{error:String(ie)}}finally{de&&(de.hasRunningTasks&&!V.isCancellationRequested&&await L.Event.toPromise(de.onEnd),de.dispose())}}$cancelExtensionTestRun(W){W===void 0?this.j.cancelAllRuns():this.j.cancelRunById(W)}};e.$5gc=h,e.$5gc=h=Ge([Ke(0,p.$RM)],h);const i=1e4;var s;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(s||(s={}));class u extends g.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(W,z,V,P){super(),this.s=W,this.w=z,this.y=V,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Sd),this.m=this.B(new L.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$3d(P));const C=this.B(new E.$bh(()=>this.z(),i));this.B(this.h.token.onCancellationRequested(()=>C.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.z()}createRun(W){const z=this.s.id,V=this.s.controllerId,P=(0,S.$mg)(),C=this.y,Z=this.m;let ce;const me=de=>(ie,...Se)=>{if(ke){console.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ie)&&(this.D(ie),de(ie,...Se))},be=(de,ie)=>{const Se=ie instanceof Array?ie.map(r.TestMessage.from):[r.TestMessage.from(ie)];if(de.uri&&de.range){const oe={range:r.Range.from(de.range),uri:de.uri};for(const x of Se)x.location=x.location||oe}this.w.$appendTestMessagesInRun(z,P,t.$FJ.fromExtHostTestItem(de,V).toString(),Se)};let ke=!1;const fe={isPersisted:this.s.isPersisted,token:this.h.token,name:W,get coverageProvider(){return ce?.provider},set coverageProvider(de){(0,c.$oF)(C,"testCoverage"),ce=de&&new k(de),Z.fire({taskId:P,runId:z,coverage:ce})},enqueued:me(de=>{this.w.$updateTestStateInRun(z,P,t.$FJ.fromExtHostTestItem(de,V).toString(),1)}),skipped:me(de=>{this.w.$updateTestStateInRun(z,P,t.$FJ.fromExtHostTestItem(de,V).toString(),5)}),started:me(de=>{this.w.$updateTestStateInRun(z,P,t.$FJ.fromExtHostTestItem(de,V).toString(),2)}),errored:me((de,ie,Se)=>{be(de,ie),this.w.$updateTestStateInRun(z,P,t.$FJ.fromExtHostTestItem(de,V).toString(),6,Se)}),failed:me((de,ie,Se)=>{be(de,ie),this.w.$updateTestStateInRun(z,P,t.$FJ.fromExtHostTestItem(de,V).toString(),4,Se)}),passed:me((de,ie)=>{this.w.$updateTestStateInRun(z,P,t.$FJ.fromExtHostTestItem(de,this.s.controllerId).toString(),3,ie)}),appendOutput:(de,ie,Se)=>{ke||(Se&&(this.s.isIncluded(Se)?this.D(Se):Se=void 0),this.w.$appendOutputToRun(z,P,T.$ge.fromString(de),ie&&r.location.from(ie),Se&&t.$FJ.fromExtHostTestItem(Se,V).toString()))},end:()=>{ke||(ke=!0,this.w.$finishedTestRunTask(z,P),this.f.delete(P),this.f.size||this.C())}};return this.f.set(P,{run:fe}),this.w.$startedTestRunTask(z,{id:P,name:W,running:!0}),fe}z(){for(const{run:W}of this.f.values())W.end()}C(){this.c!==2&&(this.c=2,this.j.fire())}D(W){if(!(W instanceof b.$5M))throw new n.$JM(W.id);if(this.g.has(t.$FJ.fromExtHostTestItem(W,this.s.controllerId).toString()))return;const z=[],V=this.s.colllection.root;for(;;){const P=r.TestItem.from(W);if(z.unshift(P),this.g.has(P.extId)||(this.g.add(P.extId),W===V))break;W=W.parent||V}this.w.$addTestsToRun(this.s.controllerId,this.s.id,z)}dispose(){this.C(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(W){this.g=W,this.c=new Map,this.f=[]}getCoverageReport(W,z){return this.f.find(V=>V.runId===W)?.coverage.get(z)}prepareForMainThreadTestRun(W,z,V,P){return this.h(W,z,V,P)}cancelRunById(W){for(const z of this.c.values())if(z.id===W){z.cancel();return}}cancelAllRuns(){for(const W of this.c.values())W.cancel()}createTestRun(W,z,V,P,C,Z){const ce=this.c.get(P);if(ce)return ce.createRun(C);const me=f.fromPublic(z,V,P,Z),be=m(P);this.g.$startedExtensionTestRun({controllerId:z,continuous:!!P.continuous,profile:be&&{group:N[be.kind],id:be.profileId},exclude:P.exclude?.map(fe=>t.$FJ.fromExtHostTestItem(fe,V.root.id).toString())??[],id:me.id,include:P.include?.map(fe=>t.$FJ.fromExtHostTestItem(fe,V.root.id).toString())??[V.root.id],persist:Z});const ke=this.h(P,me,W);return L.Event.once(ke.onEnd)(()=>{this.g.$finishedExtensionTestRun(me.id),ke.dispose()}),ke.createRun(C)}h(W,z,V,P){const C=new u(z,this.g,V,P);this.c.set(W,C);let Z;const ce=C.onDidCoverage(({runId:me,taskId:be,coverage:ke})=>{Z||(Z={runId:me,coverage:new Map},this.f.unshift(Z),this.f.length>o.$MJ&&this.f.pop()),Z.coverage.set(be,ke),this.g.$signalCoverageAvailable(me,be,!!ke)});return L.Event.once(C.onEnd)(()=>{this.c.delete(W),ce.dispose()}),C}}e.$6gc=d;const m=O=>{if(O.profile){if(!(O.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class f{static fromPublic(W,z,V,P){return new f(W,(0,S.$mg)(),V.include?.map(C=>t.$FJ.fromExtHostTestItem(C,W).toString())??[W],V.exclude?.map(C=>t.$FJ.fromExtHostTestItem(C,W).toString())??[],P,z)}static fromInternal(W,z){return new f(W.controllerId,W.runId,W.testIds,W.excludeExtIds,!0,z)}constructor(W,z,V,P,C,Z){this.controllerId=W,this.id=z,this.isPersisted=C,this.colllection=Z,this.c=V.map(ce=>ce+"\0"),this.f=P.map(ce=>ce+"\0")}isIncluded(W){const z=t.$FJ.fromExtHostTestItem(W,this.controllerId).toString()+"\0";for(const V of this.f)if(z===V||z.startsWith(V))return!1;for(const V of this.c)if(z===V||z.startsWith(V))return!0;return!1}}e.$7gc=f;class k{constructor(W){this.provider=W}async provideFileCoverage(W){this.c||(this.c=(async()=>this.provider.provideFileCoverage(W))());try{return(await this.c)?.map(r.TestCoverage.fromFile)??[]}catch(z){throw this.c=void 0,z}}async resolveFileCoverage(W,z){const V=await this.c;let P=V?.[W];return!this.provider||!V||!P?[]:(P.detailedCoverage||(P=V[W]=await this.provider.resolveFileCoverage?.(P,z)??P),P.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class F{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(W){this.j=W,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(W){this.c.add(W)}update(W){Object.assign(W.revived,r.TestItem.toPlain(W.item)),this.c.has(W)||this.f.add(W)}remove(W){if(this.c.has(W)){this.c.delete(W);return}this.f.delete(W);const z=t.$FJ.parentId(W.item.extId);if(z&&this.h.has(z.toString())){this.h.add(W.item.extId);return}this.g.add(W)}getChangeEvent(){const{c:W,f:z,g:V}=this;return{get added(){return[...W].map(P=>P.revived)},get updated(){return[...z].map(P=>P.revived)},get removed(){return[...V].map(P=>P.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends o.$NJ{constructor(){super(...arguments),this.s=new L.$Sd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(W){return this.f.get(W)}getMirroredTestDataByReference(W){return this.f.get(W.id)}w(W,z){return{...W,revived:r.TestItem.toPlain(W.item),depth:z?z.depth+1:0,children:new Set}}v(){return new F(this.s)}}class y{constructor(W){this.f=W}checkout(){this.c||(this.c=this.g());const W=this.c;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(z=>z.revived)},dispose:(0,R.$db)(()=>{--W.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(W){return this.c?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.c?.tests.apply(W)}g(){const W=new v({asCanonicalUri:z=>z});return this.f.$subscribeToDiffs(),{observers:0,tests:W}}}class D{#e;#t;#i;#o;#r;get label(){return this.f}set label(W){W!==this.f&&(this.f=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:W}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(W){W!==this.h&&(this.h=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:W}))}get isDefault(){return this.g}set isDefault(W){W!==this.g&&(this.g=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:W}))}get tag(){return this._tag}set tag(W){W?.id!==this._tag?.id&&(this._tag=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:W?r.TestTag.namespace(this.controllerId,W.id):null}))}get configureHandler(){return this.c}set configureHandler(W){W!==this.c&&(this.c=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!W}))}get isSelected(){return(0,c.$oF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,c.$oF)(this.#t,"testingActiveProfile"),L.Event.chain(this.#o,W=>W.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(A.$Mf))}constructor(W,z,V,P,C,Z,ce,me,be,ke,fe=!1,de=void 0,ie=!1){this.controllerId=Z,this.profileId=ce,this.f=me,this.kind=be,this.runHandler=ke,this.g=fe,this._tag=de,this.h=ie,this.#e=W,this.#r=z,this.#t=V,this.#i=P,this.#o=C,z.set(ce,this);const Se=N[be];if(typeof Se!="number")throw new Error(`Unknown TestRunProfile.group ${be}`);this.#e.$publishTestRunProfile({profileId:ce,controllerId:Z,tag:de?r.TestTag.namespace(this.controllerId,de.id):null,label:me,group:Se,isDefault:fe,hasConfigurationHandler:!1,supportsContinuousRun:ie})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$8gc=D;const N={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Ce[268],Re([1,0,18,5,3,109,8,7]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class g{constructor(A,S){this.i=S,this.a=new T.$Sd,this.b=new T.$Sd,this.c=new T.$Sd,this.d=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(I.$NK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const S=this.i.allEditors();return A?S:S.map(l=>l.value)}async showTextDocument(A,S,l){let p;typeof S=="number"?p={position:R.ViewColumn.from(S),preserveFocus:l}:typeof S=="object"?p={position:R.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?R.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:p={preserveFocus:!1};const b=await this.h.$tryShowTextDocument(A.uri,p),r=b&&this.i.getEditor(b);if(r)return r.value;throw b?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,S){return new L.$YM(this.h,A,S).value}$acceptEditorPropertiesChanged(A,S){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(S.options&&l._acceptOptions(S.options),S.selections){const p=S.selections.selections.map(R.Selection.to);l._acceptSelections(p)}if(S.visibleRanges){const p=E.$Hb(S.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(p)}if(S.options&&this.b.fire({textEditor:l.value,options:{...S.options,lineNumbers:R.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const p=$.TextEditorSelectionChangeKind.fromValue(S.selections.source),b=S.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:b,kind:p})}if(S.visibleRanges){const p=E.$Hb(S.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:p})}}$acceptEditorPositionData(A){for(const S in A){const l=this.i.getEditor(S);if(!l)throw new Error("Unknown text editor");const p=R.ViewColumn.to(A[S]);l.value.viewColumn!==p&&(l._acceptViewColumn(p),this.d.fire({textEditor:l.value,viewColumn:p}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$rfc=g}),define(Ce[269],Re([1,0,2,4,3,6,7,8,22,16]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0,e.$0gc=(0,T.$2h)("IExtHostTimeline");class A{constructor(p,b){this.b=new Map,this.c=new Map,this.a=p.getProxy(I.$NK.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(r,a)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&g.$hm.equals(a,this.b.get(r.source)?.extension)){const t=r.uri===void 0?void 0:E.URI.revive(r.uri);return this.c.get(r.source)?.get(S(t))?.get(r.handle)}else return;return r}})}async $getTimeline(p,b,r,a){return this.b.get(p)?.provider.provideTimeline(E.URI.revive(b),r,a)}registerTimelineProvider(p,b,r,a){const t=new L.$Rc,n=this.d(b.id,a,t).bind(this);let o;b.onDidChange&&(o=b.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:b.id}),this));const c=this.c;return this.f({...b,scheme:p,onDidChange:void 0,async provideTimeline(h,i,s){i?.resetCache&&(t.clear(),c.get(b.id)?.clear());const u=await b.provideTimeline(h,i,s);if(u==null)return;const d=n(h,i);return{...u,source:b.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(b.id)?.clear();o?.dispose(),t.dispose()}},r)}d(p,b,r){return(a,t)=>{let n;if(t?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const c=S(a);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...h}=o,i=`${p}|${o.id??o.timestamp}`;n?.set(i,o);let s,u,d;o.iconPath&&(c instanceof R.$KL?d={id:c.id,color:c.color}:E.URI.isUri(c)?(s=c,u=c):{light:s,dark:u}=c);let m;return R.$eL.isMarkdownString(h.tooltip)?m=$.MarkdownString.from(h.tooltip):(0,w.$Ef)(h.tooltip)?m=h.tooltip:R.$eL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=$.MarkdownString.from(h.detail)):(0,w.$Ef)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),m=h.detail),{...h,id:h.id??void 0,handle:i,source:p,command:o.command?b.toInternal(o.command,r):void 0,icon:s,iconDark:u,themeIcon:d,tooltip:m,accessibilityInformation:o.accessibilityInformation}}}}f(p,b){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:b}),(0,L.$Qc)(()=>{for(const a of this.c.values())a.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$$gc=A;function S(l){return l?.toString()}}),define(Ce[87],Re([1,0,20,5,6,168,4,15,197,3,27,17,7]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ayb=e.$_xb=e.TunnelDtoConverter=void 0;class p extends g.$vv{}var b;(function(a){function t(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:o.protocol}}a.fromApiTunnel=t;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==g.TunnelPrivacyId.ConstantPrivate&&o.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}a.fromServiceTunnel=n})(b||(e.TunnelDtoConverter=b={})),e.$_xb=(0,R.$2h)("IExtHostTunnelService");let r=class extends I.$Sc{constructor(t,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(w.$NK.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,t.displayName);if(o){const c=new p(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const o=this.u();return this.r.set(o,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,o),new l.$PK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(t,n,o,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(n.map(async m=>{let f;try{f=await d.provider.providePortAttributes({port:m,pid:o,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(m,o,c,h)}return{providedAttributes:f,port:m}})))}const s=i.filter(u=>!!u.providedAttributes);return s.length>0?s.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$3d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,I.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const o=t.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,I.$Qc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const o=this.g.get(t.host);o.has(t.port)&&(n&&o.get(t.port).disposeListener.dispose(),await o.get(t.port).tunnel.dispose(),o.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),b.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),o=t.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$ayb=r,e.$ayb=r=Ge([Ke(0,S.$RM),Ke(1,A.$8M),Ke(2,$.$jj)],r)}),define(Ce[270],Re([1,0,6,12,2,3]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(L.$NK.MainThreadUriOpeners)}registerExternalUriOpener(g,w,A,S){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=S.schemes.find(p=>!R.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,A),this.b.$registerUriOpener(w,S.schemes,g,S.label),(0,E.$Qc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(g,w,A){const S=this.c.get(g);if(!S)throw new Error(`Unknown opener with id: ${g}`);const l=I.URI.revive(w);return S.canOpenExternalUri(l,A)}async $openUri(g,w,A){const S=this.c.get(g);if(!S)throw new Error(`Unknown opener id: '${g}'`);return S.openExternalUri(I.URI.revive(w.resolvedUri),{sourceUri:I.URI.revive(w.sourceUri)},A)}}e.$ahc=R}),define(Ce[271],Re([1,0,3,2,6,14,22]),function(ge,e,E,T,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class ${static{this.a=0}constructor(w){this.c=new R.$im,this.d=new Map,this.b=w.getProxy(E.$NK.MainThreadUrls)}registerUriHandler(w,A){const S=w.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=$.a++;return this.c.add(S),this.d.set(l,A),this.b.$registerUriHandler(l,S,w.displayName||w.name),(0,I.$Qc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,A){const S=this.d.get(w);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(A))}catch(l){(0,L.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$bhc=$}),define(Ce[65],Re([1,0,5,6,12,26,2,182,204,78,3]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=e.$Hfc=e.$Gfc=e.$Ffc=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,h,i,s,u,d,m){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Sd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=s,this.#r=u,this.#n=d,this.#l=l(d),this.#d=p(d),this.#i=m}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$ivb)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===I.Schemas.https||c.scheme===I.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$hvb}return w.$hvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),L.$mn(this.#s,c)||this.#t.$setOptions(this.#e,a(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$1kb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#n.extensionLocation?.scheme===I.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,m,f,k)=>{const F=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,w.$ivb)(F,{isRemote:h,authority:i}).toString();return`${u}${v}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,m,f,k)=>{const F=R.URI.from({scheme:m||"file",path:decodeURIComponent(f)}),v=(0,w.$ivb)(F,{isRemote:h,authority:i}).toString();return`${u}${v}${k}`})}}e.$Ffc=S;function l(o){try{const c=(0,$.$2o)((0,$.$1o)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Gfc=l;function p(o){try{const c=(0,$.$2o)((0,$.$1o)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class b extends T.$Sc{constructor(c,h,i,s,u){super(),this.c=h,this.f=i,this.g=s,this.h=u,this.b=new Map,this.a=c.getProxy(A.$NK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const s=this.j(c);if(s){const{message:u}=(0,g.$2kb)(h,i.value);s._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const s=new S(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,s);const u=s._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return s}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Hfc=b;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.$Ifc=r;function a(o,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(o,c)}}e.$Jfc=a;function t(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>R.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(Ce[272],Re([1,0,20,98,6,12,25,2,8,65,75,3,7]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class p{constructor(s,u){this.document=s,this.b=u,this.a=1,this.c=new A.$$ec("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,u){await this.f(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.f(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this.a++;return(0,R.$Dg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const u=this.c.get(s,0);if(!u)throw new Error("No edit found");return u}}class b{constructor(){this.a=new Map}get(s,u){return this.a.get(this.b(s,u))}add(s,u,d){const m=this.b(s,u.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const f=new p(u,d);return this.a.set(m,f),f}delete(s,u){const d=this.b(s,u.uri);this.a.delete(d)}b(s,u){return`${s}@@@${u}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class a{constructor(){this.a=new Map}addTextProvider(s,u,d){return this.b(0,s,u,d)}addCustomProvider(s,u,d){return this.b(1,s,u,d)}get(s){return this.a.get(s)}b(s,u,d,m){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:s,extension:d,provider:m}),new l.$PK(()=>this.a.delete(u))}}class t{constructor(s,u,d,m,f){this.d=u,this.f=d,this.g=m,this.h=f,this.b=new a,this.c=new b,this.a=s.getProxy(S.$NK.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,d,m){const f=new I.$Rc;return o(d)?(f.add(this.b.addTextProvider(u,s,d)),this.a.$registerTextEditorProvider((0,w.$Ifc)(s),u,m.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,w.$Gfc)(s))):(f.add(this.b.addCustomProvider(u,s,d)),n(d)&&f.add(d.onDidChangeCustomDocument(k=>{const F=this.i(u,k.document.uri);if(c(k)){const v=F.addEdit(k);this.a.$onDidEdit(k.document.uri,u,v,k.label)}else this.a.$onContentChange(k.document.uri,u)})),this.a.$registerCustomEditorProvider((0,w.$Ifc)(s),u,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,w.$Gfc)(s))),l.$PK.from(f,new l.$PK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,d,m,f){const k=this.b.get(u);if(!k)throw new Error(`No provider found for '${u}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${u}'`);const F=$.URI.revive(s),v=await k.provider.openCustomDocument(F,{backupId:d,untitledDocumentData:m?.buffer},f);let y;return n(k.provider)&&this.f&&(y=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(u,v,y),{editable:n(k.provider)}}async $disposeCustomDocument(s,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const m=$.URI.revive(s),{document:f}=this.i(u,m);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(s,u,d,m,f,k){const F=this.b.get(d);if(!F)throw new Error(`No provider found for '${d}'`);const v=g.ViewColumn.to(f),y=this.g.createNewWebview(u,m.contentOptions,F.extension),D=this.h.createNewWebviewPanel(u,d,m.title,v,m.options,y,m.active),N=$.URI.revive(s);switch(F.type){case 1:{const{document:O}=this.i(d,N);return F.provider.resolveCustomEditor(O,D,k)}case 0:{const O=this.d.getDocument(N);return F.provider.resolveCustomTextEditor(O,D,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,d){this.i(u,s).disposeEdits(d)}async $onMoveCustomEditor(s,u,d){const m=this.b.get(d);if(!m)throw new Error(`No provider found for '${d}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(s);if(!f)throw new Error("No webview found");const k=$.URI.revive(u),F=this.d.getDocument(k);await m.provider.moveCustomTextEditor(F,f,E.CancellationToken.None)}async $undo(s,u,d,m){return this.i(u,s).undo(d,m)}async $redo(s,u,d,m){return this.i(u,s).redo(d,m)}async $revert(s,u,d){const m=this.i(u,s);await this.j(u).revertCustomDocument(m.document,d),m.disposeBackup()}async $onSave(s,u,d){const m=this.i(u,s);await this.j(u).saveCustomDocument(m.document,d),m.disposeBackup()}async $onSaveAs(s,u,d,m){const f=this.i(u,s);return this.j(u).saveCustomDocumentAs(f.document,$.URI.revive(d),m)}async $backup(s,u,d){const m=this.i(u,s),k=await this.j(u).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},d);return m.updateBackup(k),k.id}i(s,u){const d=this.c.get(s,$.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$Lfc=t;function n(i){return!!i.onDidChangeCustomDocument}function o(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const s=i.scheme===L.Schemas.file||i.scheme===L.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Pi)(s)+""}}),define(Ce[273],Re([1,0,5,6,2,33,8,65,3,7]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class A extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(b,r,a,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=r,this.#o=a,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(b){this.c(),this.#n!==b&&(this.#n=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,I.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(b){this.#l||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#u=b.active,this.#c=b.visible,this.#s=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:R.ViewColumn.from(b),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends T.$Sc{static c(){return(0,L.$mg)()}constructor(b,r,a){super(),this.j=r,this.m=a,this.g=new Map,this.h=new Map,this.f=b.getProxy(g.$NK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,r,a,t,n={}){const o=typeof t=="object"?t.viewColumn:t,c={viewColumn:R.ViewColumn.from(o),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,$.$Gfc)(b),i=S.c();this.f.$createWebviewPanel((0,$.$Ifc)(b),i,r,{title:a,panelOptions:l(n),webviewOptions:(0,$.$Jfc)(b,this.m,n),serializeBuffersForPostMessage:h},c);const s=this.j.createNewWebview(i,n,b);return this.createNewWebviewPanel(i,r,a,o,n,s,!0)}$onDidChangeWebviewPanelViewStates(b){const r=Object.keys(b);r.sort((a,t)=>{const n=b[a],o=b[t];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const a of r){const t=this.getWebviewPanel(a);if(!t)continue;const n=b[a];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,r,a){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:a,extension:b}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,$.$Gfc)(b)}),new w.$PK(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(b,r,a,t){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:o,extension:c}=n,h=this.j.createNewWebview(b,a.webviewOptions,c),i=this.createNewWebviewPanel(b,r,a.title,t,a.panelOptions,h,a.active);await o.deserializeWebviewPanel(i,a.state)}createNewWebviewPanel(b,r,a,t,n,o,c){const h=new A(b,this.f,o,{viewType:r,title:a,viewColumn:t,panelOptions:n,active:c});return this.g.set(b,h),h}getWebviewPanel(b){return this.g.get(b)}}e.$Kfc=S;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ce[274],Re([1,0,5,6,65,8,3,7]),function(ge,e,E,T,I,L,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class g extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,l,p,b,r,a){super(),this.#r=!1,this.#u=this.B(new E.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Sd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=b,this.#e=S,this.#t=l,this.#o=r,this.#n=a}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class w{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$NK.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,p,b){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:S}),this.a.$registerWebviewViewProvider((0,I.$Ifc)(S),l,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Gfc)(S)}),new $.$PK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,p,b,r){const a=this.b.get(l);if(!a)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=a,o=this.d.createNewWebview(S,{},n),c=new g(S,this.a,l,p,o,!0);this.c.set(S,c),await t.resolveWebviewView(c,{state:b},r)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$chc=w}),define(Ce[111],Re([1,0,5,3,2,12,11,4,17,23]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=e.$dhc=void 0;let S=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const b=this.d;return{get focused(){return b.focused},get active(){return(0,w.$oF)(p,"windowActivity"),b.active}}}constructor(p){this.c=new E.$Sd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(T.$NK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:r})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,b){b!==this.d[p]&&(this.d={...this.d,[p]:b},this.c.fire(this.d))}openUri(p,b){let r;if(typeof p=="string"){r=p;try{p=I.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Ge)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,r,b)}async asExternalUri(p,b){if((0,R.$Ge)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(p,b);return I.URI.from(r)}};e.$dhc=S,e.$dhc=S=A=Ge([Ke(0,g.$RM)],S),e.$ehc=(0,$.$2h)("IExtHostWindow")}),define(Ce[275],Re([1,0,241,27,17]),function(ge,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;let L=class extends E.$hhc{constructor($,g){super($,g)}f($,g,w){g.apply(console,w)}};e.$qjc=L,e.$qjc=L=Ge([Ke(0,I.$RM),Ke(1,T.$8M)],L)}),define(Ce[276],Re([1,0,13,24,20,14,5,6,139,230,49]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.ResponsiveState=e.RequestInitiator=e.$r7b=e.$q7b=void 0;function l(D,N){try{return JSON.stringify(D,N)}catch{return"null"}}const p="$$ref$$",b={[p]:-1};class r{constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function a(D,N=null,O=!1){const W=[];return{jsonString:(O?l:JSON.stringify)(D,(V,P)=>{if(typeof P>"u")return b;if(typeof P=="object"){if(P instanceof T.$ge){const C=W.push(P)-1;return{[p]:C}}if(N)return N(V,P)}return P}),referencedBuffers:W}}e.$q7b=a;function t(D,N,O){return JSON.parse(D,(W,z)=>{if(z){const V=z[p];if(typeof V=="number")return N[V];if(O&&z.$mid===1)return O.transformIncoming(z)}return z})}e.$r7b=t;function n(D,N){return JSON.stringify(D,N)}function o(D){return D?(N,O)=>O&&O.$mid===1?D.transformOutgoing(O):O:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends $.$Sc{static{S=s}static{this.a=3*1e3}constructor(N,O=null,W=null){super(),this[S]=!0,this.b=this.B(new R.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=W,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,V=A.$Cv.count;z<V;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$bh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,g.$3m)(N,this.g):N}getProxy(N){const{nid:O,sid:W}=N;return this.s[O]||(this.s[O]=this.J(O,W)),this.s[O]}J(N,O){const W={get:(z,V)=>(typeof V=="string"&&!z[V]&&V.charCodeAt(0)===36&&(z[V]=(...P)=>this.U(N,V,P)),V===u?O:z[V])};return new Proxy(Object.create(null),W)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,W=N.length;O<W;O++){const z=N[O];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,W=f.read(N,0),z=W.readUInt8(),V=W.readUInt32();switch(z){case 1:case 2:{let{rpcId:P,method:C,args:Z}=F.deserializeRequestJSONArgs(W);this.g&&(Z=(0,g.$3m)(Z,this.g)),this.M(O,V,P,C,Z,z===2);break}case 3:case 4:{let{rpcId:P,method:C,args:Z}=F.deserializeRequestMixedArgs(W);this.g&&(Z=(0,g.$3m)(Z,this.g)),this.M(O,V,P,C,Z,z===4);break}case 5:{this.f?.logIncoming(O,V,0,"ack"),this.G(V);break}case 6:{this.N(O,V);break}case 7:{this.O(O,V,void 0);break}case 9:{let P=F.deserializeReplyOKJSON(W);this.g&&(P=(0,g.$3m)(P,this.g)),this.O(O,V,P);break}case 10:{const P=F.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(O,V,P);break}case 8:{const P=F.deserializeReplyOKVSBuffer(W);this.O(O,V,P);break}case 11:{let P=F.deserializeReplyErrError(W);this.g&&(P=(0,g.$3m)(P,this.g)),this.P(O,V,P);break}case 12:{this.P(O,V,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,W,z,V,P){this.f?.logIncoming(N,O,1,`receiveRequest ${(0,A.$Ev)(W)}.${z}(`,V);const C=String(O);let Z,ce;if(P){const be=new I.$3d;V.push(be.token),Z=this.Q(W,z,V),ce=()=>be.cancel()}else Z=this.Q(W,z,V),ce=i;this.u[C]=ce;const me=F.serializeAcknowledged(O);this.f?.logOutgoing(me.byteLength,O,1,"ack"),this.c.send(me),Z.then(be=>{delete this.u[C];const ke=F.serializeReplyOK(O,be,this.h);this.f?.logOutgoing(ke.byteLength,O,1,"reply:",be),this.c.send(ke)},be=>{delete this.u[C];const ke=F.serializeReplyErr(O,be);this.f?.logOutgoing(ke.byteLength,O,1,"replyErr:",be),this.c.send(ke)})}N(N,O){this.f?.logIncoming(N,O,1,"receiveCancel");const W=String(O);this.u[W]?.()}O(N,O,W){this.f?.logIncoming(N,O,0,"receiveReply:",W);const z=String(O);if(!this.w.hasOwnProperty(z))return;const V=this.w[z];delete this.w[z],V.resolveOk(W)}P(N,O,W){this.f?.logIncoming(N,O,0,"receiveReplyErr:",W);const z=String(O);if(!this.w.hasOwnProperty(z))return;const V=this.w[z];delete this.w[z];let P;W&&(W.$isError?(P=new Error,P.name=W.name,P.message=W.message,P.stack=W.stack):P=W),V.resolveErr(P)}Q(N,O,W){try{return Promise.resolve(this.S(N,O,W))}catch(z){return Promise.reject(z)}}S(N,O,W){const z=this.m[N];if(!z)throw new Error("Unknown actor "+(0,A.$Ev)(N));const V=z[O];if(typeof V!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Ev)(N));return V.apply(z,W)}U(N,O,W){if(this.j)return new w.$p7b;let z=null;if(W.length>0&&I.CancellationToken.isCancellationToken(W[W.length-1])&&(z=W.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$6());const V=F.serializeRequestArguments(W,this.h),P=++this.t,C=String(P),Z=new w.$o7b,ce=new $.$Rc;z&&ce.add(z.onCancellationRequested(()=>{const be=F.serializeCancel(P);this.f?.logOutgoing(be.byteLength,P,0,"cancel"),this.c.send(F.serializeCancel(P))})),this.w[C]=new m(Z,ce),this.F(P);const me=F.serializeRequest(P,N,O,V,!!z);return this.f?.logOutgoing(me.byteLength,P,0,`request: ${(0,A.$Ev)(N)}.${O}(`,W),this.c.send(me),Z}}e.$s7b=d;class m{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class f{static alloc(N,O,W){const z=new f(T.$ge.alloc(W+1+4),0);return z.writeUInt8(N),z.writeUInt32(O),z}static read(N,O){return new f(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let W=0,z=N.length;W<z;W++){const V=N[W];switch(O+=1,V.type){case 1:O+=this.sizeLongString(V.value);break;case 2:O+=this.sizeVSBuffer(V.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(V.value);for(let P=0;P<V.buffers.length;++P)O+=this.sizeVSBuffer(V.buffers[P]);break;case 4:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,W=N.length;O<W;O++){const z=N[O];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let V=0;V<z.buffers.length;++V)this.writeBuffer(z.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let W=0;W<N;W++)switch(this.readUInt8()){case 1:O[W]=this.readLongString();break;case 2:O[W]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),P=this.readLongString(),C=[];for(let Z=0;Z<V;++Z)C.push(this.readVSBuffer());O[W]=new A.$Fv(t(P,C,null));break}case 4:O[W]=void 0;break}return O}}var k;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(k||(k={}));class F{static a(N){for(let O=0,W=N.length;O<W;O++)if(N[O]instanceof T.$ge||N[O]instanceof A.$Fv||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const W=[];for(let z=0,V=N.length;z<V;z++){const P=N[z];if(P instanceof T.$ge)W[z]={type:2,value:P};else if(typeof P>"u")W[z]={type:4};else if(P instanceof A.$Fv){const{jsonString:C,referencedBuffers:Z}=a(P.value,O);W[z]={type:3,value:T.$ge.fromString(C),buffers:Z}}else W[z]={type:1,value:T.$ge.fromString(n(P,O))}}return{type:1,args:W}}return{type:0,args:n(N,O)}}static serializeRequest(N,O,W,z,V){switch(z.type){case 0:return this.b(N,O,W,z.args,V);case 1:return this.c(N,O,W,z.args,V)}}static b(N,O,W,z,V){const P=T.$ge.fromString(W),C=T.$ge.fromString(z);let Z=0;Z+=f.sizeUInt8(),Z+=f.sizeShortString(P),Z+=f.sizeLongString(C);const ce=f.alloc(V?2:1,N,Z);return ce.writeUInt8(O),ce.writeShortString(P),ce.writeLongString(C),ce.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),W=N.readShortString(),z=N.readLongString();return{rpcId:O,method:W,args:JSON.parse(z)}}static c(N,O,W,z,V){const P=T.$ge.fromString(W);let C=0;C+=f.sizeUInt8(),C+=f.sizeShortString(P),C+=f.sizeMixedArray(z);const Z=f.alloc(V?4:3,N,C);return Z.writeUInt8(O),Z.writeShortString(P),Z.writeMixedArray(z),Z.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),W=N.readShortString(),z=N.readMixedArray(),V=new Array(z.length);for(let P=0,C=z.length;P<C;P++){const Z=z[P];typeof Z=="string"?V[P]=JSON.parse(Z):V[P]=Z}return{rpcId:O,method:W,args:V}}static serializeAcknowledged(N){return f.alloc(5,N,0).buffer}static serializeCancel(N){return f.alloc(6,N,0).buffer}static serializeReplyOK(N,O,W){if(typeof O>"u")return this.d(N);if(O instanceof T.$ge)return this.e(N,O);if(O instanceof A.$Fv){const{jsonString:z,referencedBuffers:V}=a(O.value,W,!0);return this.g(N,z,V)}else return this.f(N,l(O,W))}static d(N){return f.alloc(7,N,0).buffer}static e(N,O){let W=0;W+=f.sizeVSBuffer(O);const z=f.alloc(8,N,W);return z.writeVSBuffer(O),z.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const W=T.$ge.fromString(O);let z=0;z+=f.sizeLongString(W);const V=f.alloc(9,N,z);return V.writeLongString(W),V.buffer}static g(N,O,W){const z=T.$ge.fromString(O);let V=0;V+=f.sizeUInt32,V+=f.sizeLongString(z);for(const C of W)V+=f.sizeVSBuffer(C);const P=f.alloc(10,N,V);P.writeUInt32(W.length),P.writeLongString(z);for(const C of W)P.writeBuffer(C);return P.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const W=N.readUInt32(),z=N.readLongString(),V=[];for(let P=0;P<W;++P)V.push(N.readVSBuffer());return new A.$Fv(t(z,V,O))}static serializeReplyErr(N,O){const W=O?l(L.$3(O),null):void 0;if(typeof W!="string")return this.h(N);const z=T.$ge.fromString(W);let V=0;V+=f.sizeLongString(z);const P=f.alloc(11,N,V);return P.writeLongString(z),P.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return f.alloc(12,N,0).buffer}}var v;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(Ce[277],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;const E=function(L){const R=$=>{globalThis.removeEventListener("message",R);const g=$.data;Object.defineProperties(globalThis,{postMessage:{value(w,A){g.postMessage(w,A)}},onmessage:{get(){return g.onmessage},set(w){g.onmessage=w}}}),g.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class T extends EventTarget{constructor(L,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${R}'))`,w=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(w),S=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:S.port2,url:A,options:$};L(p,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{L({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(b){S.port1.onmessage=b}},onmessageerror:{get(){return S.port1.onmessageerror},set(b){S.port1.onmessageerror=b}}}),S.port1.addEventListener("messageerror",b=>{const r=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(r)}),S.port1.addEventListener("message",b=>{const r=new MessageEvent("message",{data:b.data});this.dispatchEvent(r)}),S.port1.start()}}e.$sjc=T}),define(Ce[278],Re([1,0,5,30,35,4]),function(ge,e,E,T,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.OutputChannelUpdateMode=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=void 0,e.$YJ="text/x-code-output",e.$ZJ="output",e.$1J="Log",e.$2J="text/x-code-log-output",e.$3J="log",e.$4J="workbench.panel.output",e.$5J=new I.$gj("inOutput",!1),e.$6J=new I.$gj("activeLogOutput",!1),e.$7J=new I.$gj("outputView.scrollLock",!1),e.$8J=(0,L.$2h)("outputService");var R;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$9J={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(A=>w.push(A)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$un.add(e.$9J.OutputChannels,new $),e.$0J=new I.$gj("activeOutputChannel","")}),define(Ce[112],Re([1,0,3,4,17,22,15,278,63,27,43,136,24,16,42,5,6]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;class t extends R.$pj{get disposed(){return this.n}constructor(h,i,s,u,d){super(),this.id=h,this.name=i,this.r=s,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$ge.fromString(i).byteLength,(0,R.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let o=class{constructor(h,i,s,u,d,m){this.i=i,this.j=s,this.k=u,this.l=d,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$NK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$sm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(h,i,s){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,p.$Ef)(i)?i:void 0;if((0,p.$Ef)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const f=this.i.environment.extensionLogLevel?.find(([F])=>L.$hm.equals(s.identifier,F))?.[1];f&&(m=(0,R.$zj)(f));const k=u?this.o(h,m,s):this.n(h,d,s);return k.then(F=>{this.g.set(F.id,F),F.visible=F.id===this.h}),u?this.r(h,m??this.m.getLevel(),k):this.q(h,k)}async n(h,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,s.identifier.value);return new t(f,h,m,this.a,s)}async o(h,i,s){const u=await this.p(s),d=h.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(u,`${d}.log`),f=`${s.identifier.value}.${d}`,k=this.l.createLogger(m,{id:f,name:h,logLevel:i,extensionId:s.identifier.value});return new n(f,h,k,this.a,s)}p(h){let i=this.d.get(h.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(u){if((0,b.$Ck)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}return s})())}return i}q(h,i){let s=!1;const u=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(m=>m.append(d))},appendLine(d){u(),i.then(m=>m.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(m=>m.replace(d))},show(d,m){u(),i.then(f=>f.show(d,m))},hide(){u(),i.then(d=>d.hide())},dispose(){s=!0,i.then(d=>d.dispose())}}}r(h,i,s){const u=new a.$Rc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},m=u.add(new r.$Sd);function f(k){i=k,m.fire(k)}return s.then(k=>{u.add(k),k.logLevel!==i&&f(k.logLevel),u.add(k.onDidChangeLogLevel(F=>f(F)))}),{...this.q(h,s),get logLevel(){return i},onDidChangeLogLevel:m.event,trace(k,...F){d(),s.then(v=>v.trace(k,...F))},debug(k,...F){d(),s.then(v=>v.debug(k,...F))},info(k,...F){d(),s.then(v=>v.info(k,...F))},warn(k,...F){d(),s.then(v=>v.warn(k,...F))},error(k,...F){d(),s.then(v=>v.error(k,...F))},dispose(){u.dispose()}}}};e.$Pgc=o,e.$Pgc=o=Ge([Ke(0,I.$RM),Ke(1,w.$8M),Ke(2,g.$Cfc),Ke(3,A.$cfc),Ke(4,R.$kj),Ke(5,R.$jj)],o),e.$Qgc=(0,T.$2h)("IExtHostOutputService")}),define(Ce[113],Re([1,0,4,13]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=(0,E.$2h)("remoteAgentService"),e.$Im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let L=1/0;for(let $=0;$<this.maxSampleCount;$++){const g=await I.getRoundTripTime();if(g===void 0)return;L=Math.min(L,g/2),await(0,T.$3g)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce(($,g)=>$+g,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce(($,g)=>$+g,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ce[279],Re([1,0,170,54,30,47,41,6,5,113,21,26]),function(ge,e,E,T,I,L,R,$,g,w,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=void 0,e.$DH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$EH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$FH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$GH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new l;I.$un.add(e.$GH.ConfigurationMigration,p);let b=class extends $.$Sc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(o=>this.g(o,t?.uri))])}async g(t,n){const o=this.a.inspect(t.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,i]of c){const s=[];for(const d of o.overrideIdentifiers??[]){const m=await this.h(t,{resource:n,overrideIdentifier:d},h);for(const f of m??[]){let k=s.find(([[F,v]])=>F===f[0]&&(0,S.$mn)(v.value,f[1].value));k||s.push(k=[f,[]]),k[1].push(d)}}const u=await this.h(t,{resource:n},h,o);for(const d of u??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,m],f])=>this.a.updateValue(d,m.value,{resource:n,overrideIdentifiers:f},i)))}}async h(t,n,o,c){const h=d=>i(this.a.inspect(d,n)),i=d=>{const m=d[o];return n.overrideIdentifier?m?.override:m?.value},s=c?i(c):h(t.key);if(s===void 0)return;const u=await t.migrateFn(s,h);return Array.isArray(u)?u:[[t.key,u]]}};e.$HH=b,e.$HH=b=Ge([Ke(0,R.$vi),Ke(1,L.$$h)],b);let r=class extends $.$Sc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;I.$un.as(T.$zn.Configuration).registerConfiguration({...e.$FH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$IH=r,e.$IH=r=Ge([Ke(0,w.$Hm)],r)}),define(Ce[280],Re([1,0,34,12,19,25,178,279,54,4,30]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cb=e.$4cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$3cb=e.$2cb=void 0,e.$2cb=(0,w.$2h)("editorResolverService"),e.$3cb="workbench.editorAssociations";const S=A.$un.as(g.$zn.Configuration),l={...$.$EH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var b;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function r(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$4cb=r;function a(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(I.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,L.$Ag)(n);return E.$Hj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$5cb=a}),define(Ce[281],Re([1,0,46,12,19,21,25,2,4,199,47,217,113]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.$pK=void 0,e.$pK=(0,g.$2h)("pathService");let b=p=class{constructor(a,t,n,o){this.d=a,this.e=t,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(o=>this.h(a,o,t)):this.h(a,t,n)}h(a,t,n){return a.scheme===T.Schemas.file||a.scheme===T.Schemas.vscodeRemote?(0,E.$2f)(n??(0,R.$Ag)(a),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,t){if(a.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,w.$mK)(t.getWorkspace());if(n)return n;const o=t.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?I.$fc:I.$gc)}async fileURI(a){let t="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const o=a.indexOf("/",2);o===-1?(t=a.substring(2),a="/"):(t=a.substring(2,o),a=a.substring(o)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:t,path:a,query:"",fragment:""})}};e.$qK=b,e.$qK=b=p=Ge([Ke(1,l.$Hm),Ke(2,S.$$J),Ke(3,A.$$h)],b)}),define(Ce[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$5I=e.$4I=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$4I=E;class T{constructor(R,$,g,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(g,w)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$5I=T;var I;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ce[44],Re([1,0,18,34,26,46,11,4,19,14,114,13]),function(ge,e,E,T,I,L,R,$,g,w,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.SearchErrorCode=e.$hJ=e.$gJ=e.SearchSortOrder=e.ViewMode=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.SearchCompletionExitCode=e.$bJ=e.$aJ=e.$_I=e.QueryType=e.SearchProviderType=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$6I="workbench.view.search",e.$7I="workbench.panel.search",e.$8I="workbench.view.search",e.$9I="search-result",e.$0I="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",b=(l.length+p.length+5)*2;e.$$I=(0,$.$2h)("searchService");var r;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text"})(r||(e.SearchProviderType=r={}));var a;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text"})(a||(e.QueryType=a={}));function t(fe){return!!fe.preview}e.$_I=t;function n(fe){return!!fe.resource}e.$aJ=n;function o(fe){return!!fe.message}e.$bJ=o;var c;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(de){this.resource=de,this.results=[]}}e.$cJ=h;class i{constructor(de,ie,Se,oe){this.ranges=ie,this.webviewIndex=oe;const x=Array.isArray(ie)?ie:[ie];if(Se&&Se.matchLines===1&&s(x)){de=(0,R.$xf)(de,Se.matchLines);let q="",ne=0,Ie=0;const Ae=Math.floor(Se.charsPerLine/5),Pe=[];for(const ae of x){const te=Math.max(ae.startColumn-Ae,0),J=ae.startColumn+Se.charsPerLine;if(te>Ie+Ae+b){const ee=l+(te-Ie)+p;q+=ee+de.slice(te,J),ne+=te-(Ie+ee.length)}else q+=de.slice(Ie,J);Pe.push(new d(0,ae.startColumn-ne,ae.endColumn-ne)),Ie=J}this.preview={text:q,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const q=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:de,matches:(0,E.$2b)(ie,ne=>new u(ne.startLineNumber-q,ne.startColumn,ne.endLineNumber-q,ne.endColumn))}}}}e.$dJ=i;function s(fe){const de=fe[0].startLineNumber;for(const ie of fe)if(ie.startLineNumber!==de||ie.endLineNumber!==de)return!1;return!0}class u{constructor(de,ie,Se,oe){this.startLineNumber=de,this.startColumn=ie,this.endLineNumber=Se,this.endColumn=oe}}e.$eJ=u;class d extends u{constructor(de,ie,Se){super(de,ie,de,Se)}}e.$fJ=d;var m;(function(fe){fe.List="list",fe.Tree="tree"})(m||(e.ViewMode=m={}));var f;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function k(fe,de=!0){const ie=fe&&fe.files&&fe.files.exclude,Se=de&&fe&&fe.search&&fe.search.exclude;if(!ie&&!Se)return;if(!ie||!Se)return ie||Se;let oe=Object.create(null);return oe=I.$ln(oe,I.$in(ie)),oe=I.$ln(oe,I.$in(Se),!0),oe}e.$gJ=k;function F(fe,de){return fe.excludePattern&&T.$Hj(fe.excludePattern,de)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&T.$Hj(fe.includePattern,de)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(ie=>{const Se=ie.folder.fsPath;if(L.$4f(de,Se)){const oe=g.$lc(Se,de);return!ie.includePattern||!!T.$Hj(ie.includePattern,oe)}else return!1}):!1:!0}e.$hJ=F;var v;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class y extends Error{constructor(de,ie){super(de),this.code=ie}}e.$iJ=y;function D(fe){const de=fe.message;if((0,w.$4)(fe))return new y(de,v.canceled);try{const ie=JSON.parse(de);return new y(ie.message,ie.code)}catch{return new y(de,v.other)}}e.$jJ=D;function N(fe){const de={message:fe.message,code:fe.code};return new Error(JSON.stringify(de))}e.$kJ=N;function O(fe){return fe.type==="error"?!0:fe.type==="success"}e.$lJ=O;function W(fe){return fe.type==="success"}e.$mJ=W;function z(fe){return!!fe.path}e.$nJ=z;function V(fe,de){const ie=fe.searchPath?fe.searchPath:fe.relativePath;return(0,R.$uf)(ie,de)}e.$oJ=V;class P{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$pJ=P;function C(fe,de){const ie={...fe||{},...de||{}};return Object.keys(ie).filter(Se=>{const oe=ie[Se];return typeof oe=="boolean"&&oe})}e.$qJ=C;class Z{constructor(de,ie){this.c=null,this.a={...de.excludePattern||{},...ie.excludePattern||{}},this.b=T.$Ij(this.a);let Se=de.includePattern;ie.includePattern&&(Se?Se={...Se,...ie.includePattern}:Se=ie.includePattern),Se&&(this.c=T.$Ij(Se))}matchesExcludesSync(de,ie,Se){return!!(this.b&&this.b(de,ie,Se))}includedInQuerySync(de,ie,Se){return!(this.b&&this.b(de,ie,Se)||this.c&&!this.c(de,ie,Se))}includedInQuery(de,ie,Se){const oe=this.b(de,ie,Se),x=()=>this.c?!!this.c(de,ie,Se):!0;return(0,S.$Og)(oe)?oe.then(q=>q?!1:x()):x()}hasSiblingExcludeClauses(){return ce(this.a)}}e.$rJ=Z;function ce(fe){for(const de in fe)if(typeof fe[de]!="boolean")return!0;return!1}function me(fe){if(!fe)return;let de;return ie=>(de||(de=(fe()||Promise.resolve([])).then(Se=>Se?ke(Se):{})),de.then(Se=>!!Se[ie]))}e.$sJ=me;function be(fe){if(!fe)return;let de;return ie=>{if(!de){const Se=fe();de=Se?ke(Se):{}}return!!de[ie]}}e.$tJ=be;function ke(fe){const de={};for(const ie of fe)de[ie]=!0;return de}}),define(Ce[36],Re([1,0,18,13,20,5,6,50,12,122,25,11,2,169,4,15,188,47,43,27,17,8,7,57,44,3,51]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c,h,i,s,u,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=void 0;function f(W,z,V){return new A.$sg(P=>y(P,V)).isEqual(W,z)}function k(W,z,V){return f(W.uri,z.uri,V)?0:(0,S.$1e)(W.uri.toString(),z.uri.toString())}function F(W,z,V){return W.index!==z.index?W.index<z.index?-1:1:f(W.uri,z.uri,V)?(0,S.$1e)(W.name,z.name):(0,S.$1e)(W.uri.toString(),z.uri.toString())}function v(W,z,V,P){const C=W.slice(0).sort((ce,me)=>V(ce,me,P)),Z=z.slice(0).sort((ce,me)=>V(ce,me,P));return(0,E.$Eb)(C,Z,(ce,me)=>V(ce,me,P))}function y(W,z){const V=z.getCapabilities(W.scheme);return!(V&&V&1024)}class D extends t.$ii{static toExtHostWorkspace(z,V,P,C){if(!z)return{workspace:null,added:[],removed:[]};const{id:Z,name:ce,folders:me,configuration:be,transient:ke,isUntitled:fe}=z,de=[],ie=V;V?me.forEach((q,ne)=>{const Ie=l.URI.revive(q.uri),Ae=D.o(P||V,Ie,C);Ae?(Ae.name=q.name,Ae.index=q.index,de.push(Ae)):de.push({uri:Ie,name:q.name,index:ne})}):de.push(...me.map(({uri:q,name:ne,index:Ie})=>({uri:l.URI.revive(q),name:ne,index:Ie}))),de.sort((q,ne)=>q.index<ne.index?-1:1);const Se=new D(Z,ce,de,!!ke,be?l.URI.revive(be):null,!!fe,q=>y(q,C)),{added:oe,removed:x}=v(ie?ie.workspaceFolders:[],Se.workspaceFolders,k,C);return{workspace:Se,added:oe,removed:x}}static o(z,V,P){for(let C=0;C<z.folders.length;C++){const Z=z.workspaceFolders[C];if(f(Z.uri,V,P))return Z}}constructor(z,V,P,C,Z,ce,me){super(z,P.map(be=>new t.$ji(be)),C,Z,me),this.t=V,this.u=ce,this.q=[],this.s=$.$8h.forUris(me),P.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,V){return V&&this.s.get(z)&&(z=(0,A.$Cg)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let N=class{constructor(z,V,P,C,Z){this.c=new L.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Ud,this.B=new Map,this.h=C,this.s=P,this.t=Z,this.j=new w.$5l,this.k=new T.$1g,this.o=z.getProxy(d.$NK.MainThreadWorkspace),this.q=z.getProxy(d.$NK.MainThreadMessageService);const ce=V.workspace;this.l=ce?new D(ce.id,ce.name,[],!!ce.transient,ce.configuration?l.URI.revive(ce.configuration):null,!!ce.isUntitled,me=>y(me,P)):void 0}$initializeWorkspace(z,V){this.v=V,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,A.$Ag)((0,A.$Cg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,V,P,...C){const Z=[];if(Array.isArray(C)&&C.forEach(fe=>{l.URI.isUri(fe.uri)&&!Z.some(de=>f(de.uri,fe.uri,this.s))&&Z.push({uri:fe.uri,name:fe.name||(0,A.$zg)(fe.uri)})}),this.n||[V,P].some(fe=>typeof fe!="number"||fe<0)||P===0&&Z.length===0)return!1;const ce=this.x?this.x.workspaceFolders:[];if(V+P>ce.length)return!1;const me=ce.slice(0);me.splice(V,P,...Z.map(fe=>({uri:fe.uri,name:fe.name||(0,A.$zg)(fe.uri),index:void 0})));for(let fe=0;fe<me.length;fe++){const de=me[fe];if(me.some((ie,Se)=>Se!==fe&&f(de.uri,ie.uri,this.s)))return!1}me.forEach((fe,de)=>fe.index=de);const{added:be,removed:ke}=v(ce,me,F,this.s);if(be.length===0&&ke.length===0)return!1;if(this.o){const fe=z.displayName||z.name;this.o.$updateWorkspaceFolders(fe,V,P,Z).then(void 0,de=>{this.n=void 0;const ie={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(a.Severity.Error,(0,p.localize)(0,null,fe,de.toString()),ie,[])})}return this.y(me),!0}getWorkspaceFolder(z,V){if(this.x)return this.x.getWorkspaceFolder(z,V)}async getWorkspaceFolder2(z,V){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,V)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,V){let P,C="";if(typeof z=="string"?(P=l.URI.file(z),C=z):typeof z<"u"&&(P=z,C=z.fsPath),!P)return C;const Z=this.getWorkspaceFolder(P,!0);if(!Z)return C;typeof V>"u"&&this.x&&(V=this.x.folders.length>1);let ce=(0,A.$Fg)(Z.uri,P);return V&&Z.name&&(ce=`${Z.name}/${ce}`),ce}y(z){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:V,added:P,removed:C}=D.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=V||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:C}))}findFiles(z,V,P,C,Z=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${C.value}, entryPoint: findFiles`);let ce;if(V===null?ce=!1:V&&(typeof V=="string"?ce=V:ce=V.pattern),Z&&Z.isCancellationRequested)return Promise.resolve([]);const{includePattern:me,folder:be}=O(h.GlobPattern.from(z));return this.o.$startFileSearch(me??null,be??null,ce??null,P??null,Z).then(ke=>Array.isArray(ke)?ke.map(fe=>l.URI.revive(fe)):[])}async findTextInFiles(z,V,P,C,Z=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${C.value}, entryPoint: findTextInFiles`);const ce=this.j.getNext(),me=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:be,folder:ke}=O(h.GlobPattern.from(V.include)),fe=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,de={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:me,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:be,excludePattern:fe},ie=!1;if(this.u[ce]=Se=>{if(ie)return;const oe=l.URI.revive(Se.resource);Se.results.forEach(x=>{const q=(0,m.$yh)(x);(0,u.$_I)(q)?P({uri:oe,preview:{text:q.preview.text,matches:(0,E.$2b)(q.preview.matches,ne=>new i.$RK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,E.$2b)(q.ranges,ne=>new i.$RK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):P({uri:oe,text:q.text,lineNumber:q.lineNumber})})},Z.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(z,ke??null,de,ce,Z);return delete this.u[ce],Se||{}}catch(Se){throw delete this.u[ce],Se}}$handleTextSearchResult(z,V){this.u[V]?.(z)}async save(z){const V=await this.o.$save(z,{saveAs:!1});return l.URI.revive(V)}async saveAs(z){const V=await this.o.$save(z,{saveAs:!0});return l.URI.revive(V)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,V){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,V);const P=this.t.transformOutgoingScheme(z),C=this.z++;return this.o.$registerEditSessionIdentityProvider(C,P),(0,R.$Qc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(C)})}async $getEditSessionIdentifier(z,V){this.h.info("Getting edit session identifier for workspaceFolder",z);const P=await this.resolveWorkspaceFolder(l.URI.revive(z));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const C=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!C),!C)return;const Z=await C.provideEditSessionIdentity(P,V);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(z,V,P,C){this.h.info("Getting edit session identifier for workspaceFolder",z);const Z=await this.resolveWorkspaceFolder(l.URI.revive(z));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const ce=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!ce),!ce)return;const me=await ce.provideEditSessionIdentityMatch?.(V,P,C);if(this.h.info("Provider returned edit session identifier match result: ",me),!!me)return me}getOnWillCreateEditSessionIdentityEvent(z){return(V,P,C)=>{const Z=function(me){V.call(P,me)};return Z.extension=z,this.A.event(Z,void 0,C)}}async $onWillCreateEditSessionIdentity(z,V,P){const C=await this.resolveWorkspaceFolder(l.URI.revive(z));if(C===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:C},V,async(Z,ce)=>{const me=Date.now();await Promise.resolve(Z),Date.now()-me>P&&this.h.warn("SLOW edit session create-participant",ce.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider(z,V){if(this.B.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.B.set(z,V);const P=this.t.transformOutgoingScheme(z),C=this.z++;return this.o.$registerCanonicalUriProvider(C,P),(0,R.$Qc)(()=>{this.B.delete(z),this.o.$unregisterCanonicalUriProvider(C)})}async provideCanonicalUri(z,V,P){const C=this.B.get(z.scheme);if(!C)return;const Z=await C.provideCanonicalUri?.(l.URI.revive(z),V,P);if(Z)return Z}async $provideCanonicalUri(z,V,P){return this.provideCanonicalUri(l.URI.revive(z),{targetScheme:V},P)}};e.$wfc=N,e.$wfc=N=Ge([Ke(0,c.$RM),Ke(1,o.$8M),Ke(2,n.$cfc),Ke(3,r.$jj),Ke(4,s.$ufc)],N),e.$xfc=(0,b.$2h)("IExtHostWorkspace");function O(W){let z,V;return W&&(typeof W=="string"?z=W:(z=W.pattern,V=l.URI.revive(W.baseUri))),{includePattern:z,folder:V}}}),define(Ce[37],Re([1,0,26,5,36,3,7,190,54,16,13,4,17,15,2]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=void 0;function r(s,u){if(u){const d=u.split(".");let m=s;for(let f=0;m&&f<d.length;f++)m=m[d[f]];return m}}function a(s){return s instanceof b.URI}function t(s){return s&&s.uri instanceof b.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function o(s){return s&&s.uri instanceof b.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function c(s){if(a(s))return{resource:s};if(t(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(o(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(u,d,m){this.a=u.getProxy(L.$NK.MainThreadConfiguration),this.c=d,this.b=m,this.d=new A.$1g,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(u,d))}};e.$yfc=h,e.$yfc=h=Ge([Ke(0,l.$RM),Ke(1,I.$xfc),Ke(2,p.$jj)],h);class i{constructor(u,d,m,f){this.a=new T.$Sd,this.b=u,this.f=f,this.c=d,this.e=$.$Sn.parse(m),this.d=this.k(m.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const m={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Sn.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,m))}getConfiguration(u,d,m){const f=c(d)||{},k=this.g(u?r(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,m?.identifier);function F(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(y){return typeof r(k,y)<"u"},get:(y,D)=>{this.h(u?`${u}.${y}`:y,f,m?.identifier);let N=r(k,y);if(typeof N>"u")N=D;else{let O;const W=(z,V)=>{if((0,w.$Gf)(z)){let P;const C=()=>{O=O||(0,E.$in)(k),P=P||r(O,V)};return new Proxy(z,{get:(Z,ce)=>{if(typeof ce=="string"&&ce.toLowerCase()==="tojson")return C(),()=>P;if(O)return P=P||r(O,V),P[ce];const me=Z[ce];return typeof ce=="string"?W(me,`${V}.${ce}`):me},set:(Z,ce,me)=>(C(),P&&(P[ce]=me),!0),deleteProperty:(Z,ce)=>(C(),P&&delete P[ce],!0),defineProperty:(Z,ce,me)=>(C(),P&&Object.defineProperty(P,ce,me),!0)})}return Array.isArray(z)?(0,E.$in)(z):z};N=W(N,y)}return N},update:(y,D,N,O)=>{y=u?`${u}.${y}`:y;const W=F(N);return D!==void 0?this.b.$updateConfigurationOption(W,y,D,f,O):this.b.$removeConfigurationOption(W,y,f,O)},inspect:y=>{y=u?`${u}.${y}`:y;const D=this.e.inspect(y,f,this.c.workspace);if(D)return{key:y,defaultValue:(0,E.$in)(D.policy?.value??D.default?.value),globalValue:(0,E.$in)(D.user?.value??D.application?.value),workspaceValue:(0,E.$in)(D.workspace?.value),workspaceFolderValue:(0,E.$in)(D.workspaceFolder?.value),defaultLanguageValue:(0,E.$in)(D.default?.override),globalLanguageValue:(0,E.$in)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,E.$in)(D.workspace?.override),workspaceFolderLanguageValue:(0,E.$in)(D.workspaceFolder?.override),languageIds:(0,E.$in)(D.overrideIdentifiers)}}};return typeof k=="object"&&(0,E.$ln)(v,k,!1),Object.freeze(v)}g(u){const d=m=>(0,w.$Gf)(m)?new Proxy(m,{get:(f,k)=>d(f[k]),set:(f,k,F)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(f,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(f,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return d(u)}h(u,d,m){const f=g.$Jn.test(u)?4:this.d.get(u),k=m?`[${m.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const m=new $.$Un(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,k)=>m.affectsConfiguration(f,c(k))})}k(u){return u.reduce((d,m)=>(d.set(m[0],m[1]),d),new Map)}}e.$zfc=i,e.$Afc=(0,S.$2h)("IExtHostConfiguration")}),define(Ce[115],Re([1,0,2,13,5,3,7,36,61,37,20,64,17,27,4,12,21,15,81,229,14]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(W){function z(P){if(P!=null)return P}W.from=z;function V(P){if(P!=null)return P}W.to=V})(h||(h={}));var i;(function(W){function z(P){if(P!=null)return P}W.from=z;function V(P){if(P!=null)return P}W.to=V})(i||(i={}));var s;(function(W){function z(P){if(P!=null)return P}W.from=z;function V(P){if(P!=null)return P}W.to=V})(s||(s={}));var u;(function(W){function z(C){if(C){const Z=C;return Z&&!!Z.process}else return!1}W.is=z;function V(C){if(C==null)return;const Z={process:C.process,args:C.args};return C.options&&(Z.options=s.from(C.options)),Z}W.from=V;function P(C){if(C!=null)return new R.$yL(C.process,C.args,C.options)}W.to=P})(u||(u={}));var d;(function(W){function z(P){if(P!=null)return P}W.from=z;function V(P){if(P!=null)return P}W.to=V})(d||(d={}));var m;(function(W){function z(C){if(C){const Z=C;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}W.is=z;function V(C){if(C==null)return;const Z={};return C.commandLine!==void 0?Z.commandLine=C.commandLine:(Z.command=C.command,Z.args=C.args),C.options&&(Z.options=d.from(C.options)),Z}W.from=V;function P(C){if(!(C==null||C.command===void 0&&C.commandLine===void 0))return C.commandLine?new R.$zL(C.commandLine,C.options):new R.$zL(C.command,C.args?C.args:[],C.options)}W.to=P})(m||(m={}));var f;(function(W){function z(C){if(C){const Z=C;return Z&&Z.customExecution==="customExecution"}else return!1}W.is=z;function V(C){return{customExecution:"customExecution"}}W.from=V;function P(C,Z){return Z.get(C)}W.to=P})(f||(e.CustomExecutionDTO=f={}));var k;(function(W){function z(V,P){let C;return V.scope!==void 0&&typeof V.scope!="number"?C=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?C=P.workspaceFile:C=o.$kG),{id:V._id,workspaceFolder:C}}W.from=z})(k||(e.TaskHandleDTO=k={}));var F;(function(W){function z(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}W.from=z})(F||(F={}));var v;(function(W){function z(C,Z){if(C==null)return[];const ce=[];for(const me of C){const be=V(me,Z);be&&ce.push(be)}return ce}W.fromMany=z;function V(C,Z){if(C==null)return;let ce;C.execution instanceof R.$yL?ce=u.from(C.execution):C.execution instanceof R.$zL?ce=m.from(C.execution):C.execution&&C.execution instanceof R.$AL&&(ce=f.from(C.execution));const me=h.from(C.definition);let be;return C.scope?typeof C.scope=="number"?be=C.scope:be=C.scope.uri:be=R.TaskScope.Workspace,!me||!be?void 0:{_id:C._id,definition:me,name:C.name,source:{extensionId:Z.identifier.value,label:C.source,scope:be},execution:ce,isBackground:C.isBackground,group:F.from(C.group),presentationOptions:i.from(C.presentationOptions),problemMatchers:C.problemMatchers,hasDefinedMatchers:C.hasDefinedMatchers,runOptions:C.runOptions?C.runOptions:{reevaluateOnRerun:!0},detail:C.detail}}W.from=V;async function P(C,Z,ce){if(C==null)return;let me;u.is(C.execution)?me=u.to(C.execution):m.is(C.execution)?me=m.to(C.execution):f.is(C.execution)&&(me=f.to(C._id,ce));const be=h.to(C.definition);let ke;if(C.source&&(C.source.scope!==void 0?typeof C.source.scope=="number"?ke=C.source.scope:ke=await Z.resolveWorkspaceFolder(E.URI.revive(C.source.scope)):ke=R.TaskScope.Workspace),!be||!ke)return;const fe=new R.$BL(be,ke,C.name,C.source.label,me,C.problemMatchers);return C.isBackground!==void 0&&(fe.isBackground=C.isBackground),C.group!==void 0&&(fe.group=R.$xL.from(C.group._id),fe.group&&C.group.isDefault&&(fe.group=new R.$xL(fe.group.id,fe.group.label),C.group.isDefault===!0&&(fe.group.isDefault=C.group.isDefault))),C.presentationOptions&&(fe.presentationOptions=i.to(C.presentationOptions)),C._id&&(fe._id=C._id),C.detail&&(fe.detail=C.detail),fe}W.to=P})(v||(e.TaskDTO=v={}));var y;(function(W){function z(P){return P}W.from=z;function V(P){if(P)return Object.assign(Object.create(null),P)}W.to=V})(y||(y={}));class D{#e;constructor(z,V,P){this._id=V,this.a=P,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let N=class{constructor(z,V,P,C,Z,ce,me,be){this.q=new I.$Sd,this.r=new I.$Sd,this.s=new I.$Sd,this.u=new I.$Sd,this.a=z.getProxy(L.$NK.MainThreadTask),this.b=P,this.c=C,this.d=Z,this.e=ce,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,V,P){if(!P)return new R.$PK(()=>{});const C=this.x();return this.j.set(C,{type:V,provider:P,extension:z}),this.a.$registerTaskProvider(C,V),new R.$PK(()=>{this.j.delete(C),this.a.$unregisterTaskProvider(C)})}registerTaskSystem(z,V){this.a.$registerTaskSystem(z,V)}fetchTasks(z){return this.a.$fetchTasks(y.from(z)).then(async V=>{const P=[];for(const C of V){const Z=await v.to(C,this.b,this.m);Z&&P.push(Z)}return P})}get taskExecutions(){const z=[];return this.k.forEach(V=>z.push(V)),z}terminateTask(z){if(!(z instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,V,P){const C=this.m.get(z.id);C&&(this.o.set(z.id,C),this.e.attachPtyToTerminal(V,await C.callback(P))),this.p=z.id,this.q.fire({execution:await this.z(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){if(!this.l.has(z.id))return;const V=await this.z(z);this.l.delete(z.id),this.k.delete(z.id),this.B(z),this.r.fire({execution:V})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const V=await this.z(z.id);this.s.fire({execution:V,processId:z.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(z){const V=await this.z(z.id);this.u.fire({execution:V,exitCode:z.exitCode})}$provideTasks(z,V){const P=this.j.get(z);if(!P)return Promise.reject(new Error("no handler found"));const C=[],Z=(0,T.$Ug)(()=>P.provider.provideTasks(A.CancellationToken.None)).then(ce=>this.v(V,C,P,ce));return new Promise(ce=>{Z.then(me=>{Promise.all(C).then(()=>{ce(me)})})})}async $resolveTask(z,V){const P=this.j.get(z);if(!P)return Promise.reject(new Error("no handler found"));if(V.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${P.type}].`);const C=await v.to(V,this.b,this.m);if(!C)throw new Error("Unexpected: Task cannot be resolved.");const Z=await P.provider.resolveTask(C,A.CancellationToken.None);if(!Z)return;this.A(Z,P);const ce=v.from(Z,P.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==C.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ce.execution)&&await this.y(ce,Z,!0),await this.w(ce)}x(){return this.h++}async y(z,V,P){const C=await this.a.$createTaskId(z);!P&&!this.m.has(C)&&(this.n.add(C),this.o.set(C,V.execution)),this.m.set(C,V.execution)}async z(z,V){if(typeof z=="string"){const Z=this.l.get(z);if(!Z)throw new c.$bb("Unexpected: The specified task is missing an execution");return Z}const P=this.l.get(z.id);if(P)return P;let C;return V?C=Promise.resolve(new D(this,z.id,V)):C=v.to(z.task,this.b,this.m).then(Z=>{if(!Z)throw new c.$bb("Unexpected: Task does not exist.");return new D(this,z.id,Z)}),this.l.set(z.id,C),C.then(Z=>(this.k.set(z.id,Z),Z))}A(z,V){z._deprecated&&this.g.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}B(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const P=this.n.values();let C=P.next();for(;!C.done;)!this.o.has(C.value)&&this.p!==C.value&&(this.m.delete(C.value),this.n.delete(C.value)),C=P.next()}};e.$2gc=N,e.$2gc=N=Ge([Ke(0,l.$RM),Ke(1,p.$8M),Ke(2,$.$xfc),Ke(3,g.$3M),Ke(4,w.$Afc),Ke(5,S.$Yfc),Ke(6,t.$jj),Ke(7,n.$ffc)],N);let O=class extends N{constructor(z,V,P,C,Z,ce,me,be){super(z,V,P,C,Z,ce,me,be),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:a.$h(0)})}async executeTask(z,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const P=v.from(V,z);if(P===void 0)throw new Error("Task is not valid");if(f.is(P.execution))await this.y(P,V,!1);else throw new c.$_;const C=await this.z(await this.a.$getTaskExecution(P),V);return this.a.$executeTask(P).catch(Z=>{throw new Error(Z)}),C}v(z,V,P,C){const Z=[];if(C)for(const ce of C){if(this.A(ce,P),!ce.definition||!z[ce.definition.type]){const be=ce.source?ce.source:"No task source";this.f.warn(`The task [${be}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`)}const me=v.from(ce,P.extension);me&&f.is(me.execution)?(Z.push(me),V.push(this.y(me,ce,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:P.extension}}async w(z){if(f.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,V,P){}};e.$3gc=O,e.$3gc=O=Ge([Ke(0,l.$RM),Ke(1,p.$8M),Ke(2,$.$xfc),Ke(3,g.$3M),Ke(4,w.$Afc),Ke(5,S.$Yfc),Ke(6,t.$jj),Ke(7,n.$ffc)],O),e.$4gc=(0,b.$2h)("IExtHostTask")}),define(Ce[282],Re([1,0,44,29]),function(ge,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BJ=e.$AJ=e.$zJ=void 0;function I(R){return"cellResults"in R}e.$zJ=I,e.$AJ="rawCell#";function L(R,$){let g=-1;const w=[];let A=[];return R.forEach(l=>{l.range.startLineNumber!==g&&A.length>0&&(w.push([...A]),A=[]),A.push(l),g=l.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(l=>{const p=[],b=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let a=b;a<=r;a++)p.push($.getLineContent(a));return new E.$dJ(p.join(`
`)+`
`,l.map(a=>new T.$Hs(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.$BJ=L}),define(Ce[283],Re([1,0,162,24,5,6,28,11,16,2,42,75,3,32,8,7,49,221,107,26,12,212,282,280]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,f,k,F,v,y){this.q=k,this.r=F,this.s=v,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new I.$Sd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Sd,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Sd,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Sd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$$ec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(l.$NK.MainThreadNotebook),this.c=m.getProxy(l.$NK.MainThreadNotebookDocuments),this.d=m.getProxy(l.$NK.MainThreadNotebookEditors),this.i=f.converter,f.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const N=D.notebookEditor?.notebookUri,O=D.cell.handle,z=this.g.get(N)?.getCell(O);if(z)return z.apiCell}if(D&&D.$mid===14){const N=D.uri,O=this.g.get(N);if(O)return O.apiNotebook}return D}}),u.B(f)}getEditorById(m){const f=this.h.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return f}getIdByEditor(m){for(const[f,k]of this.h)if(k.apiEditor===m)return f}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,f){const k=this.g.get(m);if(!k&&!f)throw new Error(`NO notebook document for '${m}'`);return k}static u(m,f){if(!f)return;const k=f.filenamePattern.map(F=>b.NotebookExclusiveDocumentPattern.from(F)).filter(F=>F!==void 0);if(f.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:f.displayName,filenamePattern:k,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,f,k){const F=u.a++,v=typeof k.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(F,k),this.b.$registerNotebookCellStatusBarItemProvider(F,v,f);let y;return v!==void 0&&(y=k.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(v))),new r.$PK(()=>{this.f.delete(F),this.b.$unregisterNotebookCellStatusBarItemProvider(F,v),y?.dispose()})}async createNotebookDocument(m){const f=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&b.NotebookData.from(m.content)});return w.URI.revive(f)}async openNotebookDocument(m){const f=this.g.get(m);if(f)return f.apiNotebook;const k=await this.c.$tryOpenNotebook(m),F=this.g.get(w.URI.revive(k));return(0,g.$Pf)(F?.apiNotebook)}async showNotebookDocument(m,f){w.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let k;typeof f=="object"?k={position:b.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(b.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:k={preserveFocus:!1};const F=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,k),v=F&&this.h.get(F)?.apiEditor;if(v)return v;throw F?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,f,k,F){const v=this.f.get(m),y=w.URI.revive(f),D=this.g.get(y);if(!D||!v)return;const N=D.getCellFromIndex(k);if(!N)return;const O=await v.provideCellStatusBarItems(N.apiCell,F);if(!O)return;const W=new L.$Rc,z=this.p.add([W]),P=(Array.isArray(O)?O:[O]).map(C=>b.NotebookStatusBarItem.from(C,this.i,W));return{cacheId:z,items:P}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,f,k,F,v){if((0,$.$Ge)(f))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:f,serializer:k,options:F}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},f,b.NotebookDocumentContentOptions.from(F),u.u(m,v)),(0,L.$Qc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,f,k){const F=this.x.get(m);if(!F)throw new Error("NO serializer found");const v=await F.serializer.deserializeNotebook(f.buffer,k);return new a.$Fv(b.NotebookData.from(v))}async $notebookToData(m,f,k){const F=this.x.get(m);if(!F)throw new Error("NO serializer found");const v=await F.serializer.serializeNotebook(b.NotebookData.to(f.value),k);return T.$ge.wrap(v)}async $saveNotebook(m,f,k,F,v){const y=w.URI.revive(f),D=this.x.get(m);if(!D)throw new Error("NO serializer found");const N=this.g.get(y);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$Hk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,F);const O={metadata:(0,o.$qn)(N.apiNotebook.metadata,C=>!(D.options?.transientDocumentMetadata??{})[C]),cells:[]};for(const C of N.apiNotebook.getCells()){const Z=new r.$cM(C.kind,C.document.getText(),C.document.languageId,C.mime,D.options?.transientOutputs?[]:[...C.outputs],C.metadata,C.executionSummary);Z.metadata=(0,o.$qn)(C.metadata,ce=>!(D.options?.transientCellMetadata??{})[ce]),O.cells.push(Z)}const W=await D.serializer.serializeNotebook(O,v);await this.s.value.writeFile(y,W);const z=this.s.getFileSystemProviderExtUri(y.scheme),V=await this.s.value.stat(y);return{name:z.basename(y),isFile:(V.type&A.FileType.File)!==0,isDirectory:(V.type&A.FileType.Directory)!==0,isSymbolicLink:(V.type&A.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((V.permissions??0)&A.FilePermission.Locked),etag:A.$Sk({mtime:V.mtime,size:V.size}),children:void 0}}async $searchInNotebooks(m,f,k,F,v){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const D=new R.$Bc;await(async(V,P,C)=>{await Promise.all(V.map(async Z=>await Promise.all(Z.filenamePatterns.map(ce=>{const me={_reason:C._reason,folderQueries:C.folderQueries,includePattern:C.includePattern,excludePattern:C.excludePattern,maxResults:C.maxResults,type:1,filePattern:ce};return this.t.doInternalFileSearchWithCustomCallback(me,P,be=>{be.forEach(ke=>{D.has(ke)||F.some(de=>Z.isFromSettings&&!de.isFromSettings?!1:de.filenamePatterns.some(ie=>(0,s.$5cb)(ie,ke)))||D.add(ke)})})}))))})(k,v,f);const O=new R.$Ac;let W=!1;const z=Array.from(D).map(async V=>{const P=[];try{if(v.isCancellationRequested)return;if(f.maxResults&&[...O.values()].reduce((me,be)=>me+be.cellResults.length,0)>f.maxResults){W=!0;return}const C=[],Z=this.g.get(V);if(Z)Z.apiNotebook.getCells().forEach(be=>C.push({input:be.document.getText(),outputs:be.outputs.flatMap(ke=>ke.items.map(fe=>fe.data.toString()))}));else{const me=await this.s.value.readFile(V),be=T.$ge.fromString(me.toString()),ke=await y.deserializeNotebook(be.buffer,v);if(v.isCancellationRequested)return;b.NotebookData.from(ke).cells.forEach(de=>C.push({input:de.source,outputs:de.outputs.flatMap(ie=>ie.items.map(Se=>Se.valueBytes.toString()))}))}if(v.isCancellationRequested)return;C.forEach((me,be)=>{const ke=f.contentPattern.pattern,fe=new h.$7Pb(me.input,void 0,me.outputs),de=fe.findInInputs(ke),ie=fe.findInOutputs(ke),Se=ie.flatMap(oe=>(0,i.$BJ)(oe.matches,oe.textBuffer)).map((oe,x)=>(oe.webviewIndex=x,oe));if(de.length>0||ie.length>0){const oe={index:be,contentResults:(0,i.$BJ)(de,fe.inputTextBuffer),webviewResults:Se};P.push(oe)}});const ce={resource:V,cellResults:P};O.set(V,ce);return}catch{return}});return await Promise.all(z),{limitHit:W,results:[...O.values()]}}async y(m,f){const k=await this.s.value.stat(m);if(typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==A.$Rk&&typeof k.mtime=="number"&&typeof k.size=="number"&&f.mtime<k.mtime&&f.etag!==A.$Sk({mtime:f.mtime,size:k.size}))throw new A.$Hk((0,E.localize)(1,null),3,f)}z(m){return m.scheme===c.Schemas.file?m.fsPath:m.toString()}A(m,f,k){if(this.h.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const F=new n.$ugc(f,this.d,m,k.visibleRanges.map(b.NotebookRange.to),k.selections.map(b.NotebookRange.to),typeof k.viewColumn=="number"?b.ViewColumn.to(k.viewColumn):void 0);this.h.set(f,F)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const k of m.value.removedDocuments){const F=w.URI.revive(k),v=this.g.get(F);v&&(v.dispose(),this.g.delete(F),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(v.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===F.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const k=[];for(const F of m.value.addedDocuments){const v=w.URI.revive(F.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const y=new t.$tgc(this.c,this.q,this.r,v,F);k.push(...F.cells.map(D=>t.$sgc.asModelAddData(y.apiNotebook,D))),this.g.get(v)?.dispose(),this.g.set(v,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const k of m.value.addedEditors){if(this.h.has(k.id))return;const F=w.URI.revive(k.documentUri),v=this.g.get(F);v&&this.A(v,k.id,k)}const f=[];if(m.value.removedEditors)for(const k of m.value.removedEditors){const F=this.h.get(k);F&&(this.h.delete(k),this.k?.id===F.id&&(this.k=void 0),f.push(F))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(F=>this.h.get(F)).filter(F=>!!F);const k=new Set;this.l.forEach(F=>k.add(F.id));for(const F of this.h.values()){const v=k.has(F.id);F._acceptVisibility(v)}this.l=[...this.h.values()].map(F=>F).filter(F=>F.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const f=p.$dN.String.with("notebookType","A notebook type"),k=new p.$fN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new p.$dN("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$ge.wrap(v))],new p.$eN("Notebook Data",v=>b.NotebookData.to(v.value))),F=new p.$fN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new p.$dN("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new a.$Fv(b.NotebookData.from(v)))],new p.$eN("Bytes",v=>v.buffer));m.registerApiCommand(k),m.registerApiCommand(F)}}e.$Dgc=u}),define(Ce[284],Re([1,0,19,20,40,34,25,60,44]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class w{constructor(l,p,b){this.k=l,this.l=p,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&L.$Ij(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&L.$Ij(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((b,r)=>{const a=t=>{this.f++,l(t)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),o=E.$nc(n);this.j&&this.j(n,o)||this.v(a,{base:t,basename:o})}),Promise.all(p.map(t=>this.p(t,a))).then(t=>{b({limitHit:this.e,stats:t[0]||void 0})},t=>{r(new Error((0,I.$Mi)(t)))})})}async p(l,p){const b=new T.$3d,r=this.q(l),a=this.r(),t=new g.$rJ(this.k,l),n=!t.hasSiblingExcludeClauses();let o;try{this.h.add(b),o=$.$Od.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,b.token),h=o.elapsed(),i=$.$Od.create();return this.g&&!this.e||(c&&c.forEach(s=>{const u=E.$gc.relative(l.folder.path,s.path);if(n){const d=E.$nc(s.path);this.v(p,{base:l.folder,relativePath:u,basename:d});return}this.s(a,l.folder,u,p)}),this.g&&!this.e)?null:(this.u(a,t,p),{providerTime:h,postProcessTime:i.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(l){const p=(0,g.$qJ)(this.k.includePattern,l.includePattern),b=(0,g.$qJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:b,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,b,r){if(b===this.a){const t=E.$nc(this.a);this.v(r,{base:p,relativePath:this.a,basename:t})}function a(t){const n=E.$nc(t),o=E.$mc(t);let c=l[o];c||(c=l[o]=[],a(o)),c.push({base:p,relativePath:t,basename:n})}a(b)}u({rootEntries:l,pathToEntries:p},b,r){const a=this,t=this.a;function n(o){const c=(0,g.$tJ)(()=>o.map(h=>h.basename));for(let h=0,i=o.length;h<i;h++){const s=o[h],{relativePath:u,basename:d}=s;if(b.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const m=p[u];if(m)n(m);else{if(u===t)continue;a.v(r,s)}if(a.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,b,r){const a=this.c(l.cacheKey),t=new w(l,p,a&&a.token);let n=0;const o=c=>{n+=c.length,b(c.map(h=>this.d(h)))};return this.e(t,A.a,o,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$3d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Dg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,b,r){const a=r.onCancellationRequested(()=>{l.cancel()}),t=o=>{o&&(n.push(o),p>0&&n.length>=p&&(b(n),n=[]))};let n=[];return l.search(t).then(o=>(n.length&&b(n),a.dispose(),o),o=>(n.length&&b(n),a.dispose(),Promise.reject(o)))}}e.$vgc=A}),define(Ce[285],Re([1,0,18,246,34,95,28,12,19,25,11,16,2,94,180,41,15,47,105,281,44]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.$rK=void 0;let h=class{constructor(y,D,N,O,W){this.a=y,this.b=D,this.c=N,this.d=O,this.e=W}text(y,D,N={}){y=this.f(y,N);const O=this.a.getValue(),W=D&&D.some(V=>!this.a.getValue({resource:V}).search.useRipgrep);return{...this.h(D?.map(t.$ki),N),type:2,contentPattern:y,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:O.search.usePCRE2||W||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(y,D){const N=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const O={...y,wordSeparators:N.editor.wordSeparators};return this.j(y,D)&&(O.isCaseSensitive=!0),this.k(y)&&(O.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),O}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(y,D){return y?(y=Array.isArray(y)?y.map(m):m(y),D?this.parseSearchPaths(y):{pattern:s(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const N=this.g(D.includePattern,D.expandPatterns),O=this.g(D.excludePattern,D.expandPatterns),W=y.length>1,z=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(C=>this.q(C,D,O)):y.map(C=>this.r(C,D,O,W))).filter(C=>!!C),V={_reason:D._reason,folderQueries:z,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:N.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const C=E.$Hb(E.$Rb(this.c.groups.map(me=>me.editors.map(be=>be.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(C));const Z=C.filter(me=>(0,c.$hJ)(V,me.fsPath)),ce=this.i(Z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ce)),{...V,...ce}}const P=D.extraFileResources&&D.extraFileResources.filter(C=>(0,c.$hJ)(V,C.fsPath));return V.extraFileResources=P&&P.length?P:void 0,V}i(y){const D=[],N=new R.$Ac,O={};let W=!1;return y.forEach(z=>{if(z.scheme===$.Schemas.walkThrough)return;if((0,w.$Hg)(z)){const P=this.b.getWorkspaceFolder(z)?.uri??z.with({path:g.$mc(z.fsPath)});let C=N.get(P);C||(W=!0,C={folder:P,includePattern:{}},D.push(C),N.set(P,C));const Z=g.$lc(P.fsPath,z.fsPath);(0,S.$Pf)(C.includePattern)[Z.replace(/\\/g,"/")]=!0}else z.fsPath&&(W=!0,O[z.fsPath]=!0)}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(A.$vf(y.pattern,!0))return!0}else if(A.$vf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,p.$OB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=ce=>g.$ic(ce)||/^\.\.?([\/\\]|$)/.test(ce),O=(Array.isArray(y)?y:u(y)).map(ce=>{const me=this.e.resolvedUserHome;return me?(0,L.$Kv)(ce,me.scheme===$.Schemas.file?me.fsPath:me.path):ce}),W=T.$K(O,ce=>D(ce)?"searchPaths":"exprSegments"),z=(W.exprSegments||[]).map(ce=>A.$Qe(ce,"/")).map(ce=>A.$Qe(ce,"\\")).map(ce=>(ce[0]==="."&&(ce="*"+ce),d(ce))),V={},P=this.m(W.searchPaths||[]);P&&P.length&&(V.searchPaths=P);const C=E.$Rb(z),Z=s(...C);return Z&&(V.pattern=Z),V}l(y,D){return D.disregardExcludeSettings?void 0:(0,c.$gJ)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(O=>{let{pathPortion:W,globPortion:z}=i(O);return z&&(z=f(z)),this.n(W).flatMap(P=>this.o(P,z))}),N=new Map;return D.forEach(O=>{const W=O.searchPath.toString(),z=N.get(W);z?O.pattern&&(z.pattern=z.pattern||{},z.pattern[O.pattern]=!0):N.set(W,{searchPath:O.searchPath,pattern:O.pattern?s(O.pattern):void 0})}),Array.from(N.values())}n(y){if(g.$ic(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==$.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=m(y),y.startsWith("../")||y===".."){const O=g.$gc.resolve(D.path,y);return[{searchPath:D.with({path:O})}]}const N=f(y);return[{searchPath:D,pattern:N}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(W=>{const z=D.match(new RegExp(`^${A.$Ke(W.name)}(?:/(.*)|$)`));return z?{match:z,folder:W}:null}).filter(S.$Mf);if(O.length)return O.map(W=>{const z=W.match[1];return{searchPath:W.folder.uri,pattern:z&&f(z)}});{const W=y.match(/\.[\/\\](.+)[\/\\]?/),z=W?W[1]:y,V=b.localize(0,null,z);throw new Error(V)}}}}o(y,D){const N=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,O=[{searchPath:y.searchPath,pattern:N}];return N&&!N.endsWith("**")&&O.push({searchPath:y.searchPath,pattern:N+"/**"}),O}q(y,D,N){const O=this.r((0,t.$ki)(y.searchPath),D,N,!1);return O?{...O,includePattern:y.pattern}:null}r(y,D,N,O){let W;const z=l.URI.isUri(y)?y:y.uri;if(N.searchPaths){const ce=N.searchPaths.filter(me=>(0,w.$wg)(me.searchPath,z))[0];if(ce&&!ce.pattern)return null;ce&&(W=ce.pattern)}const V=this.a.getValue({resource:z}),C={...this.l(V,D)||{},...W||{}},Z=l.URI.isUri(y)?(0,w.$Ag)(y):y.name;return{folder:z,folderName:O?Z:void 0,excludePattern:Object.keys(C).length>0?C:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!V.search.followSymlinks}}};e.$rK=h,e.$rK=h=Ge([Ke(0,r.$vi),Ke(1,t.$$h),Ke(2,n.$TC),Ke(3,a.$jj),Ke(4,o.$pK)],h);function i(v){const y=v.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,N=v.substr(0,D).match(/[/|\\][^/\\]*$/);if(N){let O=v.substr(0,N.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:v.substr((N.index||0)+1)}}}return{pathPortion:v}}function s(...v){return v.length?v.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function u(v){return I.$Gj(v,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(v){return[`**/${v}/**`,`**/${v}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function m(v){return v.replace(/\\/g,"/")}function f(v){return m(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(v){return v.replace(/([?*[\]])/g,"[$1]")}function F(v,y){v=E.$Mb(v,O=>O.toString());const D=[],N=y.getWorkspace();return v&&v.forEach(O=>{let W;if(y.getWorkbenchState()===2)W=(0,w.$Fg)(N.folders[0].uri,O),W&&W!=="."&&(W="./"+W);else{const z=y.getWorkspaceFolder(O);if(z){const V=z.name;if(N.folders.filter(C=>C.name===V).length===1){const C=(0,w.$Fg)(z.uri,O);C===""?W=`./${z.name}`:W=`./${z.name}/${C}`}else W=O.fsPath}}W&&D.push(k(W))}),D}e.$sK=F}),define(Ce[286],Re([1,0,25,2,20,14,4,285,44,47]),function(ge,e,E,T,I,L,R,$,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsb=e.$csb=void 0;const A=7e3;function S(r,a){const t=a.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],o=[];for(const d of t)if(/^workspaceContains:/.test(d)){const m=d.substr(18);m.indexOf("*")>=0||m.indexOf("?")>=0||r.forceUsingSearch?o.push(m):n.push(m)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,m)=>{c=d}),i=d=>c({activationEvent:d}),s=Promise.all(n.map(d=>l(r,d,i))).then(()=>{}),u=p(r,a.identifier,o,i);return Promise.all([s,u]).then(()=>{c(void 0)}),h}e.$csb=S;async function l(r,a,t){for(const n of r.folders)if(await r.exists(E.$Dg(T.URI.revive(n),a))){t(`workspaceContains:${a}`);return}}async function p(r,a,t,n){if(t.length===0)return Promise.resolve(void 0);const o=new I.$3d,c=r.checkExists(r.folders,t,o.token),h=setTimeout(async()=>{o.cancel(),r.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(s){L.$4(s)||L.$1(s)}o.dispose(),clearTimeout(h),i&&n(`workspaceContains:${t.join(",")}`)}function b(r,a,t,n){const o=r.get(R.$1h),c=r.get(g.$$I),i=o.createInstance($.$rK).file(a.map(s=>(0,w.$ki)(T.URI.revive(s))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(s=>!!s.limitHit,s=>L.$4(s)?!1:Promise.reject(s))}e.$dsb=b}),define(Ce[38],Re([1,0,159,19,88,25,13,6,50,2,15,3,37,218,85,36,23,106,14,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,12,82,60,21,83]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c,h,i,s,u,d,m,f,k,F,v,y,D,N,O,W,z,V,P,C){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=e.$agc=e.$_fc=e.$$fc=e.$0fc=void 0,e.$0fc=(0,u.$2h)("IHostUtils");let ce=Z=class extends $.$Sc{constructor(x,q,ne,Ie,Ae,Pe,ae,te,J,ee,$e,ve){super(),this.X=ve,this.a=this.B(new y.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=q,this.g=ne,this.f=ae,this.j=Ie,this.m=Ae,this.s=Pe,this.t=J,this.u=ee,this.w=$e,this.y=this.g.getProxy(S.$NK.MainThreadWorkspace),this.z=this.g.getProxy(S.$NK.MainThreadTelemetry),this.C=this.g.getProxy(S.$NK.MainThreadExtensionService),this.D=new R.$1g,this.F=new R.$1g,this.G=new R.$1g,this.H=new R.$1g,this.I=new Se(this.f.extensions.activationEvents),this.L=new t.$k7b(this.I,this.f.extensions.allExtensions);const Fe=new o.$im(this.f.extensions.myExtensions);this.J=new t.$k7b(this.I,de(this.L,Fe)),P.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new b.$Ufc(this.g,this.s),this.N=new N.$3fc(this.g),this.O=te,this.h=x.createChild(new k.$Zh([b.$Vfc,this.M],[N.$4fc,this.N])),this.P=this.B(new p.$Tfc(this.J,this.L,{onExtensionActivationError:(le,we,M)=>{this.C.$onExtensionActivationError(le,n.$3(we),M)},actualActivateExtension:async(le,we)=>{if(t.$k7b.isHostExtension(le,this.J,this.L))return await this.C.$activateExtension(le,we),new p.$Sfc;const M=this.J.getExtensionDescription(le);return this.db(M,we)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(x){n.$1(x)}}async Y(){this.O.onWillDeactivateAll();let x=[];try{x=this.J.getAllExtensionDescriptions().map(Ae=>Ae.identifier).filter(Ae=>this.isActivated(Ae)).map(Ae=>this.cb(Ae))}catch{}await Promise.all(x)}terminate(x,q=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${x}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$3g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(x){return this.G.isOpen()?this.P.isActivated(x):!1}async getExtension(x){const q=await this.C.$getExtension(x);return q&&{...q,identifier:new o.$hm(q.identifier.value),extensionLocation:w.URI.revive(q.extensionLocation)}}Z(x,q){return this.P.activateByEvent(x,q)}$(x,q){return this.P.activateById(x,q)}activateByIdWithErrors(x,q){return this.$(x,q).then(()=>{const ne=this.P.getActivatedExtension(x);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(x=>this.J)}getExtensionExports(x){if(this.G.isOpen())return this.P.getActivatedExtension(x).exports;try{return this.P.getActivatedExtension(x).exports}catch{return null}}async ab(x){if(x.scheme===W.Schemas.file&&this.c.fsRealpath){const q=await this.c.fsRealpath(x.fsPath);return w.URI.file(q)}return x}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(x=>new ie(x))),this.Q}async bb(x){const q=g.$8h.forUris(ne=>L.$ug.ignorePathCasing(ne));return await Promise.all(x.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);q.set(Ie,ne)}})),q}cb(x){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(x))return q;const ne=this.P.getActivatedExtension(x);if(!ne)return q;try{typeof ne.module.deactivate=="function"&&(q=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${x.value}':`),this.s.error(Ie)}try{(0,$.$Nc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.s.error(Ie)}return q}async db(x,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(x.identifier):await this.C.$onWillActivateExtension(x.identifier),this.fb(x,q).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(x.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,q),this.eb(x,q,"success",Ie),ne},ne=>{throw this.eb(x,q,"failure"),ne})}eb(x,q,ne,Ie){const Ae=be(x,q);this.z.$publicLog2("extensionActivationTimes",{...Ae,...Ie||{},outcome:ne})}fb(x,q){const ne=be(x,q);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(x);if(!Ie)return Promise.resolve(new p.$Rfc(p.$Ofc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${x.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const Ae=new p.$Pfc(q.startup);return Promise.all([this.vb(x,(0,L.$Dg)(x.extensionLocation,Ie),Ae),this.gb(x)]).then(Pe=>(I.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Z.hb(this.s,x.identifier,Pe[0],Pe[1],Ae))).then(Pe=>(I.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Pe))}gb(x){const q=new h.$Xfc(x,this.M),ne=new h.$Wfc(x.identifier.value,!1,this.M),Ie=new O.$5fc(x,this.N),Ae=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([q.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ae=this;let te,J;const ee=(0,a.$nF)(x,"ipc")?this.f.messagePorts?.get(o.$hm.toKey(x.identifier)):void 0;return Object.freeze({globalState:q,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath($e){return T.$jc(x.extensionLocation.fsPath,$e)},get storagePath(){return ae.O.workspaceValue(x)?.fsPath},get globalStoragePath(){return ae.O.globalValue(x).fsPath},get logPath(){return T.$jc(ae.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return w.URI.joinPath(ae.f.logsLocation,x.identifier.value)},get storageUri(){return ae.O.workspaceValue(x)},get globalStorageUri(){return ae.O.globalValue(x)},get extensionMode(){return Ae},get extension(){return te===void 0&&(te=new fe(ae,x.identifier,x,Pe,!1)),te},get extensionRuntime(){return(0,a.$oF)(x,"extensionRuntime"),ae.extensionRuntime},get environmentVariableCollection(){return ae.u.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!J){if(!ee)return;const $e=y.Event.buffer(y.Event.fromDOMEventEmitter(ee,"message",ve=>ve.data));ee.start(),J={onDidReceiveMessage:$e,postMessage:ee.postMessage.bind(ee)}}return J}})})}static hb(x,q,ne,Ie,Ae){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(x,q,ne,Ie,Ae).then(Pe=>new p.$Qfc(!1,null,Ae.build(),ne,Pe,Ie.subscriptions))}static ib(x,q,ne,Ie,Ae){if(typeof ne.activate=="function")try{Ae.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${q.value}`);const Pe=typeof global=="object"?global:self,ae=ne.activate.apply(Pe,[Ie]);return Ae.activateCallStop(),Ae.activateResolveStart(),Promise.resolve(ae).then(te=>(Ae.activateResolveStop(),te))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(ne)}jb(x,q){this.$(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:q}).then(void 0,ne=>{this.s.error(ne)})}kb(x,q=0){const Ie=Date.now();(0,P.$B)(()=>{for(let Ae=q;Ae<x.length;Ae+=1){const Pe=x[Ae];for(const ae of Pe.activationEvents??[])if(ae==="onStartupFinished")if(Date.now()-Ie>50){this.kb(x,Ae);break}else this.jb(Pe,ae)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(x=>{const q=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(q)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Ae of Ie.activationEvents)Ae==="onStartupFinished"&&this.jb(Ie,Ae)})}mb(){const x=this.Z("*",!0).then(void 0,Pe=>{this.s.error(Pe)});this.B(this.j.onDidChangeWorkspace(Pe=>this.nb(Pe.added)));const q=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(q),Ie=this.pb(),Ae=Promise.all([Ie,x,ne]).then(()=>{});return Promise.race([Ae,(0,R.$3g)(1e4)]).then(()=>{this.lb()}),Ae}nb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.ob(x,q))).then(()=>{})}async ob(x,q){if(this.isActivated(q.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:x.map(Pe=>Pe.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Pe=>this.c.fsExists(Pe.fsPath),checkExists:(Pe,ae,te)=>this.y.$checkExists(Pe,ae,te)},Ae=await(0,D.$csb)(Ie,q);if(Ae)return this.$(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:Ae.activationEvent}).then(void 0,Pe=>this.s.error(Pe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(x){throw console.error(x),x}}async qb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:q}=this.f.environment;if(!x||!q)throw new Error(E.localize(0,null));const ne=await this.vb(null,q,new p.$Pfc(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,q.toString()));return new Promise((Ie,Ae)=>{const Pe=(J,ee)=>{J?(P.$t&&this.s.error("Test runner called back with error",J),Ae(J)):(P.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},ae=(0,L.$rg)(q),te=ne.run(ae,Pe);te&&te.then&&te.then(()=>{P.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(J=>{P.$t&&this.s.error("Test runner finished with error",J),Ae(J instanceof Error&&J.stack?J.stack:String(J))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$3g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,q){return this.R[x]=q,(0,$.$Qc)(()=>{delete this.R[x]})}async getRemoteExecServer(x){const{resolver:q}=await this.sb(x);return q?.resolveExecServer?.(x,{resolveAttempt:0})}async sb(x){const q=x.indexOf("+");if(q===-1)throw new i.$VK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=x.substr(0,q);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(x,q){const ne=V.$Od.create(!1),Ie=()=>`[resolveAuthority(${(0,s.$8k)(x)},${q})][${ne.elapsed()}ms] `,Ae=H=>this.s.info(`${Ie()}${H}`),Pe=H=>this.s.warn(`${Ie()}${H}`),ae=(H,U=void 0)=>this.s.error(`${Ie()}${H}`,U),te=H=>{if(H instanceof i.$VK)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},J=async H=>{Ae(`activating resolver for ${H}...`);const{resolver:U,authorityPrefix:Q}=await this.sb(H);if(!U)throw ae(`no resolver for ${Q}`),new i.$VK(`No remote extension installed to resolve ${Q}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:U,authorityPrefix:Q,remoteAuthority:H}},ee=x.split(/@|%40/g).reverse();Ae(`activating remote resolvers ${ee.join(" -> ")}`);let $e;try{$e=await Promise.all(ee.map(J)).catch(async H=>{if(!(H instanceof i.$VK)||H._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return Pe(`resolving nested authorities failed: ${H.message}`),[await J(x)]})}catch(H){return te(H)}const ve=new R.$ah;ve.cancelAndSet(()=>Ae("waiting..."),1e3);let Fe,le;for(const[H,{authorityPrefix:U,resolver:Q,remoteAuthority:X}]of $e.entries())try{if(H===$e.length-1)Ae("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${U}`),Fe=await Q.resolve(X,{resolveAttempt:q,execServer:le}),I.mark(`code/extHost/didResolveAuthorityOK/${U}`),Ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,i.$UK.isManagedResolvedAuthority(Fe)?Fe:void 0));else{if(Ae(`invoking resolveExecServer() for ${X}`),I.mark(`code/extHost/willResolveExecServer/${U}`),le=await Q.resolveExecServer?.(X,{resolveAttempt:q,execServer:le}),!le)throw new i.$VK(`Exec server was not available for ${X}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${U}`)}}catch(ye){return I.mark(`code/extHost/didResolveAuthorityError/${U}`),ae("returned an error",ye),ve.dispose(),te(ye)}ve.dispose();const we={environmentTunnels:Fe.environmentTunnels,features:Fe.tunnelFeatures},M={extensionHostEnv:Fe.extensionHostEnv,isTrusted:Fe.isTrusted,authenticationSession:Fe.authenticationSessionForInitializingExtensions?{id:Fe.authenticationSessionForInitializingExtensions.id,providerId:Fe.authenticationSessionForInitializingExtensions.providerId}:void 0};Ae(`returned ${i.$UK.isManagedResolvedAuthority(Fe)?"managed authority":`${Fe.host}:${Fe.port}`}`);let K;if(i.$UK.isManagedResolvedAuthority(Fe)){const H=q;this.X.setFactory(H,Fe.makeConnection),K={authority:x,connectTo:new s.$5k(H),connectionToken:Fe.connectionToken}}else K={authority:x,connectTo:new s.$6k(Fe.host,Fe.port),connectionToken:Fe.connectionToken};return{type:"ok",value:{authority:K,options:M,tunnelInformation:we}}}async $getCanonicalURI(x,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$8k)(x)})`);const{resolver:ne}=await this.sb(x);if(!ne)return null;const Ie=w.URI.revive(q);if(typeof ne.getCanonicalURI>"u")return Ie;const Ae=await(0,R.$Ug)(()=>ne.getCanonicalURI(Ie));return Ae||Ie}$startExtensionHost(x){x.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:q,myExtensions:ne}=me(this.I,this.L,this.J,x);return this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),P.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(x,q){return q===1?this.D.wait().then(ne=>this.Z(x,!1)):this.G.wait().then(ne=>this.Z(x,!1))}async $activate(x,q){return await this.G.wait(),this.J.getExtensionDescription(x)?(await this.$(x,q),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(Pe=>Pe.extensionLocation=w.URI.revive(Pe.extensionLocation));const{globalRegistry:q,myExtensions:ne}=me(this.I,this.L,this.J,x),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),P.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const q=c.$ge.alloc(x),ne=Math.random()%256;for(let Ie=0;Ie<x;Ie++)q.writeUInt8(ne,Ie);return q}async $updateRemoteConnectionData(x){this.W=x,this.a.fire()}};e.$$fc=ce,e.$$fc=ce=Z=Ge([Ke(0,u.$1h),Ke(1,e.$0fc),Ke(2,f.$RM),Ke(3,r.$xfc),Ke(4,l.$Afc),Ke(5,A.$jj),Ke(6,d.$8M),Ke(7,m.$Dfc),Ke(8,F.$_xb),Ke(9,v.$Yfc),Ke(10,z.$7fc),Ke(11,C.$8fc)],ce);function me(oe,x,q,ne){oe.addActivationEvents(ne.addActivationEvents);const Ie=new t.$k7b(oe,x.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Ae=new o.$im(q.getAllExtensionDescriptions().map(ae=>ae.identifier));for(const ae of ne.myToRemove)Ae.delete(ae);for(const ae of ne.myToAdd)Ae.add(ae);const Pe=de(Ie,Ae);return{globalRegistry:Ie,myExtensions:Pe}}function be(oe,x){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}function ke(oe){return oe.getAllExtensionDescriptions().map(x=>x.identifier.value).join(",")}e.$_fc=(0,u.$2h)("IExtHostExtensionService");class fe{#e;#t;#i;constructor(x,q,ne,Ie,Ae){this.#e=x,this.#t=q,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$hc((0,L.$rg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$agc=fe;function de(oe,x){return oe.getAllExtensionDescriptions().filter(q=>x.has(q.identifier))}class ie{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.$bgc=ie;class Se{constructor(x){this.a=new o.$jm,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)??[]}addActivationEvents(x){for(const q of Object.keys(x))this.a.set(q,x[q])}}}),define(Ce[287],Re([1,0,88,2,3,37,23,22,17,27,4,38,15,11]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;let r=class{constructor(c,h,i,s,u,d,m){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.h=d,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$jhc=r,e.$jhc=r=Ge([Ke(2,A.$1h),Ke(3,L.$Afc),Ke(4,S.$_fc),Ke(5,w.$8M),Ke(6,l.$jj)],r);let a=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&b.a.size){const h=(0,p.$Ke)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,s,u]=h,d=b.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};a=b=Ge([Ke(0,w.$8M)],a);class t{constructor(c,h,i,s,u){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.nodeModuleName="vscode",this.a=new $.$jm}load(c,h){const i=this.d.findSubstr(h);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((u,d)=>s+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$iF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$NK.MainThreadTelemetry);const s=i.getProxy(I.$NK.MainThreadWindow);this.c=(u,d)=>{const m=T.URI.parse(u);return d?this.g(u,d):m.scheme==="http"||m.scheme==="https"?s.$openUri(m,u,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?s.$openUri(m,u,{}):this.g(u,d)}}load(c,h,i){const s=this.e.findSubstr(h);return s&&(this.a=s.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ge([Ke(2,g.$RM)],n)}),define(Ce[116],Re([1,0,39,6,19,74,4,61,62,38,7,36,215,37]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=void 0,e.$cgc=(0,R.$2h)("IExtHostVariableResolverProvider");class b extends l.$SN{constructor(t,n,o,c,h,i,s){function u(){if(o){const d=o.activeEditor();if(d)return d.document.uri;const m=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof A.$wM||m.input instanceof A.$BM)return m.input.modified;if(m.input instanceof A.$vM||m.input instanceof A.$AM||m.input instanceof A.$yM)return m.input.uri}}}super({getFolderUri:d=>{const m=i.folders.filter(f=>f.name===d);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,m)=>h.getConfiguration(void 0,d).get(m),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return I.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=u();if(d){const m=n.getWorkspaceFolder(d);if(m)return I.$hc(m.uri.fsPath)}}},getSelectedText:()=>{if(o){const d=o.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(o){const d=o.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let r=class extends T.$Sc{constructor(t,n,o,c,h){super(),this.b=t,this.c=n,this.g=o,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$dgc=r,e.$dgc=r=Ge([Ke(0,w.$_fc),Ke(1,S.$xfc),Ke(2,$.$3M),Ke(3,p.$Afc),Ke(4,g.$Mfc)],r)}),define(Ce[117],Re([1,0,13,5,2,4,3,62,38,17,7,36,207,209,37,116]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=e.$hgc=e.$ggc=e.$fgc=e.$egc=void 0,e.$egc=(0,L.$2h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,u,d,m,f,k){this.E=u,this.F=d,this.G=m,this.H=f,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Sd,this.n=new T.$Sd,this.o=new T.$Sd,this.u=new T.$Sd,this.k=s.getProxy(R.$NK.MainThreadDebugService),this.y=new T.$Sd,this.A=new T.$Sd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(F=>{F.onDidChange(v=>{this.J(F)}),this.J(F)})}asDebugSourceUri(s,u){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let m=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(m+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),m+=`${f}ref=${d.sourceReference}`,I.URI.parse(m)}else{if(d.path)return I.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const u=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const m=d.contributes.debuggers;if(m&&m.length>0)for(const f of m)(0,p.$ZF)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(u=>s.push(u)),s}addBreakpoints(s){const u=s.filter(f=>{const k=f.id;return this.w.has(k)?!1:(this.w.set(k,f),!0)});this.U(u,[],[]);const d=[],m=new Map;for(const f of u)if(f instanceof A.$PL){let k=m.get(f.location.uri.toString());k||(k={type:"sourceMulti",uri:f.location.uri,lines:[]},m.set(f.location.uri.toString(),k),d.push(k)),k.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.$QL&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const u=s.filter(k=>this.w.delete(k.id));this.U([],u,[]);const d=u.filter(k=>k instanceof A.$PL).map(k=>k.id),m=u.filter(k=>k instanceof A.$QL).map(k=>k.id),f=u.filter(k=>k instanceof A.$RL).map(k=>k.id);return this.k.$unregisterBreakpoints(d,m,f)}startDebugging(s,u,d){return this.k.$startDebugging(s?s.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,u,d){if(!u)return new A.$PK(()=>{});const m=this.d++;return this.f.push({type:s,handle:m,provider:u}),this.k.$registerDebugConfigurationProvider(s,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,m),new A.$PK(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(s,u,d){if(!d)return new A.$PK(()=>{});if(!this.Q(s,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:u,handle:m,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,m),new A.$PK(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(s,u){if(!u)return new A.$PK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:u}),new A.$PK(()=>{this.j=this.j.filter(m=>m.factory!==u)})}async $runInTerminal(s,u){return Promise.resolve(void 0)}async $substituteVariables(s,u){let d;const m=await this.W(s);return m&&(d={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(s,u){if(s.type==="implementation")return new c(s.implementation)}L(){}async $startDASession(s,u){const d=this,m=await this.V(u);return this.S(this.N(m.type),m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const k=this.M(f),F=this.K(k,m);if(!F)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const v=F;return this.B.set(s,v),this.R(m).then(y=>(y&&this.C.set(s,y),v.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const N=D,O={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const W=await this.D.sign(N.arguments.value);O.body={signature:W},v.sendResponse(O)}else throw new Error("no signer")}catch(W){O.success=!1,O.message=W.message,v.sendResponse(O)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(D),D=(0,p.$5F)(D,!0),d.k.$acceptDAMessage(s,D)}),v.onError(D=>{y&&y.onError&&y.onError(D),this.k.$acceptDAError(s,D.name,D.message,D.stack)}),v.onExit(D=>{y&&y.onExit&&y.onExit(D??void 0,void 0),this.k.$acceptDAExit(s,D??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),v.startSession()))})}$sendDAMessage(s,u){u=(0,p.$4F)(u,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(s)?.sendMessage(u)}$stopDASession(s){const u=this.C.get(s);this.C.delete(s),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const u=[],d=[],m=[];if(s.added)for(const f of s.added){const k=f.id;if(k&&!this.w.has(k)){let F;if(f.type==="function")F=new A.$QL(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")F=new A.$RL(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const v=I.URI.revive(f.uri);F=new A.$PL(new A.$2K(v,new A.$QK(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.$NL)(F,k),this.w.set(k,F),u.push(F)}}if(s.removed)for(const f of s.removed){const k=this.w.get(f);k&&(this.w.delete(f),d.push(k))}if(s.changed){for(const f of s.changed)if(f.id){const k=this.w.get(f.id);if(k){if(k instanceof A.$QL&&f.type==="function"){const F=k;F.enabled=f.enabled,F.condition=f.condition,F.hitCondition=f.hitCondition,F.logMessage=f.logMessage,F.functionName=f.functionName}else if(k instanceof A.$PL&&f.type==="source"){const F=k;F.enabled=f.enabled,F.condition=f.condition,F.hitCondition=f.hitCondition,F.logMessage=f.logMessage,F.location=new A.$2K(I.URI.revive(f.uri),new A.$QK(f.line,f.character))}m.push(k)}}}this.U(u,d,m)}async $acceptStackFrameFocus(s){let u;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?u=new A.$XL(d,s.threadId):u=new A.$WL(d,s.threadId,s.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(s,u,d){return(0,E.$Ug)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return m.provideDebugConfigurations(f,d)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(s,u,d,m){return(0,E.$Ug)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(u);return f.resolveDebugConfiguration(k,d,m)})}$resolveDebugConfigurationWithSubstitutedVariables(s,u,d,m){return(0,E.$Ug)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(k,d,m)})}async $provideDebugAdapter(s,u){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(u);return this.S(d,m).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(s){const u=await this.V(s);this.m.fire(u)}async $acceptDebugSessionTerminated(s){const u=await this.V(s);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,u){(await this.V(s))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(s,u){const m={session:await this.V(s),event:u.event,body:u.body};this.u.fire(m)}M(s){if(s instanceof A.$SL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$TL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$UL)return{type:"pipeServer",path:s.path};if(s instanceof A.$VL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const u=this.h.filter(d=>d.type===s);if(u.length>0)return u[0].factory}O(s){const u=this.h.filter(d=>d.handle===s);if(u.length>0)return u[0].factory}P(s){const u=this.f.filter(d=>d.handle===s);if(u.length>0)return u[0].provider}Q(s,u){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const m of d)if(m.label&&m.type&&m.type===u)return!0}}return!1}R(s){const d=s.configuration.type,m=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Ug)(()=>f.factory.createDebugAdapterTracker(s)).then(k=>k,k=>null));return Promise.race([Promise.all(m).then(f=>{const k=f.filter(F=>!!F);if(k.length>0)return new o(k)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(s,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new A.$TL(d));if(s){const f=await this.F.getExtensionRegistry();return(0,E.$Ug)(()=>s.createDebugAdapterDescriptor(u,this.T(u,f))).then(k=>{if(k)return k})}const m=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,m))}T(s,u){}U(s,u,d){(s.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:u,changed:d}))}async V(s){if(s)if(typeof s=="string"){const u=this.l.get(s);if(u)return u}else{let u=this.l.get(s.id);if(!u){const d=await this.W(s.folderUri),m=s.parent?this.l.get(s.parent):void 0;u=new t(this.k,s.id,s.type,s.name,d,s.configuration,m),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(s){if(s){const u=I.URI.revive(s);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$fgc=a,e.$fgc=a=Ge([Ke(0,w.$RM),Ke(1,S.$xfc),Ke(2,g.$_fc),Ke(3,b.$Afc),Ke(4,$.$Mfc),Ke(5,r.$cgc)],a);class t{constructor(s,u,d,m,f,k,F){this.d=s,this.f=u,this.g=d,this.h=m,this.i=f,this.j=k,this.k=F}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,u){return this.d.$customDebugAdapterRequest(this.f,s,u)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$ggc=t;class n{constructor(s){this.value=Object.freeze({append(u){s.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$hgc=n;class o{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(u=>u.onError?u.onError(s):void 0)}onExit(s,u){this.d.forEach(d=>d.onExit?d.onExit(s,u):void 0)}}class c extends l.$ulb{constructor(s){super(),this.h=s,s.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends a{constructor(s,u,d,m,f,k){super(s,u,d,m,f,k)}};e.$igc=h,e.$igc=h=Ge([Ke(0,w.$RM),Ke(1,S.$xfc),Ke(2,g.$_fc),Ke(3,b.$Afc),Ke(4,$.$Mfc),Ke(5,r.$cgc)],h)}),define(Ce[288],Re([1,0,14,88,2,3,276,15,70,71,27,185,17,57,38,59]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=e.$khc=void 0;class a{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get($.$jj),i=o.get(l.$RM).getProxy(L.$NK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{c.error(s);const u=E.$3(s);i.$onUnexpectedError(u)})}static async installFullHandler(o){const c=o.get($.$jj),h=o.get(l.$RM),i=o.get(b.$_fc),s=o.get(r.$_M),u=h.getProxy(L.$NK.MainThreadExtensionService),d=h.getProxy(L.$NK.MainThreadErrors),m=await i.getExtensionPathIndex(),f=new WeakMap;function k(y,D){if(f.has(y))return f.get(y).stack;let N="",O,W;for(const V of D)N+=`
	at ${V.toString()}`,W=V.getFileName(),!O&&W&&(O=m.findSubstr(I.URI.file(W)));const z=`${y.name||"Error"}: ${y.message||""}${N}`;return f.set(y,{extensionIdentifier:O?.identifier,stack:z}),z}const F=Symbol("prepareStackTrace wrapped");let v=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(y){if(y===k||!y||y[F]){v=y||k;return}v=function(D,N){return k(D,N),y.call(Error,D,N)},Object.assign(v,{[F]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const D=E.$3(y),N=f.get(y);if(!N?.extensionIdentifier){d.$onUnexpectedError(D);return}u.$onExtensionRuntimeError(N.extensionIdentifier,D);const O=s.onExtensionError(N.extensionIdentifier,y);c.trace("forwarded error to extension?",O,N)})}}e.$khc=a;class t{constructor(o,c,h,i,s){this.a=h,this.b=new R.$s7b(o,null,i),c=t.e(c,this.b);const u=new w.$Zh(...(0,g.$Lr)());u.set(A.$8M,{_serviceBrand:void 0,...c,messagePorts:s}),u.set(l.$RM,new l.$SM(this.b)),u.set(p.$ufc,new p.$vfc(i)),u.set(b.$0fc,h);const d=new S.$rq(u,!0);d.invokeFunction(a.installEarlyHandler),this.d=d.invokeFunction(m=>m.get($.$jj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(m=>m.get(b.$_fc)),this.c.initialize(),d.invokeFunction(a.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(L.$NK.MainThreadExtensionService);return I.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),o.environment.appRoot=I.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const h=o.environment.extensionDevelopmentLocationURI;return h&&(o.environment.extensionDevelopmentLocationURI=h.map(i=>I.URI.revive(c.transformIncomingURIs(i)))),o.environment.extensionTestsLocationURI=I.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=I.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=I.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=I.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=I.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=I.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$lhc=t}),define(Ce[289],Re([1,0,18,13,20,40,12,19,25,2,44]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=e.$xgc=e.$wgc=void 0;class S{constructor(n,o,c,h){this.d=n,this.e=o,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],h=new I.$3d(o);return new Promise((i,s)=>{this.a=new p(n);let u=!1;const d=(m,f)=>{if(!u&&!this.b){const k=this.h(m);r(m)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),m=this.j(m,this.d.maxResults-this.c));const F=this.h(m);this.c+=F,(F>0||!r(m))&&this.a.add(m,f)}};Promise.all(c.map((m,f)=>this.k(m,k=>d(k,f),h.token))).then(m=>{h.dispose(),this.a.flush();const f=m.some(k=>!!k&&!!k.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(m.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},m=>{h.dispose();const f=(0,L.$Mi)(m);s(new Error(f))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:h.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const h=new A.$rJ(this.d,n),i=[],s={report:m=>{if(!this.l(m))return;const f=n.folder.scheme===R.Schemas.file?(0,A.$sJ)(()=>this.f.readdir(g.$Cg(m.uri))):void 0,k=g.$Fg(n.folder,m.uri);if(k){const F=h.includedInQuery(k,$.$nc(k),f);(0,T.$Og)(F)?i.push(F.then(v=>{v&&o(m)})):F&&o(m)}}},u=this.n(n),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,s,c);return i.length&&await Promise.all(i),d}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,A.$qJ)(this.d.includePattern,n.includePattern),c=(0,A.$qJ)(this.d.excludePattern,n.excludePattern),h={folder:w.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$wgc=S;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new a(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!g.$wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(b(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$xgc=p;function b(t){return r(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function r(t){return!!t.preview}e.$ygc=r;class a{static{this.a=4e3}static{this.b=50}constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$zgc=a}),define(Ce[118],Re([1,0,6,3,4,284,17,57,15,2,289]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=e.$Agc=void 0,e.$Agc=(0,I.$2h)("IExtHostSearch");let S=class{constructor(r,a,t){this.k=r,this.l=a,this.n=t,this.c=this.k.getProxy(T.$NK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$vgc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,a){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const t=this.d++;return this.e.set(t,a),this.c.$registerTextSearchProvider(t,this.o(r)),(0,E.$Qc)(()=>{this.g.delete(r),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(r,a){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const t=this.d++;return this.h.set(t,a),this.c.$registerFileSearchProvider(t,this.o(r)),(0,E.$Qc)(()=>{this.i.delete(r),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(r,a,t,n){const o=l(t),c=this.h.get(r);if(c)return this.j.fileSearch(o,c,h=>{this.c.$handleFileMatch(r,a,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,a,t){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,a,t,n){const o=this.e.get(r);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const c=l(t);return this.q(c,o).search(i=>this.c.$handleTextMatch(r,a,i),n)}$enableExtensionHostSearch(){}q(r,a){return new A.$wgc(r,a,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$Bgc=S,e.$Bgc=S=Ge([Ke(0,R.$RM),Ke(1,$.$ufc),Ke(2,g.$jj)],S);function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(r=>w.URI.revive(r))}}e.$Cgc=l;function p(b){return{...b,folder:w.URI.revive(b.folder)}}}),define(Ce[290],Re([1,0,20,14,5,6,12,31,2,146,142,130,93,22,42,15,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,37,272,117,110,242,243,244,220,245,61,62,247,38,248,63,249,43,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,36,208,79,23,114]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c,h,i,s,u,d,m,f,k,F,v,y,D,N,O,W,z,V,P,C,Z,ce,me,be,ke,fe,de,ie,Se,oe,x,q,ne,Ie,Ae,Pe,ae,te,J,ee,$e,ve,Fe,le,we,M,K,H,U,Q,X,ye,Te,We,He,Ye,st,nt,tt,at,ct,ze,vt,Y,_,pe,Be,Qe,it,rt,Ne,Pt,Tt,Ht,Bt,yt,Kt,Nt,Zt,jt,Rt,Xe,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;function Jt(lt){const $t=lt.get(x.$8M),zt=lt.get(oe.$cfc),Wt=lt.get(ie.$Cfc),Dt=lt.get(fe.$_fc),dt=lt.get(Zt.$xfc),Ct=lt.get(ze.$_M),xt=lt.get(N.$Afc),kt=lt.get(Tt.$ufc),qe=lt.get(ye.$RM),Ft=lt.get(tt.$Vfc),Vt=lt.get(at.$Dfc),Qt=lt.get(r.$kj),gt=lt.get(r.$jj),Mt=lt.get(it.$_xb),Ee=lt.get(i.$ffc),Me=lt.get(Nt.$ehc),he=lt.get(He.$4fc),G=lt.get(be.$Mfc),Le=lt.get(J.$8fc);qe.set(o.$OK.ExtHostFileSystemInfo,zt),qe.set(o.$OK.ExtHostLogLevelServiceShape,Qt),qe.set(o.$OK.ExtHostWorkspace,dt),qe.set(o.$OK.ExtHostConfiguration,xt),qe.set(o.$OK.ExtHostExtensionService,Dt),qe.set(o.$OK.ExtHostStorage,Ft),qe.set(o.$OK.ExtHostTunnelService,Mt),qe.set(o.$OK.ExtHostWindow,Me),qe.set(o.$OK.ExtHostSecretState,he),qe.set(o.$OK.ExtHostTelemetry,Ct),qe.set(o.$OK.ExtHostEditorTabs,G),qe.set(o.$OK.ExtHostManagedSockets,Le);const Ue=qe.set(o.$OK.ExtHostDecorations,lt.get(z.$kgc)),Ze=qe.set(o.$OK.ExtHostDocumentsAndEditors,lt.get(me.$3M)),Ve=qe.set(o.$OK.ExtHostCommands,lt.get(y.$bN)),_e=qe.set(o.$OK.ExtHostTerminalService,lt.get(vt.$Yfc)),mt=qe.set(o.$OK.ExtHostDebugService,lt.get(W.$egc)),Ut=qe.set(o.$OK.ExtHostSearch,lt.get(We.$Agc)),Et=qe.set(o.$OK.ExtHostTask,lt.get(ct.$4gc)),St=qe.set(o.$OK.ExtHostOutputService,lt.get(K.$Qgc)),wt=qe.set(o.$OK.ExtHostLocalization,lt.get(te.$7fc)),gi=qe.set(o.$OK.ExtHostUrls,new Ht.$bhc(qe)),At=qe.set(o.$OK.ExtHostDocuments,new ce.$afc(qe,Ze)),Si=qe.set(o.$OK.ExtHostDocumentContentProviders,new C.$mgc(qe,Ze,gt)),Hi=qe.set(o.$OK.ExtHostDocumentSaveParticipant,new Z.$ngc(gt,At,qe.getProxy(o.$NK.MainThreadBulkEdits))),It=qe.set(o.$OK.ExtHostNotebook,new $e.$Dgc(qe,Ve,Ze,At,Wt,Ut)),ri=qe.set(o.$OK.ExtHostNotebookDocuments,new Fe.$Kgc(It)),mi=qe.set(o.$OK.ExtHostNotebookEditors,new le.$Lgc(gt,It)),ci=qe.set(o.$OK.ExtHostNotebookKernels,new we.$Mgc(qe,$t,It,Ve,gt)),Ii=qe.set(o.$OK.ExtHostNotebookRenderers,new M.$Ogc(qe,It)),Ci=qe.set(o.$OK.ExtHostNotebookDocumentSaveParticipant,new ve.$Jgc(gt,It,qe.getProxy(o.$NK.MainThreadBulkEdits))),Ot=qe.set(o.$OK.ExtHostEditors,new _.$rfc(qe,Ze)),$i=qe.set(o.$OK.ExtHostTreeViews,new Qe.$_gc(qe.getProxy(o.$NK.MainThreadTreeViews),Ve,gt)),Pi=qe.set(o.$OK.ExtHostEditorInsets,new v.$sfc(qe.getProxy(o.$NK.MainThreadEditorInsets),Ot,$t.remote)),ui=qe.set(o.$OK.ExtHostDiagnostics,new V.$efc(qe,gt,zt,Ze)),li=qe.set(o.$OK.ExtHostLanguages,new ae.$Hgc(qe,At,Ve.converter,kt)),ht=qe.set(o.$OK.ExtHostLanguageFeatures,new Pe.$ifc(qe,kt,At,Ve,ui,gt,Ee,Ct)),Gi=qe.set(o.$OK.ExtHostFileSystem,new de.$pgc(qe,ht)),_t=qe.set(o.$OK.ExtHostFileSystemEventService,new Se.$qgc(qe,gt,Ze)),si=qe.set(o.$OK.ExtHostQuickOpen,(0,X.$Ugc)(qe,dt,Ve)),pi=qe.set(o.$OK.ExtHostSCM,new Te.$Wgc(qe,Ve,At,gt)),Ri=qe.set(o.$OK.ExtHostQuickDiff,new Q.$Tgc(qe,kt)),Ji=qe.set(o.$OK.ExtHostShare,new Ye.$Xgc(qe,kt)),Ai=qe.set(o.$OK.ExtHostComments,(0,D.$tfc)(qe,Ve,At)),vi=qe.set(o.$OK.ExtHostProgress,new U.$Sgc(qe.getProxy(o.$NK.MainThreadProgress))),Qi=qe.set(o.$OK.ExtHostLabelService,new Ae.$Ggc(qe)),Li=qe.set(o.$OK.ExtHostTheming,new pe.$9gc(qe)),hi=qe.set(o.$OK.ExtHostAuthentication,new s.$kfc(qe)),Zi=qe.set(o.$OK.ExtHostTimeline,new Be.$$gc(qe,Ve)),bi=qe.set(o.$OK.ExtHostWebviews,new Bt.$Hfc(qe,$t.remote,dt,gt,Ee)),Fi=qe.set(o.$OK.ExtHostWebviewPanels,new yt.$Kfc(qe,bi,dt)),cn=qe.set(o.$OK.ExtHostCustomEditors,new O.$Lfc(qe,At,Vt,bi,Fi)),Mi=qe.set(o.$OK.ExtHostWebviewViews,new Kt.$chc(qe,bi)),oi=qe.set(o.$OK.ExtHostTesting,new Y.$5gc(qe,Ve,Ze)),un=qe.set(o.$OK.ExtHostUriOpeners,new Pt.$ahc(qe)),ln=qe.set(o.$OK.ExtHostProfileContentHandlers,new H.$Rgc(qe));qe.set(o.$OK.ExtHostInteractive,new ne.$Egc(qe,It,Ze,Ve,gt));const Yi=qe.set(o.$OK.ExtHostInlineChat,new q.$rgc(qe,Ve,At,gt)),di=qe.set(o.$OK.ExtHostChatProvider,new f.$nfc(qe,gt)),Xi=qe.set(o.$OK.ExtHostChatAgents2,new m.$ofc(qe,di,gt)),xi=qe.set(o.$OK.ExtHostChatVariables,new k.$pfc(qe)),wi=qe.set(o.$OK.ExtHostChat,new d.$mfc(qe)),_i=qe.set(o.$OK.ExtHostAiRelatedInformation,new c.$_ec(qe)),Ti=qe.set(o.$OK.ExtHostAiEmbeddingVector,new ke.$ogc(qe)),Ni=qe.set(o.$OK.ExtHostIssueReporter,new Ie.$Fgc(qe)),ei=qe.set(o.$OK.ExtHostStatusBar,new nt.$1gc(qe,Ve.converter)),yi=qe.set(o.$OK.ExtHostSpeech,new st.$Ygc(qe)),hn=Object.values(o.$OK);qe.assertRegistered(hn);const Yt=new u.$lfc(qe,Ze),Ei=new F.$qfc(qe),Di=new ee.$Igc(qe,gt),Oi=new P.$lgc(qe);return h.$jfc.register(Ve),function(je,ti,en){function et(re){return(ue,Oe,ot)=>{const bt=re(Lt=>{try{ue.call(Oe,Lt)}catch(an){T.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event`,{cause:an})),Ct.onExtensionError(je.identifier,an)}});return ot?.push(bt),bt}}const pt=function(){let re=!je.isUnderDevelopment;function ue(){re||(gt.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ue();else{const bt=ot;typeof bt.scheme>"u"&&ue(),typeof bt.exclusive=="boolean"&&(0,Xe.$oF)(je,"documentFiltersExclusive")}return ot}}(),dn={getSession(re,ue,Oe){return hi.getSession(je,re,ue,Oe)},getSessions(re,ue){return(0,Xe.$oF)(je,"authGetSessions"),hi.getSessions(je,re,ue)},async hasSession(re,ue){return(0,Xe.$oF)(je,"authSession"),!!await hi.getSession(je,re,ue,{silent:!0})},get onDidChangeSessions(){return et(hi.onDidChangeSessions)},registerAuthenticationProvider(re,ue,Oe,ot){return hi.registerAuthenticationProvider(re,ue,Oe,ot)}},fn={registerCommand(re,ue,Oe){return Ve.registerCommand(!0,re,ue,Oe,void 0,je)},registerTextEditorCommand(re,ue,Oe){return Ve.registerCommand(!0,re,(...ot)=>{const bt=Ot.getActiveTextEditor();if(!bt){gt.warn("Cannot execute "+re+" because there is no active text editor.");return}return bt.edit(Lt=>{ue.apply(Oe,[bt,Lt,...ot])}).then(Lt=>{Lt||gt.warn("Edits from command "+re+" were not applied.")},Lt=>{gt.warn("An error occurred while running command "+re,Lt)})},void 0,void 0,je)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Xe.$oF)(je,"diffCommand"),Ve.registerCommand(!0,re,async(...ot)=>{const bt=Ze.activeEditor(!0);if(!bt){gt.warn("Cannot execute "+re+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(bt.id);ue.apply(Oe,[Lt,...ot])},void 0,void 0,je)),executeCommand(re,...ue){return Ve.executeCommand(re,...ue)},getCommands(re=!1){return Ve.getCommands(re)}},ji={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return et(_e.onDidChangeShell)},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Ct.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$oF)(je,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$oF)(je,"telemetry"),et(Ct.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ze.$$M)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return ze.$0M.validateSender(re),Ct.instantiateLogger(je,re,ue)},openExternal(re,ue){return Me.openUri(re,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===$t.environment.appUriScheme)return gi.createAppUri(re);try{return await Me.asExternalUri(re,{allowTunneling:!!$t.remote.authority})}catch(ue){if((0,R.$ag)(re,R.Schemas.http)||(0,R.$ag)(re,R.Schemas.https))return re;throw ue}},get remoteName(){return(0,a.$0k)($t.remote.authority)},get remoteAuthority(){return(0,Xe.$oF)(je,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return et(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(re){return(0,Xe.$oF)(je,"handleIssueUri"),Ni.registerIssueUriRequestHandler(je,re)},registerIssueDataProvider(re){return(0,Xe.$oF)(je,"handleIssueUri"),Ni.registerIssueDataProvider(je,re)},get appQuality(){return(0,Xe.$oF)(je,"resolvers"),$t.quality},get appCommit(){return(0,Xe.$oF)(je,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(ji);const zi={createTestController(re,ue,Oe){return oi.createTestController(je,re,ue,Oe)},createTestObserver(){return(0,Xe.$oF)(je,"testObserver"),oi.createTestObserver()},runTests(re){return(0,Xe.$oF)(je,"testObserver"),oi.runTests(re)},get onDidChangeTestResults(){return(0,Xe.$oF)(je,"testObserver"),et(oi.onResultsChanged)},get testResults(){return(0,Xe.$oF)(je,"testObserver"),oi.results}},fi=$t.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,tn={getExtension(re,ue){(0,Xe.$nF)(je,"extensionsAny")||(ue=!1);const Oe=ti.mine.getExtensionDescription(re);if(Oe)return new fe.$agc(Dt,je.identifier,Oe,fi,!1);if(ue){const ot=ti.all.getExtensionDescription(re);if(ot)return new fe.$agc(Dt,je.identifier,ot,fi,!0)}},get all(){const re=[];for(const ue of ti.mine.getAllExtensionDescriptions())re.push(new fe.$agc(Dt,je.identifier,ue,fi,!1));return re},get allAcrossExtensionHosts(){(0,Xe.$oF)(je,"extensionsAny");const re=new p.$im(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const ot=!re.has(Oe.identifier);ue.push(new fe.$agc(Dt,je.identifier,Oe,fi,ot))}return ue},get onDidChange(){return(0,Xe.$nF)(je,"extensionsAny")?et(I.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):et(ti.mine.onDidChange)}},nn={createDiagnosticCollection(re){return ui.createDiagnosticCollection(je.identifier,re)},get onDidChangeDiagnostics(){return et(ui.onDidChangeDiagnostics)},getDiagnostics:re=>ui.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,ue){return li.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,A.$ot)(rt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return ht.registerCodeActionProvider(je,pt(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Xe.$oF)(je,"documentPaste"),ht.registerDocumentPasteEditProvider(je,pt(re),ue,Oe)},registerCodeLensProvider(re,ue){return ht.registerCodeLensProvider(je,pt(re),ue)},registerDefinitionProvider(re,ue){return ht.registerDefinitionProvider(je,pt(re),ue)},registerDeclarationProvider(re,ue){return ht.registerDeclarationProvider(je,pt(re),ue)},registerImplementationProvider(re,ue){return ht.registerImplementationProvider(je,pt(re),ue)},registerTypeDefinitionProvider(re,ue){return ht.registerTypeDefinitionProvider(je,pt(re),ue)},registerHoverProvider(re,ue){return ht.registerHoverProvider(je,pt(re),ue,je.identifier)},registerEvaluatableExpressionProvider(re,ue){return ht.registerEvaluatableExpressionProvider(je,pt(re),ue,je.identifier)},registerInlineValuesProvider(re,ue){return ht.registerInlineValuesProvider(je,pt(re),ue,je.identifier)},registerDocumentHighlightProvider(re,ue){return ht.registerDocumentHighlightProvider(je,pt(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return ht.registerMultiDocumentHighlightProvider(je,pt(re),ue)},registerLinkedEditingRangeProvider(re,ue){return ht.registerLinkedEditingRangeProvider(je,pt(re),ue)},registerReferenceProvider(re,ue){return ht.registerReferenceProvider(je,pt(re),ue)},registerRenameProvider(re,ue){return ht.registerRenameProvider(je,pt(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return ht.registerDocumentSymbolProvider(je,pt(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return ht.registerWorkspaceSymbolProvider(je,re)},registerDocumentFormattingEditProvider(re,ue){return ht.registerDocumentFormattingEditProvider(je,pt(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return ht.registerDocumentRangeFormattingEditProvider(je,pt(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...ot){return ht.registerOnTypeFormattingEditProvider(je,pt(re),ue,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentSemanticTokensProvider(je,pt(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return ht.registerDocumentRangeSemanticTokensProvider(je,pt(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...ot){return typeof Oe=="object"?ht.registerSignatureHelpProvider(je,pt(re),ue,Oe):ht.registerSignatureHelpProvider(je,pt(re),ue,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(re,ue,...Oe){return ht.registerCompletionItemProvider(je,pt(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Xe.$oF)(je,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$oF)(je,"inlineCompletionsAdditions"),Oe&&(0,Xe.$oF)(je,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(je,pt(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return ht.registerDocumentLinkProvider(je,pt(re),ue)},registerColorProvider(re,ue){return ht.registerColorProvider(je,pt(re),ue)},registerFoldingRangeProvider(re,ue){return ht.registerFoldingRangeProvider(je,pt(re),ue)},registerSelectionRangeProvider(re,ue){return ht.registerSelectionRangeProvider(je,re,ue)},registerCallHierarchyProvider(re,ue){return ht.registerCallHierarchyProvider(je,re,ue)},registerTypeHierarchyProvider(re,ue){return ht.registerTypeHierarchyProvider(je,re,ue)},setLanguageConfiguration:(re,ue)=>ht.setLanguageConfiguration(je,re,ue),getTokenInformationAtPosition(re,ue){return(0,Xe.$oF)(je,"tokenInformation"),li.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return ht.registerInlayHintsProvider(je,re,ue)},createLanguageStatusItem(re,ue){return li.createLanguageStatusItem(je,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return ht.registerDocumentOnDropEditProvider(je,re,ue,(0,Xe.$nF)(je,"dropMetadata")?Oe:void 0)}},gn={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const ot=await(g.URI.isUri(re)?Promise.resolve(rn.openTextDocument(re)):Promise.resolve(re));return Ot.showTextDocument(ot,ue,Oe)},createTextEditorDecorationType(re){return Ot.createTextEditorDecorationType(je,re)},onDidChangeActiveTextEditor(re,ue,Oe){return et(Ot.onDidChangeActiveTextEditor)(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return et(Ot.onDidChangeVisibleTextEditors)(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return et(Ot.onDidChangeTextEditorSelection)(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return et(Ot.onDidChangeTextEditorOptions)(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return et(Ot.onDidChangeTextEditorVisibleRanges)(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return et(Ot.onDidChangeTextEditorViewColumn)(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return et(_e.onDidCloseTerminal)(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return et(_e.onDidOpenTerminal)(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return et(_e.onDidChangeActiveTerminal)(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Xe.$oF)(je,"terminalDimensions"),et(_e.onDidChangeTerminalDimensions)(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return et(_e.onDidChangeTerminalState)(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Xe.$oF)(je,"terminalDataWriteEvent"),et(_e.onDidWriteTerminalData)(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Xe.$oF)(je,"terminalExecuteCommandEvent"),et(_e.onDidExecuteTerminalCommand)(re,ue,Oe)},get state(){return Me.getState(je)},onDidChangeWindowState(re,ue,Oe){return et(Me.onDidChangeWindowState)(re,ue,Oe)},showInformationMessage(re,...ue){return Di.showMessage(je,$.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return Di.showMessage(je,$.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return Di.showMessage(je,$.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return si.showQuickPick(je,re,ue,Oe)},showWorkspaceFolderPick(re){return si.showWorkspaceFolderPick(re)},showInputBox(re,ue){return si.showInput(re,ue)},showOpenDialog(re){return Oi.showOpenDialog(je,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let ot,bt,Lt;return typeof re=="string"?(ot=re,bt=ue,Lt=Oe):(bt=re,Lt=ue),ei.createStatusBarEntry(je,ot,bt,Lt)},setStatusBarMessage(re,ue){return ei.setStatusBarMessage(re,ue)},withScmProgress(re){return Ee.report("window.withScmProgress",je,"Use 'withProgress' instead."),vi.withProgress(je,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(ot){}}))},withProgress(re,ue){return vi.withProgress(je,re,ue)},createOutputChannel(re,ue){return St.createOutputChannel(re,ue,je)},createWebviewPanel(re,ue,Oe,ot){return Fi.createWebviewPanel(je,re,ue,Oe,ot)},createWebviewTextEditorInset(re,ue,Oe,ot){return(0,Xe.$oF)(je,"editorInsets"),Pi.createWebviewEditorInset(re,ue,Oe,ot,je)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(je,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Xe.$oF)(je,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,je.identifier.value,ue)},registerTreeDataProvider(re,ue){return $i.registerTreeDataProvider(re,ue,je)},createTreeView(re,ue){return $i.createTreeView(re,ue,je)},registerWebviewPanelSerializer:(re,ue)=>Fi.registerWebviewPanelSerializer(je,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>cn.registerCustomEditorProvider(je,re,ue,Oe),registerFileDecorationProvider(re){return Ue.registerFileDecorationProvider(re,je)},registerUriHandler(re){return gi.registerUriHandler(je,re)},createQuickPick(){return si.createQuickPick(je)},createInputBox(){return si.createInputBox(je)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return et(Li.onDidChangeActiveColorTheme)(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Mi.registerWebviewViewProvider(je,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return et(It.onDidChangeActiveNotebookEditor)(re,ue,Oe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(re,ue,Oe){return et(mi.onDidChangeNotebookEditorSelection)(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return et(mi.onDidChangeNotebookEditorVisibleRanges)(re,ue,Oe)},showNotebookDocument(re,ue){return It.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Xe.$oF)(je,"externalUriOpener"),un.registerExternalUriOpener(je.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Xe.$oF)(je,"profileContentHandlers"),ln.registrProfileContentHandler(je,re,ue)},registerQuickDiffProvider(re,ue,Oe,ot){return(0,Xe.$oF)(je,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(re),ue,Oe,ot)},get tabGroups(){return G.tabGroups},registerShareProvider(re,ue){return(0,Xe.$oF)(je,"shareProvider"),Ji.registerShareProvider(pt(re),ue)}},rn={get rootPath(){return Ee.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new T.$9("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new T.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>dt.updateWorkspaceFolders(je,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return et(dt.onDidChangeWorkspace)(re,ue,Oe)},asRelativePath:(re,ue)=>dt.getRelativePath(re,ue),findFiles:(re,ue,Oe,ot)=>dt.findFiles(re,ue,Oe,je.identifier,ot),findTextInFiles:(re,ue,Oe,ot)=>{(0,Xe.$oF)(je,"findTextInFiles");let bt,Lt;return typeof ue=="object"?(bt=ue,Lt=Oe):(bt={},Lt=ue,ot=Oe),dt.findTextInFiles(re,bt||{},Lt,je.identifier,ot)},save:re=>dt.save(re),saveAs:re=>dt.saveAs(re),saveAll:re=>dt.saveAll(re),applyEdit(re,ue){return Yt.applyWorkspaceEdit(re,je,ue)},createFileSystemWatcher:(re,ue,Oe,ot)=>{let bt;return typeof ue=="boolean"?bt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ue&&((0,Xe.$oF)(je,"createFileSystemWatcher"),bt={...ue,correlate:!0}),_t.createFileSystemWatcher(dt,je,re,bt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new T.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(g.URI.file(re));else if(g.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ot=>At.ensureDocumentData(ot).then(bt=>bt.document))},onDidOpenTextDocument:(re,ue,Oe)=>et(At.onDidAddDocument)(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>et(At.onDidRemoveDocument)(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>et(At.onDidChangeDocument)(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>et(At.onDidSaveDocument)(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>et(Hi.getOnWillSaveTextDocumentEvent(je))(re,ue,Oe),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(g.URI.isUri(re))Oe=re,await It.openNotebookDocument(re);else if(typeof re=="string")Oe=g.URI.revive(await It.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return et(ri.onDidSaveNotebookDocument)(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return et(ri.onDidChangeNotebookDocument)(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return et(Ci.getOnWillSaveNotebookDocumentEvent(je))(re,ue,Oe)},get onDidOpenNotebookDocument(){return et(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(It.onDidCloseNotebookDocument)},registerNotebookSerializer(re,ue,Oe,ot){return It.registerNotebookSerializer(je,re,ue,Oe,(0,Xe.$nF)(je,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>et(en.onDidChangeConfiguration)(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,en.getConfiguration(re,ue,je)},registerTextDocumentContentProvider(re,ue){return Si.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Ee.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(je,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,L.$Pc)(Gi.registerFileSystemProvider(je,re,ue,Oe),Wt.addFileSystemProvider(re,ue,Oe))},get fs(){return Wt.value},registerFileSearchProvider:(re,ue)=>((0,Xe.$oF)(je,"fileSearchProvider"),Ut.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Xe.$oF)(je,"textSearchProvider"),Ut.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Xe.$oF)(je,"resolvers"),Dt.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Xe.$oF)(je,"resolvers"),Qi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Xe.$oF)(je,"resolvers"),Dt.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>et(_t.onDidCreateFile)(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>et(_t.onDidDeleteFile)(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>et(_t.onDidRenameFile)(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>et(_t.getOnWillCreateFileEvent(je))(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>et(_t.getOnWillDeleteFileEvent(je))(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>et(_t.getOnWillRenameFileEvent(je))(re,ue,Oe),openTunnel:re=>((0,Xe.$oF)(je,"tunnels"),Mt.openTunnel(je,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Xe.$oF)(je,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Xe.$oF)(je,"tunnels"),et(Mt.onDidChangeTunnels)(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Xe.$oF)(je,"portsAttributes"),Mt.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Xe.$oF)(je,"tunnelFactory"),Mt.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Xe.$oF)(je,"timeline"),Zi.registerTimelineProvider(re,ue,je.identifier,Ve.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Xe.$oF)(je,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>et(dt.onDidGrantWorkspaceTrust)(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Xe.$oF)(je,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Xe.$oF)(je,"editSessionIdentityProvider"),et(dt.getOnWillCreateEditSessionIdentityEvent(je))(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Xe.$oF)(je,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Xe.$oF)(je,"canonicalUriProvider"),dt.provideCanonicalUri(re,ue,Oe))},sn={get inputBox(){return Ee.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(je)},createSourceControl(re,ue,Oe){return pi.createSourceControl(je,re,ue,Oe)}},on={createCommentController(re,ue){return Ai.createCommentController(je,re,ue)}},Ui={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return et(mt.onDidStartDebugSession)(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return et(mt.onDidTerminateDebugSession)(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return et(mt.onDidChangeActiveDebugSession)(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return et(mt.onDidReceiveDebugSessionCustomEvent)(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return et(mt.onDidChangeBreakpoints)(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Xe.$oF)(je,"debugFocus"),et(mt.onDidChangeStackFrameFocus)(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return mt.registerDebugConfigurationProvider(re,ue,Oe||jt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return mt.registerDebugAdapterDescriptorFactory(je,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return mt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(re,ue,{parentSession:Oe}):mt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return mt.asDebugSourceUri(re,ue)}},Bi={registerTaskProvider:(re,ue)=>Et.registerTaskProvider(je,re,ue),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(je,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,ue,Oe)=>et(Et.onDidStartTask)(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>et(Et.onDidEndTask)(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>et(Et.onDidStartTaskProcess)(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>et(Et.onDidEndTaskProcess)(re,ue,Oe)},Wi={createNotebookController(re,ue,Oe,ot,bt){return ci.createNotebookController(je,re,ue,Oe,ot,(0,Xe.$nF)(je,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>It.registerNotebookCellStatusBarItemProvider(je,re,ue),createRendererMessaging(re){return Ii.createRendererMessaging(je,re)},createNotebookControllerDetectionTask(re){return(0,Xe.$oF)(je,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(je,re)},registerKernelSourceActionProvider(re,ue){return(0,Xe.$oF)(je,"notebookKernelSource"),ci.registerKernelSourceActionProvider(je,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Xe.$oF)(je,"notebookCellExecutionState"),et(ci.onDidChangeNotebookCellExecutionState)(re,ue,Oe)}},ki={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return wt.getMessage(je.identifier.value,{message:ue,args:Oe})}return wt.getMessage(je.identifier.value,re[0])},get bundle(){return wt.getBundle(je.identifier.value)},get uri(){return wt.getBundleUri(je.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Xe.$oF)(je,"interactive"),Yi.registerProvider(je,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Xe.$oF)(je,"interactive"),wi.registerChatProvider(je,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Xe.$oF)(je,"interactive"),wi.sendInteractiveRequestToProvider(re,ue)},transferChatSession(re,ue){return(0,Xe.$oF)(je,"interactive"),wi.transferChatSession(re,ue)}},mn={getRelatedInformation(re,ue){return(0,Xe.$oF)(je,"aiRelatedInformation"),_i.getRelatedInformation(je,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Xe.$oF)(je,"aiRelatedInformation"),_i.registerRelatedInformationProvider(je,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Xe.$oF)(je,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(je,re,ue)}},$n={registerChatResponseProvider(re,ue,Oe){return(0,Xe.$oF)(je,"chatProvider"),di.registerProvider(je.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Xe.$oF)(je,"chatRequestAccess"),di.requestChatResponseProvider(je.identifier,re)},registerVariable(re,ue,Oe){return(0,Xe.$oF)(je,"chatVariables"),xi.registerVariableResolver(je,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Xe.$oF)(je,"mappedEditsProvider"),ht.registerMappedEditsProvider(je,re,ue)},createChatAgent(re,ue){return(0,Xe.$oF)(je,"chatAgents2"),Xi.createChatAgent(je,re,ue)}},pn={registerSpeechProvider(re,ue){return(0,Xe.$oF)(je,"speech"),yi.registerProvider(je.identifier,re,ue)}};return{version:$t.version,ai:mn,authentication:dn,commands:fn,comments:on,chat:$n,debug:Ui,env:ji,extensions:tn,interactive:Vi,l10n:ki,languages:nn,notebooks:Wi,scm:sn,speech:pn,tasks:Bi,tests:zi,window:gn,workspace:rn,Breakpoint:Ne.$OL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$GM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$FM,CallHierarchyIncomingCall:Ne.$bL,CallHierarchyItem:Ne.$aL,CallHierarchyOutgoingCall:Ne.$cL,CancellationError:T.$5,CancellationTokenSource:E.$3d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$0K,CodeActionKind:Ne.$$K,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$dL,Color:Ne.$qL,ColorInformation:Ne.$rL,ColorPresentation:Ne.$sL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$kL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$lL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$AL,DebugAdapterExecutable:Ne.$SL,DebugAdapterInlineImplementation:Ne.$VL,DebugAdapterNamedPipeServer:Ne.$UL,DebugAdapterServer:Ne.$TL,DebugConfigurationProviderTriggerKind:jt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$4K,DiagnosticRelatedInformation:Ne.$3K,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$PK,DocumentHighlight:Ne.$6K,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$7K,DocumentLink:Ne.$pL,DocumentSymbol:Ne.$9K,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$YL,InlineValueText:Ne.$ZL,InlineValueVariableLookup:Ne.$1L,InlineValueEvaluatableExpression:Ne.$2L,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Sd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$_L,FileDecoration2:Ne.$_L,FileSystemError:Ne.$4L,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:Ne.$5L,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$QL,InlineCompletionItem:Ne.$mL,InlineCompletionList:Ne.$nL,Hover:Ne.$5K,IndentAction:S.IndentAction,Location:Ne.$2K,MarkdownString:Ne.$eL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$fL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$QK,ProcessExecution:Ne.$yL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$$L,Range:Ne.$RK,RelativePattern:Ne.$ML,Selection:Ne.$SK,SelectionRange:Ne.$_K,SemanticTokens:Ne.$8L,SemanticTokensBuilder:Ne.$7L,SemanticTokensEdit:Ne.$9L,SemanticTokensEdits:Ne.$0L,SemanticTokensLegend:Ne.$6L,ShellExecution:Ne.$zL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$hL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$gL,SnippetString:Ne.$1K,SourceBreakpoint:Ne.$PL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$8K,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$BL,TaskGroup:Ne.$xL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$tL,TerminalQuickFixTerminalCommand:Ne.$vL,TerminalQuickFixOpener:Ne.$uL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$wL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$WK,SnippetTextEdit:Ne.$YK,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$LL,ThemeIcon:Ne.$KL,TreeItem:Ne.$CL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$uM,UIKind:Rt.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$ZK,DocumentDropEdit:Ne.$IL,DocumentPasteEdit:Ne.$JL,InlayHint:Ne.$jL,InlayHintLabelPart:Ne.$iL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$VK,ResolvedAuthority:Ne.$TK,ManagedResolvedAuthority:Ne.$UK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$jM,NotebookRange:Ne.$bM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$cM,NotebookData:Ne.$dM,NotebookRendererScript:Ne.$hM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$fM,NotebookCellOutputItem:Ne.$eM,NotebookCellStatusBarItem:Ne.$gM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$XK,NotebookKernelSourceAction:Ne.$iM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$lM,LinkedEditingRanges:Ne.$kM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$mM,TestMessage:Ne.$nM,TestMessage2:Ne.$nM,TestTag:Ne.$oM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Ne.$HL,DataTransferItem:Ne.$DL,CoveredCount:Ne.$pM,FileCoverage:Ne.$qM,StatementCoverage:Ne.$rM,BranchCoverage:Ne.$sM,FunctionCoverage:Ne.$tM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$vM,TabInputTextDiff:Ne.$wM,TabInputTextMerge:Ne.$xM,TabInputCustom:Ne.$yM,TabInputNotebook:Ne.$AM,TabInputNotebookDiff:Ne.$BM,TabInputWebview:Ne.$zM,TabInputTerminal:Ne.$CM,TabInputInteractiveWindow:Ne.$DM,TabInputChat:Ne.$EM,TelemetryTrustedValue:t.$xo,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$WL,ThreadFocus:Ne.$XL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$fhc=Jt}),define(Ce[291],Re([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,256,15,116,82,83]),function(ge,e,E,T,I,L,R,$,g,w,A,S,l,p,b,r,a,t,n,o,c,h,i,s,u,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Kr)(d.$7fc,d.$6fc,1),(0,E.$Kr)(s.$kj,i.$ghc,1),(0,E.$Kr)(r.$ffc,r.$gfc,1),(0,E.$Kr)($.$bN,$.$aN,0),(0,E.$Kr)(R.$Afc,R.$yfc,0),(0,E.$Kr)(t.$Cfc,t.$Bfc,0),(0,E.$Kr)(S.$egc,S.$igc,0),(0,E.$Kr)(L.$kgc,L.$jgc,0),(0,E.$Kr)(g.$3M,g.$2M,0),(0,E.$Kr)(m.$8fc,m.$9fc,0),(0,E.$Kr)(n.$cfc,n.$bfc,0),(0,E.$Kr)(T.$Qgc,T.$Pgc,1),(0,E.$Kr)(l.$Agc,l.$Bgc,0),(0,E.$Kr)(p.$Vfc,p.$Ufc,0),(0,E.$Kr)(A.$4gc,A.$3gc,0),(0,E.$Kr)(w.$Yfc,w.$2fc,0),(0,E.$Kr)(b.$_xb,b.$ayb,0),(0,E.$Kr)(a.$ehc,a.$dhc,0),(0,E.$Kr)(I.$xfc,I.$wfc,0),(0,E.$Kr)(o.$4fc,o.$3fc,0),(0,E.$Kr)(c.$_M,c.$9M,0),(0,E.$Kr)(h.$Mfc,h.$Nfc,0),(0,E.$Kr)(u.$cgc,u.$dgc,0)}),define(Ce[292],Re([1,0,290,38,2,287,7,13,275]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0;class w extends L.$jhc{j(){}getModule(p,b){for(const r of this.b){const a=r(p);if(a){p=a;break}}if(this.a.has(p))return this.a.get(p).load(p,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$$fc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$qjc);const p=this.h.invokeFunction(E.$fhc);this.r=this.h.createInstance(w,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,b,r){b=b.with({path:S(b.path,".js")});const a=p?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const t=I.URI.revive(await this.C.$asBrowserUri(b)),n=await fetch(t.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${b.toString(!0)}#vscode-extension`,h=`${o}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(m){throw console.error(a?`Loading code for extension ${a} failed: ${m.message}`:`Loading code failed: ${m.message}`),console.error(`${b.toString(!0)}${typeof m.line=="number"?` line ${m.line}`:""}${typeof m.column=="number"?` column ${m.column}`:""}`),console.error(m),m}p&&await this.w.initializeLocalizedMessages(p);const s={},u={exports:s},d=m=>{const f=this.r.getModule(m,b);if(f===void 0)throw new Error(`Cannot load module '${m}'`);return f};try{return r.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),i(u,s,d),u.exports!==s?u.exports:s}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),r.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+p;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,$.$3g)(10)}}e.$rjc=A;function S(l,p){return l.endsWith(p)?l:l+p}}),define(Ce[293],Re([1,0,69,70,15,38,200,86,292]),function(ge,e,E,T,I,L,R,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Kr)(I.$jj,new E.$Yh(R.$ihc,[!0],!0)),(0,T.$Kr)(L.$_fc,g.$rjc,0),(0,T.$Kr)($.$Dfc,$.$Efc,0)}),define(Ce[298],Re([1,0,24,5,79,288,277,19,88,12,2,291,293]),function(ge,e,E,T,I,L,R,$,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const b=fetch.bind(self);function r(i){self.fetch=async function(s,u){return s instanceof Request||p(String(s))&&(s=(await i(A.URI.parse(String(s)))).toString(!0)),b(s,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,u,d,m,f){(async()=>(p(u.toString())&&(u=(await i(A.URI.parse(u.toString()))).toString(!0)),super.open(s,u,d??!0,m,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,u){if(/^file:/i.test(s.toString()))s=w.$kg.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const m=`(${function(v){function y(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const D=fetch.bind(self);self.fetch=function(O,W){return O instanceof Request?D(O,W):D(y(O),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,W,z,V,P){return super.open(O,y(W),z??!0,V,P)}};const N=importScripts.bind(self);self.importScripts=(...O)=>{N(...O.map(y))},N(v)}.toString()}('${s}'))`;u=u||{},u.name=u.name||$.$nc(s.toString());const f=new Blob([m],{type:"application/javascript"}),k=URL.createObjectURL(f);return new i(k,u)}}else self.Worker=class extends R.$sjc{constructor(i,s){super(l,i,{name:$.$nc(i.toString()),...s})}};const a=new class{constructor(){this.pid=void 0}exit(i){S()}};class t{constructor(){const s=new MessageChannel,u=new T.$Sd;let d=!1;l(s.port2,[s.port2]),s.port1.onmessage=m=>{const{data:f}=m;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const k=E.$ge.wrap(new Uint8Array(f,0,f.byteLength));if((0,I.$qm)(k,2)){d=!0,o("received terminate message from renderer");return}u.fire(k)},this.protocol={onMessage:u.event,send:m=>{if(!d){const f=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function n(i){return new Promise(s=>{const u=i.onMessage(d=>{u.dispose();const m=JSON.parse(d.toString());i.send((0,I.$pm)(0)),s({protocol:i,initData:m})});i.send((0,I.$pm)(1))})}let o=i=>S();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(s){c(s)&&n(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new L.$lhc(u.protocol,u.initData,a,null,s.data);r(m=>d.asBrowserUri(m)),o=m=>d.terminate(m)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/279872bd965e4030c81129a9bf1ce1710ff7cd55/core/vs/workbench/api/worker/extensionHostWorker.js.map
